(set-logic QF_NIA)
(set-info :source |

SMT script generated by Ultimate LassoRanker [1].
Ultimate LassoRanker is a tool that analyzes termination and nontermination of
lasso-shaped programs. This script contains the SMT commands that Ultimate 
LassoRanker used while checking if a lasso-shaped program has a geometric 
nontermination argument. (See [2] for a preliminary definition of
geometric nontermination argument.)

This SMT script belongs to a set of SMT scripts that was generated by applying
Ultimate Buchi Automizer [3,4] to benchmarks from the SV-COMP 2016 [5,6] 
which are available at [7]. Ultimate Buchi Automizer takes omega-traces
(lasso-shaped programs) and uses LassoRanker in order to check if the 
lasso-shaped program is terminating.

2016-04-30, Matthias Heizmann (heizmann@informatik.uni-freiburg.de)


[1] https://ultimate.informatik.uni-freiburg.de/LassoRanker/
[2] Jan Leike, Matthias Heizmann: Geometric Series as Nontermination
Arguments for Linear Lasso Programs. CoRR abs/1405.4413 (2014)
http://arxiv.org/abs/1405.4413
[3] http://ultimate.informatik.uni-freiburg.de/BuchiAutomizer/
[4] Matthias Heizmann, Jochen Hoenicke, Andreas Podelski: Software Model
Checking for People Who Love Automata. CAV 2013:36-52
[5] http://sv-comp.sosy-lab.org/2016/
[6] Dirk Beyer: Reliable and Reproducible Competition Results with BenchExec
and Witnesses (Report on SV-COMP 2016). TACAS 2016: 887-904
[7] https://github.com/dbeyer/sv-benchmarks

|)
(set-info :smt-lib-version 2.5)
(set-info :category "industrial")
(set-info :status unsat)
(declare-fun |init_isOdd_#in~n| () Int)
(declare-fun |honda_isOdd_#in~n| () Int)
(declare-fun |init_isEven_#in~n| () Int)
(declare-fun |honda_isEven_#in~n| () Int)
(declare-fun |gev_isOdd_#in~n0| () Int)
(declare-fun |gev_isEven_#in~n0| () Int)
(declare-fun lambda0 () Int)
(declare-fun |gev_isOdd_#in~n1| () Int)
(declare-fun |gev_isEven_#in~n1| () Int)
(declare-fun lambda1 () Int)
(declare-fun |gev_isOdd_#in~n2| () Int)
(declare-fun |gev_isEven_#in~n2| () Int)
(declare-fun lambda2 () Int)
(declare-fun nu0 () Int)
(declare-fun nu1 () Int)
(assert (and (and (= |init_isEven_#in~n| |honda_isEven_#in~n|) (>= (+ (* |honda_isOdd_#in~n| 1) (* |honda_isEven_#in~n| 0) (* |init_isOdd_#in~n| 0) 0) 0)) (or (and (>= (+ (* (+ (* |gev_isOdd_#in~n0| lambda0) (* |gev_isOdd_#in~n1| nu0)) 0) (* (+ (* |gev_isEven_#in~n0| lambda0) (* |gev_isEven_#in~n1| nu0)) 0) (* |gev_isOdd_#in~n0| (- 1)) (* |gev_isEven_#in~n0| 0)) 0) (>= (+ (* (+ (* |gev_isOdd_#in~n0| lambda0) (* |gev_isOdd_#in~n1| nu0)) (- 1)) (* (+ (* |gev_isEven_#in~n0| lambda0) (* |gev_isEven_#in~n1| nu0)) 1) (* |gev_isOdd_#in~n0| 0) (* |gev_isEven_#in~n0| 0)) 0) (>= (+ (* (+ (* |gev_isOdd_#in~n0| lambda0) (* |gev_isOdd_#in~n1| nu0)) 0) (* (+ (* |gev_isEven_#in~n0| lambda0) (* |gev_isEven_#in~n1| nu0)) (- 1)) (* |gev_isOdd_#in~n0| 1) (* |gev_isEven_#in~n0| 0)) 0) (>= (+ (* (+ (* |gev_isOdd_#in~n0| lambda0) (* |gev_isOdd_#in~n1| nu0)) 1) (* (+ (* |gev_isEven_#in~n0| lambda0) (* |gev_isEven_#in~n1| nu0)) (- 1)) (* |gev_isOdd_#in~n0| 0) (* |gev_isEven_#in~n0| 0)) 0) (>= (+ (* (+ (* |gev_isOdd_#in~n0| lambda0) (* |gev_isOdd_#in~n1| nu0)) 0) (* (+ (* |gev_isEven_#in~n0| lambda0) (* |gev_isEven_#in~n1| nu0)) 1) (* |gev_isOdd_#in~n0| (- 1)) (* |gev_isEven_#in~n0| 0)) 0) (>= (+ (* (+ (* |gev_isOdd_#in~n1| lambda1) (* |gev_isOdd_#in~n2| nu1)) 0) (* (+ (* |gev_isEven_#in~n1| lambda1) (* |gev_isEven_#in~n2| nu1)) 0) (* |gev_isOdd_#in~n1| (- 1)) (* |gev_isEven_#in~n1| 0)) 0) (>= (+ (* (+ (* |gev_isOdd_#in~n1| lambda1) (* |gev_isOdd_#in~n2| nu1)) (- 1)) (* (+ (* |gev_isEven_#in~n1| lambda1) (* |gev_isEven_#in~n2| nu1)) 1) (* |gev_isOdd_#in~n1| 0) (* |gev_isEven_#in~n1| 0)) 0) (>= (+ (* (+ (* |gev_isOdd_#in~n1| lambda1) (* |gev_isOdd_#in~n2| nu1)) 0) (* (+ (* |gev_isEven_#in~n1| lambda1) (* |gev_isEven_#in~n2| nu1)) (- 1)) (* |gev_isOdd_#in~n1| 1) (* |gev_isEven_#in~n1| 0)) 0) (>= (+ (* (+ (* |gev_isOdd_#in~n1| lambda1) (* |gev_isOdd_#in~n2| nu1)) 1) (* (+ (* |gev_isEven_#in~n1| lambda1) (* |gev_isEven_#in~n2| nu1)) (- 1)) (* |gev_isOdd_#in~n1| 0) (* |gev_isEven_#in~n1| 0)) 0) (>= (+ (* (+ (* |gev_isOdd_#in~n1| lambda1) (* |gev_isOdd_#in~n2| nu1)) 0) (* (+ (* |gev_isEven_#in~n1| lambda1) (* |gev_isEven_#in~n2| nu1)) 1) (* |gev_isOdd_#in~n1| (- 1)) (* |gev_isEven_#in~n1| 0)) 0) (>= (+ (* (* |gev_isOdd_#in~n2| lambda2) 0) (* (* |gev_isEven_#in~n2| lambda2) 0) (* |gev_isOdd_#in~n2| (- 1)) (* |gev_isEven_#in~n2| 0)) 0) (>= (+ (* (* |gev_isOdd_#in~n2| lambda2) (- 1)) (* (* |gev_isEven_#in~n2| lambda2) 1) (* |gev_isOdd_#in~n2| 0) (* |gev_isEven_#in~n2| 0)) 0) (>= (+ (* (* |gev_isOdd_#in~n2| lambda2) 0) (* (* |gev_isEven_#in~n2| lambda2) (- 1)) (* |gev_isOdd_#in~n2| 1) (* |gev_isEven_#in~n2| 0)) 0) (>= (+ (* (* |gev_isOdd_#in~n2| lambda2) 1) (* (* |gev_isEven_#in~n2| lambda2) (- 1)) (* |gev_isOdd_#in~n2| 0) (* |gev_isEven_#in~n2| 0)) 0) (>= (+ (* (* |gev_isOdd_#in~n2| lambda2) 0) (* (* |gev_isEven_#in~n2| lambda2) 1) (* |gev_isOdd_#in~n2| (- 1)) (* |gev_isEven_#in~n2| 0)) 0) (>= (+ (* (+ |honda_isOdd_#in~n| |gev_isOdd_#in~n0| |gev_isOdd_#in~n1| |gev_isOdd_#in~n2|) 0) (* (+ |honda_isEven_#in~n| |gev_isEven_#in~n0| |gev_isEven_#in~n1| |gev_isEven_#in~n2|) 0) (* |honda_isOdd_#in~n| (- 1)) (* |honda_isEven_#in~n| 0) (- 1)) 0) (>= (+ (* (+ |honda_isOdd_#in~n| |gev_isOdd_#in~n0| |gev_isOdd_#in~n1| |gev_isOdd_#in~n2|) (- 1)) (* (+ |honda_isEven_#in~n| |gev_isEven_#in~n0| |gev_isEven_#in~n1| |gev_isEven_#in~n2|) 1) (* |honda_isOdd_#in~n| 0) (* |honda_isEven_#in~n| 0) (- 1)) 0) (>= (+ (* (+ |honda_isOdd_#in~n| |gev_isOdd_#in~n0| |gev_isOdd_#in~n1| |gev_isOdd_#in~n2|) 0) (* (+ |honda_isEven_#in~n| |gev_isEven_#in~n0| |gev_isEven_#in~n1| |gev_isEven_#in~n2|) (- 1)) (* |honda_isOdd_#in~n| 1) (* |honda_isEven_#in~n| 0) (- 1)) 0) (>= (+ (* (+ |honda_isOdd_#in~n| |gev_isOdd_#in~n0| |gev_isOdd_#in~n1| |gev_isOdd_#in~n2|) 1) (* (+ |honda_isEven_#in~n| |gev_isEven_#in~n0| |gev_isEven_#in~n1| |gev_isEven_#in~n2|) (- 1)) (* |honda_isOdd_#in~n| 0) (* |honda_isEven_#in~n| 0) 1) 0) (>= (+ (* (+ |honda_isOdd_#in~n| |gev_isOdd_#in~n0| |gev_isOdd_#in~n1| |gev_isOdd_#in~n2|) 0) (* (+ |honda_isEven_#in~n| |gev_isEven_#in~n0| |gev_isEven_#in~n1| |gev_isEven_#in~n2|) 1) (* |honda_isOdd_#in~n| (- 1)) (* |honda_isEven_#in~n| 0) 1) 0)) (and (>= (+ (* (+ (* |gev_isOdd_#in~n0| lambda0) (* |gev_isOdd_#in~n1| nu0)) (- 1)) (* (+ (* |gev_isEven_#in~n0| lambda0) (* |gev_isEven_#in~n1| nu0)) 1) (* |gev_isOdd_#in~n0| 0) (* |gev_isEven_#in~n0| 0)) 0) (>= (+ (* (+ (* |gev_isOdd_#in~n0| lambda0) (* |gev_isOdd_#in~n1| nu0)) 0) (* (+ (* |gev_isEven_#in~n0| lambda0) (* |gev_isEven_#in~n1| nu0)) (- 1)) (* |gev_isOdd_#in~n0| 1) (* |gev_isEven_#in~n0| 0)) 0) (>= (+ (* (+ (* |gev_isOdd_#in~n0| lambda0) (* |gev_isOdd_#in~n1| nu0)) 0) (* (+ (* |gev_isEven_#in~n0| lambda0) (* |gev_isEven_#in~n1| nu0)) 1) (* |gev_isOdd_#in~n0| 0) (* |gev_isEven_#in~n0| 0)) 0) (>= (+ (* (+ (* |gev_isOdd_#in~n0| lambda0) (* |gev_isOdd_#in~n1| nu0)) 1) (* (+ (* |gev_isEven_#in~n0| lambda0) (* |gev_isEven_#in~n1| nu0)) (- 1)) (* |gev_isOdd_#in~n0| 0) (* |gev_isEven_#in~n0| 0)) 0) (>= (+ (* (+ (* |gev_isOdd_#in~n0| lambda0) (* |gev_isOdd_#in~n1| nu0)) 0) (* (+ (* |gev_isEven_#in~n0| lambda0) (* |gev_isEven_#in~n1| nu0)) 1) (* |gev_isOdd_#in~n0| (- 1)) (* |gev_isEven_#in~n0| 0)) 0) (>= (+ (* (+ (* |gev_isOdd_#in~n1| lambda1) (* |gev_isOdd_#in~n2| nu1)) (- 1)) (* (+ (* |gev_isEven_#in~n1| lambda1) (* |gev_isEven_#in~n2| nu1)) 1) (* |gev_isOdd_#in~n1| 0) (* |gev_isEven_#in~n1| 0)) 0) (>= (+ (* (+ (* |gev_isOdd_#in~n1| lambda1) (* |gev_isOdd_#in~n2| nu1)) 0) (* (+ (* |gev_isEven_#in~n1| lambda1) (* |gev_isEven_#in~n2| nu1)) (- 1)) (* |gev_isOdd_#in~n1| 1) (* |gev_isEven_#in~n1| 0)) 0) (>= (+ (* (+ (* |gev_isOdd_#in~n1| lambda1) (* |gev_isOdd_#in~n2| nu1)) 0) (* (+ (* |gev_isEven_#in~n1| lambda1) (* |gev_isEven_#in~n2| nu1)) 1) (* |gev_isOdd_#in~n1| 0) (* |gev_isEven_#in~n1| 0)) 0) (>= (+ (* (+ (* |gev_isOdd_#in~n1| lambda1) (* |gev_isOdd_#in~n2| nu1)) 1) (* (+ (* |gev_isEven_#in~n1| lambda1) (* |gev_isEven_#in~n2| nu1)) (- 1)) (* |gev_isOdd_#in~n1| 0) (* |gev_isEven_#in~n1| 0)) 0) (>= (+ (* (+ (* |gev_isOdd_#in~n1| lambda1) (* |gev_isOdd_#in~n2| nu1)) 0) (* (+ (* |gev_isEven_#in~n1| lambda1) (* |gev_isEven_#in~n2| nu1)) 1) (* |gev_isOdd_#in~n1| (- 1)) (* |gev_isEven_#in~n1| 0)) 0) (>= (+ (* (* |gev_isOdd_#in~n2| lambda2) (- 1)) (* (* |gev_isEven_#in~n2| lambda2) 1) (* |gev_isOdd_#in~n2| 0) (* |gev_isEven_#in~n2| 0)) 0) (>= (+ (* (* |gev_isOdd_#in~n2| lambda2) 0) (* (* |gev_isEven_#in~n2| lambda2) (- 1)) (* |gev_isOdd_#in~n2| 1) (* |gev_isEven_#in~n2| 0)) 0) (>= (+ (* (* |gev_isOdd_#in~n2| lambda2) 0) (* (* |gev_isEven_#in~n2| lambda2) 1) (* |gev_isOdd_#in~n2| 0) (* |gev_isEven_#in~n2| 0)) 0) (>= (+ (* (* |gev_isOdd_#in~n2| lambda2) 1) (* (* |gev_isEven_#in~n2| lambda2) (- 1)) (* |gev_isOdd_#in~n2| 0) (* |gev_isEven_#in~n2| 0)) 0) (>= (+ (* (* |gev_isOdd_#in~n2| lambda2) 0) (* (* |gev_isEven_#in~n2| lambda2) 1) (* |gev_isOdd_#in~n2| (- 1)) (* |gev_isEven_#in~n2| 0)) 0) (>= (+ (* (+ |honda_isOdd_#in~n| |gev_isOdd_#in~n0| |gev_isOdd_#in~n1| |gev_isOdd_#in~n2|) (- 1)) (* (+ |honda_isEven_#in~n| |gev_isEven_#in~n0| |gev_isEven_#in~n1| |gev_isEven_#in~n2|) 1) (* |honda_isOdd_#in~n| 0) (* |honda_isEven_#in~n| 0) (- 1)) 0) (>= (+ (* (+ |honda_isOdd_#in~n| |gev_isOdd_#in~n0| |gev_isOdd_#in~n1| |gev_isOdd_#in~n2|) 0) (* (+ |honda_isEven_#in~n| |gev_isEven_#in~n0| |gev_isEven_#in~n1| |gev_isEven_#in~n2|) (- 1)) (* |honda_isOdd_#in~n| 1) (* |honda_isEven_#in~n| 0) (- 1)) 0) (>= (+ (* (+ |honda_isOdd_#in~n| |gev_isOdd_#in~n0| |gev_isOdd_#in~n1| |gev_isOdd_#in~n2|) 0) (* (+ |honda_isEven_#in~n| |gev_isEven_#in~n0| |gev_isEven_#in~n1| |gev_isEven_#in~n2|) 1) (* |honda_isOdd_#in~n| 0) (* |honda_isEven_#in~n| 0) (- 2)) 0) (>= (+ (* (+ |honda_isOdd_#in~n| |gev_isOdd_#in~n0| |gev_isOdd_#in~n1| |gev_isOdd_#in~n2|) 1) (* (+ |honda_isEven_#in~n| |gev_isEven_#in~n0| |gev_isEven_#in~n1| |gev_isEven_#in~n2|) (- 1)) (* |honda_isOdd_#in~n| 0) (* |honda_isEven_#in~n| 0) 1) 0) (>= (+ (* (+ |honda_isOdd_#in~n| |gev_isOdd_#in~n0| |gev_isOdd_#in~n1| |gev_isOdd_#in~n2|) 0) (* (+ |honda_isEven_#in~n| |gev_isEven_#in~n0| |gev_isEven_#in~n1| |gev_isEven_#in~n2|) 1) (* |honda_isOdd_#in~n| (- 1)) (* |honda_isEven_#in~n| 0) 1) 0))) (and (or (= nu0 0) (= nu0 1)) (or (= nu1 0) (= nu1 1)) (>= lambda0 0) (>= lambda1 0) (>= lambda2 0))))
(check-sat)
(exit)
