(set-logic QF_NIA)
(set-info :source |

SMT script generated by Ultimate LassoRanker [1].
Ultimate LassoRanker is a tool that analyzes termination and nontermination of
lasso-shaped programs. This script contains the SMT commands that Ultimate 
LassoRanker used while checking if a lasso-shaped program has a geometric 
nontermination argument. (See [2] for a preliminary definition of
geometric nontermination argument.)

This SMT script belongs to a set of SMT scripts that was generated by applying
Ultimate Buchi Automizer [3,4] to benchmarks from the SV-COMP 2016 [5,6] 
which are available at [7]. Ultimate Buchi Automizer takes omega-traces
(lasso-shaped programs) and uses LassoRanker in order to check if the 
lasso-shaped program is terminating.

2016-04-30, Matthias Heizmann (heizmann@informatik.uni-freiburg.de)


[1] https://ultimate.informatik.uni-freiburg.de/LassoRanker/
[2] Jan Leike, Matthias Heizmann: Geometric Series as Nontermination
Arguments for Linear Lasso Programs. CoRR abs/1405.4413 (2014)
http://arxiv.org/abs/1405.4413
[3] http://ultimate.informatik.uni-freiburg.de/BuchiAutomizer/
[4] Matthias Heizmann, Jochen Hoenicke, Andreas Podelski: Software Model
Checking for People Who Love Automata. CAV 2013:36-52
[5] http://sv-comp.sosy-lab.org/2016/
[6] Dirk Beyer: Reliable and Reproducible Competition Results with BenchExec
and Witnesses (Report on SV-COMP 2016). TACAS 2016: 887-904
[7] https://github.com/dbeyer/sv-benchmarks

|)
(set-info :smt-lib-version 2.5)
(set-info :category "industrial")
(set-info :status unsat)
(declare-fun |init_g_#in~x| () Int)
(declare-fun |honda_g_#in~x| () Int)
(declare-fun |init_f_#in~x| () Int)
(declare-fun |honda_f_#in~x| () Int)
(declare-fun |gev_g_#in~x0| () Int)
(declare-fun |gev_f_#in~x0| () Int)
(declare-fun lambda0 () Int)
(declare-fun |gev_g_#in~x1| () Int)
(declare-fun |gev_f_#in~x1| () Int)
(declare-fun lambda1 () Int)
(declare-fun |gev_g_#in~x2| () Int)
(declare-fun |gev_f_#in~x2| () Int)
(declare-fun lambda2 () Int)
(declare-fun nu0 () Int)
(declare-fun nu1 () Int)
(assert (and true (and (>= (+ (* (+ (* |gev_g_#in~x0| lambda0) (* |gev_g_#in~x1| nu0)) (- 1)) (* (+ (* |gev_f_#in~x0| lambda0) (* |gev_f_#in~x1| nu0)) 1) (* |gev_g_#in~x0| 0) (* |gev_f_#in~x0| 0)) 0) (>= (+ (* (+ (* |gev_g_#in~x0| lambda0) (* |gev_g_#in~x1| nu0)) 0) (* (+ (* |gev_f_#in~x0| lambda0) (* |gev_f_#in~x1| nu0)) (- 1)) (* |gev_g_#in~x0| 1) (* |gev_f_#in~x0| 0)) 0) (>= (+ (* (+ (* |gev_g_#in~x0| lambda0) (* |gev_g_#in~x1| nu0)) 1) (* (+ (* |gev_f_#in~x0| lambda0) (* |gev_f_#in~x1| nu0)) 0) (* |gev_g_#in~x0| 0) (* |gev_f_#in~x0| 0)) 0) (>= (+ (* (+ (* |gev_g_#in~x0| lambda0) (* |gev_g_#in~x1| nu0)) 0) (* (+ (* |gev_f_#in~x0| lambda0) (* |gev_f_#in~x1| nu0)) 1) (* |gev_g_#in~x0| (- 1)) (* |gev_f_#in~x0| 0)) 0) (>= (+ (* (+ (* |gev_g_#in~x0| lambda0) (* |gev_g_#in~x1| nu0)) 1) (* (+ (* |gev_f_#in~x0| lambda0) (* |gev_f_#in~x1| nu0)) (- 1)) (* |gev_g_#in~x0| 0) (* |gev_f_#in~x0| 0)) 0) (>= (+ (* (+ (* |gev_g_#in~x1| lambda1) (* |gev_g_#in~x2| nu1)) (- 1)) (* (+ (* |gev_f_#in~x1| lambda1) (* |gev_f_#in~x2| nu1)) 1) (* |gev_g_#in~x1| 0) (* |gev_f_#in~x1| 0)) 0) (>= (+ (* (+ (* |gev_g_#in~x1| lambda1) (* |gev_g_#in~x2| nu1)) 0) (* (+ (* |gev_f_#in~x1| lambda1) (* |gev_f_#in~x2| nu1)) (- 1)) (* |gev_g_#in~x1| 1) (* |gev_f_#in~x1| 0)) 0) (>= (+ (* (+ (* |gev_g_#in~x1| lambda1) (* |gev_g_#in~x2| nu1)) 1) (* (+ (* |gev_f_#in~x1| lambda1) (* |gev_f_#in~x2| nu1)) 0) (* |gev_g_#in~x1| 0) (* |gev_f_#in~x1| 0)) 0) (>= (+ (* (+ (* |gev_g_#in~x1| lambda1) (* |gev_g_#in~x2| nu1)) 0) (* (+ (* |gev_f_#in~x1| lambda1) (* |gev_f_#in~x2| nu1)) 1) (* |gev_g_#in~x1| (- 1)) (* |gev_f_#in~x1| 0)) 0) (>= (+ (* (+ (* |gev_g_#in~x1| lambda1) (* |gev_g_#in~x2| nu1)) 1) (* (+ (* |gev_f_#in~x1| lambda1) (* |gev_f_#in~x2| nu1)) (- 1)) (* |gev_g_#in~x1| 0) (* |gev_f_#in~x1| 0)) 0) (>= (+ (* (* |gev_g_#in~x2| lambda2) (- 1)) (* (* |gev_f_#in~x2| lambda2) 1) (* |gev_g_#in~x2| 0) (* |gev_f_#in~x2| 0)) 0) (>= (+ (* (* |gev_g_#in~x2| lambda2) 0) (* (* |gev_f_#in~x2| lambda2) (- 1)) (* |gev_g_#in~x2| 1) (* |gev_f_#in~x2| 0)) 0) (>= (+ (* (* |gev_g_#in~x2| lambda2) 1) (* (* |gev_f_#in~x2| lambda2) 0) (* |gev_g_#in~x2| 0) (* |gev_f_#in~x2| 0)) 0) (>= (+ (* (* |gev_g_#in~x2| lambda2) 0) (* (* |gev_f_#in~x2| lambda2) 1) (* |gev_g_#in~x2| (- 1)) (* |gev_f_#in~x2| 0)) 0) (>= (+ (* (* |gev_g_#in~x2| lambda2) 1) (* (* |gev_f_#in~x2| lambda2) (- 1)) (* |gev_g_#in~x2| 0) (* |gev_f_#in~x2| 0)) 0) (>= (+ (* (+ |honda_g_#in~x| |gev_g_#in~x0| |gev_g_#in~x1| |gev_g_#in~x2|) (- 1)) (* (+ |honda_f_#in~x| |gev_f_#in~x0| |gev_f_#in~x1| |gev_f_#in~x2|) 1) (* |honda_g_#in~x| 0) (* |honda_f_#in~x| 0) 0) 0) (>= (+ (* (+ |honda_g_#in~x| |gev_g_#in~x0| |gev_g_#in~x1| |gev_g_#in~x2|) 0) (* (+ |honda_f_#in~x| |gev_f_#in~x0| |gev_f_#in~x1| |gev_f_#in~x2|) (- 1)) (* |honda_g_#in~x| 1) (* |honda_f_#in~x| 0) (- 2)) 0) (>= (+ (* (+ |honda_g_#in~x| |gev_g_#in~x0| |gev_g_#in~x1| |gev_g_#in~x2|) 1) (* (+ |honda_f_#in~x| |gev_f_#in~x0| |gev_f_#in~x1| |gev_f_#in~x2|) 0) (* |honda_g_#in~x| 0) (* |honda_f_#in~x| 0) (- 1)) 0) (>= (+ (* (+ |honda_g_#in~x| |gev_g_#in~x0| |gev_g_#in~x1| |gev_g_#in~x2|) 0) (* (+ |honda_f_#in~x| |gev_f_#in~x0| |gev_f_#in~x1| |gev_f_#in~x2|) 1) (* |honda_g_#in~x| (- 1)) (* |honda_f_#in~x| 0) 2) 0) (>= (+ (* (+ |honda_g_#in~x| |gev_g_#in~x0| |gev_g_#in~x1| |gev_g_#in~x2|) 1) (* (+ |honda_f_#in~x| |gev_f_#in~x0| |gev_f_#in~x1| |gev_f_#in~x2|) (- 1)) (* |honda_g_#in~x| 0) (* |honda_f_#in~x| 0) 0) 0)) (and (or (= nu0 0) (= nu0 1)) (or (= nu1 0) (= nu1 1)) (>= lambda0 0) (>= lambda1 0) (>= lambda2 0))))
(check-sat)
(exit)
