(set-logic QF_NIA)
(set-info :source |
     See Hofbauer/Waldmann: Termination of String Rewriting with Matrix
     Interpretations, RTA06, LNCS 4098, pp 328-342.  Proof of unsat is
     found in Section 6, Remark "Exponential derivation length", last
     paragraph.

     Contibuted by Johannes Waldmann at HTWK Leipzig.
   |)
(set-info :smt-lib-version 2.0)
(set-info :category "crafted")
(set-info :status unsat)
(declare-fun n0 () Int)
(assert (>= n0 0))
(declare-fun n1 () Int)
(assert (>= n1 0))
(assert (>= n1 1))
(declare-fun n2 () Int)
(assert (>= n2 0))
(declare-fun n3 () Int)
(assert (>= n3 0))
(assert (>= n3 1))
(declare-fun n4 () Int)
(assert (>= n4 0))
(declare-fun n5 () Int)
(assert (>= n5 0))
(assert (>= n5 1))
(declare-fun n6 () Int)
(assert (= n6 (* n3 n2)))
(declare-fun n7 () Int)
(assert (= n7 (+ n2 n6)))
(declare-fun n8 () Int)
(assert (= n8 (* n3 n3)))
(declare-fun n9 () Int)
(assert (= n9 (* n3 n4)))
(declare-fun n10 () Int)
(assert (= n10 (+ n2 n9)))
(declare-fun n11 () Int)
(assert (= n11 (* n3 n5)))
(declare-fun n12 () Int)
(assert (= n12 (* n1 n2)))
(declare-fun n13 () Int)
(assert (= n13 (+ n0 n12)))
(declare-fun n14 () Int)
(assert (= n14 (* n1 n3)))
(declare-fun n15 () Int)
(assert (= n15 (* n11 n0)))
(declare-fun n16 () Int)
(assert (= n16 (+ n10 n15)))
(declare-fun n17 () Int)
(assert (= n17 (* n11 n1)))
(assert (>= n13 n16))
(assert (>= n14 n17))
(declare-fun n18 () Int)
(assert (= n18 (* n5 n2)))
(declare-fun n19 () Int)
(assert (= n19 (+ n4 n18)))
(declare-fun n20 () Int)
(assert (= n20 (* n5 n3)))
(declare-fun n21 () Int)
(assert (= n21 (* n8 n4)))
(declare-fun n22 () Int)
(assert (= n22 (+ n7 n21)))
(declare-fun n23 () Int)
(assert (= n23 (* n8 n5)))
(assert (>= n19 n22))
(assert (>= n20 n23))
(assert (or (> n13 n16) (> n19 n22)))
(check-sat)
(exit)
