(set-logic QF_NIA)
(set-info :source |
 more info in 'N. P. Lopes, L. Aksoy, V. Manquinho, J. Monteiro.
 Optimally Solving the MCM Problem Using Pseudo-Boolean Satisfiability.
 Technical Report RT/43/2010, INESC-ID, Nov. 2010'. |)
(set-info :smt-lib-version 2.0)
(set-info :category "industrial")
(set-info :status unknown)
(declare-fun X19 () Int)
(declare-fun X20 () Int)
(declare-fun S0 () Int)
(declare-fun S1 () Int)
(declare-fun S2 () Int)
(declare-fun S3 () Int)
(define-fun power2 ((x Int)) Bool
  (or (= x 1024) (= x 512) (= x 256) (= x 128) (= x 64) (= x 32) (= x 16) (= x 8) (= x 4) (= x 2) (= x 1)))
(assert (or
 (= X19 (+ S0 S1))
 (= X19 (- S0 S1))
 (= X19 (+ (* 33 S0) S1))
 (= X19 (- (* 33 S0) S1))
 (= X19 (- S0 (* 33 S1)))
 (= X19 (+ (* 33 S0) (* 33 S1)))
 (= X19 (- (* 33 S0) (* 33 S1)))
 (= X19 (+ (* 33 S0) (* 29 S1)))
 (= X19 (- (* 33 S0) (* 29 S1)))
 (= X19 (- (* 29 S0) (* 33 S1)))
 (= X19 (+ (* 33 S0) (* 233 S1)))
 (= X19 (- (* 33 S0) (* 233 S1)))
 (= X19 (- (* 233 S0) (* 33 S1)))
 (= X19 (+ (* 33 S0) (* 231 S1)))
 (= X19 (- (* 33 S0) (* 231 S1)))
 (= X19 (- (* 231 S0) (* 33 S1)))
 (= X19 (+ (* 33 S0) (* 23 S1)))
 (= X19 (- (* 33 S0) (* 23 S1)))
 (= X19 (- (* 23 S0) (* 33 S1)))
 (= X19 (+ (* 33 S0) (* 199 S1)))
 (= X19 (- (* 33 S0) (* 199 S1)))
 (= X19 (- (* 199 S0) (* 33 S1)))
 (= X19 (+ (* 33 S0) (* 185 S1)))
 (= X19 (- (* 33 S0) (* 185 S1)))
 (= X19 (- (* 185 S0) (* 33 S1)))
 (= X19 (+ (* 33 S0) (* 71 S1)))
 (= X19 (- (* 33 S0) (* 71 S1)))
 (= X19 (- (* 71 S0) (* 33 S1)))
 (= X19 (+ (* 33 S0) (* 145 S1)))
 (= X19 (- (* 33 S0) (* 145 S1)))
 (= X19 (- (* 145 S0) (* 33 S1)))
 (= X19 (+ (* 33 S0) (* 173 S1)))
 (= X19 (- (* 33 S0) (* 173 S1)))
 (= X19 (- (* 173 S0) (* 33 S1)))
 (= X19 (+ (* 33 S0) (* 213 S1)))
 (= X19 (- (* 33 S0) (* 213 S1)))
 (= X19 (- (* 213 S0) (* 33 S1)))
 (= X19 (+ (* 33 S0) (* 393 S1)))
 (= X19 (- (* 33 S0) (* 393 S1)))
 (= X19 (- (* 393 S0) (* 33 S1)))
 (= X19 (+ (* 33 S0) (* 525 S1)))
 (= X19 (- (* 33 S0) (* 525 S1)))
 (= X19 (- (* 525 S0) (* 33 S1)))
 (= X19 (+ (* 33 S0) (* 509 S1)))
 (= X19 (- (* 33 S0) (* 509 S1)))
 (= X19 (- (* 509 S0) (* 33 S1)))
 (= X19 (+ (* 33 S0) (* 573 S1)))
 (= X19 (- (* 33 S0) (* 573 S1)))
 (= X19 (- (* 573 S0) (* 33 S1)))
 (= X19 (+ (* 33 S0) (* 813 S1)))
 (= X19 (- (* 33 S0) (* 813 S1)))
 (= X19 (- (* 813 S0) (* 33 S1)))
 (= X19 (+ (* 33 S0) (* 623 S1)))
 (= X19 (- (* 33 S0) (* 623 S1)))
 (= X19 (- (* 623 S0) (* 33 S1)))
 (= X19 (+ (* 33 S0) (* 863 S1)))
 (= X19 (- (* 33 S0) (* 863 S1)))
 (= X19 (- (* 863 S0) (* 33 S1)))
 (= X19 (+ (* 33 S0) (* 1005 S1)))
 (= X19 (- (* 33 S0) (* 1005 S1)))
 (= X19 (- (* 1005 S0) (* 33 S1)))
 (= X19 (+ (* 29 S0) S1))
 (= X19 (- (* 29 S0) S1))
 (= X19 (- S0 (* 29 S1)))
 (= X19 (+ (* 29 S0) (* 29 S1)))
 (= X19 (- (* 29 S0) (* 29 S1)))
 (= X19 (+ (* 29 S0) (* 233 S1)))
 (= X19 (- (* 29 S0) (* 233 S1)))
 (= X19 (- (* 233 S0) (* 29 S1)))
 (= X19 (+ (* 29 S0) (* 231 S1)))
 (= X19 (- (* 29 S0) (* 231 S1)))
 (= X19 (- (* 231 S0) (* 29 S1)))
 (= X19 (+ (* 29 S0) (* 23 S1)))
 (= X19 (- (* 29 S0) (* 23 S1)))
 (= X19 (- (* 23 S0) (* 29 S1)))
 (= X19 (+ (* 29 S0) (* 199 S1)))
 (= X19 (- (* 29 S0) (* 199 S1)))
 (= X19 (- (* 199 S0) (* 29 S1)))
 (= X19 (+ (* 29 S0) (* 185 S1)))
 (= X19 (- (* 29 S0) (* 185 S1)))
 (= X19 (- (* 185 S0) (* 29 S1)))
 (= X19 (+ (* 29 S0) (* 71 S1)))
 (= X19 (- (* 29 S0) (* 71 S1)))
 (= X19 (- (* 71 S0) (* 29 S1)))
 (= X19 (+ (* 29 S0) (* 145 S1)))
 (= X19 (- (* 29 S0) (* 145 S1)))
 (= X19 (- (* 145 S0) (* 29 S1)))
 (= X19 (+ (* 29 S0) (* 173 S1)))
 (= X19 (- (* 29 S0) (* 173 S1)))
 (= X19 (- (* 173 S0) (* 29 S1)))
 (= X19 (+ (* 29 S0) (* 213 S1)))
 (= X19 (- (* 29 S0) (* 213 S1)))
 (= X19 (- (* 213 S0) (* 29 S1)))
 (= X19 (+ (* 29 S0) (* 393 S1)))
 (= X19 (- (* 29 S0) (* 393 S1)))
 (= X19 (- (* 393 S0) (* 29 S1)))
 (= X19 (+ (* 29 S0) (* 525 S1)))
 (= X19 (- (* 29 S0) (* 525 S1)))
 (= X19 (- (* 525 S0) (* 29 S1)))
 (= X19 (+ (* 29 S0) (* 509 S1)))
 (= X19 (- (* 29 S0) (* 509 S1)))
 (= X19 (- (* 509 S0) (* 29 S1)))
 (= X19 (+ (* 29 S0) (* 573 S1)))
 (= X19 (- (* 29 S0) (* 573 S1)))
 (= X19 (- (* 573 S0) (* 29 S1)))
 (= X19 (+ (* 29 S0) (* 813 S1)))
 (= X19 (- (* 29 S0) (* 813 S1)))
 (= X19 (- (* 813 S0) (* 29 S1)))
 (= X19 (+ (* 29 S0) (* 623 S1)))
 (= X19 (- (* 29 S0) (* 623 S1)))
 (= X19 (- (* 623 S0) (* 29 S1)))
 (= X19 (+ (* 29 S0) (* 863 S1)))
 (= X19 (- (* 29 S0) (* 863 S1)))
 (= X19 (- (* 863 S0) (* 29 S1)))
 (= X19 (+ (* 29 S0) (* 1005 S1)))
 (= X19 (- (* 29 S0) (* 1005 S1)))
 (= X19 (- (* 1005 S0) (* 29 S1)))
 (= X19 (+ (* 233 S0) S1))
 (= X19 (- (* 233 S0) S1))
 (= X19 (- S0 (* 233 S1)))
 (= X19 (+ (* 233 S0) (* 233 S1)))
 (= X19 (- (* 233 S0) (* 233 S1)))
 (= X19 (+ (* 233 S0) (* 231 S1)))
 (= X19 (- (* 233 S0) (* 231 S1)))
 (= X19 (- (* 231 S0) (* 233 S1)))
 (= X19 (+ (* 233 S0) (* 23 S1)))
 (= X19 (- (* 233 S0) (* 23 S1)))
 (= X19 (- (* 23 S0) (* 233 S1)))
 (= X19 (+ (* 233 S0) (* 199 S1)))
 (= X19 (- (* 233 S0) (* 199 S1)))
 (= X19 (- (* 199 S0) (* 233 S1)))
 (= X19 (+ (* 233 S0) (* 185 S1)))
 (= X19 (- (* 233 S0) (* 185 S1)))
 (= X19 (- (* 185 S0) (* 233 S1)))
 (= X19 (+ (* 233 S0) (* 71 S1)))
 (= X19 (- (* 233 S0) (* 71 S1)))
 (= X19 (- (* 71 S0) (* 233 S1)))
 (= X19 (+ (* 233 S0) (* 145 S1)))
 (= X19 (- (* 233 S0) (* 145 S1)))
 (= X19 (- (* 145 S0) (* 233 S1)))
 (= X19 (+ (* 233 S0) (* 173 S1)))
 (= X19 (- (* 233 S0) (* 173 S1)))
 (= X19 (- (* 173 S0) (* 233 S1)))
 (= X19 (+ (* 233 S0) (* 213 S1)))
 (= X19 (- (* 233 S0) (* 213 S1)))
 (= X19 (- (* 213 S0) (* 233 S1)))
 (= X19 (+ (* 233 S0) (* 393 S1)))
 (= X19 (- (* 233 S0) (* 393 S1)))
 (= X19 (- (* 393 S0) (* 233 S1)))
 (= X19 (+ (* 233 S0) (* 525 S1)))
 (= X19 (- (* 233 S0) (* 525 S1)))
 (= X19 (- (* 525 S0) (* 233 S1)))
 (= X19 (+ (* 233 S0) (* 509 S1)))
 (= X19 (- (* 233 S0) (* 509 S1)))
 (= X19 (- (* 509 S0) (* 233 S1)))
 (= X19 (+ (* 233 S0) (* 573 S1)))
 (= X19 (- (* 233 S0) (* 573 S1)))
 (= X19 (- (* 573 S0) (* 233 S1)))
 (= X19 (+ (* 233 S0) (* 813 S1)))
 (= X19 (- (* 233 S0) (* 813 S1)))
 (= X19 (- (* 813 S0) (* 233 S1)))
 (= X19 (+ (* 233 S0) (* 623 S1)))
 (= X19 (- (* 233 S0) (* 623 S1)))
 (= X19 (- (* 623 S0) (* 233 S1)))
 (= X19 (+ (* 233 S0) (* 863 S1)))
 (= X19 (- (* 233 S0) (* 863 S1)))
 (= X19 (- (* 863 S0) (* 233 S1)))
 (= X19 (+ (* 233 S0) (* 1005 S1)))
 (= X19 (- (* 233 S0) (* 1005 S1)))
 (= X19 (- (* 1005 S0) (* 233 S1)))
 (= X19 (+ (* 231 S0) S1))
 (= X19 (- (* 231 S0) S1))
 (= X19 (- S0 (* 231 S1)))
 (= X19 (+ (* 231 S0) (* 231 S1)))
 (= X19 (- (* 231 S0) (* 231 S1)))
 (= X19 (+ (* 231 S0) (* 23 S1)))
 (= X19 (- (* 231 S0) (* 23 S1)))
 (= X19 (- (* 23 S0) (* 231 S1)))
 (= X19 (+ (* 231 S0) (* 199 S1)))
 (= X19 (- (* 231 S0) (* 199 S1)))
 (= X19 (- (* 199 S0) (* 231 S1)))
 (= X19 (+ (* 231 S0) (* 185 S1)))
 (= X19 (- (* 231 S0) (* 185 S1)))
 (= X19 (- (* 185 S0) (* 231 S1)))
 (= X19 (+ (* 231 S0) (* 71 S1)))
 (= X19 (- (* 231 S0) (* 71 S1)))
 (= X19 (- (* 71 S0) (* 231 S1)))
 (= X19 (+ (* 231 S0) (* 145 S1)))
 (= X19 (- (* 231 S0) (* 145 S1)))
 (= X19 (- (* 145 S0) (* 231 S1)))
 (= X19 (+ (* 231 S0) (* 173 S1)))
 (= X19 (- (* 231 S0) (* 173 S1)))
 (= X19 (- (* 173 S0) (* 231 S1)))
 (= X19 (+ (* 231 S0) (* 213 S1)))
 (= X19 (- (* 231 S0) (* 213 S1)))
 (= X19 (- (* 213 S0) (* 231 S1)))
 (= X19 (+ (* 231 S0) (* 393 S1)))
 (= X19 (- (* 231 S0) (* 393 S1)))
 (= X19 (- (* 393 S0) (* 231 S1)))
 (= X19 (+ (* 231 S0) (* 525 S1)))
 (= X19 (- (* 231 S0) (* 525 S1)))
 (= X19 (- (* 525 S0) (* 231 S1)))
 (= X19 (+ (* 231 S0) (* 509 S1)))
 (= X19 (- (* 231 S0) (* 509 S1)))
 (= X19 (- (* 509 S0) (* 231 S1)))
 (= X19 (+ (* 231 S0) (* 573 S1)))
 (= X19 (- (* 231 S0) (* 573 S1)))
 (= X19 (- (* 573 S0) (* 231 S1)))
 (= X19 (+ (* 231 S0) (* 813 S1)))
 (= X19 (- (* 231 S0) (* 813 S1)))
 (= X19 (- (* 813 S0) (* 231 S1)))
 (= X19 (+ (* 231 S0) (* 623 S1)))
 (= X19 (- (* 231 S0) (* 623 S1)))
 (= X19 (- (* 623 S0) (* 231 S1)))
 (= X19 (+ (* 231 S0) (* 863 S1)))
 (= X19 (- (* 231 S0) (* 863 S1)))
 (= X19 (- (* 863 S0) (* 231 S1)))
 (= X19 (+ (* 231 S0) (* 1005 S1)))
 (= X19 (- (* 231 S0) (* 1005 S1)))
 (= X19 (- (* 1005 S0) (* 231 S1)))
 (= X19 (+ (* 23 S0) S1))
 (= X19 (- (* 23 S0) S1))
 (= X19 (- S0 (* 23 S1)))
 (= X19 (+ (* 23 S0) (* 23 S1)))
 (= X19 (- (* 23 S0) (* 23 S1)))
 (= X19 (+ (* 23 S0) (* 199 S1)))
 (= X19 (- (* 23 S0) (* 199 S1)))
 (= X19 (- (* 199 S0) (* 23 S1)))
 (= X19 (+ (* 23 S0) (* 185 S1)))
 (= X19 (- (* 23 S0) (* 185 S1)))
 (= X19 (- (* 185 S0) (* 23 S1)))
 (= X19 (+ (* 23 S0) (* 71 S1)))
 (= X19 (- (* 23 S0) (* 71 S1)))
 (= X19 (- (* 71 S0) (* 23 S1)))
 (= X19 (+ (* 23 S0) (* 145 S1)))
 (= X19 (- (* 23 S0) (* 145 S1)))
 (= X19 (- (* 145 S0) (* 23 S1)))
 (= X19 (+ (* 23 S0) (* 173 S1)))
 (= X19 (- (* 23 S0) (* 173 S1)))
 (= X19 (- (* 173 S0) (* 23 S1)))
 (= X19 (+ (* 23 S0) (* 213 S1)))
 (= X19 (- (* 23 S0) (* 213 S1)))
 (= X19 (- (* 213 S0) (* 23 S1)))
 (= X19 (+ (* 23 S0) (* 393 S1)))
 (= X19 (- (* 23 S0) (* 393 S1)))
 (= X19 (- (* 393 S0) (* 23 S1)))
 (= X19 (+ (* 23 S0) (* 525 S1)))
 (= X19 (- (* 23 S0) (* 525 S1)))
 (= X19 (- (* 525 S0) (* 23 S1)))
 (= X19 (+ (* 23 S0) (* 509 S1)))
 (= X19 (- (* 23 S0) (* 509 S1)))
 (= X19 (- (* 509 S0) (* 23 S1)))
 (= X19 (+ (* 23 S0) (* 573 S1)))
 (= X19 (- (* 23 S0) (* 573 S1)))
 (= X19 (- (* 573 S0) (* 23 S1)))
 (= X19 (+ (* 23 S0) (* 813 S1)))
 (= X19 (- (* 23 S0) (* 813 S1)))
 (= X19 (- (* 813 S0) (* 23 S1)))
 (= X19 (+ (* 23 S0) (* 623 S1)))
 (= X19 (- (* 23 S0) (* 623 S1)))
 (= X19 (- (* 623 S0) (* 23 S1)))
 (= X19 (+ (* 23 S0) (* 863 S1)))
 (= X19 (- (* 23 S0) (* 863 S1)))
 (= X19 (- (* 863 S0) (* 23 S1)))
 (= X19 (+ (* 23 S0) (* 1005 S1)))
 (= X19 (- (* 23 S0) (* 1005 S1)))
 (= X19 (- (* 1005 S0) (* 23 S1)))
 (= X19 (+ (* 199 S0) S1))
 (= X19 (- (* 199 S0) S1))
 (= X19 (- S0 (* 199 S1)))
 (= X19 (+ (* 199 S0) (* 199 S1)))
 (= X19 (- (* 199 S0) (* 199 S1)))
 (= X19 (+ (* 199 S0) (* 185 S1)))
 (= X19 (- (* 199 S0) (* 185 S1)))
 (= X19 (- (* 185 S0) (* 199 S1)))
 (= X19 (+ (* 199 S0) (* 71 S1)))
 (= X19 (- (* 199 S0) (* 71 S1)))
 (= X19 (- (* 71 S0) (* 199 S1)))
 (= X19 (+ (* 199 S0) (* 145 S1)))
 (= X19 (- (* 199 S0) (* 145 S1)))
 (= X19 (- (* 145 S0) (* 199 S1)))
 (= X19 (+ (* 199 S0) (* 173 S1)))
 (= X19 (- (* 199 S0) (* 173 S1)))
 (= X19 (- (* 173 S0) (* 199 S1)))
 (= X19 (+ (* 199 S0) (* 213 S1)))
 (= X19 (- (* 199 S0) (* 213 S1)))
 (= X19 (- (* 213 S0) (* 199 S1)))
 (= X19 (+ (* 199 S0) (* 393 S1)))
 (= X19 (- (* 199 S0) (* 393 S1)))
 (= X19 (- (* 393 S0) (* 199 S1)))
 (= X19 (+ (* 199 S0) (* 525 S1)))
 (= X19 (- (* 199 S0) (* 525 S1)))
 (= X19 (- (* 525 S0) (* 199 S1)))
 (= X19 (+ (* 199 S0) (* 509 S1)))
 (= X19 (- (* 199 S0) (* 509 S1)))
 (= X19 (- (* 509 S0) (* 199 S1)))
 (= X19 (+ (* 199 S0) (* 573 S1)))
 (= X19 (- (* 199 S0) (* 573 S1)))
 (= X19 (- (* 573 S0) (* 199 S1)))
 (= X19 (+ (* 199 S0) (* 813 S1)))
 (= X19 (- (* 199 S0) (* 813 S1)))
 (= X19 (- (* 813 S0) (* 199 S1)))
 (= X19 (+ (* 199 S0) (* 623 S1)))
 (= X19 (- (* 199 S0) (* 623 S1)))
 (= X19 (- (* 623 S0) (* 199 S1)))
 (= X19 (+ (* 199 S0) (* 863 S1)))
 (= X19 (- (* 199 S0) (* 863 S1)))
 (= X19 (- (* 863 S0) (* 199 S1)))
 (= X19 (+ (* 199 S0) (* 1005 S1)))
 (= X19 (- (* 199 S0) (* 1005 S1)))
 (= X19 (- (* 1005 S0) (* 199 S1)))
 (= X19 (+ (* 185 S0) S1))
 (= X19 (- (* 185 S0) S1))
 (= X19 (- S0 (* 185 S1)))
 (= X19 (+ (* 185 S0) (* 185 S1)))
 (= X19 (- (* 185 S0) (* 185 S1)))
 (= X19 (+ (* 185 S0) (* 71 S1)))
 (= X19 (- (* 185 S0) (* 71 S1)))
 (= X19 (- (* 71 S0) (* 185 S1)))
 (= X19 (+ (* 185 S0) (* 145 S1)))
 (= X19 (- (* 185 S0) (* 145 S1)))
 (= X19 (- (* 145 S0) (* 185 S1)))
 (= X19 (+ (* 185 S0) (* 173 S1)))
 (= X19 (- (* 185 S0) (* 173 S1)))
 (= X19 (- (* 173 S0) (* 185 S1)))
 (= X19 (+ (* 185 S0) (* 213 S1)))
 (= X19 (- (* 185 S0) (* 213 S1)))
 (= X19 (- (* 213 S0) (* 185 S1)))
 (= X19 (+ (* 185 S0) (* 393 S1)))
 (= X19 (- (* 185 S0) (* 393 S1)))
 (= X19 (- (* 393 S0) (* 185 S1)))
 (= X19 (+ (* 185 S0) (* 525 S1)))
 (= X19 (- (* 185 S0) (* 525 S1)))
 (= X19 (- (* 525 S0) (* 185 S1)))
 (= X19 (+ (* 185 S0) (* 509 S1)))
 (= X19 (- (* 185 S0) (* 509 S1)))
 (= X19 (- (* 509 S0) (* 185 S1)))
 (= X19 (+ (* 185 S0) (* 573 S1)))
 (= X19 (- (* 185 S0) (* 573 S1)))
 (= X19 (- (* 573 S0) (* 185 S1)))
 (= X19 (+ (* 185 S0) (* 813 S1)))
 (= X19 (- (* 185 S0) (* 813 S1)))
 (= X19 (- (* 813 S0) (* 185 S1)))
 (= X19 (+ (* 185 S0) (* 623 S1)))
 (= X19 (- (* 185 S0) (* 623 S1)))
 (= X19 (- (* 623 S0) (* 185 S1)))
 (= X19 (+ (* 185 S0) (* 863 S1)))
 (= X19 (- (* 185 S0) (* 863 S1)))
 (= X19 (- (* 863 S0) (* 185 S1)))
 (= X19 (+ (* 185 S0) (* 1005 S1)))
 (= X19 (- (* 185 S0) (* 1005 S1)))
 (= X19 (- (* 1005 S0) (* 185 S1)))
 (= X19 (+ (* 71 S0) S1))
 (= X19 (- (* 71 S0) S1))
 (= X19 (- S0 (* 71 S1)))
 (= X19 (+ (* 71 S0) (* 71 S1)))
 (= X19 (- (* 71 S0) (* 71 S1)))
 (= X19 (+ (* 71 S0) (* 145 S1)))
 (= X19 (- (* 71 S0) (* 145 S1)))
 (= X19 (- (* 145 S0) (* 71 S1)))
 (= X19 (+ (* 71 S0) (* 173 S1)))
 (= X19 (- (* 71 S0) (* 173 S1)))
 (= X19 (- (* 173 S0) (* 71 S1)))
 (= X19 (+ (* 71 S0) (* 213 S1)))
 (= X19 (- (* 71 S0) (* 213 S1)))
 (= X19 (- (* 213 S0) (* 71 S1)))
 (= X19 (+ (* 71 S0) (* 393 S1)))
 (= X19 (- (* 71 S0) (* 393 S1)))
 (= X19 (- (* 393 S0) (* 71 S1)))
 (= X19 (+ (* 71 S0) (* 525 S1)))
 (= X19 (- (* 71 S0) (* 525 S1)))
 (= X19 (- (* 525 S0) (* 71 S1)))
 (= X19 (+ (* 71 S0) (* 509 S1)))
 (= X19 (- (* 71 S0) (* 509 S1)))
 (= X19 (- (* 509 S0) (* 71 S1)))
 (= X19 (+ (* 71 S0) (* 573 S1)))
 (= X19 (- (* 71 S0) (* 573 S1)))
 (= X19 (- (* 573 S0) (* 71 S1)))
 (= X19 (+ (* 71 S0) (* 813 S1)))
 (= X19 (- (* 71 S0) (* 813 S1)))
 (= X19 (- (* 813 S0) (* 71 S1)))
 (= X19 (+ (* 71 S0) (* 623 S1)))
 (= X19 (- (* 71 S0) (* 623 S1)))
 (= X19 (- (* 623 S0) (* 71 S1)))
 (= X19 (+ (* 71 S0) (* 863 S1)))
 (= X19 (- (* 71 S0) (* 863 S1)))
 (= X19 (- (* 863 S0) (* 71 S1)))
 (= X19 (+ (* 71 S0) (* 1005 S1)))
 (= X19 (- (* 71 S0) (* 1005 S1)))
 (= X19 (- (* 1005 S0) (* 71 S1)))
 (= X19 (+ (* 145 S0) S1))
 (= X19 (- (* 145 S0) S1))
 (= X19 (- S0 (* 145 S1)))
 (= X19 (+ (* 145 S0) (* 145 S1)))
 (= X19 (- (* 145 S0) (* 145 S1)))
 (= X19 (+ (* 145 S0) (* 173 S1)))
 (= X19 (- (* 145 S0) (* 173 S1)))
 (= X19 (- (* 173 S0) (* 145 S1)))
 (= X19 (+ (* 145 S0) (* 213 S1)))
 (= X19 (- (* 145 S0) (* 213 S1)))
 (= X19 (- (* 213 S0) (* 145 S1)))
 (= X19 (+ (* 145 S0) (* 393 S1)))
 (= X19 (- (* 145 S0) (* 393 S1)))
 (= X19 (- (* 393 S0) (* 145 S1)))
 (= X19 (+ (* 145 S0) (* 525 S1)))
 (= X19 (- (* 145 S0) (* 525 S1)))
 (= X19 (- (* 525 S0) (* 145 S1)))
 (= X19 (+ (* 145 S0) (* 509 S1)))
 (= X19 (- (* 145 S0) (* 509 S1)))
 (= X19 (- (* 509 S0) (* 145 S1)))
 (= X19 (+ (* 145 S0) (* 573 S1)))
 (= X19 (- (* 145 S0) (* 573 S1)))
 (= X19 (- (* 573 S0) (* 145 S1)))
 (= X19 (+ (* 145 S0) (* 813 S1)))
 (= X19 (- (* 145 S0) (* 813 S1)))
 (= X19 (- (* 813 S0) (* 145 S1)))
 (= X19 (+ (* 145 S0) (* 623 S1)))
 (= X19 (- (* 145 S0) (* 623 S1)))
 (= X19 (- (* 623 S0) (* 145 S1)))
 (= X19 (+ (* 145 S0) (* 863 S1)))
 (= X19 (- (* 145 S0) (* 863 S1)))
 (= X19 (- (* 863 S0) (* 145 S1)))
 (= X19 (+ (* 145 S0) (* 1005 S1)))
 (= X19 (- (* 145 S0) (* 1005 S1)))
 (= X19 (- (* 1005 S0) (* 145 S1)))
 (= X19 (+ (* 173 S0) S1))
 (= X19 (- (* 173 S0) S1))
 (= X19 (- S0 (* 173 S1)))
 (= X19 (+ (* 173 S0) (* 173 S1)))
 (= X19 (- (* 173 S0) (* 173 S1)))
 (= X19 (+ (* 173 S0) (* 213 S1)))
 (= X19 (- (* 173 S0) (* 213 S1)))
 (= X19 (- (* 213 S0) (* 173 S1)))
 (= X19 (+ (* 173 S0) (* 393 S1)))
 (= X19 (- (* 173 S0) (* 393 S1)))
 (= X19 (- (* 393 S0) (* 173 S1)))
 (= X19 (+ (* 173 S0) (* 525 S1)))
 (= X19 (- (* 173 S0) (* 525 S1)))
 (= X19 (- (* 525 S0) (* 173 S1)))
 (= X19 (+ (* 173 S0) (* 509 S1)))
 (= X19 (- (* 173 S0) (* 509 S1)))
 (= X19 (- (* 509 S0) (* 173 S1)))
 (= X19 (+ (* 173 S0) (* 573 S1)))
 (= X19 (- (* 173 S0) (* 573 S1)))
 (= X19 (- (* 573 S0) (* 173 S1)))
 (= X19 (+ (* 173 S0) (* 813 S1)))
 (= X19 (- (* 173 S0) (* 813 S1)))
 (= X19 (- (* 813 S0) (* 173 S1)))
 (= X19 (+ (* 173 S0) (* 623 S1)))
 (= X19 (- (* 173 S0) (* 623 S1)))
 (= X19 (- (* 623 S0) (* 173 S1)))
 (= X19 (+ (* 173 S0) (* 863 S1)))
 (= X19 (- (* 173 S0) (* 863 S1)))
 (= X19 (- (* 863 S0) (* 173 S1)))
 (= X19 (+ (* 173 S0) (* 1005 S1)))
 (= X19 (- (* 173 S0) (* 1005 S1)))
 (= X19 (- (* 1005 S0) (* 173 S1)))
 (= X19 (+ (* 213 S0) S1))
 (= X19 (- (* 213 S0) S1))
 (= X19 (- S0 (* 213 S1)))
 (= X19 (+ (* 213 S0) (* 213 S1)))
 (= X19 (- (* 213 S0) (* 213 S1)))
 (= X19 (+ (* 213 S0) (* 393 S1)))
 (= X19 (- (* 213 S0) (* 393 S1)))
 (= X19 (- (* 393 S0) (* 213 S1)))
 (= X19 (+ (* 213 S0) (* 525 S1)))
 (= X19 (- (* 213 S0) (* 525 S1)))
 (= X19 (- (* 525 S0) (* 213 S1)))
 (= X19 (+ (* 213 S0) (* 509 S1)))
 (= X19 (- (* 213 S0) (* 509 S1)))
 (= X19 (- (* 509 S0) (* 213 S1)))
 (= X19 (+ (* 213 S0) (* 573 S1)))
 (= X19 (- (* 213 S0) (* 573 S1)))
 (= X19 (- (* 573 S0) (* 213 S1)))
 (= X19 (+ (* 213 S0) (* 813 S1)))
 (= X19 (- (* 213 S0) (* 813 S1)))
 (= X19 (- (* 813 S0) (* 213 S1)))
 (= X19 (+ (* 213 S0) (* 623 S1)))
 (= X19 (- (* 213 S0) (* 623 S1)))
 (= X19 (- (* 623 S0) (* 213 S1)))
 (= X19 (+ (* 213 S0) (* 863 S1)))
 (= X19 (- (* 213 S0) (* 863 S1)))
 (= X19 (- (* 863 S0) (* 213 S1)))
 (= X19 (+ (* 213 S0) (* 1005 S1)))
 (= X19 (- (* 213 S0) (* 1005 S1)))
 (= X19 (- (* 1005 S0) (* 213 S1)))
 (= X19 (+ (* 393 S0) S1))
 (= X19 (- (* 393 S0) S1))
 (= X19 (- S0 (* 393 S1)))
 (= X19 (+ (* 393 S0) (* 393 S1)))
 (= X19 (- (* 393 S0) (* 393 S1)))
 (= X19 (+ (* 393 S0) (* 525 S1)))
 (= X19 (- (* 393 S0) (* 525 S1)))
 (= X19 (- (* 525 S0) (* 393 S1)))
 (= X19 (+ (* 393 S0) (* 509 S1)))
 (= X19 (- (* 393 S0) (* 509 S1)))
 (= X19 (- (* 509 S0) (* 393 S1)))
 (= X19 (+ (* 393 S0) (* 573 S1)))
 (= X19 (- (* 393 S0) (* 573 S1)))
 (= X19 (- (* 573 S0) (* 393 S1)))
 (= X19 (+ (* 393 S0) (* 813 S1)))
 (= X19 (- (* 393 S0) (* 813 S1)))
 (= X19 (- (* 813 S0) (* 393 S1)))
 (= X19 (+ (* 393 S0) (* 623 S1)))
 (= X19 (- (* 393 S0) (* 623 S1)))
 (= X19 (- (* 623 S0) (* 393 S1)))
 (= X19 (+ (* 393 S0) (* 863 S1)))
 (= X19 (- (* 393 S0) (* 863 S1)))
 (= X19 (- (* 863 S0) (* 393 S1)))
 (= X19 (+ (* 393 S0) (* 1005 S1)))
 (= X19 (- (* 393 S0) (* 1005 S1)))
 (= X19 (- (* 1005 S0) (* 393 S1)))
 (= X19 (+ (* 525 S0) S1))
 (= X19 (- (* 525 S0) S1))
 (= X19 (- S0 (* 525 S1)))
 (= X19 (+ (* 525 S0) (* 525 S1)))
 (= X19 (- (* 525 S0) (* 525 S1)))
 (= X19 (+ (* 525 S0) (* 509 S1)))
 (= X19 (- (* 525 S0) (* 509 S1)))
 (= X19 (- (* 509 S0) (* 525 S1)))
 (= X19 (+ (* 525 S0) (* 573 S1)))
 (= X19 (- (* 525 S0) (* 573 S1)))
 (= X19 (- (* 573 S0) (* 525 S1)))
 (= X19 (+ (* 525 S0) (* 813 S1)))
 (= X19 (- (* 525 S0) (* 813 S1)))
 (= X19 (- (* 813 S0) (* 525 S1)))
 (= X19 (+ (* 525 S0) (* 623 S1)))
 (= X19 (- (* 525 S0) (* 623 S1)))
 (= X19 (- (* 623 S0) (* 525 S1)))
 (= X19 (+ (* 525 S0) (* 863 S1)))
 (= X19 (- (* 525 S0) (* 863 S1)))
 (= X19 (- (* 863 S0) (* 525 S1)))
 (= X19 (+ (* 525 S0) (* 1005 S1)))
 (= X19 (- (* 525 S0) (* 1005 S1)))
 (= X19 (- (* 1005 S0) (* 525 S1)))
 (= X19 (+ (* 509 S0) S1))
 (= X19 (- (* 509 S0) S1))
 (= X19 (- S0 (* 509 S1)))
 (= X19 (+ (* 509 S0) (* 509 S1)))
 (= X19 (- (* 509 S0) (* 509 S1)))
 (= X19 (+ (* 509 S0) (* 573 S1)))
 (= X19 (- (* 509 S0) (* 573 S1)))
 (= X19 (- (* 573 S0) (* 509 S1)))
 (= X19 (+ (* 509 S0) (* 813 S1)))
 (= X19 (- (* 509 S0) (* 813 S1)))
 (= X19 (- (* 813 S0) (* 509 S1)))
 (= X19 (+ (* 509 S0) (* 623 S1)))
 (= X19 (- (* 509 S0) (* 623 S1)))
 (= X19 (- (* 623 S0) (* 509 S1)))
 (= X19 (+ (* 509 S0) (* 863 S1)))
 (= X19 (- (* 509 S0) (* 863 S1)))
 (= X19 (- (* 863 S0) (* 509 S1)))
 (= X19 (+ (* 509 S0) (* 1005 S1)))
 (= X19 (- (* 509 S0) (* 1005 S1)))
 (= X19 (- (* 1005 S0) (* 509 S1)))
 (= X19 (+ (* 573 S0) S1))
 (= X19 (- (* 573 S0) S1))
 (= X19 (- S0 (* 573 S1)))
 (= X19 (+ (* 573 S0) (* 573 S1)))
 (= X19 (- (* 573 S0) (* 573 S1)))
 (= X19 (+ (* 573 S0) (* 813 S1)))
 (= X19 (- (* 573 S0) (* 813 S1)))
 (= X19 (- (* 813 S0) (* 573 S1)))
 (= X19 (+ (* 573 S0) (* 623 S1)))
 (= X19 (- (* 573 S0) (* 623 S1)))
 (= X19 (- (* 623 S0) (* 573 S1)))
 (= X19 (+ (* 573 S0) (* 863 S1)))
 (= X19 (- (* 573 S0) (* 863 S1)))
 (= X19 (- (* 863 S0) (* 573 S1)))
 (= X19 (+ (* 573 S0) (* 1005 S1)))
 (= X19 (- (* 573 S0) (* 1005 S1)))
 (= X19 (- (* 1005 S0) (* 573 S1)))
 (= X19 (+ (* 813 S0) S1))
 (= X19 (- (* 813 S0) S1))
 (= X19 (- S0 (* 813 S1)))
 (= X19 (+ (* 813 S0) (* 813 S1)))
 (= X19 (- (* 813 S0) (* 813 S1)))
 (= X19 (+ (* 813 S0) (* 623 S1)))
 (= X19 (- (* 813 S0) (* 623 S1)))
 (= X19 (- (* 623 S0) (* 813 S1)))
 (= X19 (+ (* 813 S0) (* 863 S1)))
 (= X19 (- (* 813 S0) (* 863 S1)))
 (= X19 (- (* 863 S0) (* 813 S1)))
 (= X19 (+ (* 813 S0) (* 1005 S1)))
 (= X19 (- (* 813 S0) (* 1005 S1)))
 (= X19 (- (* 1005 S0) (* 813 S1)))
 (= X19 (+ (* 623 S0) S1))
 (= X19 (- (* 623 S0) S1))
 (= X19 (- S0 (* 623 S1)))
 (= X19 (+ (* 623 S0) (* 623 S1)))
 (= X19 (- (* 623 S0) (* 623 S1)))
 (= X19 (+ (* 623 S0) (* 863 S1)))
 (= X19 (- (* 623 S0) (* 863 S1)))
 (= X19 (- (* 863 S0) (* 623 S1)))
 (= X19 (+ (* 623 S0) (* 1005 S1)))
 (= X19 (- (* 623 S0) (* 1005 S1)))
 (= X19 (- (* 1005 S0) (* 623 S1)))
 (= X19 (+ (* 863 S0) S1))
 (= X19 (- (* 863 S0) S1))
 (= X19 (- S0 (* 863 S1)))
 (= X19 (+ (* 863 S0) (* 863 S1)))
 (= X19 (- (* 863 S0) (* 863 S1)))
 (= X19 (+ (* 863 S0) (* 1005 S1)))
 (= X19 (- (* 863 S0) (* 1005 S1)))
 (= X19 (- (* 1005 S0) (* 863 S1)))
 (= X19 (+ (* 1005 S0) S1))
 (= X19 (- (* 1005 S0) S1))
 (= X19 (- S0 (* 1005 S1)))
 (= X19 (+ (* 1005 S0) (* 1005 S1)))
 (= X19 (- (* 1005 S0) (* 1005 S1)))
))
(assert (and (> X19 0) (< X19 2048) (power2 S0) (power2 S1)))
(assert (or
 (= X20 (+ (* 33 S2) S3))
 (= X20 (- (* 33 S2) S3))
 (= X20 (- S2 (* 33 S3)))
 (= X20 (+ (* 33 S2) (* 33 S3)))
 (= X20 (- (* 33 S2) (* 33 S3)))
 (= X20 (+ (* 33 S2) (* 29 S3)))
 (= X20 (- (* 33 S2) (* 29 S3)))
 (= X20 (- (* 29 S2) (* 33 S3)))
 (= X20 (+ (* 33 S2) (* 233 S3)))
 (= X20 (- (* 33 S2) (* 233 S3)))
 (= X20 (- (* 233 S2) (* 33 S3)))
 (= X20 (+ (* 33 S2) (* 231 S3)))
 (= X20 (- (* 33 S2) (* 231 S3)))
 (= X20 (- (* 231 S2) (* 33 S3)))
 (= X20 (+ (* 33 S2) (* 23 S3)))
 (= X20 (- (* 33 S2) (* 23 S3)))
 (= X20 (- (* 23 S2) (* 33 S3)))
 (= X20 (+ (* 33 S2) (* 199 S3)))
 (= X20 (- (* 33 S2) (* 199 S3)))
 (= X20 (- (* 199 S2) (* 33 S3)))
 (= X20 (+ (* 33 S2) (* 185 S3)))
 (= X20 (- (* 33 S2) (* 185 S3)))
 (= X20 (- (* 185 S2) (* 33 S3)))
 (= X20 (+ (* 33 S2) (* 71 S3)))
 (= X20 (- (* 33 S2) (* 71 S3)))
 (= X20 (- (* 71 S2) (* 33 S3)))
 (= X20 (+ (* 33 S2) (* 145 S3)))
 (= X20 (- (* 33 S2) (* 145 S3)))
 (= X20 (- (* 145 S2) (* 33 S3)))
 (= X20 (+ (* 33 S2) (* 173 S3)))
 (= X20 (- (* 33 S2) (* 173 S3)))
 (= X20 (- (* 173 S2) (* 33 S3)))
 (= X20 (+ (* 33 S2) (* 213 S3)))
 (= X20 (- (* 33 S2) (* 213 S3)))
 (= X20 (- (* 213 S2) (* 33 S3)))
 (= X20 (+ (* 33 S2) (* 393 S3)))
 (= X20 (- (* 33 S2) (* 393 S3)))
 (= X20 (- (* 393 S2) (* 33 S3)))
 (= X20 (+ (* 33 S2) (* 525 S3)))
 (= X20 (- (* 33 S2) (* 525 S3)))
 (= X20 (- (* 525 S2) (* 33 S3)))
 (= X20 (+ (* 33 S2) (* 509 S3)))
 (= X20 (- (* 33 S2) (* 509 S3)))
 (= X20 (- (* 509 S2) (* 33 S3)))
 (= X20 (+ (* 33 S2) (* 573 S3)))
 (= X20 (- (* 33 S2) (* 573 S3)))
 (= X20 (- (* 573 S2) (* 33 S3)))
 (= X20 (+ (* 33 S2) (* 813 S3)))
 (= X20 (- (* 33 S2) (* 813 S3)))
 (= X20 (- (* 813 S2) (* 33 S3)))
 (= X20 (+ (* 33 S2) (* 623 S3)))
 (= X20 (- (* 33 S2) (* 623 S3)))
 (= X20 (- (* 623 S2) (* 33 S3)))
 (= X20 (+ (* 33 S2) (* 863 S3)))
 (= X20 (- (* 33 S2) (* 863 S3)))
 (= X20 (- (* 863 S2) (* 33 S3)))
 (= X20 (+ (* 33 S2) (* 1005 S3)))
 (= X20 (- (* 33 S2) (* 1005 S3)))
 (= X20 (- (* 1005 S2) (* 33 S3)))
 (= X20 (+ (* 33 S2) (* X19 S3)))
 (= X20 (- (* 33 S2) (* X19 S3)))
 (= X20 (- (* X19 S2) (* 33 S3)))
 (= X20 (+ (* 29 S2) S3))
 (= X20 (- (* 29 S2) S3))
 (= X20 (- S2 (* 29 S3)))
 (= X20 (+ (* 29 S2) (* 29 S3)))
 (= X20 (- (* 29 S2) (* 29 S3)))
 (= X20 (+ (* 29 S2) (* 233 S3)))
 (= X20 (- (* 29 S2) (* 233 S3)))
 (= X20 (- (* 233 S2) (* 29 S3)))
 (= X20 (+ (* 29 S2) (* 231 S3)))
 (= X20 (- (* 29 S2) (* 231 S3)))
 (= X20 (- (* 231 S2) (* 29 S3)))
 (= X20 (+ (* 29 S2) (* 23 S3)))
 (= X20 (- (* 29 S2) (* 23 S3)))
 (= X20 (- (* 23 S2) (* 29 S3)))
 (= X20 (+ (* 29 S2) (* 199 S3)))
 (= X20 (- (* 29 S2) (* 199 S3)))
 (= X20 (- (* 199 S2) (* 29 S3)))
 (= X20 (+ (* 29 S2) (* 185 S3)))
 (= X20 (- (* 29 S2) (* 185 S3)))
 (= X20 (- (* 185 S2) (* 29 S3)))
 (= X20 (+ (* 29 S2) (* 71 S3)))
 (= X20 (- (* 29 S2) (* 71 S3)))
 (= X20 (- (* 71 S2) (* 29 S3)))
 (= X20 (+ (* 29 S2) (* 145 S3)))
 (= X20 (- (* 29 S2) (* 145 S3)))
 (= X20 (- (* 145 S2) (* 29 S3)))
 (= X20 (+ (* 29 S2) (* 173 S3)))
 (= X20 (- (* 29 S2) (* 173 S3)))
 (= X20 (- (* 173 S2) (* 29 S3)))
 (= X20 (+ (* 29 S2) (* 213 S3)))
 (= X20 (- (* 29 S2) (* 213 S3)))
 (= X20 (- (* 213 S2) (* 29 S3)))
 (= X20 (+ (* 29 S2) (* 393 S3)))
 (= X20 (- (* 29 S2) (* 393 S3)))
 (= X20 (- (* 393 S2) (* 29 S3)))
 (= X20 (+ (* 29 S2) (* 525 S3)))
 (= X20 (- (* 29 S2) (* 525 S3)))
 (= X20 (- (* 525 S2) (* 29 S3)))
 (= X20 (+ (* 29 S2) (* 509 S3)))
 (= X20 (- (* 29 S2) (* 509 S3)))
 (= X20 (- (* 509 S2) (* 29 S3)))
 (= X20 (+ (* 29 S2) (* 573 S3)))
 (= X20 (- (* 29 S2) (* 573 S3)))
 (= X20 (- (* 573 S2) (* 29 S3)))
 (= X20 (+ (* 29 S2) (* 813 S3)))
 (= X20 (- (* 29 S2) (* 813 S3)))
 (= X20 (- (* 813 S2) (* 29 S3)))
 (= X20 (+ (* 29 S2) (* 623 S3)))
 (= X20 (- (* 29 S2) (* 623 S3)))
 (= X20 (- (* 623 S2) (* 29 S3)))
 (= X20 (+ (* 29 S2) (* 863 S3)))
 (= X20 (- (* 29 S2) (* 863 S3)))
 (= X20 (- (* 863 S2) (* 29 S3)))
 (= X20 (+ (* 29 S2) (* 1005 S3)))
 (= X20 (- (* 29 S2) (* 1005 S3)))
 (= X20 (- (* 1005 S2) (* 29 S3)))
 (= X20 (+ (* 29 S2) (* X19 S3)))
 (= X20 (- (* 29 S2) (* X19 S3)))
 (= X20 (- (* X19 S2) (* 29 S3)))
 (= X20 (+ (* 233 S2) S3))
 (= X20 (- (* 233 S2) S3))
 (= X20 (- S2 (* 233 S3)))
 (= X20 (+ (* 233 S2) (* 233 S3)))
 (= X20 (- (* 233 S2) (* 233 S3)))
 (= X20 (+ (* 233 S2) (* 231 S3)))
 (= X20 (- (* 233 S2) (* 231 S3)))
 (= X20 (- (* 231 S2) (* 233 S3)))
 (= X20 (+ (* 233 S2) (* 23 S3)))
 (= X20 (- (* 233 S2) (* 23 S3)))
 (= X20 (- (* 23 S2) (* 233 S3)))
 (= X20 (+ (* 233 S2) (* 199 S3)))
 (= X20 (- (* 233 S2) (* 199 S3)))
 (= X20 (- (* 199 S2) (* 233 S3)))
 (= X20 (+ (* 233 S2) (* 185 S3)))
 (= X20 (- (* 233 S2) (* 185 S3)))
 (= X20 (- (* 185 S2) (* 233 S3)))
 (= X20 (+ (* 233 S2) (* 71 S3)))
 (= X20 (- (* 233 S2) (* 71 S3)))
 (= X20 (- (* 71 S2) (* 233 S3)))
 (= X20 (+ (* 233 S2) (* 145 S3)))
 (= X20 (- (* 233 S2) (* 145 S3)))
 (= X20 (- (* 145 S2) (* 233 S3)))
 (= X20 (+ (* 233 S2) (* 173 S3)))
 (= X20 (- (* 233 S2) (* 173 S3)))
 (= X20 (- (* 173 S2) (* 233 S3)))
 (= X20 (+ (* 233 S2) (* 213 S3)))
 (= X20 (- (* 233 S2) (* 213 S3)))
 (= X20 (- (* 213 S2) (* 233 S3)))
 (= X20 (+ (* 233 S2) (* 393 S3)))
 (= X20 (- (* 233 S2) (* 393 S3)))
 (= X20 (- (* 393 S2) (* 233 S3)))
 (= X20 (+ (* 233 S2) (* 525 S3)))
 (= X20 (- (* 233 S2) (* 525 S3)))
 (= X20 (- (* 525 S2) (* 233 S3)))
 (= X20 (+ (* 233 S2) (* 509 S3)))
 (= X20 (- (* 233 S2) (* 509 S3)))
 (= X20 (- (* 509 S2) (* 233 S3)))
 (= X20 (+ (* 233 S2) (* 573 S3)))
 (= X20 (- (* 233 S2) (* 573 S3)))
 (= X20 (- (* 573 S2) (* 233 S3)))
 (= X20 (+ (* 233 S2) (* 813 S3)))
 (= X20 (- (* 233 S2) (* 813 S3)))
 (= X20 (- (* 813 S2) (* 233 S3)))
 (= X20 (+ (* 233 S2) (* 623 S3)))
 (= X20 (- (* 233 S2) (* 623 S3)))
 (= X20 (- (* 623 S2) (* 233 S3)))
 (= X20 (+ (* 233 S2) (* 863 S3)))
 (= X20 (- (* 233 S2) (* 863 S3)))
 (= X20 (- (* 863 S2) (* 233 S3)))
 (= X20 (+ (* 233 S2) (* 1005 S3)))
 (= X20 (- (* 233 S2) (* 1005 S3)))
 (= X20 (- (* 1005 S2) (* 233 S3)))
 (= X20 (+ (* 233 S2) (* X19 S3)))
 (= X20 (- (* 233 S2) (* X19 S3)))
 (= X20 (- (* X19 S2) (* 233 S3)))
 (= X20 (+ (* 231 S2) S3))
 (= X20 (- (* 231 S2) S3))
 (= X20 (- S2 (* 231 S3)))
 (= X20 (+ (* 231 S2) (* 231 S3)))
 (= X20 (- (* 231 S2) (* 231 S3)))
 (= X20 (+ (* 231 S2) (* 23 S3)))
 (= X20 (- (* 231 S2) (* 23 S3)))
 (= X20 (- (* 23 S2) (* 231 S3)))
 (= X20 (+ (* 231 S2) (* 199 S3)))
 (= X20 (- (* 231 S2) (* 199 S3)))
 (= X20 (- (* 199 S2) (* 231 S3)))
 (= X20 (+ (* 231 S2) (* 185 S3)))
 (= X20 (- (* 231 S2) (* 185 S3)))
 (= X20 (- (* 185 S2) (* 231 S3)))
 (= X20 (+ (* 231 S2) (* 71 S3)))
 (= X20 (- (* 231 S2) (* 71 S3)))
 (= X20 (- (* 71 S2) (* 231 S3)))
 (= X20 (+ (* 231 S2) (* 145 S3)))
 (= X20 (- (* 231 S2) (* 145 S3)))
 (= X20 (- (* 145 S2) (* 231 S3)))
 (= X20 (+ (* 231 S2) (* 173 S3)))
 (= X20 (- (* 231 S2) (* 173 S3)))
 (= X20 (- (* 173 S2) (* 231 S3)))
 (= X20 (+ (* 231 S2) (* 213 S3)))
 (= X20 (- (* 231 S2) (* 213 S3)))
 (= X20 (- (* 213 S2) (* 231 S3)))
 (= X20 (+ (* 231 S2) (* 393 S3)))
 (= X20 (- (* 231 S2) (* 393 S3)))
 (= X20 (- (* 393 S2) (* 231 S3)))
 (= X20 (+ (* 231 S2) (* 525 S3)))
 (= X20 (- (* 231 S2) (* 525 S3)))
 (= X20 (- (* 525 S2) (* 231 S3)))
 (= X20 (+ (* 231 S2) (* 509 S3)))
 (= X20 (- (* 231 S2) (* 509 S3)))
 (= X20 (- (* 509 S2) (* 231 S3)))
 (= X20 (+ (* 231 S2) (* 573 S3)))
 (= X20 (- (* 231 S2) (* 573 S3)))
 (= X20 (- (* 573 S2) (* 231 S3)))
 (= X20 (+ (* 231 S2) (* 813 S3)))
 (= X20 (- (* 231 S2) (* 813 S3)))
 (= X20 (- (* 813 S2) (* 231 S3)))
 (= X20 (+ (* 231 S2) (* 623 S3)))
 (= X20 (- (* 231 S2) (* 623 S3)))
 (= X20 (- (* 623 S2) (* 231 S3)))
 (= X20 (+ (* 231 S2) (* 863 S3)))
 (= X20 (- (* 231 S2) (* 863 S3)))
 (= X20 (- (* 863 S2) (* 231 S3)))
 (= X20 (+ (* 231 S2) (* 1005 S3)))
 (= X20 (- (* 231 S2) (* 1005 S3)))
 (= X20 (- (* 1005 S2) (* 231 S3)))
 (= X20 (+ (* 231 S2) (* X19 S3)))
 (= X20 (- (* 231 S2) (* X19 S3)))
 (= X20 (- (* X19 S2) (* 231 S3)))
 (= X20 (+ (* 23 S2) S3))
 (= X20 (- (* 23 S2) S3))
 (= X20 (- S2 (* 23 S3)))
 (= X20 (+ (* 23 S2) (* 23 S3)))
 (= X20 (- (* 23 S2) (* 23 S3)))
 (= X20 (+ (* 23 S2) (* 199 S3)))
 (= X20 (- (* 23 S2) (* 199 S3)))
 (= X20 (- (* 199 S2) (* 23 S3)))
 (= X20 (+ (* 23 S2) (* 185 S3)))
 (= X20 (- (* 23 S2) (* 185 S3)))
 (= X20 (- (* 185 S2) (* 23 S3)))
 (= X20 (+ (* 23 S2) (* 71 S3)))
 (= X20 (- (* 23 S2) (* 71 S3)))
 (= X20 (- (* 71 S2) (* 23 S3)))
 (= X20 (+ (* 23 S2) (* 145 S3)))
 (= X20 (- (* 23 S2) (* 145 S3)))
 (= X20 (- (* 145 S2) (* 23 S3)))
 (= X20 (+ (* 23 S2) (* 173 S3)))
 (= X20 (- (* 23 S2) (* 173 S3)))
 (= X20 (- (* 173 S2) (* 23 S3)))
 (= X20 (+ (* 23 S2) (* 213 S3)))
 (= X20 (- (* 23 S2) (* 213 S3)))
 (= X20 (- (* 213 S2) (* 23 S3)))
 (= X20 (+ (* 23 S2) (* 393 S3)))
 (= X20 (- (* 23 S2) (* 393 S3)))
 (= X20 (- (* 393 S2) (* 23 S3)))
 (= X20 (+ (* 23 S2) (* 525 S3)))
 (= X20 (- (* 23 S2) (* 525 S3)))
 (= X20 (- (* 525 S2) (* 23 S3)))
 (= X20 (+ (* 23 S2) (* 509 S3)))
 (= X20 (- (* 23 S2) (* 509 S3)))
 (= X20 (- (* 509 S2) (* 23 S3)))
 (= X20 (+ (* 23 S2) (* 573 S3)))
 (= X20 (- (* 23 S2) (* 573 S3)))
 (= X20 (- (* 573 S2) (* 23 S3)))
 (= X20 (+ (* 23 S2) (* 813 S3)))
 (= X20 (- (* 23 S2) (* 813 S3)))
 (= X20 (- (* 813 S2) (* 23 S3)))
 (= X20 (+ (* 23 S2) (* 623 S3)))
 (= X20 (- (* 23 S2) (* 623 S3)))
 (= X20 (- (* 623 S2) (* 23 S3)))
 (= X20 (+ (* 23 S2) (* 863 S3)))
 (= X20 (- (* 23 S2) (* 863 S3)))
 (= X20 (- (* 863 S2) (* 23 S3)))
 (= X20 (+ (* 23 S2) (* 1005 S3)))
 (= X20 (- (* 23 S2) (* 1005 S3)))
 (= X20 (- (* 1005 S2) (* 23 S3)))
 (= X20 (+ (* 23 S2) (* X19 S3)))
 (= X20 (- (* 23 S2) (* X19 S3)))
 (= X20 (- (* X19 S2) (* 23 S3)))
 (= X20 (+ (* 199 S2) S3))
 (= X20 (- (* 199 S2) S3))
 (= X20 (- S2 (* 199 S3)))
 (= X20 (+ (* 199 S2) (* 199 S3)))
 (= X20 (- (* 199 S2) (* 199 S3)))
 (= X20 (+ (* 199 S2) (* 185 S3)))
 (= X20 (- (* 199 S2) (* 185 S3)))
 (= X20 (- (* 185 S2) (* 199 S3)))
 (= X20 (+ (* 199 S2) (* 71 S3)))
 (= X20 (- (* 199 S2) (* 71 S3)))
 (= X20 (- (* 71 S2) (* 199 S3)))
 (= X20 (+ (* 199 S2) (* 145 S3)))
 (= X20 (- (* 199 S2) (* 145 S3)))
 (= X20 (- (* 145 S2) (* 199 S3)))
 (= X20 (+ (* 199 S2) (* 173 S3)))
 (= X20 (- (* 199 S2) (* 173 S3)))
 (= X20 (- (* 173 S2) (* 199 S3)))
 (= X20 (+ (* 199 S2) (* 213 S3)))
 (= X20 (- (* 199 S2) (* 213 S3)))
 (= X20 (- (* 213 S2) (* 199 S3)))
 (= X20 (+ (* 199 S2) (* 393 S3)))
 (= X20 (- (* 199 S2) (* 393 S3)))
 (= X20 (- (* 393 S2) (* 199 S3)))
 (= X20 (+ (* 199 S2) (* 525 S3)))
 (= X20 (- (* 199 S2) (* 525 S3)))
 (= X20 (- (* 525 S2) (* 199 S3)))
 (= X20 (+ (* 199 S2) (* 509 S3)))
 (= X20 (- (* 199 S2) (* 509 S3)))
 (= X20 (- (* 509 S2) (* 199 S3)))
 (= X20 (+ (* 199 S2) (* 573 S3)))
 (= X20 (- (* 199 S2) (* 573 S3)))
 (= X20 (- (* 573 S2) (* 199 S3)))
 (= X20 (+ (* 199 S2) (* 813 S3)))
 (= X20 (- (* 199 S2) (* 813 S3)))
 (= X20 (- (* 813 S2) (* 199 S3)))
 (= X20 (+ (* 199 S2) (* 623 S3)))
 (= X20 (- (* 199 S2) (* 623 S3)))
 (= X20 (- (* 623 S2) (* 199 S3)))
 (= X20 (+ (* 199 S2) (* 863 S3)))
 (= X20 (- (* 199 S2) (* 863 S3)))
 (= X20 (- (* 863 S2) (* 199 S3)))
 (= X20 (+ (* 199 S2) (* 1005 S3)))
 (= X20 (- (* 199 S2) (* 1005 S3)))
 (= X20 (- (* 1005 S2) (* 199 S3)))
 (= X20 (+ (* 199 S2) (* X19 S3)))
 (= X20 (- (* 199 S2) (* X19 S3)))
 (= X20 (- (* X19 S2) (* 199 S3)))
 (= X20 (+ (* 185 S2) S3))
 (= X20 (- (* 185 S2) S3))
 (= X20 (- S2 (* 185 S3)))
 (= X20 (+ (* 185 S2) (* 185 S3)))
 (= X20 (- (* 185 S2) (* 185 S3)))
 (= X20 (+ (* 185 S2) (* 71 S3)))
 (= X20 (- (* 185 S2) (* 71 S3)))
 (= X20 (- (* 71 S2) (* 185 S3)))
 (= X20 (+ (* 185 S2) (* 145 S3)))
 (= X20 (- (* 185 S2) (* 145 S3)))
 (= X20 (- (* 145 S2) (* 185 S3)))
 (= X20 (+ (* 185 S2) (* 173 S3)))
 (= X20 (- (* 185 S2) (* 173 S3)))
 (= X20 (- (* 173 S2) (* 185 S3)))
 (= X20 (+ (* 185 S2) (* 213 S3)))
 (= X20 (- (* 185 S2) (* 213 S3)))
 (= X20 (- (* 213 S2) (* 185 S3)))
 (= X20 (+ (* 185 S2) (* 393 S3)))
 (= X20 (- (* 185 S2) (* 393 S3)))
 (= X20 (- (* 393 S2) (* 185 S3)))
 (= X20 (+ (* 185 S2) (* 525 S3)))
 (= X20 (- (* 185 S2) (* 525 S3)))
 (= X20 (- (* 525 S2) (* 185 S3)))
 (= X20 (+ (* 185 S2) (* 509 S3)))
 (= X20 (- (* 185 S2) (* 509 S3)))
 (= X20 (- (* 509 S2) (* 185 S3)))
 (= X20 (+ (* 185 S2) (* 573 S3)))
 (= X20 (- (* 185 S2) (* 573 S3)))
 (= X20 (- (* 573 S2) (* 185 S3)))
 (= X20 (+ (* 185 S2) (* 813 S3)))
 (= X20 (- (* 185 S2) (* 813 S3)))
 (= X20 (- (* 813 S2) (* 185 S3)))
 (= X20 (+ (* 185 S2) (* 623 S3)))
 (= X20 (- (* 185 S2) (* 623 S3)))
 (= X20 (- (* 623 S2) (* 185 S3)))
 (= X20 (+ (* 185 S2) (* 863 S3)))
 (= X20 (- (* 185 S2) (* 863 S3)))
 (= X20 (- (* 863 S2) (* 185 S3)))
 (= X20 (+ (* 185 S2) (* 1005 S3)))
 (= X20 (- (* 185 S2) (* 1005 S3)))
 (= X20 (- (* 1005 S2) (* 185 S3)))
 (= X20 (+ (* 185 S2) (* X19 S3)))
 (= X20 (- (* 185 S2) (* X19 S3)))
 (= X20 (- (* X19 S2) (* 185 S3)))
 (= X20 (+ (* 71 S2) S3))
 (= X20 (- (* 71 S2) S3))
 (= X20 (- S2 (* 71 S3)))
 (= X20 (+ (* 71 S2) (* 71 S3)))
 (= X20 (- (* 71 S2) (* 71 S3)))
 (= X20 (+ (* 71 S2) (* 145 S3)))
 (= X20 (- (* 71 S2) (* 145 S3)))
 (= X20 (- (* 145 S2) (* 71 S3)))
 (= X20 (+ (* 71 S2) (* 173 S3)))
 (= X20 (- (* 71 S2) (* 173 S3)))
 (= X20 (- (* 173 S2) (* 71 S3)))
 (= X20 (+ (* 71 S2) (* 213 S3)))
 (= X20 (- (* 71 S2) (* 213 S3)))
 (= X20 (- (* 213 S2) (* 71 S3)))
 (= X20 (+ (* 71 S2) (* 393 S3)))
 (= X20 (- (* 71 S2) (* 393 S3)))
 (= X20 (- (* 393 S2) (* 71 S3)))
 (= X20 (+ (* 71 S2) (* 525 S3)))
 (= X20 (- (* 71 S2) (* 525 S3)))
 (= X20 (- (* 525 S2) (* 71 S3)))
 (= X20 (+ (* 71 S2) (* 509 S3)))
 (= X20 (- (* 71 S2) (* 509 S3)))
 (= X20 (- (* 509 S2) (* 71 S3)))
 (= X20 (+ (* 71 S2) (* 573 S3)))
 (= X20 (- (* 71 S2) (* 573 S3)))
 (= X20 (- (* 573 S2) (* 71 S3)))
 (= X20 (+ (* 71 S2) (* 813 S3)))
 (= X20 (- (* 71 S2) (* 813 S3)))
 (= X20 (- (* 813 S2) (* 71 S3)))
 (= X20 (+ (* 71 S2) (* 623 S3)))
 (= X20 (- (* 71 S2) (* 623 S3)))
 (= X20 (- (* 623 S2) (* 71 S3)))
 (= X20 (+ (* 71 S2) (* 863 S3)))
 (= X20 (- (* 71 S2) (* 863 S3)))
 (= X20 (- (* 863 S2) (* 71 S3)))
 (= X20 (+ (* 71 S2) (* 1005 S3)))
 (= X20 (- (* 71 S2) (* 1005 S3)))
 (= X20 (- (* 1005 S2) (* 71 S3)))
 (= X20 (+ (* 71 S2) (* X19 S3)))
 (= X20 (- (* 71 S2) (* X19 S3)))
 (= X20 (- (* X19 S2) (* 71 S3)))
 (= X20 (+ (* 145 S2) S3))
 (= X20 (- (* 145 S2) S3))
 (= X20 (- S2 (* 145 S3)))
 (= X20 (+ (* 145 S2) (* 145 S3)))
 (= X20 (- (* 145 S2) (* 145 S3)))
 (= X20 (+ (* 145 S2) (* 173 S3)))
 (= X20 (- (* 145 S2) (* 173 S3)))
 (= X20 (- (* 173 S2) (* 145 S3)))
 (= X20 (+ (* 145 S2) (* 213 S3)))
 (= X20 (- (* 145 S2) (* 213 S3)))
 (= X20 (- (* 213 S2) (* 145 S3)))
 (= X20 (+ (* 145 S2) (* 393 S3)))
 (= X20 (- (* 145 S2) (* 393 S3)))
 (= X20 (- (* 393 S2) (* 145 S3)))
 (= X20 (+ (* 145 S2) (* 525 S3)))
 (= X20 (- (* 145 S2) (* 525 S3)))
 (= X20 (- (* 525 S2) (* 145 S3)))
 (= X20 (+ (* 145 S2) (* 509 S3)))
 (= X20 (- (* 145 S2) (* 509 S3)))
 (= X20 (- (* 509 S2) (* 145 S3)))
 (= X20 (+ (* 145 S2) (* 573 S3)))
 (= X20 (- (* 145 S2) (* 573 S3)))
 (= X20 (- (* 573 S2) (* 145 S3)))
 (= X20 (+ (* 145 S2) (* 813 S3)))
 (= X20 (- (* 145 S2) (* 813 S3)))
 (= X20 (- (* 813 S2) (* 145 S3)))
 (= X20 (+ (* 145 S2) (* 623 S3)))
 (= X20 (- (* 145 S2) (* 623 S3)))
 (= X20 (- (* 623 S2) (* 145 S3)))
 (= X20 (+ (* 145 S2) (* 863 S3)))
 (= X20 (- (* 145 S2) (* 863 S3)))
 (= X20 (- (* 863 S2) (* 145 S3)))
 (= X20 (+ (* 145 S2) (* 1005 S3)))
 (= X20 (- (* 145 S2) (* 1005 S3)))
 (= X20 (- (* 1005 S2) (* 145 S3)))
 (= X20 (+ (* 145 S2) (* X19 S3)))
 (= X20 (- (* 145 S2) (* X19 S3)))
 (= X20 (- (* X19 S2) (* 145 S3)))
 (= X20 (+ (* 173 S2) S3))
 (= X20 (- (* 173 S2) S3))
 (= X20 (- S2 (* 173 S3)))
 (= X20 (+ (* 173 S2) (* 173 S3)))
 (= X20 (- (* 173 S2) (* 173 S3)))
 (= X20 (+ (* 173 S2) (* 213 S3)))
 (= X20 (- (* 173 S2) (* 213 S3)))
 (= X20 (- (* 213 S2) (* 173 S3)))
 (= X20 (+ (* 173 S2) (* 393 S3)))
 (= X20 (- (* 173 S2) (* 393 S3)))
 (= X20 (- (* 393 S2) (* 173 S3)))
 (= X20 (+ (* 173 S2) (* 525 S3)))
 (= X20 (- (* 173 S2) (* 525 S3)))
 (= X20 (- (* 525 S2) (* 173 S3)))
 (= X20 (+ (* 173 S2) (* 509 S3)))
 (= X20 (- (* 173 S2) (* 509 S3)))
 (= X20 (- (* 509 S2) (* 173 S3)))
 (= X20 (+ (* 173 S2) (* 573 S3)))
 (= X20 (- (* 173 S2) (* 573 S3)))
 (= X20 (- (* 573 S2) (* 173 S3)))
 (= X20 (+ (* 173 S2) (* 813 S3)))
 (= X20 (- (* 173 S2) (* 813 S3)))
 (= X20 (- (* 813 S2) (* 173 S3)))
 (= X20 (+ (* 173 S2) (* 623 S3)))
 (= X20 (- (* 173 S2) (* 623 S3)))
 (= X20 (- (* 623 S2) (* 173 S3)))
 (= X20 (+ (* 173 S2) (* 863 S3)))
 (= X20 (- (* 173 S2) (* 863 S3)))
 (= X20 (- (* 863 S2) (* 173 S3)))
 (= X20 (+ (* 173 S2) (* 1005 S3)))
 (= X20 (- (* 173 S2) (* 1005 S3)))
 (= X20 (- (* 1005 S2) (* 173 S3)))
 (= X20 (+ (* 173 S2) (* X19 S3)))
 (= X20 (- (* 173 S2) (* X19 S3)))
 (= X20 (- (* X19 S2) (* 173 S3)))
 (= X20 (+ (* 213 S2) S3))
 (= X20 (- (* 213 S2) S3))
 (= X20 (- S2 (* 213 S3)))
 (= X20 (+ (* 213 S2) (* 213 S3)))
 (= X20 (- (* 213 S2) (* 213 S3)))
 (= X20 (+ (* 213 S2) (* 393 S3)))
 (= X20 (- (* 213 S2) (* 393 S3)))
 (= X20 (- (* 393 S2) (* 213 S3)))
 (= X20 (+ (* 213 S2) (* 525 S3)))
 (= X20 (- (* 213 S2) (* 525 S3)))
 (= X20 (- (* 525 S2) (* 213 S3)))
 (= X20 (+ (* 213 S2) (* 509 S3)))
 (= X20 (- (* 213 S2) (* 509 S3)))
 (= X20 (- (* 509 S2) (* 213 S3)))
 (= X20 (+ (* 213 S2) (* 573 S3)))
 (= X20 (- (* 213 S2) (* 573 S3)))
 (= X20 (- (* 573 S2) (* 213 S3)))
 (= X20 (+ (* 213 S2) (* 813 S3)))
 (= X20 (- (* 213 S2) (* 813 S3)))
 (= X20 (- (* 813 S2) (* 213 S3)))
 (= X20 (+ (* 213 S2) (* 623 S3)))
 (= X20 (- (* 213 S2) (* 623 S3)))
 (= X20 (- (* 623 S2) (* 213 S3)))
 (= X20 (+ (* 213 S2) (* 863 S3)))
 (= X20 (- (* 213 S2) (* 863 S3)))
 (= X20 (- (* 863 S2) (* 213 S3)))
 (= X20 (+ (* 213 S2) (* 1005 S3)))
 (= X20 (- (* 213 S2) (* 1005 S3)))
 (= X20 (- (* 1005 S2) (* 213 S3)))
 (= X20 (+ (* 213 S2) (* X19 S3)))
 (= X20 (- (* 213 S2) (* X19 S3)))
 (= X20 (- (* X19 S2) (* 213 S3)))
 (= X20 (+ (* 393 S2) S3))
 (= X20 (- (* 393 S2) S3))
 (= X20 (- S2 (* 393 S3)))
 (= X20 (+ (* 393 S2) (* 393 S3)))
 (= X20 (- (* 393 S2) (* 393 S3)))
 (= X20 (+ (* 393 S2) (* 525 S3)))
 (= X20 (- (* 393 S2) (* 525 S3)))
 (= X20 (- (* 525 S2) (* 393 S3)))
 (= X20 (+ (* 393 S2) (* 509 S3)))
 (= X20 (- (* 393 S2) (* 509 S3)))
 (= X20 (- (* 509 S2) (* 393 S3)))
 (= X20 (+ (* 393 S2) (* 573 S3)))
 (= X20 (- (* 393 S2) (* 573 S3)))
 (= X20 (- (* 573 S2) (* 393 S3)))
 (= X20 (+ (* 393 S2) (* 813 S3)))
 (= X20 (- (* 393 S2) (* 813 S3)))
 (= X20 (- (* 813 S2) (* 393 S3)))
 (= X20 (+ (* 393 S2) (* 623 S3)))
 (= X20 (- (* 393 S2) (* 623 S3)))
 (= X20 (- (* 623 S2) (* 393 S3)))
 (= X20 (+ (* 393 S2) (* 863 S3)))
 (= X20 (- (* 393 S2) (* 863 S3)))
 (= X20 (- (* 863 S2) (* 393 S3)))
 (= X20 (+ (* 393 S2) (* 1005 S3)))
 (= X20 (- (* 393 S2) (* 1005 S3)))
 (= X20 (- (* 1005 S2) (* 393 S3)))
 (= X20 (+ (* 393 S2) (* X19 S3)))
 (= X20 (- (* 393 S2) (* X19 S3)))
 (= X20 (- (* X19 S2) (* 393 S3)))
 (= X20 (+ (* 525 S2) S3))
 (= X20 (- (* 525 S2) S3))
 (= X20 (- S2 (* 525 S3)))
 (= X20 (+ (* 525 S2) (* 525 S3)))
 (= X20 (- (* 525 S2) (* 525 S3)))
 (= X20 (+ (* 525 S2) (* 509 S3)))
 (= X20 (- (* 525 S2) (* 509 S3)))
 (= X20 (- (* 509 S2) (* 525 S3)))
 (= X20 (+ (* 525 S2) (* 573 S3)))
 (= X20 (- (* 525 S2) (* 573 S3)))
 (= X20 (- (* 573 S2) (* 525 S3)))
 (= X20 (+ (* 525 S2) (* 813 S3)))
 (= X20 (- (* 525 S2) (* 813 S3)))
 (= X20 (- (* 813 S2) (* 525 S3)))
 (= X20 (+ (* 525 S2) (* 623 S3)))
 (= X20 (- (* 525 S2) (* 623 S3)))
 (= X20 (- (* 623 S2) (* 525 S3)))
 (= X20 (+ (* 525 S2) (* 863 S3)))
 (= X20 (- (* 525 S2) (* 863 S3)))
 (= X20 (- (* 863 S2) (* 525 S3)))
 (= X20 (+ (* 525 S2) (* 1005 S3)))
 (= X20 (- (* 525 S2) (* 1005 S3)))
 (= X20 (- (* 1005 S2) (* 525 S3)))
 (= X20 (+ (* 525 S2) (* X19 S3)))
 (= X20 (- (* 525 S2) (* X19 S3)))
 (= X20 (- (* X19 S2) (* 525 S3)))
 (= X20 (+ (* 509 S2) S3))
 (= X20 (- (* 509 S2) S3))
 (= X20 (- S2 (* 509 S3)))
 (= X20 (+ (* 509 S2) (* 509 S3)))
 (= X20 (- (* 509 S2) (* 509 S3)))
 (= X20 (+ (* 509 S2) (* 573 S3)))
 (= X20 (- (* 509 S2) (* 573 S3)))
 (= X20 (- (* 573 S2) (* 509 S3)))
 (= X20 (+ (* 509 S2) (* 813 S3)))
 (= X20 (- (* 509 S2) (* 813 S3)))
 (= X20 (- (* 813 S2) (* 509 S3)))
 (= X20 (+ (* 509 S2) (* 623 S3)))
 (= X20 (- (* 509 S2) (* 623 S3)))
 (= X20 (- (* 623 S2) (* 509 S3)))
 (= X20 (+ (* 509 S2) (* 863 S3)))
 (= X20 (- (* 509 S2) (* 863 S3)))
 (= X20 (- (* 863 S2) (* 509 S3)))
 (= X20 (+ (* 509 S2) (* 1005 S3)))
 (= X20 (- (* 509 S2) (* 1005 S3)))
 (= X20 (- (* 1005 S2) (* 509 S3)))
 (= X20 (+ (* 509 S2) (* X19 S3)))
 (= X20 (- (* 509 S2) (* X19 S3)))
 (= X20 (- (* X19 S2) (* 509 S3)))
 (= X20 (+ (* 573 S2) S3))
 (= X20 (- (* 573 S2) S3))
 (= X20 (- S2 (* 573 S3)))
 (= X20 (+ (* 573 S2) (* 573 S3)))
 (= X20 (- (* 573 S2) (* 573 S3)))
 (= X20 (+ (* 573 S2) (* 813 S3)))
 (= X20 (- (* 573 S2) (* 813 S3)))
 (= X20 (- (* 813 S2) (* 573 S3)))
 (= X20 (+ (* 573 S2) (* 623 S3)))
 (= X20 (- (* 573 S2) (* 623 S3)))
 (= X20 (- (* 623 S2) (* 573 S3)))
 (= X20 (+ (* 573 S2) (* 863 S3)))
 (= X20 (- (* 573 S2) (* 863 S3)))
 (= X20 (- (* 863 S2) (* 573 S3)))
 (= X20 (+ (* 573 S2) (* 1005 S3)))
 (= X20 (- (* 573 S2) (* 1005 S3)))
 (= X20 (- (* 1005 S2) (* 573 S3)))
 (= X20 (+ (* 573 S2) (* X19 S3)))
 (= X20 (- (* 573 S2) (* X19 S3)))
 (= X20 (- (* X19 S2) (* 573 S3)))
 (= X20 (+ (* 813 S2) S3))
 (= X20 (- (* 813 S2) S3))
 (= X20 (- S2 (* 813 S3)))
 (= X20 (+ (* 813 S2) (* 813 S3)))
 (= X20 (- (* 813 S2) (* 813 S3)))
 (= X20 (+ (* 813 S2) (* 623 S3)))
 (= X20 (- (* 813 S2) (* 623 S3)))
 (= X20 (- (* 623 S2) (* 813 S3)))
 (= X20 (+ (* 813 S2) (* 863 S3)))
 (= X20 (- (* 813 S2) (* 863 S3)))
 (= X20 (- (* 863 S2) (* 813 S3)))
 (= X20 (+ (* 813 S2) (* 1005 S3)))
 (= X20 (- (* 813 S2) (* 1005 S3)))
 (= X20 (- (* 1005 S2) (* 813 S3)))
 (= X20 (+ (* 813 S2) (* X19 S3)))
 (= X20 (- (* 813 S2) (* X19 S3)))
 (= X20 (- (* X19 S2) (* 813 S3)))
 (= X20 (+ (* 623 S2) S3))
 (= X20 (- (* 623 S2) S3))
 (= X20 (- S2 (* 623 S3)))
 (= X20 (+ (* 623 S2) (* 623 S3)))
 (= X20 (- (* 623 S2) (* 623 S3)))
 (= X20 (+ (* 623 S2) (* 863 S3)))
 (= X20 (- (* 623 S2) (* 863 S3)))
 (= X20 (- (* 863 S2) (* 623 S3)))
 (= X20 (+ (* 623 S2) (* 1005 S3)))
 (= X20 (- (* 623 S2) (* 1005 S3)))
 (= X20 (- (* 1005 S2) (* 623 S3)))
 (= X20 (+ (* 623 S2) (* X19 S3)))
 (= X20 (- (* 623 S2) (* X19 S3)))
 (= X20 (- (* X19 S2) (* 623 S3)))
 (= X20 (+ (* 863 S2) S3))
 (= X20 (- (* 863 S2) S3))
 (= X20 (- S2 (* 863 S3)))
 (= X20 (+ (* 863 S2) (* 863 S3)))
 (= X20 (- (* 863 S2) (* 863 S3)))
 (= X20 (+ (* 863 S2) (* 1005 S3)))
 (= X20 (- (* 863 S2) (* 1005 S3)))
 (= X20 (- (* 1005 S2) (* 863 S3)))
 (= X20 (+ (* 863 S2) (* X19 S3)))
 (= X20 (- (* 863 S2) (* X19 S3)))
 (= X20 (- (* X19 S2) (* 863 S3)))
 (= X20 (+ (* 1005 S2) S3))
 (= X20 (- (* 1005 S2) S3))
 (= X20 (- S2 (* 1005 S3)))
 (= X20 (+ (* 1005 S2) (* 1005 S3)))
 (= X20 (- (* 1005 S2) (* 1005 S3)))
 (= X20 (+ (* 1005 S2) (* X19 S3)))
 (= X20 (- (* 1005 S2) (* X19 S3)))
 (= X20 (- (* X19 S2) (* 1005 S3)))
 (= X20 (+ (* X19 S2) S3))
 (= X20 (- (* X19 S2) S3))
 (= X20 (- S2 (* X19 S3)))
 (= X20 (+ (* X19 S2) (* X19 S3)))
 (= X20 (- (* X19 S2) (* X19 S3)))
))
(assert (and (> X20 0) (< X20 2048) (power2 S2) (power2 S3)))
(assert
 (= X20 353)
)
(check-sat)
(exit)
