(set-logic QF_NIA)
(set-info :source |
 more info in 'N. P. Lopes, L. Aksoy, V. Manquinho, J. Monteiro.
 Optimally Solving the MCM Problem Using Pseudo-Boolean Satisfiability.
 Technical Report RT/43/2010, INESC-ID, Nov. 2010'. |)
(set-info :smt-lib-version 2.0)
(set-info :category "industrial")
(set-info :status unknown)
(declare-fun X16 () Int)
(declare-fun X17 () Int)
(declare-fun S0 () Int)
(declare-fun S1 () Int)
(declare-fun S2 () Int)
(declare-fun S3 () Int)
(define-fun power2 ((x Int)) Bool
  (or (= x 1024) (= x 512) (= x 256) (= x 128) (= x 64) (= x 32) (= x 16) (= x 8) (= x 4) (= x 2) (= x 1)))
(assert (or
 (= X16 (+ S0 S1))
 (= X16 (- S0 S1))
 (= X16 (+ (* 17 S0) S1))
 (= X16 (- (* 17 S0) S1))
 (= X16 (- S0 (* 17 S1)))
 (= X16 (+ (* 17 S0) (* 17 S1)))
 (= X16 (- (* 17 S0) (* 17 S1)))
 (= X16 (+ (* 17 S0) (* 31 S1)))
 (= X16 (- (* 17 S0) (* 31 S1)))
 (= X16 (- (* 31 S0) (* 17 S1)))
 (= X16 (+ (* 17 S0) (* 33 S1)))
 (= X16 (- (* 17 S0) (* 33 S1)))
 (= X16 (- (* 33 S0) (* 17 S1)))
 (= X16 (+ (* 17 S0) (* 15 S1)))
 (= X16 (- (* 17 S0) (* 15 S1)))
 (= X16 (- (* 15 S0) (* 17 S1)))
 (= X16 (+ (* 17 S0) (* 959 S1)))
 (= X16 (- (* 17 S0) (* 959 S1)))
 (= X16 (- (* 959 S0) (* 17 S1)))
 (= X16 (+ (* 17 S0) (* 77 S1)))
 (= X16 (- (* 17 S0) (* 77 S1)))
 (= X16 (- (* 77 S0) (* 17 S1)))
 (= X16 (+ (* 17 S0) (* 333 S1)))
 (= X16 (- (* 17 S0) (* 333 S1)))
 (= X16 (- (* 333 S0) (* 17 S1)))
 (= X16 (+ (* 17 S0) (* 205 S1)))
 (= X16 (- (* 17 S0) (* 205 S1)))
 (= X16 (- (* 205 S0) (* 17 S1)))
 (= X16 (+ (* 17 S0) (* 155 S1)))
 (= X16 (- (* 17 S0) (* 155 S1)))
 (= X16 (- (* 155 S0) (* 17 S1)))
 (= X16 (+ (* 17 S0) (* 301 S1)))
 (= X16 (- (* 17 S0) (* 301 S1)))
 (= X16 (- (* 301 S0) (* 17 S1)))
 (= X16 (+ (* 17 S0) (* 411 S1)))
 (= X16 (- (* 17 S0) (* 411 S1)))
 (= X16 (- (* 411 S0) (* 17 S1)))
 (= X16 (+ (* 17 S0) (* 187 S1)))
 (= X16 (- (* 17 S0) (* 187 S1)))
 (= X16 (- (* 187 S0) (* 17 S1)))
 (= X16 (+ (* 17 S0) (* 91 S1)))
 (= X16 (- (* 17 S0) (* 91 S1)))
 (= X16 (- (* 91 S0) (* 17 S1)))
 (= X16 (+ (* 17 S0) (* 171 S1)))
 (= X16 (- (* 17 S0) (* 171 S1)))
 (= X16 (- (* 171 S0) (* 17 S1)))
 (= X16 (+ (* 17 S0) (* 671 S1)))
 (= X16 (- (* 17 S0) (* 671 S1)))
 (= X16 (- (* 671 S0) (* 17 S1)))
 (= X16 (+ (* 17 S0) (* 911 S1)))
 (= X16 (- (* 17 S0) (* 911 S1)))
 (= X16 (- (* 911 S0) (* 17 S1)))
 (= X16 (+ (* 31 S0) S1))
 (= X16 (- (* 31 S0) S1))
 (= X16 (- S0 (* 31 S1)))
 (= X16 (+ (* 31 S0) (* 31 S1)))
 (= X16 (- (* 31 S0) (* 31 S1)))
 (= X16 (+ (* 31 S0) (* 33 S1)))
 (= X16 (- (* 31 S0) (* 33 S1)))
 (= X16 (- (* 33 S0) (* 31 S1)))
 (= X16 (+ (* 31 S0) (* 15 S1)))
 (= X16 (- (* 31 S0) (* 15 S1)))
 (= X16 (- (* 15 S0) (* 31 S1)))
 (= X16 (+ (* 31 S0) (* 959 S1)))
 (= X16 (- (* 31 S0) (* 959 S1)))
 (= X16 (- (* 959 S0) (* 31 S1)))
 (= X16 (+ (* 31 S0) (* 77 S1)))
 (= X16 (- (* 31 S0) (* 77 S1)))
 (= X16 (- (* 77 S0) (* 31 S1)))
 (= X16 (+ (* 31 S0) (* 333 S1)))
 (= X16 (- (* 31 S0) (* 333 S1)))
 (= X16 (- (* 333 S0) (* 31 S1)))
 (= X16 (+ (* 31 S0) (* 205 S1)))
 (= X16 (- (* 31 S0) (* 205 S1)))
 (= X16 (- (* 205 S0) (* 31 S1)))
 (= X16 (+ (* 31 S0) (* 155 S1)))
 (= X16 (- (* 31 S0) (* 155 S1)))
 (= X16 (- (* 155 S0) (* 31 S1)))
 (= X16 (+ (* 31 S0) (* 301 S1)))
 (= X16 (- (* 31 S0) (* 301 S1)))
 (= X16 (- (* 301 S0) (* 31 S1)))
 (= X16 (+ (* 31 S0) (* 411 S1)))
 (= X16 (- (* 31 S0) (* 411 S1)))
 (= X16 (- (* 411 S0) (* 31 S1)))
 (= X16 (+ (* 31 S0) (* 187 S1)))
 (= X16 (- (* 31 S0) (* 187 S1)))
 (= X16 (- (* 187 S0) (* 31 S1)))
 (= X16 (+ (* 31 S0) (* 91 S1)))
 (= X16 (- (* 31 S0) (* 91 S1)))
 (= X16 (- (* 91 S0) (* 31 S1)))
 (= X16 (+ (* 31 S0) (* 171 S1)))
 (= X16 (- (* 31 S0) (* 171 S1)))
 (= X16 (- (* 171 S0) (* 31 S1)))
 (= X16 (+ (* 31 S0) (* 671 S1)))
 (= X16 (- (* 31 S0) (* 671 S1)))
 (= X16 (- (* 671 S0) (* 31 S1)))
 (= X16 (+ (* 31 S0) (* 911 S1)))
 (= X16 (- (* 31 S0) (* 911 S1)))
 (= X16 (- (* 911 S0) (* 31 S1)))
 (= X16 (+ (* 33 S0) S1))
 (= X16 (- (* 33 S0) S1))
 (= X16 (- S0 (* 33 S1)))
 (= X16 (+ (* 33 S0) (* 33 S1)))
 (= X16 (- (* 33 S0) (* 33 S1)))
 (= X16 (+ (* 33 S0) (* 15 S1)))
 (= X16 (- (* 33 S0) (* 15 S1)))
 (= X16 (- (* 15 S0) (* 33 S1)))
 (= X16 (+ (* 33 S0) (* 959 S1)))
 (= X16 (- (* 33 S0) (* 959 S1)))
 (= X16 (- (* 959 S0) (* 33 S1)))
 (= X16 (+ (* 33 S0) (* 77 S1)))
 (= X16 (- (* 33 S0) (* 77 S1)))
 (= X16 (- (* 77 S0) (* 33 S1)))
 (= X16 (+ (* 33 S0) (* 333 S1)))
 (= X16 (- (* 33 S0) (* 333 S1)))
 (= X16 (- (* 333 S0) (* 33 S1)))
 (= X16 (+ (* 33 S0) (* 205 S1)))
 (= X16 (- (* 33 S0) (* 205 S1)))
 (= X16 (- (* 205 S0) (* 33 S1)))
 (= X16 (+ (* 33 S0) (* 155 S1)))
 (= X16 (- (* 33 S0) (* 155 S1)))
 (= X16 (- (* 155 S0) (* 33 S1)))
 (= X16 (+ (* 33 S0) (* 301 S1)))
 (= X16 (- (* 33 S0) (* 301 S1)))
 (= X16 (- (* 301 S0) (* 33 S1)))
 (= X16 (+ (* 33 S0) (* 411 S1)))
 (= X16 (- (* 33 S0) (* 411 S1)))
 (= X16 (- (* 411 S0) (* 33 S1)))
 (= X16 (+ (* 33 S0) (* 187 S1)))
 (= X16 (- (* 33 S0) (* 187 S1)))
 (= X16 (- (* 187 S0) (* 33 S1)))
 (= X16 (+ (* 33 S0) (* 91 S1)))
 (= X16 (- (* 33 S0) (* 91 S1)))
 (= X16 (- (* 91 S0) (* 33 S1)))
 (= X16 (+ (* 33 S0) (* 171 S1)))
 (= X16 (- (* 33 S0) (* 171 S1)))
 (= X16 (- (* 171 S0) (* 33 S1)))
 (= X16 (+ (* 33 S0) (* 671 S1)))
 (= X16 (- (* 33 S0) (* 671 S1)))
 (= X16 (- (* 671 S0) (* 33 S1)))
 (= X16 (+ (* 33 S0) (* 911 S1)))
 (= X16 (- (* 33 S0) (* 911 S1)))
 (= X16 (- (* 911 S0) (* 33 S1)))
 (= X16 (+ (* 15 S0) S1))
 (= X16 (- (* 15 S0) S1))
 (= X16 (- S0 (* 15 S1)))
 (= X16 (+ (* 15 S0) (* 15 S1)))
 (= X16 (- (* 15 S0) (* 15 S1)))
 (= X16 (+ (* 15 S0) (* 959 S1)))
 (= X16 (- (* 15 S0) (* 959 S1)))
 (= X16 (- (* 959 S0) (* 15 S1)))
 (= X16 (+ (* 15 S0) (* 77 S1)))
 (= X16 (- (* 15 S0) (* 77 S1)))
 (= X16 (- (* 77 S0) (* 15 S1)))
 (= X16 (+ (* 15 S0) (* 333 S1)))
 (= X16 (- (* 15 S0) (* 333 S1)))
 (= X16 (- (* 333 S0) (* 15 S1)))
 (= X16 (+ (* 15 S0) (* 205 S1)))
 (= X16 (- (* 15 S0) (* 205 S1)))
 (= X16 (- (* 205 S0) (* 15 S1)))
 (= X16 (+ (* 15 S0) (* 155 S1)))
 (= X16 (- (* 15 S0) (* 155 S1)))
 (= X16 (- (* 155 S0) (* 15 S1)))
 (= X16 (+ (* 15 S0) (* 301 S1)))
 (= X16 (- (* 15 S0) (* 301 S1)))
 (= X16 (- (* 301 S0) (* 15 S1)))
 (= X16 (+ (* 15 S0) (* 411 S1)))
 (= X16 (- (* 15 S0) (* 411 S1)))
 (= X16 (- (* 411 S0) (* 15 S1)))
 (= X16 (+ (* 15 S0) (* 187 S1)))
 (= X16 (- (* 15 S0) (* 187 S1)))
 (= X16 (- (* 187 S0) (* 15 S1)))
 (= X16 (+ (* 15 S0) (* 91 S1)))
 (= X16 (- (* 15 S0) (* 91 S1)))
 (= X16 (- (* 91 S0) (* 15 S1)))
 (= X16 (+ (* 15 S0) (* 171 S1)))
 (= X16 (- (* 15 S0) (* 171 S1)))
 (= X16 (- (* 171 S0) (* 15 S1)))
 (= X16 (+ (* 15 S0) (* 671 S1)))
 (= X16 (- (* 15 S0) (* 671 S1)))
 (= X16 (- (* 671 S0) (* 15 S1)))
 (= X16 (+ (* 15 S0) (* 911 S1)))
 (= X16 (- (* 15 S0) (* 911 S1)))
 (= X16 (- (* 911 S0) (* 15 S1)))
 (= X16 (+ (* 959 S0) S1))
 (= X16 (- (* 959 S0) S1))
 (= X16 (- S0 (* 959 S1)))
 (= X16 (+ (* 959 S0) (* 959 S1)))
 (= X16 (- (* 959 S0) (* 959 S1)))
 (= X16 (+ (* 959 S0) (* 77 S1)))
 (= X16 (- (* 959 S0) (* 77 S1)))
 (= X16 (- (* 77 S0) (* 959 S1)))
 (= X16 (+ (* 959 S0) (* 333 S1)))
 (= X16 (- (* 959 S0) (* 333 S1)))
 (= X16 (- (* 333 S0) (* 959 S1)))
 (= X16 (+ (* 959 S0) (* 205 S1)))
 (= X16 (- (* 959 S0) (* 205 S1)))
 (= X16 (- (* 205 S0) (* 959 S1)))
 (= X16 (+ (* 959 S0) (* 155 S1)))
 (= X16 (- (* 959 S0) (* 155 S1)))
 (= X16 (- (* 155 S0) (* 959 S1)))
 (= X16 (+ (* 959 S0) (* 301 S1)))
 (= X16 (- (* 959 S0) (* 301 S1)))
 (= X16 (- (* 301 S0) (* 959 S1)))
 (= X16 (+ (* 959 S0) (* 411 S1)))
 (= X16 (- (* 959 S0) (* 411 S1)))
 (= X16 (- (* 411 S0) (* 959 S1)))
 (= X16 (+ (* 959 S0) (* 187 S1)))
 (= X16 (- (* 959 S0) (* 187 S1)))
 (= X16 (- (* 187 S0) (* 959 S1)))
 (= X16 (+ (* 959 S0) (* 91 S1)))
 (= X16 (- (* 959 S0) (* 91 S1)))
 (= X16 (- (* 91 S0) (* 959 S1)))
 (= X16 (+ (* 959 S0) (* 171 S1)))
 (= X16 (- (* 959 S0) (* 171 S1)))
 (= X16 (- (* 171 S0) (* 959 S1)))
 (= X16 (+ (* 959 S0) (* 671 S1)))
 (= X16 (- (* 959 S0) (* 671 S1)))
 (= X16 (- (* 671 S0) (* 959 S1)))
 (= X16 (+ (* 959 S0) (* 911 S1)))
 (= X16 (- (* 959 S0) (* 911 S1)))
 (= X16 (- (* 911 S0) (* 959 S1)))
 (= X16 (+ (* 77 S0) S1))
 (= X16 (- (* 77 S0) S1))
 (= X16 (- S0 (* 77 S1)))
 (= X16 (+ (* 77 S0) (* 77 S1)))
 (= X16 (- (* 77 S0) (* 77 S1)))
 (= X16 (+ (* 77 S0) (* 333 S1)))
 (= X16 (- (* 77 S0) (* 333 S1)))
 (= X16 (- (* 333 S0) (* 77 S1)))
 (= X16 (+ (* 77 S0) (* 205 S1)))
 (= X16 (- (* 77 S0) (* 205 S1)))
 (= X16 (- (* 205 S0) (* 77 S1)))
 (= X16 (+ (* 77 S0) (* 155 S1)))
 (= X16 (- (* 77 S0) (* 155 S1)))
 (= X16 (- (* 155 S0) (* 77 S1)))
 (= X16 (+ (* 77 S0) (* 301 S1)))
 (= X16 (- (* 77 S0) (* 301 S1)))
 (= X16 (- (* 301 S0) (* 77 S1)))
 (= X16 (+ (* 77 S0) (* 411 S1)))
 (= X16 (- (* 77 S0) (* 411 S1)))
 (= X16 (- (* 411 S0) (* 77 S1)))
 (= X16 (+ (* 77 S0) (* 187 S1)))
 (= X16 (- (* 77 S0) (* 187 S1)))
 (= X16 (- (* 187 S0) (* 77 S1)))
 (= X16 (+ (* 77 S0) (* 91 S1)))
 (= X16 (- (* 77 S0) (* 91 S1)))
 (= X16 (- (* 91 S0) (* 77 S1)))
 (= X16 (+ (* 77 S0) (* 171 S1)))
 (= X16 (- (* 77 S0) (* 171 S1)))
 (= X16 (- (* 171 S0) (* 77 S1)))
 (= X16 (+ (* 77 S0) (* 671 S1)))
 (= X16 (- (* 77 S0) (* 671 S1)))
 (= X16 (- (* 671 S0) (* 77 S1)))
 (= X16 (+ (* 77 S0) (* 911 S1)))
 (= X16 (- (* 77 S0) (* 911 S1)))
 (= X16 (- (* 911 S0) (* 77 S1)))
 (= X16 (+ (* 333 S0) S1))
 (= X16 (- (* 333 S0) S1))
 (= X16 (- S0 (* 333 S1)))
 (= X16 (+ (* 333 S0) (* 333 S1)))
 (= X16 (- (* 333 S0) (* 333 S1)))
 (= X16 (+ (* 333 S0) (* 205 S1)))
 (= X16 (- (* 333 S0) (* 205 S1)))
 (= X16 (- (* 205 S0) (* 333 S1)))
 (= X16 (+ (* 333 S0) (* 155 S1)))
 (= X16 (- (* 333 S0) (* 155 S1)))
 (= X16 (- (* 155 S0) (* 333 S1)))
 (= X16 (+ (* 333 S0) (* 301 S1)))
 (= X16 (- (* 333 S0) (* 301 S1)))
 (= X16 (- (* 301 S0) (* 333 S1)))
 (= X16 (+ (* 333 S0) (* 411 S1)))
 (= X16 (- (* 333 S0) (* 411 S1)))
 (= X16 (- (* 411 S0) (* 333 S1)))
 (= X16 (+ (* 333 S0) (* 187 S1)))
 (= X16 (- (* 333 S0) (* 187 S1)))
 (= X16 (- (* 187 S0) (* 333 S1)))
 (= X16 (+ (* 333 S0) (* 91 S1)))
 (= X16 (- (* 333 S0) (* 91 S1)))
 (= X16 (- (* 91 S0) (* 333 S1)))
 (= X16 (+ (* 333 S0) (* 171 S1)))
 (= X16 (- (* 333 S0) (* 171 S1)))
 (= X16 (- (* 171 S0) (* 333 S1)))
 (= X16 (+ (* 333 S0) (* 671 S1)))
 (= X16 (- (* 333 S0) (* 671 S1)))
 (= X16 (- (* 671 S0) (* 333 S1)))
 (= X16 (+ (* 333 S0) (* 911 S1)))
 (= X16 (- (* 333 S0) (* 911 S1)))
 (= X16 (- (* 911 S0) (* 333 S1)))
 (= X16 (+ (* 205 S0) S1))
 (= X16 (- (* 205 S0) S1))
 (= X16 (- S0 (* 205 S1)))
 (= X16 (+ (* 205 S0) (* 205 S1)))
 (= X16 (- (* 205 S0) (* 205 S1)))
 (= X16 (+ (* 205 S0) (* 155 S1)))
 (= X16 (- (* 205 S0) (* 155 S1)))
 (= X16 (- (* 155 S0) (* 205 S1)))
 (= X16 (+ (* 205 S0) (* 301 S1)))
 (= X16 (- (* 205 S0) (* 301 S1)))
 (= X16 (- (* 301 S0) (* 205 S1)))
 (= X16 (+ (* 205 S0) (* 411 S1)))
 (= X16 (- (* 205 S0) (* 411 S1)))
 (= X16 (- (* 411 S0) (* 205 S1)))
 (= X16 (+ (* 205 S0) (* 187 S1)))
 (= X16 (- (* 205 S0) (* 187 S1)))
 (= X16 (- (* 187 S0) (* 205 S1)))
 (= X16 (+ (* 205 S0) (* 91 S1)))
 (= X16 (- (* 205 S0) (* 91 S1)))
 (= X16 (- (* 91 S0) (* 205 S1)))
 (= X16 (+ (* 205 S0) (* 171 S1)))
 (= X16 (- (* 205 S0) (* 171 S1)))
 (= X16 (- (* 171 S0) (* 205 S1)))
 (= X16 (+ (* 205 S0) (* 671 S1)))
 (= X16 (- (* 205 S0) (* 671 S1)))
 (= X16 (- (* 671 S0) (* 205 S1)))
 (= X16 (+ (* 205 S0) (* 911 S1)))
 (= X16 (- (* 205 S0) (* 911 S1)))
 (= X16 (- (* 911 S0) (* 205 S1)))
 (= X16 (+ (* 155 S0) S1))
 (= X16 (- (* 155 S0) S1))
 (= X16 (- S0 (* 155 S1)))
 (= X16 (+ (* 155 S0) (* 155 S1)))
 (= X16 (- (* 155 S0) (* 155 S1)))
 (= X16 (+ (* 155 S0) (* 301 S1)))
 (= X16 (- (* 155 S0) (* 301 S1)))
 (= X16 (- (* 301 S0) (* 155 S1)))
 (= X16 (+ (* 155 S0) (* 411 S1)))
 (= X16 (- (* 155 S0) (* 411 S1)))
 (= X16 (- (* 411 S0) (* 155 S1)))
 (= X16 (+ (* 155 S0) (* 187 S1)))
 (= X16 (- (* 155 S0) (* 187 S1)))
 (= X16 (- (* 187 S0) (* 155 S1)))
 (= X16 (+ (* 155 S0) (* 91 S1)))
 (= X16 (- (* 155 S0) (* 91 S1)))
 (= X16 (- (* 91 S0) (* 155 S1)))
 (= X16 (+ (* 155 S0) (* 171 S1)))
 (= X16 (- (* 155 S0) (* 171 S1)))
 (= X16 (- (* 171 S0) (* 155 S1)))
 (= X16 (+ (* 155 S0) (* 671 S1)))
 (= X16 (- (* 155 S0) (* 671 S1)))
 (= X16 (- (* 671 S0) (* 155 S1)))
 (= X16 (+ (* 155 S0) (* 911 S1)))
 (= X16 (- (* 155 S0) (* 911 S1)))
 (= X16 (- (* 911 S0) (* 155 S1)))
 (= X16 (+ (* 301 S0) S1))
 (= X16 (- (* 301 S0) S1))
 (= X16 (- S0 (* 301 S1)))
 (= X16 (+ (* 301 S0) (* 301 S1)))
 (= X16 (- (* 301 S0) (* 301 S1)))
 (= X16 (+ (* 301 S0) (* 411 S1)))
 (= X16 (- (* 301 S0) (* 411 S1)))
 (= X16 (- (* 411 S0) (* 301 S1)))
 (= X16 (+ (* 301 S0) (* 187 S1)))
 (= X16 (- (* 301 S0) (* 187 S1)))
 (= X16 (- (* 187 S0) (* 301 S1)))
 (= X16 (+ (* 301 S0) (* 91 S1)))
 (= X16 (- (* 301 S0) (* 91 S1)))
 (= X16 (- (* 91 S0) (* 301 S1)))
 (= X16 (+ (* 301 S0) (* 171 S1)))
 (= X16 (- (* 301 S0) (* 171 S1)))
 (= X16 (- (* 171 S0) (* 301 S1)))
 (= X16 (+ (* 301 S0) (* 671 S1)))
 (= X16 (- (* 301 S0) (* 671 S1)))
 (= X16 (- (* 671 S0) (* 301 S1)))
 (= X16 (+ (* 301 S0) (* 911 S1)))
 (= X16 (- (* 301 S0) (* 911 S1)))
 (= X16 (- (* 911 S0) (* 301 S1)))
 (= X16 (+ (* 411 S0) S1))
 (= X16 (- (* 411 S0) S1))
 (= X16 (- S0 (* 411 S1)))
 (= X16 (+ (* 411 S0) (* 411 S1)))
 (= X16 (- (* 411 S0) (* 411 S1)))
 (= X16 (+ (* 411 S0) (* 187 S1)))
 (= X16 (- (* 411 S0) (* 187 S1)))
 (= X16 (- (* 187 S0) (* 411 S1)))
 (= X16 (+ (* 411 S0) (* 91 S1)))
 (= X16 (- (* 411 S0) (* 91 S1)))
 (= X16 (- (* 91 S0) (* 411 S1)))
 (= X16 (+ (* 411 S0) (* 171 S1)))
 (= X16 (- (* 411 S0) (* 171 S1)))
 (= X16 (- (* 171 S0) (* 411 S1)))
 (= X16 (+ (* 411 S0) (* 671 S1)))
 (= X16 (- (* 411 S0) (* 671 S1)))
 (= X16 (- (* 671 S0) (* 411 S1)))
 (= X16 (+ (* 411 S0) (* 911 S1)))
 (= X16 (- (* 411 S0) (* 911 S1)))
 (= X16 (- (* 911 S0) (* 411 S1)))
 (= X16 (+ (* 187 S0) S1))
 (= X16 (- (* 187 S0) S1))
 (= X16 (- S0 (* 187 S1)))
 (= X16 (+ (* 187 S0) (* 187 S1)))
 (= X16 (- (* 187 S0) (* 187 S1)))
 (= X16 (+ (* 187 S0) (* 91 S1)))
 (= X16 (- (* 187 S0) (* 91 S1)))
 (= X16 (- (* 91 S0) (* 187 S1)))
 (= X16 (+ (* 187 S0) (* 171 S1)))
 (= X16 (- (* 187 S0) (* 171 S1)))
 (= X16 (- (* 171 S0) (* 187 S1)))
 (= X16 (+ (* 187 S0) (* 671 S1)))
 (= X16 (- (* 187 S0) (* 671 S1)))
 (= X16 (- (* 671 S0) (* 187 S1)))
 (= X16 (+ (* 187 S0) (* 911 S1)))
 (= X16 (- (* 187 S0) (* 911 S1)))
 (= X16 (- (* 911 S0) (* 187 S1)))
 (= X16 (+ (* 91 S0) S1))
 (= X16 (- (* 91 S0) S1))
 (= X16 (- S0 (* 91 S1)))
 (= X16 (+ (* 91 S0) (* 91 S1)))
 (= X16 (- (* 91 S0) (* 91 S1)))
 (= X16 (+ (* 91 S0) (* 171 S1)))
 (= X16 (- (* 91 S0) (* 171 S1)))
 (= X16 (- (* 171 S0) (* 91 S1)))
 (= X16 (+ (* 91 S0) (* 671 S1)))
 (= X16 (- (* 91 S0) (* 671 S1)))
 (= X16 (- (* 671 S0) (* 91 S1)))
 (= X16 (+ (* 91 S0) (* 911 S1)))
 (= X16 (- (* 91 S0) (* 911 S1)))
 (= X16 (- (* 911 S0) (* 91 S1)))
 (= X16 (+ (* 171 S0) S1))
 (= X16 (- (* 171 S0) S1))
 (= X16 (- S0 (* 171 S1)))
 (= X16 (+ (* 171 S0) (* 171 S1)))
 (= X16 (- (* 171 S0) (* 171 S1)))
 (= X16 (+ (* 171 S0) (* 671 S1)))
 (= X16 (- (* 171 S0) (* 671 S1)))
 (= X16 (- (* 671 S0) (* 171 S1)))
 (= X16 (+ (* 171 S0) (* 911 S1)))
 (= X16 (- (* 171 S0) (* 911 S1)))
 (= X16 (- (* 911 S0) (* 171 S1)))
 (= X16 (+ (* 671 S0) S1))
 (= X16 (- (* 671 S0) S1))
 (= X16 (- S0 (* 671 S1)))
 (= X16 (+ (* 671 S0) (* 671 S1)))
 (= X16 (- (* 671 S0) (* 671 S1)))
 (= X16 (+ (* 671 S0) (* 911 S1)))
 (= X16 (- (* 671 S0) (* 911 S1)))
 (= X16 (- (* 911 S0) (* 671 S1)))
 (= X16 (+ (* 911 S0) S1))
 (= X16 (- (* 911 S0) S1))
 (= X16 (- S0 (* 911 S1)))
 (= X16 (+ (* 911 S0) (* 911 S1)))
 (= X16 (- (* 911 S0) (* 911 S1)))
))
(assert (and (> X16 0) (< X16 2048) (power2 S0) (power2 S1)))
(assert (or
 (= X17 (+ (* 17 S2) S3))
 (= X17 (- (* 17 S2) S3))
 (= X17 (- S2 (* 17 S3)))
 (= X17 (+ (* 17 S2) (* 17 S3)))
 (= X17 (- (* 17 S2) (* 17 S3)))
 (= X17 (+ (* 17 S2) (* 31 S3)))
 (= X17 (- (* 17 S2) (* 31 S3)))
 (= X17 (- (* 31 S2) (* 17 S3)))
 (= X17 (+ (* 17 S2) (* 33 S3)))
 (= X17 (- (* 17 S2) (* 33 S3)))
 (= X17 (- (* 33 S2) (* 17 S3)))
 (= X17 (+ (* 17 S2) (* 15 S3)))
 (= X17 (- (* 17 S2) (* 15 S3)))
 (= X17 (- (* 15 S2) (* 17 S3)))
 (= X17 (+ (* 17 S2) (* 959 S3)))
 (= X17 (- (* 17 S2) (* 959 S3)))
 (= X17 (- (* 959 S2) (* 17 S3)))
 (= X17 (+ (* 17 S2) (* 77 S3)))
 (= X17 (- (* 17 S2) (* 77 S3)))
 (= X17 (- (* 77 S2) (* 17 S3)))
 (= X17 (+ (* 17 S2) (* 333 S3)))
 (= X17 (- (* 17 S2) (* 333 S3)))
 (= X17 (- (* 333 S2) (* 17 S3)))
 (= X17 (+ (* 17 S2) (* 205 S3)))
 (= X17 (- (* 17 S2) (* 205 S3)))
 (= X17 (- (* 205 S2) (* 17 S3)))
 (= X17 (+ (* 17 S2) (* 155 S3)))
 (= X17 (- (* 17 S2) (* 155 S3)))
 (= X17 (- (* 155 S2) (* 17 S3)))
 (= X17 (+ (* 17 S2) (* 301 S3)))
 (= X17 (- (* 17 S2) (* 301 S3)))
 (= X17 (- (* 301 S2) (* 17 S3)))
 (= X17 (+ (* 17 S2) (* 411 S3)))
 (= X17 (- (* 17 S2) (* 411 S3)))
 (= X17 (- (* 411 S2) (* 17 S3)))
 (= X17 (+ (* 17 S2) (* 187 S3)))
 (= X17 (- (* 17 S2) (* 187 S3)))
 (= X17 (- (* 187 S2) (* 17 S3)))
 (= X17 (+ (* 17 S2) (* 91 S3)))
 (= X17 (- (* 17 S2) (* 91 S3)))
 (= X17 (- (* 91 S2) (* 17 S3)))
 (= X17 (+ (* 17 S2) (* 171 S3)))
 (= X17 (- (* 17 S2) (* 171 S3)))
 (= X17 (- (* 171 S2) (* 17 S3)))
 (= X17 (+ (* 17 S2) (* 671 S3)))
 (= X17 (- (* 17 S2) (* 671 S3)))
 (= X17 (- (* 671 S2) (* 17 S3)))
 (= X17 (+ (* 17 S2) (* 911 S3)))
 (= X17 (- (* 17 S2) (* 911 S3)))
 (= X17 (- (* 911 S2) (* 17 S3)))
 (= X17 (+ (* 17 S2) (* X16 S3)))
 (= X17 (- (* 17 S2) (* X16 S3)))
 (= X17 (- (* X16 S2) (* 17 S3)))
 (= X17 (+ (* 31 S2) S3))
 (= X17 (- (* 31 S2) S3))
 (= X17 (- S2 (* 31 S3)))
 (= X17 (+ (* 31 S2) (* 31 S3)))
 (= X17 (- (* 31 S2) (* 31 S3)))
 (= X17 (+ (* 31 S2) (* 33 S3)))
 (= X17 (- (* 31 S2) (* 33 S3)))
 (= X17 (- (* 33 S2) (* 31 S3)))
 (= X17 (+ (* 31 S2) (* 15 S3)))
 (= X17 (- (* 31 S2) (* 15 S3)))
 (= X17 (- (* 15 S2) (* 31 S3)))
 (= X17 (+ (* 31 S2) (* 959 S3)))
 (= X17 (- (* 31 S2) (* 959 S3)))
 (= X17 (- (* 959 S2) (* 31 S3)))
 (= X17 (+ (* 31 S2) (* 77 S3)))
 (= X17 (- (* 31 S2) (* 77 S3)))
 (= X17 (- (* 77 S2) (* 31 S3)))
 (= X17 (+ (* 31 S2) (* 333 S3)))
 (= X17 (- (* 31 S2) (* 333 S3)))
 (= X17 (- (* 333 S2) (* 31 S3)))
 (= X17 (+ (* 31 S2) (* 205 S3)))
 (= X17 (- (* 31 S2) (* 205 S3)))
 (= X17 (- (* 205 S2) (* 31 S3)))
 (= X17 (+ (* 31 S2) (* 155 S3)))
 (= X17 (- (* 31 S2) (* 155 S3)))
 (= X17 (- (* 155 S2) (* 31 S3)))
 (= X17 (+ (* 31 S2) (* 301 S3)))
 (= X17 (- (* 31 S2) (* 301 S3)))
 (= X17 (- (* 301 S2) (* 31 S3)))
 (= X17 (+ (* 31 S2) (* 411 S3)))
 (= X17 (- (* 31 S2) (* 411 S3)))
 (= X17 (- (* 411 S2) (* 31 S3)))
 (= X17 (+ (* 31 S2) (* 187 S3)))
 (= X17 (- (* 31 S2) (* 187 S3)))
 (= X17 (- (* 187 S2) (* 31 S3)))
 (= X17 (+ (* 31 S2) (* 91 S3)))
 (= X17 (- (* 31 S2) (* 91 S3)))
 (= X17 (- (* 91 S2) (* 31 S3)))
 (= X17 (+ (* 31 S2) (* 171 S3)))
 (= X17 (- (* 31 S2) (* 171 S3)))
 (= X17 (- (* 171 S2) (* 31 S3)))
 (= X17 (+ (* 31 S2) (* 671 S3)))
 (= X17 (- (* 31 S2) (* 671 S3)))
 (= X17 (- (* 671 S2) (* 31 S3)))
 (= X17 (+ (* 31 S2) (* 911 S3)))
 (= X17 (- (* 31 S2) (* 911 S3)))
 (= X17 (- (* 911 S2) (* 31 S3)))
 (= X17 (+ (* 31 S2) (* X16 S3)))
 (= X17 (- (* 31 S2) (* X16 S3)))
 (= X17 (- (* X16 S2) (* 31 S3)))
 (= X17 (+ (* 33 S2) S3))
 (= X17 (- (* 33 S2) S3))
 (= X17 (- S2 (* 33 S3)))
 (= X17 (+ (* 33 S2) (* 33 S3)))
 (= X17 (- (* 33 S2) (* 33 S3)))
 (= X17 (+ (* 33 S2) (* 15 S3)))
 (= X17 (- (* 33 S2) (* 15 S3)))
 (= X17 (- (* 15 S2) (* 33 S3)))
 (= X17 (+ (* 33 S2) (* 959 S3)))
 (= X17 (- (* 33 S2) (* 959 S3)))
 (= X17 (- (* 959 S2) (* 33 S3)))
 (= X17 (+ (* 33 S2) (* 77 S3)))
 (= X17 (- (* 33 S2) (* 77 S3)))
 (= X17 (- (* 77 S2) (* 33 S3)))
 (= X17 (+ (* 33 S2) (* 333 S3)))
 (= X17 (- (* 33 S2) (* 333 S3)))
 (= X17 (- (* 333 S2) (* 33 S3)))
 (= X17 (+ (* 33 S2) (* 205 S3)))
 (= X17 (- (* 33 S2) (* 205 S3)))
 (= X17 (- (* 205 S2) (* 33 S3)))
 (= X17 (+ (* 33 S2) (* 155 S3)))
 (= X17 (- (* 33 S2) (* 155 S3)))
 (= X17 (- (* 155 S2) (* 33 S3)))
 (= X17 (+ (* 33 S2) (* 301 S3)))
 (= X17 (- (* 33 S2) (* 301 S3)))
 (= X17 (- (* 301 S2) (* 33 S3)))
 (= X17 (+ (* 33 S2) (* 411 S3)))
 (= X17 (- (* 33 S2) (* 411 S3)))
 (= X17 (- (* 411 S2) (* 33 S3)))
 (= X17 (+ (* 33 S2) (* 187 S3)))
 (= X17 (- (* 33 S2) (* 187 S3)))
 (= X17 (- (* 187 S2) (* 33 S3)))
 (= X17 (+ (* 33 S2) (* 91 S3)))
 (= X17 (- (* 33 S2) (* 91 S3)))
 (= X17 (- (* 91 S2) (* 33 S3)))
 (= X17 (+ (* 33 S2) (* 171 S3)))
 (= X17 (- (* 33 S2) (* 171 S3)))
 (= X17 (- (* 171 S2) (* 33 S3)))
 (= X17 (+ (* 33 S2) (* 671 S3)))
 (= X17 (- (* 33 S2) (* 671 S3)))
 (= X17 (- (* 671 S2) (* 33 S3)))
 (= X17 (+ (* 33 S2) (* 911 S3)))
 (= X17 (- (* 33 S2) (* 911 S3)))
 (= X17 (- (* 911 S2) (* 33 S3)))
 (= X17 (+ (* 33 S2) (* X16 S3)))
 (= X17 (- (* 33 S2) (* X16 S3)))
 (= X17 (- (* X16 S2) (* 33 S3)))
 (= X17 (+ (* 15 S2) S3))
 (= X17 (- (* 15 S2) S3))
 (= X17 (- S2 (* 15 S3)))
 (= X17 (+ (* 15 S2) (* 15 S3)))
 (= X17 (- (* 15 S2) (* 15 S3)))
 (= X17 (+ (* 15 S2) (* 959 S3)))
 (= X17 (- (* 15 S2) (* 959 S3)))
 (= X17 (- (* 959 S2) (* 15 S3)))
 (= X17 (+ (* 15 S2) (* 77 S3)))
 (= X17 (- (* 15 S2) (* 77 S3)))
 (= X17 (- (* 77 S2) (* 15 S3)))
 (= X17 (+ (* 15 S2) (* 333 S3)))
 (= X17 (- (* 15 S2) (* 333 S3)))
 (= X17 (- (* 333 S2) (* 15 S3)))
 (= X17 (+ (* 15 S2) (* 205 S3)))
 (= X17 (- (* 15 S2) (* 205 S3)))
 (= X17 (- (* 205 S2) (* 15 S3)))
 (= X17 (+ (* 15 S2) (* 155 S3)))
 (= X17 (- (* 15 S2) (* 155 S3)))
 (= X17 (- (* 155 S2) (* 15 S3)))
 (= X17 (+ (* 15 S2) (* 301 S3)))
 (= X17 (- (* 15 S2) (* 301 S3)))
 (= X17 (- (* 301 S2) (* 15 S3)))
 (= X17 (+ (* 15 S2) (* 411 S3)))
 (= X17 (- (* 15 S2) (* 411 S3)))
 (= X17 (- (* 411 S2) (* 15 S3)))
 (= X17 (+ (* 15 S2) (* 187 S3)))
 (= X17 (- (* 15 S2) (* 187 S3)))
 (= X17 (- (* 187 S2) (* 15 S3)))
 (= X17 (+ (* 15 S2) (* 91 S3)))
 (= X17 (- (* 15 S2) (* 91 S3)))
 (= X17 (- (* 91 S2) (* 15 S3)))
 (= X17 (+ (* 15 S2) (* 171 S3)))
 (= X17 (- (* 15 S2) (* 171 S3)))
 (= X17 (- (* 171 S2) (* 15 S3)))
 (= X17 (+ (* 15 S2) (* 671 S3)))
 (= X17 (- (* 15 S2) (* 671 S3)))
 (= X17 (- (* 671 S2) (* 15 S3)))
 (= X17 (+ (* 15 S2) (* 911 S3)))
 (= X17 (- (* 15 S2) (* 911 S3)))
 (= X17 (- (* 911 S2) (* 15 S3)))
 (= X17 (+ (* 15 S2) (* X16 S3)))
 (= X17 (- (* 15 S2) (* X16 S3)))
 (= X17 (- (* X16 S2) (* 15 S3)))
 (= X17 (+ (* 959 S2) S3))
 (= X17 (- (* 959 S2) S3))
 (= X17 (- S2 (* 959 S3)))
 (= X17 (+ (* 959 S2) (* 959 S3)))
 (= X17 (- (* 959 S2) (* 959 S3)))
 (= X17 (+ (* 959 S2) (* 77 S3)))
 (= X17 (- (* 959 S2) (* 77 S3)))
 (= X17 (- (* 77 S2) (* 959 S3)))
 (= X17 (+ (* 959 S2) (* 333 S3)))
 (= X17 (- (* 959 S2) (* 333 S3)))
 (= X17 (- (* 333 S2) (* 959 S3)))
 (= X17 (+ (* 959 S2) (* 205 S3)))
 (= X17 (- (* 959 S2) (* 205 S3)))
 (= X17 (- (* 205 S2) (* 959 S3)))
 (= X17 (+ (* 959 S2) (* 155 S3)))
 (= X17 (- (* 959 S2) (* 155 S3)))
 (= X17 (- (* 155 S2) (* 959 S3)))
 (= X17 (+ (* 959 S2) (* 301 S3)))
 (= X17 (- (* 959 S2) (* 301 S3)))
 (= X17 (- (* 301 S2) (* 959 S3)))
 (= X17 (+ (* 959 S2) (* 411 S3)))
 (= X17 (- (* 959 S2) (* 411 S3)))
 (= X17 (- (* 411 S2) (* 959 S3)))
 (= X17 (+ (* 959 S2) (* 187 S3)))
 (= X17 (- (* 959 S2) (* 187 S3)))
 (= X17 (- (* 187 S2) (* 959 S3)))
 (= X17 (+ (* 959 S2) (* 91 S3)))
 (= X17 (- (* 959 S2) (* 91 S3)))
 (= X17 (- (* 91 S2) (* 959 S3)))
 (= X17 (+ (* 959 S2) (* 171 S3)))
 (= X17 (- (* 959 S2) (* 171 S3)))
 (= X17 (- (* 171 S2) (* 959 S3)))
 (= X17 (+ (* 959 S2) (* 671 S3)))
 (= X17 (- (* 959 S2) (* 671 S3)))
 (= X17 (- (* 671 S2) (* 959 S3)))
 (= X17 (+ (* 959 S2) (* 911 S3)))
 (= X17 (- (* 959 S2) (* 911 S3)))
 (= X17 (- (* 911 S2) (* 959 S3)))
 (= X17 (+ (* 959 S2) (* X16 S3)))
 (= X17 (- (* 959 S2) (* X16 S3)))
 (= X17 (- (* X16 S2) (* 959 S3)))
 (= X17 (+ (* 77 S2) S3))
 (= X17 (- (* 77 S2) S3))
 (= X17 (- S2 (* 77 S3)))
 (= X17 (+ (* 77 S2) (* 77 S3)))
 (= X17 (- (* 77 S2) (* 77 S3)))
 (= X17 (+ (* 77 S2) (* 333 S3)))
 (= X17 (- (* 77 S2) (* 333 S3)))
 (= X17 (- (* 333 S2) (* 77 S3)))
 (= X17 (+ (* 77 S2) (* 205 S3)))
 (= X17 (- (* 77 S2) (* 205 S3)))
 (= X17 (- (* 205 S2) (* 77 S3)))
 (= X17 (+ (* 77 S2) (* 155 S3)))
 (= X17 (- (* 77 S2) (* 155 S3)))
 (= X17 (- (* 155 S2) (* 77 S3)))
 (= X17 (+ (* 77 S2) (* 301 S3)))
 (= X17 (- (* 77 S2) (* 301 S3)))
 (= X17 (- (* 301 S2) (* 77 S3)))
 (= X17 (+ (* 77 S2) (* 411 S3)))
 (= X17 (- (* 77 S2) (* 411 S3)))
 (= X17 (- (* 411 S2) (* 77 S3)))
 (= X17 (+ (* 77 S2) (* 187 S3)))
 (= X17 (- (* 77 S2) (* 187 S3)))
 (= X17 (- (* 187 S2) (* 77 S3)))
 (= X17 (+ (* 77 S2) (* 91 S3)))
 (= X17 (- (* 77 S2) (* 91 S3)))
 (= X17 (- (* 91 S2) (* 77 S3)))
 (= X17 (+ (* 77 S2) (* 171 S3)))
 (= X17 (- (* 77 S2) (* 171 S3)))
 (= X17 (- (* 171 S2) (* 77 S3)))
 (= X17 (+ (* 77 S2) (* 671 S3)))
 (= X17 (- (* 77 S2) (* 671 S3)))
 (= X17 (- (* 671 S2) (* 77 S3)))
 (= X17 (+ (* 77 S2) (* 911 S3)))
 (= X17 (- (* 77 S2) (* 911 S3)))
 (= X17 (- (* 911 S2) (* 77 S3)))
 (= X17 (+ (* 77 S2) (* X16 S3)))
 (= X17 (- (* 77 S2) (* X16 S3)))
 (= X17 (- (* X16 S2) (* 77 S3)))
 (= X17 (+ (* 333 S2) S3))
 (= X17 (- (* 333 S2) S3))
 (= X17 (- S2 (* 333 S3)))
 (= X17 (+ (* 333 S2) (* 333 S3)))
 (= X17 (- (* 333 S2) (* 333 S3)))
 (= X17 (+ (* 333 S2) (* 205 S3)))
 (= X17 (- (* 333 S2) (* 205 S3)))
 (= X17 (- (* 205 S2) (* 333 S3)))
 (= X17 (+ (* 333 S2) (* 155 S3)))
 (= X17 (- (* 333 S2) (* 155 S3)))
 (= X17 (- (* 155 S2) (* 333 S3)))
 (= X17 (+ (* 333 S2) (* 301 S3)))
 (= X17 (- (* 333 S2) (* 301 S3)))
 (= X17 (- (* 301 S2) (* 333 S3)))
 (= X17 (+ (* 333 S2) (* 411 S3)))
 (= X17 (- (* 333 S2) (* 411 S3)))
 (= X17 (- (* 411 S2) (* 333 S3)))
 (= X17 (+ (* 333 S2) (* 187 S3)))
 (= X17 (- (* 333 S2) (* 187 S3)))
 (= X17 (- (* 187 S2) (* 333 S3)))
 (= X17 (+ (* 333 S2) (* 91 S3)))
 (= X17 (- (* 333 S2) (* 91 S3)))
 (= X17 (- (* 91 S2) (* 333 S3)))
 (= X17 (+ (* 333 S2) (* 171 S3)))
 (= X17 (- (* 333 S2) (* 171 S3)))
 (= X17 (- (* 171 S2) (* 333 S3)))
 (= X17 (+ (* 333 S2) (* 671 S3)))
 (= X17 (- (* 333 S2) (* 671 S3)))
 (= X17 (- (* 671 S2) (* 333 S3)))
 (= X17 (+ (* 333 S2) (* 911 S3)))
 (= X17 (- (* 333 S2) (* 911 S3)))
 (= X17 (- (* 911 S2) (* 333 S3)))
 (= X17 (+ (* 333 S2) (* X16 S3)))
 (= X17 (- (* 333 S2) (* X16 S3)))
 (= X17 (- (* X16 S2) (* 333 S3)))
 (= X17 (+ (* 205 S2) S3))
 (= X17 (- (* 205 S2) S3))
 (= X17 (- S2 (* 205 S3)))
 (= X17 (+ (* 205 S2) (* 205 S3)))
 (= X17 (- (* 205 S2) (* 205 S3)))
 (= X17 (+ (* 205 S2) (* 155 S3)))
 (= X17 (- (* 205 S2) (* 155 S3)))
 (= X17 (- (* 155 S2) (* 205 S3)))
 (= X17 (+ (* 205 S2) (* 301 S3)))
 (= X17 (- (* 205 S2) (* 301 S3)))
 (= X17 (- (* 301 S2) (* 205 S3)))
 (= X17 (+ (* 205 S2) (* 411 S3)))
 (= X17 (- (* 205 S2) (* 411 S3)))
 (= X17 (- (* 411 S2) (* 205 S3)))
 (= X17 (+ (* 205 S2) (* 187 S3)))
 (= X17 (- (* 205 S2) (* 187 S3)))
 (= X17 (- (* 187 S2) (* 205 S3)))
 (= X17 (+ (* 205 S2) (* 91 S3)))
 (= X17 (- (* 205 S2) (* 91 S3)))
 (= X17 (- (* 91 S2) (* 205 S3)))
 (= X17 (+ (* 205 S2) (* 171 S3)))
 (= X17 (- (* 205 S2) (* 171 S3)))
 (= X17 (- (* 171 S2) (* 205 S3)))
 (= X17 (+ (* 205 S2) (* 671 S3)))
 (= X17 (- (* 205 S2) (* 671 S3)))
 (= X17 (- (* 671 S2) (* 205 S3)))
 (= X17 (+ (* 205 S2) (* 911 S3)))
 (= X17 (- (* 205 S2) (* 911 S3)))
 (= X17 (- (* 911 S2) (* 205 S3)))
 (= X17 (+ (* 205 S2) (* X16 S3)))
 (= X17 (- (* 205 S2) (* X16 S3)))
 (= X17 (- (* X16 S2) (* 205 S3)))
 (= X17 (+ (* 155 S2) S3))
 (= X17 (- (* 155 S2) S3))
 (= X17 (- S2 (* 155 S3)))
 (= X17 (+ (* 155 S2) (* 155 S3)))
 (= X17 (- (* 155 S2) (* 155 S3)))
 (= X17 (+ (* 155 S2) (* 301 S3)))
 (= X17 (- (* 155 S2) (* 301 S3)))
 (= X17 (- (* 301 S2) (* 155 S3)))
 (= X17 (+ (* 155 S2) (* 411 S3)))
 (= X17 (- (* 155 S2) (* 411 S3)))
 (= X17 (- (* 411 S2) (* 155 S3)))
 (= X17 (+ (* 155 S2) (* 187 S3)))
 (= X17 (- (* 155 S2) (* 187 S3)))
 (= X17 (- (* 187 S2) (* 155 S3)))
 (= X17 (+ (* 155 S2) (* 91 S3)))
 (= X17 (- (* 155 S2) (* 91 S3)))
 (= X17 (- (* 91 S2) (* 155 S3)))
 (= X17 (+ (* 155 S2) (* 171 S3)))
 (= X17 (- (* 155 S2) (* 171 S3)))
 (= X17 (- (* 171 S2) (* 155 S3)))
 (= X17 (+ (* 155 S2) (* 671 S3)))
 (= X17 (- (* 155 S2) (* 671 S3)))
 (= X17 (- (* 671 S2) (* 155 S3)))
 (= X17 (+ (* 155 S2) (* 911 S3)))
 (= X17 (- (* 155 S2) (* 911 S3)))
 (= X17 (- (* 911 S2) (* 155 S3)))
 (= X17 (+ (* 155 S2) (* X16 S3)))
 (= X17 (- (* 155 S2) (* X16 S3)))
 (= X17 (- (* X16 S2) (* 155 S3)))
 (= X17 (+ (* 301 S2) S3))
 (= X17 (- (* 301 S2) S3))
 (= X17 (- S2 (* 301 S3)))
 (= X17 (+ (* 301 S2) (* 301 S3)))
 (= X17 (- (* 301 S2) (* 301 S3)))
 (= X17 (+ (* 301 S2) (* 411 S3)))
 (= X17 (- (* 301 S2) (* 411 S3)))
 (= X17 (- (* 411 S2) (* 301 S3)))
 (= X17 (+ (* 301 S2) (* 187 S3)))
 (= X17 (- (* 301 S2) (* 187 S3)))
 (= X17 (- (* 187 S2) (* 301 S3)))
 (= X17 (+ (* 301 S2) (* 91 S3)))
 (= X17 (- (* 301 S2) (* 91 S3)))
 (= X17 (- (* 91 S2) (* 301 S3)))
 (= X17 (+ (* 301 S2) (* 171 S3)))
 (= X17 (- (* 301 S2) (* 171 S3)))
 (= X17 (- (* 171 S2) (* 301 S3)))
 (= X17 (+ (* 301 S2) (* 671 S3)))
 (= X17 (- (* 301 S2) (* 671 S3)))
 (= X17 (- (* 671 S2) (* 301 S3)))
 (= X17 (+ (* 301 S2) (* 911 S3)))
 (= X17 (- (* 301 S2) (* 911 S3)))
 (= X17 (- (* 911 S2) (* 301 S3)))
 (= X17 (+ (* 301 S2) (* X16 S3)))
 (= X17 (- (* 301 S2) (* X16 S3)))
 (= X17 (- (* X16 S2) (* 301 S3)))
 (= X17 (+ (* 411 S2) S3))
 (= X17 (- (* 411 S2) S3))
 (= X17 (- S2 (* 411 S3)))
 (= X17 (+ (* 411 S2) (* 411 S3)))
 (= X17 (- (* 411 S2) (* 411 S3)))
 (= X17 (+ (* 411 S2) (* 187 S3)))
 (= X17 (- (* 411 S2) (* 187 S3)))
 (= X17 (- (* 187 S2) (* 411 S3)))
 (= X17 (+ (* 411 S2) (* 91 S3)))
 (= X17 (- (* 411 S2) (* 91 S3)))
 (= X17 (- (* 91 S2) (* 411 S3)))
 (= X17 (+ (* 411 S2) (* 171 S3)))
 (= X17 (- (* 411 S2) (* 171 S3)))
 (= X17 (- (* 171 S2) (* 411 S3)))
 (= X17 (+ (* 411 S2) (* 671 S3)))
 (= X17 (- (* 411 S2) (* 671 S3)))
 (= X17 (- (* 671 S2) (* 411 S3)))
 (= X17 (+ (* 411 S2) (* 911 S3)))
 (= X17 (- (* 411 S2) (* 911 S3)))
 (= X17 (- (* 911 S2) (* 411 S3)))
 (= X17 (+ (* 411 S2) (* X16 S3)))
 (= X17 (- (* 411 S2) (* X16 S3)))
 (= X17 (- (* X16 S2) (* 411 S3)))
 (= X17 (+ (* 187 S2) S3))
 (= X17 (- (* 187 S2) S3))
 (= X17 (- S2 (* 187 S3)))
 (= X17 (+ (* 187 S2) (* 187 S3)))
 (= X17 (- (* 187 S2) (* 187 S3)))
 (= X17 (+ (* 187 S2) (* 91 S3)))
 (= X17 (- (* 187 S2) (* 91 S3)))
 (= X17 (- (* 91 S2) (* 187 S3)))
 (= X17 (+ (* 187 S2) (* 171 S3)))
 (= X17 (- (* 187 S2) (* 171 S3)))
 (= X17 (- (* 171 S2) (* 187 S3)))
 (= X17 (+ (* 187 S2) (* 671 S3)))
 (= X17 (- (* 187 S2) (* 671 S3)))
 (= X17 (- (* 671 S2) (* 187 S3)))
 (= X17 (+ (* 187 S2) (* 911 S3)))
 (= X17 (- (* 187 S2) (* 911 S3)))
 (= X17 (- (* 911 S2) (* 187 S3)))
 (= X17 (+ (* 187 S2) (* X16 S3)))
 (= X17 (- (* 187 S2) (* X16 S3)))
 (= X17 (- (* X16 S2) (* 187 S3)))
 (= X17 (+ (* 91 S2) S3))
 (= X17 (- (* 91 S2) S3))
 (= X17 (- S2 (* 91 S3)))
 (= X17 (+ (* 91 S2) (* 91 S3)))
 (= X17 (- (* 91 S2) (* 91 S3)))
 (= X17 (+ (* 91 S2) (* 171 S3)))
 (= X17 (- (* 91 S2) (* 171 S3)))
 (= X17 (- (* 171 S2) (* 91 S3)))
 (= X17 (+ (* 91 S2) (* 671 S3)))
 (= X17 (- (* 91 S2) (* 671 S3)))
 (= X17 (- (* 671 S2) (* 91 S3)))
 (= X17 (+ (* 91 S2) (* 911 S3)))
 (= X17 (- (* 91 S2) (* 911 S3)))
 (= X17 (- (* 911 S2) (* 91 S3)))
 (= X17 (+ (* 91 S2) (* X16 S3)))
 (= X17 (- (* 91 S2) (* X16 S3)))
 (= X17 (- (* X16 S2) (* 91 S3)))
 (= X17 (+ (* 171 S2) S3))
 (= X17 (- (* 171 S2) S3))
 (= X17 (- S2 (* 171 S3)))
 (= X17 (+ (* 171 S2) (* 171 S3)))
 (= X17 (- (* 171 S2) (* 171 S3)))
 (= X17 (+ (* 171 S2) (* 671 S3)))
 (= X17 (- (* 171 S2) (* 671 S3)))
 (= X17 (- (* 671 S2) (* 171 S3)))
 (= X17 (+ (* 171 S2) (* 911 S3)))
 (= X17 (- (* 171 S2) (* 911 S3)))
 (= X17 (- (* 911 S2) (* 171 S3)))
 (= X17 (+ (* 171 S2) (* X16 S3)))
 (= X17 (- (* 171 S2) (* X16 S3)))
 (= X17 (- (* X16 S2) (* 171 S3)))
 (= X17 (+ (* 671 S2) S3))
 (= X17 (- (* 671 S2) S3))
 (= X17 (- S2 (* 671 S3)))
 (= X17 (+ (* 671 S2) (* 671 S3)))
 (= X17 (- (* 671 S2) (* 671 S3)))
 (= X17 (+ (* 671 S2) (* 911 S3)))
 (= X17 (- (* 671 S2) (* 911 S3)))
 (= X17 (- (* 911 S2) (* 671 S3)))
 (= X17 (+ (* 671 S2) (* X16 S3)))
 (= X17 (- (* 671 S2) (* X16 S3)))
 (= X17 (- (* X16 S2) (* 671 S3)))
 (= X17 (+ (* 911 S2) S3))
 (= X17 (- (* 911 S2) S3))
 (= X17 (- S2 (* 911 S3)))
 (= X17 (+ (* 911 S2) (* 911 S3)))
 (= X17 (- (* 911 S2) (* 911 S3)))
 (= X17 (+ (* 911 S2) (* X16 S3)))
 (= X17 (- (* 911 S2) (* X16 S3)))
 (= X17 (- (* X16 S2) (* 911 S3)))
 (= X17 (+ (* X16 S2) S3))
 (= X17 (- (* X16 S2) S3))
 (= X17 (- S2 (* X16 S3)))
 (= X17 (+ (* X16 S2) (* X16 S3)))
 (= X17 (- (* X16 S2) (* X16 S3)))
))
(assert (and (> X17 0) (< X17 2048) (power2 S2) (power2 S3)))
(assert
 (= X17 887)
)
(check-sat)
(exit)
