(set-logic QF_NIA)
(set-info :source |
 more info in 'N. P. Lopes, L. Aksoy, V. Manquinho, J. Monteiro.
 Optimally Solving the MCM Problem Using Pseudo-Boolean Satisfiability.
 Technical Report RT/43/2010, INESC-ID, Nov. 2010'. |)
(set-info :smt-lib-version 2.0)
(set-info :category "industrial")
(set-info :status unknown)
(declare-fun X19 () Int)
(declare-fun X20 () Int)
(declare-fun S0 () Int)
(declare-fun S1 () Int)
(declare-fun S2 () Int)
(declare-fun S3 () Int)
(define-fun power2 ((x Int)) Bool
  (or (= x 1024) (= x 512) (= x 256) (= x 128) (= x 64) (= x 32) (= x 16) (= x 8) (= x 4) (= x 2) (= x 1)))
(assert (or
 (= X19 (+ S0 S1))
 (= X19 (- S0 S1))
 (= X19 (+ (* 31 S0) S1))
 (= X19 (- (* 31 S0) S1))
 (= X19 (- S0 (* 31 S1)))
 (= X19 (+ (* 31 S0) (* 31 S1)))
 (= X19 (- (* 31 S0) (* 31 S1)))
 (= X19 (+ (* 31 S0) (* 7 S1)))
 (= X19 (- (* 31 S0) (* 7 S1)))
 (= X19 (- (* 7 S0) (* 31 S1)))
 (= X19 (+ (* 31 S0) (* 17 S1)))
 (= X19 (- (* 31 S0) (* 17 S1)))
 (= X19 (- (* 17 S0) (* 31 S1)))
 (= X19 (+ (* 31 S0) (* 3 S1)))
 (= X19 (- (* 31 S0) (* 3 S1)))
 (= X19 (- (* 3 S0) (* 31 S1)))
 (= X19 (+ (* 31 S0) (* 63 S1)))
 (= X19 (- (* 31 S0) (* 63 S1)))
 (= X19 (- (* 63 S0) (* 31 S1)))
 (= X19 (+ (* 31 S0) (* 95 S1)))
 (= X19 (- (* 31 S0) (* 95 S1)))
 (= X19 (- (* 95 S0) (* 31 S1)))
 (= X19 (+ (* 31 S0) (* 57 S1)))
 (= X19 (- (* 31 S0) (* 57 S1)))
 (= X19 (- (* 57 S0) (* 31 S1)))
 (= X19 (+ (* 31 S0) (* 99 S1)))
 (= X19 (- (* 31 S0) (* 99 S1)))
 (= X19 (- (* 99 S0) (* 31 S1)))
 (= X19 (+ (* 31 S0) (* 229 S1)))
 (= X19 (- (* 31 S0) (* 229 S1)))
 (= X19 (- (* 229 S0) (* 31 S1)))
 (= X19 (+ (* 31 S0) (* 141 S1)))
 (= X19 (- (* 31 S0) (* 141 S1)))
 (= X19 (- (* 141 S0) (* 31 S1)))
 (= X19 (+ (* 31 S0) (* 167 S1)))
 (= X19 (- (* 31 S0) (* 167 S1)))
 (= X19 (- (* 167 S0) (* 31 S1)))
 (= X19 (+ (* 31 S0) (* 977 S1)))
 (= X19 (- (* 31 S0) (* 977 S1)))
 (= X19 (- (* 977 S0) (* 31 S1)))
 (= X19 (+ (* 31 S0) (* 981 S1)))
 (= X19 (- (* 31 S0) (* 981 S1)))
 (= X19 (- (* 981 S0) (* 31 S1)))
 (= X19 (+ (* 31 S0) (* 959 S1)))
 (= X19 (- (* 31 S0) (* 959 S1)))
 (= X19 (- (* 959 S0) (* 31 S1)))
 (= X19 (+ (* 31 S0) (* 211 S1)))
 (= X19 (- (* 31 S0) (* 211 S1)))
 (= X19 (- (* 211 S0) (* 31 S1)))
 (= X19 (+ (* 31 S0) (* 643 S1)))
 (= X19 (- (* 31 S0) (* 643 S1)))
 (= X19 (- (* 643 S0) (* 31 S1)))
 (= X19 (+ (* 31 S0) (* 627 S1)))
 (= X19 (- (* 31 S0) (* 627 S1)))
 (= X19 (- (* 627 S0) (* 31 S1)))
 (= X19 (+ (* 31 S0) (* 867 S1)))
 (= X19 (- (* 31 S0) (* 867 S1)))
 (= X19 (- (* 867 S0) (* 31 S1)))
 (= X19 (+ (* 31 S0) (* 315 S1)))
 (= X19 (- (* 31 S0) (* 315 S1)))
 (= X19 (- (* 315 S0) (* 31 S1)))
 (= X19 (+ (* 7 S0) S1))
 (= X19 (- (* 7 S0) S1))
 (= X19 (- S0 (* 7 S1)))
 (= X19 (+ (* 7 S0) (* 7 S1)))
 (= X19 (- (* 7 S0) (* 7 S1)))
 (= X19 (+ (* 7 S0) (* 17 S1)))
 (= X19 (- (* 7 S0) (* 17 S1)))
 (= X19 (- (* 17 S0) (* 7 S1)))
 (= X19 (+ (* 7 S0) (* 3 S1)))
 (= X19 (- (* 7 S0) (* 3 S1)))
 (= X19 (- (* 3 S0) (* 7 S1)))
 (= X19 (+ (* 7 S0) (* 63 S1)))
 (= X19 (- (* 7 S0) (* 63 S1)))
 (= X19 (- (* 63 S0) (* 7 S1)))
 (= X19 (+ (* 7 S0) (* 95 S1)))
 (= X19 (- (* 7 S0) (* 95 S1)))
 (= X19 (- (* 95 S0) (* 7 S1)))
 (= X19 (+ (* 7 S0) (* 57 S1)))
 (= X19 (- (* 7 S0) (* 57 S1)))
 (= X19 (- (* 57 S0) (* 7 S1)))
 (= X19 (+ (* 7 S0) (* 99 S1)))
 (= X19 (- (* 7 S0) (* 99 S1)))
 (= X19 (- (* 99 S0) (* 7 S1)))
 (= X19 (+ (* 7 S0) (* 229 S1)))
 (= X19 (- (* 7 S0) (* 229 S1)))
 (= X19 (- (* 229 S0) (* 7 S1)))
 (= X19 (+ (* 7 S0) (* 141 S1)))
 (= X19 (- (* 7 S0) (* 141 S1)))
 (= X19 (- (* 141 S0) (* 7 S1)))
 (= X19 (+ (* 7 S0) (* 167 S1)))
 (= X19 (- (* 7 S0) (* 167 S1)))
 (= X19 (- (* 167 S0) (* 7 S1)))
 (= X19 (+ (* 7 S0) (* 977 S1)))
 (= X19 (- (* 7 S0) (* 977 S1)))
 (= X19 (- (* 977 S0) (* 7 S1)))
 (= X19 (+ (* 7 S0) (* 981 S1)))
 (= X19 (- (* 7 S0) (* 981 S1)))
 (= X19 (- (* 981 S0) (* 7 S1)))
 (= X19 (+ (* 7 S0) (* 959 S1)))
 (= X19 (- (* 7 S0) (* 959 S1)))
 (= X19 (- (* 959 S0) (* 7 S1)))
 (= X19 (+ (* 7 S0) (* 211 S1)))
 (= X19 (- (* 7 S0) (* 211 S1)))
 (= X19 (- (* 211 S0) (* 7 S1)))
 (= X19 (+ (* 7 S0) (* 643 S1)))
 (= X19 (- (* 7 S0) (* 643 S1)))
 (= X19 (- (* 643 S0) (* 7 S1)))
 (= X19 (+ (* 7 S0) (* 627 S1)))
 (= X19 (- (* 7 S0) (* 627 S1)))
 (= X19 (- (* 627 S0) (* 7 S1)))
 (= X19 (+ (* 7 S0) (* 867 S1)))
 (= X19 (- (* 7 S0) (* 867 S1)))
 (= X19 (- (* 867 S0) (* 7 S1)))
 (= X19 (+ (* 7 S0) (* 315 S1)))
 (= X19 (- (* 7 S0) (* 315 S1)))
 (= X19 (- (* 315 S0) (* 7 S1)))
 (= X19 (+ (* 17 S0) S1))
 (= X19 (- (* 17 S0) S1))
 (= X19 (- S0 (* 17 S1)))
 (= X19 (+ (* 17 S0) (* 17 S1)))
 (= X19 (- (* 17 S0) (* 17 S1)))
 (= X19 (+ (* 17 S0) (* 3 S1)))
 (= X19 (- (* 17 S0) (* 3 S1)))
 (= X19 (- (* 3 S0) (* 17 S1)))
 (= X19 (+ (* 17 S0) (* 63 S1)))
 (= X19 (- (* 17 S0) (* 63 S1)))
 (= X19 (- (* 63 S0) (* 17 S1)))
 (= X19 (+ (* 17 S0) (* 95 S1)))
 (= X19 (- (* 17 S0) (* 95 S1)))
 (= X19 (- (* 95 S0) (* 17 S1)))
 (= X19 (+ (* 17 S0) (* 57 S1)))
 (= X19 (- (* 17 S0) (* 57 S1)))
 (= X19 (- (* 57 S0) (* 17 S1)))
 (= X19 (+ (* 17 S0) (* 99 S1)))
 (= X19 (- (* 17 S0) (* 99 S1)))
 (= X19 (- (* 99 S0) (* 17 S1)))
 (= X19 (+ (* 17 S0) (* 229 S1)))
 (= X19 (- (* 17 S0) (* 229 S1)))
 (= X19 (- (* 229 S0) (* 17 S1)))
 (= X19 (+ (* 17 S0) (* 141 S1)))
 (= X19 (- (* 17 S0) (* 141 S1)))
 (= X19 (- (* 141 S0) (* 17 S1)))
 (= X19 (+ (* 17 S0) (* 167 S1)))
 (= X19 (- (* 17 S0) (* 167 S1)))
 (= X19 (- (* 167 S0) (* 17 S1)))
 (= X19 (+ (* 17 S0) (* 977 S1)))
 (= X19 (- (* 17 S0) (* 977 S1)))
 (= X19 (- (* 977 S0) (* 17 S1)))
 (= X19 (+ (* 17 S0) (* 981 S1)))
 (= X19 (- (* 17 S0) (* 981 S1)))
 (= X19 (- (* 981 S0) (* 17 S1)))
 (= X19 (+ (* 17 S0) (* 959 S1)))
 (= X19 (- (* 17 S0) (* 959 S1)))
 (= X19 (- (* 959 S0) (* 17 S1)))
 (= X19 (+ (* 17 S0) (* 211 S1)))
 (= X19 (- (* 17 S0) (* 211 S1)))
 (= X19 (- (* 211 S0) (* 17 S1)))
 (= X19 (+ (* 17 S0) (* 643 S1)))
 (= X19 (- (* 17 S0) (* 643 S1)))
 (= X19 (- (* 643 S0) (* 17 S1)))
 (= X19 (+ (* 17 S0) (* 627 S1)))
 (= X19 (- (* 17 S0) (* 627 S1)))
 (= X19 (- (* 627 S0) (* 17 S1)))
 (= X19 (+ (* 17 S0) (* 867 S1)))
 (= X19 (- (* 17 S0) (* 867 S1)))
 (= X19 (- (* 867 S0) (* 17 S1)))
 (= X19 (+ (* 17 S0) (* 315 S1)))
 (= X19 (- (* 17 S0) (* 315 S1)))
 (= X19 (- (* 315 S0) (* 17 S1)))
 (= X19 (+ (* 3 S0) S1))
 (= X19 (- (* 3 S0) S1))
 (= X19 (- S0 (* 3 S1)))
 (= X19 (+ (* 3 S0) (* 3 S1)))
 (= X19 (- (* 3 S0) (* 3 S1)))
 (= X19 (+ (* 3 S0) (* 63 S1)))
 (= X19 (- (* 3 S0) (* 63 S1)))
 (= X19 (- (* 63 S0) (* 3 S1)))
 (= X19 (+ (* 3 S0) (* 95 S1)))
 (= X19 (- (* 3 S0) (* 95 S1)))
 (= X19 (- (* 95 S0) (* 3 S1)))
 (= X19 (+ (* 3 S0) (* 57 S1)))
 (= X19 (- (* 3 S0) (* 57 S1)))
 (= X19 (- (* 57 S0) (* 3 S1)))
 (= X19 (+ (* 3 S0) (* 99 S1)))
 (= X19 (- (* 3 S0) (* 99 S1)))
 (= X19 (- (* 99 S0) (* 3 S1)))
 (= X19 (+ (* 3 S0) (* 229 S1)))
 (= X19 (- (* 3 S0) (* 229 S1)))
 (= X19 (- (* 229 S0) (* 3 S1)))
 (= X19 (+ (* 3 S0) (* 141 S1)))
 (= X19 (- (* 3 S0) (* 141 S1)))
 (= X19 (- (* 141 S0) (* 3 S1)))
 (= X19 (+ (* 3 S0) (* 167 S1)))
 (= X19 (- (* 3 S0) (* 167 S1)))
 (= X19 (- (* 167 S0) (* 3 S1)))
 (= X19 (+ (* 3 S0) (* 977 S1)))
 (= X19 (- (* 3 S0) (* 977 S1)))
 (= X19 (- (* 977 S0) (* 3 S1)))
 (= X19 (+ (* 3 S0) (* 981 S1)))
 (= X19 (- (* 3 S0) (* 981 S1)))
 (= X19 (- (* 981 S0) (* 3 S1)))
 (= X19 (+ (* 3 S0) (* 959 S1)))
 (= X19 (- (* 3 S0) (* 959 S1)))
 (= X19 (- (* 959 S0) (* 3 S1)))
 (= X19 (+ (* 3 S0) (* 211 S1)))
 (= X19 (- (* 3 S0) (* 211 S1)))
 (= X19 (- (* 211 S0) (* 3 S1)))
 (= X19 (+ (* 3 S0) (* 643 S1)))
 (= X19 (- (* 3 S0) (* 643 S1)))
 (= X19 (- (* 643 S0) (* 3 S1)))
 (= X19 (+ (* 3 S0) (* 627 S1)))
 (= X19 (- (* 3 S0) (* 627 S1)))
 (= X19 (- (* 627 S0) (* 3 S1)))
 (= X19 (+ (* 3 S0) (* 867 S1)))
 (= X19 (- (* 3 S0) (* 867 S1)))
 (= X19 (- (* 867 S0) (* 3 S1)))
 (= X19 (+ (* 3 S0) (* 315 S1)))
 (= X19 (- (* 3 S0) (* 315 S1)))
 (= X19 (- (* 315 S0) (* 3 S1)))
 (= X19 (+ (* 63 S0) S1))
 (= X19 (- (* 63 S0) S1))
 (= X19 (- S0 (* 63 S1)))
 (= X19 (+ (* 63 S0) (* 63 S1)))
 (= X19 (- (* 63 S0) (* 63 S1)))
 (= X19 (+ (* 63 S0) (* 95 S1)))
 (= X19 (- (* 63 S0) (* 95 S1)))
 (= X19 (- (* 95 S0) (* 63 S1)))
 (= X19 (+ (* 63 S0) (* 57 S1)))
 (= X19 (- (* 63 S0) (* 57 S1)))
 (= X19 (- (* 57 S0) (* 63 S1)))
 (= X19 (+ (* 63 S0) (* 99 S1)))
 (= X19 (- (* 63 S0) (* 99 S1)))
 (= X19 (- (* 99 S0) (* 63 S1)))
 (= X19 (+ (* 63 S0) (* 229 S1)))
 (= X19 (- (* 63 S0) (* 229 S1)))
 (= X19 (- (* 229 S0) (* 63 S1)))
 (= X19 (+ (* 63 S0) (* 141 S1)))
 (= X19 (- (* 63 S0) (* 141 S1)))
 (= X19 (- (* 141 S0) (* 63 S1)))
 (= X19 (+ (* 63 S0) (* 167 S1)))
 (= X19 (- (* 63 S0) (* 167 S1)))
 (= X19 (- (* 167 S0) (* 63 S1)))
 (= X19 (+ (* 63 S0) (* 977 S1)))
 (= X19 (- (* 63 S0) (* 977 S1)))
 (= X19 (- (* 977 S0) (* 63 S1)))
 (= X19 (+ (* 63 S0) (* 981 S1)))
 (= X19 (- (* 63 S0) (* 981 S1)))
 (= X19 (- (* 981 S0) (* 63 S1)))
 (= X19 (+ (* 63 S0) (* 959 S1)))
 (= X19 (- (* 63 S0) (* 959 S1)))
 (= X19 (- (* 959 S0) (* 63 S1)))
 (= X19 (+ (* 63 S0) (* 211 S1)))
 (= X19 (- (* 63 S0) (* 211 S1)))
 (= X19 (- (* 211 S0) (* 63 S1)))
 (= X19 (+ (* 63 S0) (* 643 S1)))
 (= X19 (- (* 63 S0) (* 643 S1)))
 (= X19 (- (* 643 S0) (* 63 S1)))
 (= X19 (+ (* 63 S0) (* 627 S1)))
 (= X19 (- (* 63 S0) (* 627 S1)))
 (= X19 (- (* 627 S0) (* 63 S1)))
 (= X19 (+ (* 63 S0) (* 867 S1)))
 (= X19 (- (* 63 S0) (* 867 S1)))
 (= X19 (- (* 867 S0) (* 63 S1)))
 (= X19 (+ (* 63 S0) (* 315 S1)))
 (= X19 (- (* 63 S0) (* 315 S1)))
 (= X19 (- (* 315 S0) (* 63 S1)))
 (= X19 (+ (* 95 S0) S1))
 (= X19 (- (* 95 S0) S1))
 (= X19 (- S0 (* 95 S1)))
 (= X19 (+ (* 95 S0) (* 95 S1)))
 (= X19 (- (* 95 S0) (* 95 S1)))
 (= X19 (+ (* 95 S0) (* 57 S1)))
 (= X19 (- (* 95 S0) (* 57 S1)))
 (= X19 (- (* 57 S0) (* 95 S1)))
 (= X19 (+ (* 95 S0) (* 99 S1)))
 (= X19 (- (* 95 S0) (* 99 S1)))
 (= X19 (- (* 99 S0) (* 95 S1)))
 (= X19 (+ (* 95 S0) (* 229 S1)))
 (= X19 (- (* 95 S0) (* 229 S1)))
 (= X19 (- (* 229 S0) (* 95 S1)))
 (= X19 (+ (* 95 S0) (* 141 S1)))
 (= X19 (- (* 95 S0) (* 141 S1)))
 (= X19 (- (* 141 S0) (* 95 S1)))
 (= X19 (+ (* 95 S0) (* 167 S1)))
 (= X19 (- (* 95 S0) (* 167 S1)))
 (= X19 (- (* 167 S0) (* 95 S1)))
 (= X19 (+ (* 95 S0) (* 977 S1)))
 (= X19 (- (* 95 S0) (* 977 S1)))
 (= X19 (- (* 977 S0) (* 95 S1)))
 (= X19 (+ (* 95 S0) (* 981 S1)))
 (= X19 (- (* 95 S0) (* 981 S1)))
 (= X19 (- (* 981 S0) (* 95 S1)))
 (= X19 (+ (* 95 S0) (* 959 S1)))
 (= X19 (- (* 95 S0) (* 959 S1)))
 (= X19 (- (* 959 S0) (* 95 S1)))
 (= X19 (+ (* 95 S0) (* 211 S1)))
 (= X19 (- (* 95 S0) (* 211 S1)))
 (= X19 (- (* 211 S0) (* 95 S1)))
 (= X19 (+ (* 95 S0) (* 643 S1)))
 (= X19 (- (* 95 S0) (* 643 S1)))
 (= X19 (- (* 643 S0) (* 95 S1)))
 (= X19 (+ (* 95 S0) (* 627 S1)))
 (= X19 (- (* 95 S0) (* 627 S1)))
 (= X19 (- (* 627 S0) (* 95 S1)))
 (= X19 (+ (* 95 S0) (* 867 S1)))
 (= X19 (- (* 95 S0) (* 867 S1)))
 (= X19 (- (* 867 S0) (* 95 S1)))
 (= X19 (+ (* 95 S0) (* 315 S1)))
 (= X19 (- (* 95 S0) (* 315 S1)))
 (= X19 (- (* 315 S0) (* 95 S1)))
 (= X19 (+ (* 57 S0) S1))
 (= X19 (- (* 57 S0) S1))
 (= X19 (- S0 (* 57 S1)))
 (= X19 (+ (* 57 S0) (* 57 S1)))
 (= X19 (- (* 57 S0) (* 57 S1)))
 (= X19 (+ (* 57 S0) (* 99 S1)))
 (= X19 (- (* 57 S0) (* 99 S1)))
 (= X19 (- (* 99 S0) (* 57 S1)))
 (= X19 (+ (* 57 S0) (* 229 S1)))
 (= X19 (- (* 57 S0) (* 229 S1)))
 (= X19 (- (* 229 S0) (* 57 S1)))
 (= X19 (+ (* 57 S0) (* 141 S1)))
 (= X19 (- (* 57 S0) (* 141 S1)))
 (= X19 (- (* 141 S0) (* 57 S1)))
 (= X19 (+ (* 57 S0) (* 167 S1)))
 (= X19 (- (* 57 S0) (* 167 S1)))
 (= X19 (- (* 167 S0) (* 57 S1)))
 (= X19 (+ (* 57 S0) (* 977 S1)))
 (= X19 (- (* 57 S0) (* 977 S1)))
 (= X19 (- (* 977 S0) (* 57 S1)))
 (= X19 (+ (* 57 S0) (* 981 S1)))
 (= X19 (- (* 57 S0) (* 981 S1)))
 (= X19 (- (* 981 S0) (* 57 S1)))
 (= X19 (+ (* 57 S0) (* 959 S1)))
 (= X19 (- (* 57 S0) (* 959 S1)))
 (= X19 (- (* 959 S0) (* 57 S1)))
 (= X19 (+ (* 57 S0) (* 211 S1)))
 (= X19 (- (* 57 S0) (* 211 S1)))
 (= X19 (- (* 211 S0) (* 57 S1)))
 (= X19 (+ (* 57 S0) (* 643 S1)))
 (= X19 (- (* 57 S0) (* 643 S1)))
 (= X19 (- (* 643 S0) (* 57 S1)))
 (= X19 (+ (* 57 S0) (* 627 S1)))
 (= X19 (- (* 57 S0) (* 627 S1)))
 (= X19 (- (* 627 S0) (* 57 S1)))
 (= X19 (+ (* 57 S0) (* 867 S1)))
 (= X19 (- (* 57 S0) (* 867 S1)))
 (= X19 (- (* 867 S0) (* 57 S1)))
 (= X19 (+ (* 57 S0) (* 315 S1)))
 (= X19 (- (* 57 S0) (* 315 S1)))
 (= X19 (- (* 315 S0) (* 57 S1)))
 (= X19 (+ (* 99 S0) S1))
 (= X19 (- (* 99 S0) S1))
 (= X19 (- S0 (* 99 S1)))
 (= X19 (+ (* 99 S0) (* 99 S1)))
 (= X19 (- (* 99 S0) (* 99 S1)))
 (= X19 (+ (* 99 S0) (* 229 S1)))
 (= X19 (- (* 99 S0) (* 229 S1)))
 (= X19 (- (* 229 S0) (* 99 S1)))
 (= X19 (+ (* 99 S0) (* 141 S1)))
 (= X19 (- (* 99 S0) (* 141 S1)))
 (= X19 (- (* 141 S0) (* 99 S1)))
 (= X19 (+ (* 99 S0) (* 167 S1)))
 (= X19 (- (* 99 S0) (* 167 S1)))
 (= X19 (- (* 167 S0) (* 99 S1)))
 (= X19 (+ (* 99 S0) (* 977 S1)))
 (= X19 (- (* 99 S0) (* 977 S1)))
 (= X19 (- (* 977 S0) (* 99 S1)))
 (= X19 (+ (* 99 S0) (* 981 S1)))
 (= X19 (- (* 99 S0) (* 981 S1)))
 (= X19 (- (* 981 S0) (* 99 S1)))
 (= X19 (+ (* 99 S0) (* 959 S1)))
 (= X19 (- (* 99 S0) (* 959 S1)))
 (= X19 (- (* 959 S0) (* 99 S1)))
 (= X19 (+ (* 99 S0) (* 211 S1)))
 (= X19 (- (* 99 S0) (* 211 S1)))
 (= X19 (- (* 211 S0) (* 99 S1)))
 (= X19 (+ (* 99 S0) (* 643 S1)))
 (= X19 (- (* 99 S0) (* 643 S1)))
 (= X19 (- (* 643 S0) (* 99 S1)))
 (= X19 (+ (* 99 S0) (* 627 S1)))
 (= X19 (- (* 99 S0) (* 627 S1)))
 (= X19 (- (* 627 S0) (* 99 S1)))
 (= X19 (+ (* 99 S0) (* 867 S1)))
 (= X19 (- (* 99 S0) (* 867 S1)))
 (= X19 (- (* 867 S0) (* 99 S1)))
 (= X19 (+ (* 99 S0) (* 315 S1)))
 (= X19 (- (* 99 S0) (* 315 S1)))
 (= X19 (- (* 315 S0) (* 99 S1)))
 (= X19 (+ (* 229 S0) S1))
 (= X19 (- (* 229 S0) S1))
 (= X19 (- S0 (* 229 S1)))
 (= X19 (+ (* 229 S0) (* 229 S1)))
 (= X19 (- (* 229 S0) (* 229 S1)))
 (= X19 (+ (* 229 S0) (* 141 S1)))
 (= X19 (- (* 229 S0) (* 141 S1)))
 (= X19 (- (* 141 S0) (* 229 S1)))
 (= X19 (+ (* 229 S0) (* 167 S1)))
 (= X19 (- (* 229 S0) (* 167 S1)))
 (= X19 (- (* 167 S0) (* 229 S1)))
 (= X19 (+ (* 229 S0) (* 977 S1)))
 (= X19 (- (* 229 S0) (* 977 S1)))
 (= X19 (- (* 977 S0) (* 229 S1)))
 (= X19 (+ (* 229 S0) (* 981 S1)))
 (= X19 (- (* 229 S0) (* 981 S1)))
 (= X19 (- (* 981 S0) (* 229 S1)))
 (= X19 (+ (* 229 S0) (* 959 S1)))
 (= X19 (- (* 229 S0) (* 959 S1)))
 (= X19 (- (* 959 S0) (* 229 S1)))
 (= X19 (+ (* 229 S0) (* 211 S1)))
 (= X19 (- (* 229 S0) (* 211 S1)))
 (= X19 (- (* 211 S0) (* 229 S1)))
 (= X19 (+ (* 229 S0) (* 643 S1)))
 (= X19 (- (* 229 S0) (* 643 S1)))
 (= X19 (- (* 643 S0) (* 229 S1)))
 (= X19 (+ (* 229 S0) (* 627 S1)))
 (= X19 (- (* 229 S0) (* 627 S1)))
 (= X19 (- (* 627 S0) (* 229 S1)))
 (= X19 (+ (* 229 S0) (* 867 S1)))
 (= X19 (- (* 229 S0) (* 867 S1)))
 (= X19 (- (* 867 S0) (* 229 S1)))
 (= X19 (+ (* 229 S0) (* 315 S1)))
 (= X19 (- (* 229 S0) (* 315 S1)))
 (= X19 (- (* 315 S0) (* 229 S1)))
 (= X19 (+ (* 141 S0) S1))
 (= X19 (- (* 141 S0) S1))
 (= X19 (- S0 (* 141 S1)))
 (= X19 (+ (* 141 S0) (* 141 S1)))
 (= X19 (- (* 141 S0) (* 141 S1)))
 (= X19 (+ (* 141 S0) (* 167 S1)))
 (= X19 (- (* 141 S0) (* 167 S1)))
 (= X19 (- (* 167 S0) (* 141 S1)))
 (= X19 (+ (* 141 S0) (* 977 S1)))
 (= X19 (- (* 141 S0) (* 977 S1)))
 (= X19 (- (* 977 S0) (* 141 S1)))
 (= X19 (+ (* 141 S0) (* 981 S1)))
 (= X19 (- (* 141 S0) (* 981 S1)))
 (= X19 (- (* 981 S0) (* 141 S1)))
 (= X19 (+ (* 141 S0) (* 959 S1)))
 (= X19 (- (* 141 S0) (* 959 S1)))
 (= X19 (- (* 959 S0) (* 141 S1)))
 (= X19 (+ (* 141 S0) (* 211 S1)))
 (= X19 (- (* 141 S0) (* 211 S1)))
 (= X19 (- (* 211 S0) (* 141 S1)))
 (= X19 (+ (* 141 S0) (* 643 S1)))
 (= X19 (- (* 141 S0) (* 643 S1)))
 (= X19 (- (* 643 S0) (* 141 S1)))
 (= X19 (+ (* 141 S0) (* 627 S1)))
 (= X19 (- (* 141 S0) (* 627 S1)))
 (= X19 (- (* 627 S0) (* 141 S1)))
 (= X19 (+ (* 141 S0) (* 867 S1)))
 (= X19 (- (* 141 S0) (* 867 S1)))
 (= X19 (- (* 867 S0) (* 141 S1)))
 (= X19 (+ (* 141 S0) (* 315 S1)))
 (= X19 (- (* 141 S0) (* 315 S1)))
 (= X19 (- (* 315 S0) (* 141 S1)))
 (= X19 (+ (* 167 S0) S1))
 (= X19 (- (* 167 S0) S1))
 (= X19 (- S0 (* 167 S1)))
 (= X19 (+ (* 167 S0) (* 167 S1)))
 (= X19 (- (* 167 S0) (* 167 S1)))
 (= X19 (+ (* 167 S0) (* 977 S1)))
 (= X19 (- (* 167 S0) (* 977 S1)))
 (= X19 (- (* 977 S0) (* 167 S1)))
 (= X19 (+ (* 167 S0) (* 981 S1)))
 (= X19 (- (* 167 S0) (* 981 S1)))
 (= X19 (- (* 981 S0) (* 167 S1)))
 (= X19 (+ (* 167 S0) (* 959 S1)))
 (= X19 (- (* 167 S0) (* 959 S1)))
 (= X19 (- (* 959 S0) (* 167 S1)))
 (= X19 (+ (* 167 S0) (* 211 S1)))
 (= X19 (- (* 167 S0) (* 211 S1)))
 (= X19 (- (* 211 S0) (* 167 S1)))
 (= X19 (+ (* 167 S0) (* 643 S1)))
 (= X19 (- (* 167 S0) (* 643 S1)))
 (= X19 (- (* 643 S0) (* 167 S1)))
 (= X19 (+ (* 167 S0) (* 627 S1)))
 (= X19 (- (* 167 S0) (* 627 S1)))
 (= X19 (- (* 627 S0) (* 167 S1)))
 (= X19 (+ (* 167 S0) (* 867 S1)))
 (= X19 (- (* 167 S0) (* 867 S1)))
 (= X19 (- (* 867 S0) (* 167 S1)))
 (= X19 (+ (* 167 S0) (* 315 S1)))
 (= X19 (- (* 167 S0) (* 315 S1)))
 (= X19 (- (* 315 S0) (* 167 S1)))
 (= X19 (+ (* 977 S0) S1))
 (= X19 (- (* 977 S0) S1))
 (= X19 (- S0 (* 977 S1)))
 (= X19 (+ (* 977 S0) (* 977 S1)))
 (= X19 (- (* 977 S0) (* 977 S1)))
 (= X19 (+ (* 977 S0) (* 981 S1)))
 (= X19 (- (* 977 S0) (* 981 S1)))
 (= X19 (- (* 981 S0) (* 977 S1)))
 (= X19 (+ (* 977 S0) (* 959 S1)))
 (= X19 (- (* 977 S0) (* 959 S1)))
 (= X19 (- (* 959 S0) (* 977 S1)))
 (= X19 (+ (* 977 S0) (* 211 S1)))
 (= X19 (- (* 977 S0) (* 211 S1)))
 (= X19 (- (* 211 S0) (* 977 S1)))
 (= X19 (+ (* 977 S0) (* 643 S1)))
 (= X19 (- (* 977 S0) (* 643 S1)))
 (= X19 (- (* 643 S0) (* 977 S1)))
 (= X19 (+ (* 977 S0) (* 627 S1)))
 (= X19 (- (* 977 S0) (* 627 S1)))
 (= X19 (- (* 627 S0) (* 977 S1)))
 (= X19 (+ (* 977 S0) (* 867 S1)))
 (= X19 (- (* 977 S0) (* 867 S1)))
 (= X19 (- (* 867 S0) (* 977 S1)))
 (= X19 (+ (* 977 S0) (* 315 S1)))
 (= X19 (- (* 977 S0) (* 315 S1)))
 (= X19 (- (* 315 S0) (* 977 S1)))
 (= X19 (+ (* 981 S0) S1))
 (= X19 (- (* 981 S0) S1))
 (= X19 (- S0 (* 981 S1)))
 (= X19 (+ (* 981 S0) (* 981 S1)))
 (= X19 (- (* 981 S0) (* 981 S1)))
 (= X19 (+ (* 981 S0) (* 959 S1)))
 (= X19 (- (* 981 S0) (* 959 S1)))
 (= X19 (- (* 959 S0) (* 981 S1)))
 (= X19 (+ (* 981 S0) (* 211 S1)))
 (= X19 (- (* 981 S0) (* 211 S1)))
 (= X19 (- (* 211 S0) (* 981 S1)))
 (= X19 (+ (* 981 S0) (* 643 S1)))
 (= X19 (- (* 981 S0) (* 643 S1)))
 (= X19 (- (* 643 S0) (* 981 S1)))
 (= X19 (+ (* 981 S0) (* 627 S1)))
 (= X19 (- (* 981 S0) (* 627 S1)))
 (= X19 (- (* 627 S0) (* 981 S1)))
 (= X19 (+ (* 981 S0) (* 867 S1)))
 (= X19 (- (* 981 S0) (* 867 S1)))
 (= X19 (- (* 867 S0) (* 981 S1)))
 (= X19 (+ (* 981 S0) (* 315 S1)))
 (= X19 (- (* 981 S0) (* 315 S1)))
 (= X19 (- (* 315 S0) (* 981 S1)))
 (= X19 (+ (* 959 S0) S1))
 (= X19 (- (* 959 S0) S1))
 (= X19 (- S0 (* 959 S1)))
 (= X19 (+ (* 959 S0) (* 959 S1)))
 (= X19 (- (* 959 S0) (* 959 S1)))
 (= X19 (+ (* 959 S0) (* 211 S1)))
 (= X19 (- (* 959 S0) (* 211 S1)))
 (= X19 (- (* 211 S0) (* 959 S1)))
 (= X19 (+ (* 959 S0) (* 643 S1)))
 (= X19 (- (* 959 S0) (* 643 S1)))
 (= X19 (- (* 643 S0) (* 959 S1)))
 (= X19 (+ (* 959 S0) (* 627 S1)))
 (= X19 (- (* 959 S0) (* 627 S1)))
 (= X19 (- (* 627 S0) (* 959 S1)))
 (= X19 (+ (* 959 S0) (* 867 S1)))
 (= X19 (- (* 959 S0) (* 867 S1)))
 (= X19 (- (* 867 S0) (* 959 S1)))
 (= X19 (+ (* 959 S0) (* 315 S1)))
 (= X19 (- (* 959 S0) (* 315 S1)))
 (= X19 (- (* 315 S0) (* 959 S1)))
 (= X19 (+ (* 211 S0) S1))
 (= X19 (- (* 211 S0) S1))
 (= X19 (- S0 (* 211 S1)))
 (= X19 (+ (* 211 S0) (* 211 S1)))
 (= X19 (- (* 211 S0) (* 211 S1)))
 (= X19 (+ (* 211 S0) (* 643 S1)))
 (= X19 (- (* 211 S0) (* 643 S1)))
 (= X19 (- (* 643 S0) (* 211 S1)))
 (= X19 (+ (* 211 S0) (* 627 S1)))
 (= X19 (- (* 211 S0) (* 627 S1)))
 (= X19 (- (* 627 S0) (* 211 S1)))
 (= X19 (+ (* 211 S0) (* 867 S1)))
 (= X19 (- (* 211 S0) (* 867 S1)))
 (= X19 (- (* 867 S0) (* 211 S1)))
 (= X19 (+ (* 211 S0) (* 315 S1)))
 (= X19 (- (* 211 S0) (* 315 S1)))
 (= X19 (- (* 315 S0) (* 211 S1)))
 (= X19 (+ (* 643 S0) S1))
 (= X19 (- (* 643 S0) S1))
 (= X19 (- S0 (* 643 S1)))
 (= X19 (+ (* 643 S0) (* 643 S1)))
 (= X19 (- (* 643 S0) (* 643 S1)))
 (= X19 (+ (* 643 S0) (* 627 S1)))
 (= X19 (- (* 643 S0) (* 627 S1)))
 (= X19 (- (* 627 S0) (* 643 S1)))
 (= X19 (+ (* 643 S0) (* 867 S1)))
 (= X19 (- (* 643 S0) (* 867 S1)))
 (= X19 (- (* 867 S0) (* 643 S1)))
 (= X19 (+ (* 643 S0) (* 315 S1)))
 (= X19 (- (* 643 S0) (* 315 S1)))
 (= X19 (- (* 315 S0) (* 643 S1)))
 (= X19 (+ (* 627 S0) S1))
 (= X19 (- (* 627 S0) S1))
 (= X19 (- S0 (* 627 S1)))
 (= X19 (+ (* 627 S0) (* 627 S1)))
 (= X19 (- (* 627 S0) (* 627 S1)))
 (= X19 (+ (* 627 S0) (* 867 S1)))
 (= X19 (- (* 627 S0) (* 867 S1)))
 (= X19 (- (* 867 S0) (* 627 S1)))
 (= X19 (+ (* 627 S0) (* 315 S1)))
 (= X19 (- (* 627 S0) (* 315 S1)))
 (= X19 (- (* 315 S0) (* 627 S1)))
 (= X19 (+ (* 867 S0) S1))
 (= X19 (- (* 867 S0) S1))
 (= X19 (- S0 (* 867 S1)))
 (= X19 (+ (* 867 S0) (* 867 S1)))
 (= X19 (- (* 867 S0) (* 867 S1)))
 (= X19 (+ (* 867 S0) (* 315 S1)))
 (= X19 (- (* 867 S0) (* 315 S1)))
 (= X19 (- (* 315 S0) (* 867 S1)))
 (= X19 (+ (* 315 S0) S1))
 (= X19 (- (* 315 S0) S1))
 (= X19 (- S0 (* 315 S1)))
 (= X19 (+ (* 315 S0) (* 315 S1)))
 (= X19 (- (* 315 S0) (* 315 S1)))
))
(assert (and (> X19 0) (< X19 2048) (power2 S0) (power2 S1)))
(assert (or
 (= X20 (+ (* 31 S2) S3))
 (= X20 (- (* 31 S2) S3))
 (= X20 (- S2 (* 31 S3)))
 (= X20 (+ (* 31 S2) (* 31 S3)))
 (= X20 (- (* 31 S2) (* 31 S3)))
 (= X20 (+ (* 31 S2) (* 7 S3)))
 (= X20 (- (* 31 S2) (* 7 S3)))
 (= X20 (- (* 7 S2) (* 31 S3)))
 (= X20 (+ (* 31 S2) (* 17 S3)))
 (= X20 (- (* 31 S2) (* 17 S3)))
 (= X20 (- (* 17 S2) (* 31 S3)))
 (= X20 (+ (* 31 S2) (* 3 S3)))
 (= X20 (- (* 31 S2) (* 3 S3)))
 (= X20 (- (* 3 S2) (* 31 S3)))
 (= X20 (+ (* 31 S2) (* 63 S3)))
 (= X20 (- (* 31 S2) (* 63 S3)))
 (= X20 (- (* 63 S2) (* 31 S3)))
 (= X20 (+ (* 31 S2) (* 95 S3)))
 (= X20 (- (* 31 S2) (* 95 S3)))
 (= X20 (- (* 95 S2) (* 31 S3)))
 (= X20 (+ (* 31 S2) (* 57 S3)))
 (= X20 (- (* 31 S2) (* 57 S3)))
 (= X20 (- (* 57 S2) (* 31 S3)))
 (= X20 (+ (* 31 S2) (* 99 S3)))
 (= X20 (- (* 31 S2) (* 99 S3)))
 (= X20 (- (* 99 S2) (* 31 S3)))
 (= X20 (+ (* 31 S2) (* 229 S3)))
 (= X20 (- (* 31 S2) (* 229 S3)))
 (= X20 (- (* 229 S2) (* 31 S3)))
 (= X20 (+ (* 31 S2) (* 141 S3)))
 (= X20 (- (* 31 S2) (* 141 S3)))
 (= X20 (- (* 141 S2) (* 31 S3)))
 (= X20 (+ (* 31 S2) (* 167 S3)))
 (= X20 (- (* 31 S2) (* 167 S3)))
 (= X20 (- (* 167 S2) (* 31 S3)))
 (= X20 (+ (* 31 S2) (* 977 S3)))
 (= X20 (- (* 31 S2) (* 977 S3)))
 (= X20 (- (* 977 S2) (* 31 S3)))
 (= X20 (+ (* 31 S2) (* 981 S3)))
 (= X20 (- (* 31 S2) (* 981 S3)))
 (= X20 (- (* 981 S2) (* 31 S3)))
 (= X20 (+ (* 31 S2) (* 959 S3)))
 (= X20 (- (* 31 S2) (* 959 S3)))
 (= X20 (- (* 959 S2) (* 31 S3)))
 (= X20 (+ (* 31 S2) (* 211 S3)))
 (= X20 (- (* 31 S2) (* 211 S3)))
 (= X20 (- (* 211 S2) (* 31 S3)))
 (= X20 (+ (* 31 S2) (* 643 S3)))
 (= X20 (- (* 31 S2) (* 643 S3)))
 (= X20 (- (* 643 S2) (* 31 S3)))
 (= X20 (+ (* 31 S2) (* 627 S3)))
 (= X20 (- (* 31 S2) (* 627 S3)))
 (= X20 (- (* 627 S2) (* 31 S3)))
 (= X20 (+ (* 31 S2) (* 867 S3)))
 (= X20 (- (* 31 S2) (* 867 S3)))
 (= X20 (- (* 867 S2) (* 31 S3)))
 (= X20 (+ (* 31 S2) (* 315 S3)))
 (= X20 (- (* 31 S2) (* 315 S3)))
 (= X20 (- (* 315 S2) (* 31 S3)))
 (= X20 (+ (* 31 S2) (* X19 S3)))
 (= X20 (- (* 31 S2) (* X19 S3)))
 (= X20 (- (* X19 S2) (* 31 S3)))
 (= X20 (+ (* 7 S2) S3))
 (= X20 (- (* 7 S2) S3))
 (= X20 (- S2 (* 7 S3)))
 (= X20 (+ (* 7 S2) (* 7 S3)))
 (= X20 (- (* 7 S2) (* 7 S3)))
 (= X20 (+ (* 7 S2) (* 17 S3)))
 (= X20 (- (* 7 S2) (* 17 S3)))
 (= X20 (- (* 17 S2) (* 7 S3)))
 (= X20 (+ (* 7 S2) (* 3 S3)))
 (= X20 (- (* 7 S2) (* 3 S3)))
 (= X20 (- (* 3 S2) (* 7 S3)))
 (= X20 (+ (* 7 S2) (* 63 S3)))
 (= X20 (- (* 7 S2) (* 63 S3)))
 (= X20 (- (* 63 S2) (* 7 S3)))
 (= X20 (+ (* 7 S2) (* 95 S3)))
 (= X20 (- (* 7 S2) (* 95 S3)))
 (= X20 (- (* 95 S2) (* 7 S3)))
 (= X20 (+ (* 7 S2) (* 57 S3)))
 (= X20 (- (* 7 S2) (* 57 S3)))
 (= X20 (- (* 57 S2) (* 7 S3)))
 (= X20 (+ (* 7 S2) (* 99 S3)))
 (= X20 (- (* 7 S2) (* 99 S3)))
 (= X20 (- (* 99 S2) (* 7 S3)))
 (= X20 (+ (* 7 S2) (* 229 S3)))
 (= X20 (- (* 7 S2) (* 229 S3)))
 (= X20 (- (* 229 S2) (* 7 S3)))
 (= X20 (+ (* 7 S2) (* 141 S3)))
 (= X20 (- (* 7 S2) (* 141 S3)))
 (= X20 (- (* 141 S2) (* 7 S3)))
 (= X20 (+ (* 7 S2) (* 167 S3)))
 (= X20 (- (* 7 S2) (* 167 S3)))
 (= X20 (- (* 167 S2) (* 7 S3)))
 (= X20 (+ (* 7 S2) (* 977 S3)))
 (= X20 (- (* 7 S2) (* 977 S3)))
 (= X20 (- (* 977 S2) (* 7 S3)))
 (= X20 (+ (* 7 S2) (* 981 S3)))
 (= X20 (- (* 7 S2) (* 981 S3)))
 (= X20 (- (* 981 S2) (* 7 S3)))
 (= X20 (+ (* 7 S2) (* 959 S3)))
 (= X20 (- (* 7 S2) (* 959 S3)))
 (= X20 (- (* 959 S2) (* 7 S3)))
 (= X20 (+ (* 7 S2) (* 211 S3)))
 (= X20 (- (* 7 S2) (* 211 S3)))
 (= X20 (- (* 211 S2) (* 7 S3)))
 (= X20 (+ (* 7 S2) (* 643 S3)))
 (= X20 (- (* 7 S2) (* 643 S3)))
 (= X20 (- (* 643 S2) (* 7 S3)))
 (= X20 (+ (* 7 S2) (* 627 S3)))
 (= X20 (- (* 7 S2) (* 627 S3)))
 (= X20 (- (* 627 S2) (* 7 S3)))
 (= X20 (+ (* 7 S2) (* 867 S3)))
 (= X20 (- (* 7 S2) (* 867 S3)))
 (= X20 (- (* 867 S2) (* 7 S3)))
 (= X20 (+ (* 7 S2) (* 315 S3)))
 (= X20 (- (* 7 S2) (* 315 S3)))
 (= X20 (- (* 315 S2) (* 7 S3)))
 (= X20 (+ (* 7 S2) (* X19 S3)))
 (= X20 (- (* 7 S2) (* X19 S3)))
 (= X20 (- (* X19 S2) (* 7 S3)))
 (= X20 (+ (* 17 S2) S3))
 (= X20 (- (* 17 S2) S3))
 (= X20 (- S2 (* 17 S3)))
 (= X20 (+ (* 17 S2) (* 17 S3)))
 (= X20 (- (* 17 S2) (* 17 S3)))
 (= X20 (+ (* 17 S2) (* 3 S3)))
 (= X20 (- (* 17 S2) (* 3 S3)))
 (= X20 (- (* 3 S2) (* 17 S3)))
 (= X20 (+ (* 17 S2) (* 63 S3)))
 (= X20 (- (* 17 S2) (* 63 S3)))
 (= X20 (- (* 63 S2) (* 17 S3)))
 (= X20 (+ (* 17 S2) (* 95 S3)))
 (= X20 (- (* 17 S2) (* 95 S3)))
 (= X20 (- (* 95 S2) (* 17 S3)))
 (= X20 (+ (* 17 S2) (* 57 S3)))
 (= X20 (- (* 17 S2) (* 57 S3)))
 (= X20 (- (* 57 S2) (* 17 S3)))
 (= X20 (+ (* 17 S2) (* 99 S3)))
 (= X20 (- (* 17 S2) (* 99 S3)))
 (= X20 (- (* 99 S2) (* 17 S3)))
 (= X20 (+ (* 17 S2) (* 229 S3)))
 (= X20 (- (* 17 S2) (* 229 S3)))
 (= X20 (- (* 229 S2) (* 17 S3)))
 (= X20 (+ (* 17 S2) (* 141 S3)))
 (= X20 (- (* 17 S2) (* 141 S3)))
 (= X20 (- (* 141 S2) (* 17 S3)))
 (= X20 (+ (* 17 S2) (* 167 S3)))
 (= X20 (- (* 17 S2) (* 167 S3)))
 (= X20 (- (* 167 S2) (* 17 S3)))
 (= X20 (+ (* 17 S2) (* 977 S3)))
 (= X20 (- (* 17 S2) (* 977 S3)))
 (= X20 (- (* 977 S2) (* 17 S3)))
 (= X20 (+ (* 17 S2) (* 981 S3)))
 (= X20 (- (* 17 S2) (* 981 S3)))
 (= X20 (- (* 981 S2) (* 17 S3)))
 (= X20 (+ (* 17 S2) (* 959 S3)))
 (= X20 (- (* 17 S2) (* 959 S3)))
 (= X20 (- (* 959 S2) (* 17 S3)))
 (= X20 (+ (* 17 S2) (* 211 S3)))
 (= X20 (- (* 17 S2) (* 211 S3)))
 (= X20 (- (* 211 S2) (* 17 S3)))
 (= X20 (+ (* 17 S2) (* 643 S3)))
 (= X20 (- (* 17 S2) (* 643 S3)))
 (= X20 (- (* 643 S2) (* 17 S3)))
 (= X20 (+ (* 17 S2) (* 627 S3)))
 (= X20 (- (* 17 S2) (* 627 S3)))
 (= X20 (- (* 627 S2) (* 17 S3)))
 (= X20 (+ (* 17 S2) (* 867 S3)))
 (= X20 (- (* 17 S2) (* 867 S3)))
 (= X20 (- (* 867 S2) (* 17 S3)))
 (= X20 (+ (* 17 S2) (* 315 S3)))
 (= X20 (- (* 17 S2) (* 315 S3)))
 (= X20 (- (* 315 S2) (* 17 S3)))
 (= X20 (+ (* 17 S2) (* X19 S3)))
 (= X20 (- (* 17 S2) (* X19 S3)))
 (= X20 (- (* X19 S2) (* 17 S3)))
 (= X20 (+ (* 3 S2) S3))
 (= X20 (- (* 3 S2) S3))
 (= X20 (- S2 (* 3 S3)))
 (= X20 (+ (* 3 S2) (* 3 S3)))
 (= X20 (- (* 3 S2) (* 3 S3)))
 (= X20 (+ (* 3 S2) (* 63 S3)))
 (= X20 (- (* 3 S2) (* 63 S3)))
 (= X20 (- (* 63 S2) (* 3 S3)))
 (= X20 (+ (* 3 S2) (* 95 S3)))
 (= X20 (- (* 3 S2) (* 95 S3)))
 (= X20 (- (* 95 S2) (* 3 S3)))
 (= X20 (+ (* 3 S2) (* 57 S3)))
 (= X20 (- (* 3 S2) (* 57 S3)))
 (= X20 (- (* 57 S2) (* 3 S3)))
 (= X20 (+ (* 3 S2) (* 99 S3)))
 (= X20 (- (* 3 S2) (* 99 S3)))
 (= X20 (- (* 99 S2) (* 3 S3)))
 (= X20 (+ (* 3 S2) (* 229 S3)))
 (= X20 (- (* 3 S2) (* 229 S3)))
 (= X20 (- (* 229 S2) (* 3 S3)))
 (= X20 (+ (* 3 S2) (* 141 S3)))
 (= X20 (- (* 3 S2) (* 141 S3)))
 (= X20 (- (* 141 S2) (* 3 S3)))
 (= X20 (+ (* 3 S2) (* 167 S3)))
 (= X20 (- (* 3 S2) (* 167 S3)))
 (= X20 (- (* 167 S2) (* 3 S3)))
 (= X20 (+ (* 3 S2) (* 977 S3)))
 (= X20 (- (* 3 S2) (* 977 S3)))
 (= X20 (- (* 977 S2) (* 3 S3)))
 (= X20 (+ (* 3 S2) (* 981 S3)))
 (= X20 (- (* 3 S2) (* 981 S3)))
 (= X20 (- (* 981 S2) (* 3 S3)))
 (= X20 (+ (* 3 S2) (* 959 S3)))
 (= X20 (- (* 3 S2) (* 959 S3)))
 (= X20 (- (* 959 S2) (* 3 S3)))
 (= X20 (+ (* 3 S2) (* 211 S3)))
 (= X20 (- (* 3 S2) (* 211 S3)))
 (= X20 (- (* 211 S2) (* 3 S3)))
 (= X20 (+ (* 3 S2) (* 643 S3)))
 (= X20 (- (* 3 S2) (* 643 S3)))
 (= X20 (- (* 643 S2) (* 3 S3)))
 (= X20 (+ (* 3 S2) (* 627 S3)))
 (= X20 (- (* 3 S2) (* 627 S3)))
 (= X20 (- (* 627 S2) (* 3 S3)))
 (= X20 (+ (* 3 S2) (* 867 S3)))
 (= X20 (- (* 3 S2) (* 867 S3)))
 (= X20 (- (* 867 S2) (* 3 S3)))
 (= X20 (+ (* 3 S2) (* 315 S3)))
 (= X20 (- (* 3 S2) (* 315 S3)))
 (= X20 (- (* 315 S2) (* 3 S3)))
 (= X20 (+ (* 3 S2) (* X19 S3)))
 (= X20 (- (* 3 S2) (* X19 S3)))
 (= X20 (- (* X19 S2) (* 3 S3)))
 (= X20 (+ (* 63 S2) S3))
 (= X20 (- (* 63 S2) S3))
 (= X20 (- S2 (* 63 S3)))
 (= X20 (+ (* 63 S2) (* 63 S3)))
 (= X20 (- (* 63 S2) (* 63 S3)))
 (= X20 (+ (* 63 S2) (* 95 S3)))
 (= X20 (- (* 63 S2) (* 95 S3)))
 (= X20 (- (* 95 S2) (* 63 S3)))
 (= X20 (+ (* 63 S2) (* 57 S3)))
 (= X20 (- (* 63 S2) (* 57 S3)))
 (= X20 (- (* 57 S2) (* 63 S3)))
 (= X20 (+ (* 63 S2) (* 99 S3)))
 (= X20 (- (* 63 S2) (* 99 S3)))
 (= X20 (- (* 99 S2) (* 63 S3)))
 (= X20 (+ (* 63 S2) (* 229 S3)))
 (= X20 (- (* 63 S2) (* 229 S3)))
 (= X20 (- (* 229 S2) (* 63 S3)))
 (= X20 (+ (* 63 S2) (* 141 S3)))
 (= X20 (- (* 63 S2) (* 141 S3)))
 (= X20 (- (* 141 S2) (* 63 S3)))
 (= X20 (+ (* 63 S2) (* 167 S3)))
 (= X20 (- (* 63 S2) (* 167 S3)))
 (= X20 (- (* 167 S2) (* 63 S3)))
 (= X20 (+ (* 63 S2) (* 977 S3)))
 (= X20 (- (* 63 S2) (* 977 S3)))
 (= X20 (- (* 977 S2) (* 63 S3)))
 (= X20 (+ (* 63 S2) (* 981 S3)))
 (= X20 (- (* 63 S2) (* 981 S3)))
 (= X20 (- (* 981 S2) (* 63 S3)))
 (= X20 (+ (* 63 S2) (* 959 S3)))
 (= X20 (- (* 63 S2) (* 959 S3)))
 (= X20 (- (* 959 S2) (* 63 S3)))
 (= X20 (+ (* 63 S2) (* 211 S3)))
 (= X20 (- (* 63 S2) (* 211 S3)))
 (= X20 (- (* 211 S2) (* 63 S3)))
 (= X20 (+ (* 63 S2) (* 643 S3)))
 (= X20 (- (* 63 S2) (* 643 S3)))
 (= X20 (- (* 643 S2) (* 63 S3)))
 (= X20 (+ (* 63 S2) (* 627 S3)))
 (= X20 (- (* 63 S2) (* 627 S3)))
 (= X20 (- (* 627 S2) (* 63 S3)))
 (= X20 (+ (* 63 S2) (* 867 S3)))
 (= X20 (- (* 63 S2) (* 867 S3)))
 (= X20 (- (* 867 S2) (* 63 S3)))
 (= X20 (+ (* 63 S2) (* 315 S3)))
 (= X20 (- (* 63 S2) (* 315 S3)))
 (= X20 (- (* 315 S2) (* 63 S3)))
 (= X20 (+ (* 63 S2) (* X19 S3)))
 (= X20 (- (* 63 S2) (* X19 S3)))
 (= X20 (- (* X19 S2) (* 63 S3)))
 (= X20 (+ (* 95 S2) S3))
 (= X20 (- (* 95 S2) S3))
 (= X20 (- S2 (* 95 S3)))
 (= X20 (+ (* 95 S2) (* 95 S3)))
 (= X20 (- (* 95 S2) (* 95 S3)))
 (= X20 (+ (* 95 S2) (* 57 S3)))
 (= X20 (- (* 95 S2) (* 57 S3)))
 (= X20 (- (* 57 S2) (* 95 S3)))
 (= X20 (+ (* 95 S2) (* 99 S3)))
 (= X20 (- (* 95 S2) (* 99 S3)))
 (= X20 (- (* 99 S2) (* 95 S3)))
 (= X20 (+ (* 95 S2) (* 229 S3)))
 (= X20 (- (* 95 S2) (* 229 S3)))
 (= X20 (- (* 229 S2) (* 95 S3)))
 (= X20 (+ (* 95 S2) (* 141 S3)))
 (= X20 (- (* 95 S2) (* 141 S3)))
 (= X20 (- (* 141 S2) (* 95 S3)))
 (= X20 (+ (* 95 S2) (* 167 S3)))
 (= X20 (- (* 95 S2) (* 167 S3)))
 (= X20 (- (* 167 S2) (* 95 S3)))
 (= X20 (+ (* 95 S2) (* 977 S3)))
 (= X20 (- (* 95 S2) (* 977 S3)))
 (= X20 (- (* 977 S2) (* 95 S3)))
 (= X20 (+ (* 95 S2) (* 981 S3)))
 (= X20 (- (* 95 S2) (* 981 S3)))
 (= X20 (- (* 981 S2) (* 95 S3)))
 (= X20 (+ (* 95 S2) (* 959 S3)))
 (= X20 (- (* 95 S2) (* 959 S3)))
 (= X20 (- (* 959 S2) (* 95 S3)))
 (= X20 (+ (* 95 S2) (* 211 S3)))
 (= X20 (- (* 95 S2) (* 211 S3)))
 (= X20 (- (* 211 S2) (* 95 S3)))
 (= X20 (+ (* 95 S2) (* 643 S3)))
 (= X20 (- (* 95 S2) (* 643 S3)))
 (= X20 (- (* 643 S2) (* 95 S3)))
 (= X20 (+ (* 95 S2) (* 627 S3)))
 (= X20 (- (* 95 S2) (* 627 S3)))
 (= X20 (- (* 627 S2) (* 95 S3)))
 (= X20 (+ (* 95 S2) (* 867 S3)))
 (= X20 (- (* 95 S2) (* 867 S3)))
 (= X20 (- (* 867 S2) (* 95 S3)))
 (= X20 (+ (* 95 S2) (* 315 S3)))
 (= X20 (- (* 95 S2) (* 315 S3)))
 (= X20 (- (* 315 S2) (* 95 S3)))
 (= X20 (+ (* 95 S2) (* X19 S3)))
 (= X20 (- (* 95 S2) (* X19 S3)))
 (= X20 (- (* X19 S2) (* 95 S3)))
 (= X20 (+ (* 57 S2) S3))
 (= X20 (- (* 57 S2) S3))
 (= X20 (- S2 (* 57 S3)))
 (= X20 (+ (* 57 S2) (* 57 S3)))
 (= X20 (- (* 57 S2) (* 57 S3)))
 (= X20 (+ (* 57 S2) (* 99 S3)))
 (= X20 (- (* 57 S2) (* 99 S3)))
 (= X20 (- (* 99 S2) (* 57 S3)))
 (= X20 (+ (* 57 S2) (* 229 S3)))
 (= X20 (- (* 57 S2) (* 229 S3)))
 (= X20 (- (* 229 S2) (* 57 S3)))
 (= X20 (+ (* 57 S2) (* 141 S3)))
 (= X20 (- (* 57 S2) (* 141 S3)))
 (= X20 (- (* 141 S2) (* 57 S3)))
 (= X20 (+ (* 57 S2) (* 167 S3)))
 (= X20 (- (* 57 S2) (* 167 S3)))
 (= X20 (- (* 167 S2) (* 57 S3)))
 (= X20 (+ (* 57 S2) (* 977 S3)))
 (= X20 (- (* 57 S2) (* 977 S3)))
 (= X20 (- (* 977 S2) (* 57 S3)))
 (= X20 (+ (* 57 S2) (* 981 S3)))
 (= X20 (- (* 57 S2) (* 981 S3)))
 (= X20 (- (* 981 S2) (* 57 S3)))
 (= X20 (+ (* 57 S2) (* 959 S3)))
 (= X20 (- (* 57 S2) (* 959 S3)))
 (= X20 (- (* 959 S2) (* 57 S3)))
 (= X20 (+ (* 57 S2) (* 211 S3)))
 (= X20 (- (* 57 S2) (* 211 S3)))
 (= X20 (- (* 211 S2) (* 57 S3)))
 (= X20 (+ (* 57 S2) (* 643 S3)))
 (= X20 (- (* 57 S2) (* 643 S3)))
 (= X20 (- (* 643 S2) (* 57 S3)))
 (= X20 (+ (* 57 S2) (* 627 S3)))
 (= X20 (- (* 57 S2) (* 627 S3)))
 (= X20 (- (* 627 S2) (* 57 S3)))
 (= X20 (+ (* 57 S2) (* 867 S3)))
 (= X20 (- (* 57 S2) (* 867 S3)))
 (= X20 (- (* 867 S2) (* 57 S3)))
 (= X20 (+ (* 57 S2) (* 315 S3)))
 (= X20 (- (* 57 S2) (* 315 S3)))
 (= X20 (- (* 315 S2) (* 57 S3)))
 (= X20 (+ (* 57 S2) (* X19 S3)))
 (= X20 (- (* 57 S2) (* X19 S3)))
 (= X20 (- (* X19 S2) (* 57 S3)))
 (= X20 (+ (* 99 S2) S3))
 (= X20 (- (* 99 S2) S3))
 (= X20 (- S2 (* 99 S3)))
 (= X20 (+ (* 99 S2) (* 99 S3)))
 (= X20 (- (* 99 S2) (* 99 S3)))
 (= X20 (+ (* 99 S2) (* 229 S3)))
 (= X20 (- (* 99 S2) (* 229 S3)))
 (= X20 (- (* 229 S2) (* 99 S3)))
 (= X20 (+ (* 99 S2) (* 141 S3)))
 (= X20 (- (* 99 S2) (* 141 S3)))
 (= X20 (- (* 141 S2) (* 99 S3)))
 (= X20 (+ (* 99 S2) (* 167 S3)))
 (= X20 (- (* 99 S2) (* 167 S3)))
 (= X20 (- (* 167 S2) (* 99 S3)))
 (= X20 (+ (* 99 S2) (* 977 S3)))
 (= X20 (- (* 99 S2) (* 977 S3)))
 (= X20 (- (* 977 S2) (* 99 S3)))
 (= X20 (+ (* 99 S2) (* 981 S3)))
 (= X20 (- (* 99 S2) (* 981 S3)))
 (= X20 (- (* 981 S2) (* 99 S3)))
 (= X20 (+ (* 99 S2) (* 959 S3)))
 (= X20 (- (* 99 S2) (* 959 S3)))
 (= X20 (- (* 959 S2) (* 99 S3)))
 (= X20 (+ (* 99 S2) (* 211 S3)))
 (= X20 (- (* 99 S2) (* 211 S3)))
 (= X20 (- (* 211 S2) (* 99 S3)))
 (= X20 (+ (* 99 S2) (* 643 S3)))
 (= X20 (- (* 99 S2) (* 643 S3)))
 (= X20 (- (* 643 S2) (* 99 S3)))
 (= X20 (+ (* 99 S2) (* 627 S3)))
 (= X20 (- (* 99 S2) (* 627 S3)))
 (= X20 (- (* 627 S2) (* 99 S3)))
 (= X20 (+ (* 99 S2) (* 867 S3)))
 (= X20 (- (* 99 S2) (* 867 S3)))
 (= X20 (- (* 867 S2) (* 99 S3)))
 (= X20 (+ (* 99 S2) (* 315 S3)))
 (= X20 (- (* 99 S2) (* 315 S3)))
 (= X20 (- (* 315 S2) (* 99 S3)))
 (= X20 (+ (* 99 S2) (* X19 S3)))
 (= X20 (- (* 99 S2) (* X19 S3)))
 (= X20 (- (* X19 S2) (* 99 S3)))
 (= X20 (+ (* 229 S2) S3))
 (= X20 (- (* 229 S2) S3))
 (= X20 (- S2 (* 229 S3)))
 (= X20 (+ (* 229 S2) (* 229 S3)))
 (= X20 (- (* 229 S2) (* 229 S3)))
 (= X20 (+ (* 229 S2) (* 141 S3)))
 (= X20 (- (* 229 S2) (* 141 S3)))
 (= X20 (- (* 141 S2) (* 229 S3)))
 (= X20 (+ (* 229 S2) (* 167 S3)))
 (= X20 (- (* 229 S2) (* 167 S3)))
 (= X20 (- (* 167 S2) (* 229 S3)))
 (= X20 (+ (* 229 S2) (* 977 S3)))
 (= X20 (- (* 229 S2) (* 977 S3)))
 (= X20 (- (* 977 S2) (* 229 S3)))
 (= X20 (+ (* 229 S2) (* 981 S3)))
 (= X20 (- (* 229 S2) (* 981 S3)))
 (= X20 (- (* 981 S2) (* 229 S3)))
 (= X20 (+ (* 229 S2) (* 959 S3)))
 (= X20 (- (* 229 S2) (* 959 S3)))
 (= X20 (- (* 959 S2) (* 229 S3)))
 (= X20 (+ (* 229 S2) (* 211 S3)))
 (= X20 (- (* 229 S2) (* 211 S3)))
 (= X20 (- (* 211 S2) (* 229 S3)))
 (= X20 (+ (* 229 S2) (* 643 S3)))
 (= X20 (- (* 229 S2) (* 643 S3)))
 (= X20 (- (* 643 S2) (* 229 S3)))
 (= X20 (+ (* 229 S2) (* 627 S3)))
 (= X20 (- (* 229 S2) (* 627 S3)))
 (= X20 (- (* 627 S2) (* 229 S3)))
 (= X20 (+ (* 229 S2) (* 867 S3)))
 (= X20 (- (* 229 S2) (* 867 S3)))
 (= X20 (- (* 867 S2) (* 229 S3)))
 (= X20 (+ (* 229 S2) (* 315 S3)))
 (= X20 (- (* 229 S2) (* 315 S3)))
 (= X20 (- (* 315 S2) (* 229 S3)))
 (= X20 (+ (* 229 S2) (* X19 S3)))
 (= X20 (- (* 229 S2) (* X19 S3)))
 (= X20 (- (* X19 S2) (* 229 S3)))
 (= X20 (+ (* 141 S2) S3))
 (= X20 (- (* 141 S2) S3))
 (= X20 (- S2 (* 141 S3)))
 (= X20 (+ (* 141 S2) (* 141 S3)))
 (= X20 (- (* 141 S2) (* 141 S3)))
 (= X20 (+ (* 141 S2) (* 167 S3)))
 (= X20 (- (* 141 S2) (* 167 S3)))
 (= X20 (- (* 167 S2) (* 141 S3)))
 (= X20 (+ (* 141 S2) (* 977 S3)))
 (= X20 (- (* 141 S2) (* 977 S3)))
 (= X20 (- (* 977 S2) (* 141 S3)))
 (= X20 (+ (* 141 S2) (* 981 S3)))
 (= X20 (- (* 141 S2) (* 981 S3)))
 (= X20 (- (* 981 S2) (* 141 S3)))
 (= X20 (+ (* 141 S2) (* 959 S3)))
 (= X20 (- (* 141 S2) (* 959 S3)))
 (= X20 (- (* 959 S2) (* 141 S3)))
 (= X20 (+ (* 141 S2) (* 211 S3)))
 (= X20 (- (* 141 S2) (* 211 S3)))
 (= X20 (- (* 211 S2) (* 141 S3)))
 (= X20 (+ (* 141 S2) (* 643 S3)))
 (= X20 (- (* 141 S2) (* 643 S3)))
 (= X20 (- (* 643 S2) (* 141 S3)))
 (= X20 (+ (* 141 S2) (* 627 S3)))
 (= X20 (- (* 141 S2) (* 627 S3)))
 (= X20 (- (* 627 S2) (* 141 S3)))
 (= X20 (+ (* 141 S2) (* 867 S3)))
 (= X20 (- (* 141 S2) (* 867 S3)))
 (= X20 (- (* 867 S2) (* 141 S3)))
 (= X20 (+ (* 141 S2) (* 315 S3)))
 (= X20 (- (* 141 S2) (* 315 S3)))
 (= X20 (- (* 315 S2) (* 141 S3)))
 (= X20 (+ (* 141 S2) (* X19 S3)))
 (= X20 (- (* 141 S2) (* X19 S3)))
 (= X20 (- (* X19 S2) (* 141 S3)))
 (= X20 (+ (* 167 S2) S3))
 (= X20 (- (* 167 S2) S3))
 (= X20 (- S2 (* 167 S3)))
 (= X20 (+ (* 167 S2) (* 167 S3)))
 (= X20 (- (* 167 S2) (* 167 S3)))
 (= X20 (+ (* 167 S2) (* 977 S3)))
 (= X20 (- (* 167 S2) (* 977 S3)))
 (= X20 (- (* 977 S2) (* 167 S3)))
 (= X20 (+ (* 167 S2) (* 981 S3)))
 (= X20 (- (* 167 S2) (* 981 S3)))
 (= X20 (- (* 981 S2) (* 167 S3)))
 (= X20 (+ (* 167 S2) (* 959 S3)))
 (= X20 (- (* 167 S2) (* 959 S3)))
 (= X20 (- (* 959 S2) (* 167 S3)))
 (= X20 (+ (* 167 S2) (* 211 S3)))
 (= X20 (- (* 167 S2) (* 211 S3)))
 (= X20 (- (* 211 S2) (* 167 S3)))
 (= X20 (+ (* 167 S2) (* 643 S3)))
 (= X20 (- (* 167 S2) (* 643 S3)))
 (= X20 (- (* 643 S2) (* 167 S3)))
 (= X20 (+ (* 167 S2) (* 627 S3)))
 (= X20 (- (* 167 S2) (* 627 S3)))
 (= X20 (- (* 627 S2) (* 167 S3)))
 (= X20 (+ (* 167 S2) (* 867 S3)))
 (= X20 (- (* 167 S2) (* 867 S3)))
 (= X20 (- (* 867 S2) (* 167 S3)))
 (= X20 (+ (* 167 S2) (* 315 S3)))
 (= X20 (- (* 167 S2) (* 315 S3)))
 (= X20 (- (* 315 S2) (* 167 S3)))
 (= X20 (+ (* 167 S2) (* X19 S3)))
 (= X20 (- (* 167 S2) (* X19 S3)))
 (= X20 (- (* X19 S2) (* 167 S3)))
 (= X20 (+ (* 977 S2) S3))
 (= X20 (- (* 977 S2) S3))
 (= X20 (- S2 (* 977 S3)))
 (= X20 (+ (* 977 S2) (* 977 S3)))
 (= X20 (- (* 977 S2) (* 977 S3)))
 (= X20 (+ (* 977 S2) (* 981 S3)))
 (= X20 (- (* 977 S2) (* 981 S3)))
 (= X20 (- (* 981 S2) (* 977 S3)))
 (= X20 (+ (* 977 S2) (* 959 S3)))
 (= X20 (- (* 977 S2) (* 959 S3)))
 (= X20 (- (* 959 S2) (* 977 S3)))
 (= X20 (+ (* 977 S2) (* 211 S3)))
 (= X20 (- (* 977 S2) (* 211 S3)))
 (= X20 (- (* 211 S2) (* 977 S3)))
 (= X20 (+ (* 977 S2) (* 643 S3)))
 (= X20 (- (* 977 S2) (* 643 S3)))
 (= X20 (- (* 643 S2) (* 977 S3)))
 (= X20 (+ (* 977 S2) (* 627 S3)))
 (= X20 (- (* 977 S2) (* 627 S3)))
 (= X20 (- (* 627 S2) (* 977 S3)))
 (= X20 (+ (* 977 S2) (* 867 S3)))
 (= X20 (- (* 977 S2) (* 867 S3)))
 (= X20 (- (* 867 S2) (* 977 S3)))
 (= X20 (+ (* 977 S2) (* 315 S3)))
 (= X20 (- (* 977 S2) (* 315 S3)))
 (= X20 (- (* 315 S2) (* 977 S3)))
 (= X20 (+ (* 977 S2) (* X19 S3)))
 (= X20 (- (* 977 S2) (* X19 S3)))
 (= X20 (- (* X19 S2) (* 977 S3)))
 (= X20 (+ (* 981 S2) S3))
 (= X20 (- (* 981 S2) S3))
 (= X20 (- S2 (* 981 S3)))
 (= X20 (+ (* 981 S2) (* 981 S3)))
 (= X20 (- (* 981 S2) (* 981 S3)))
 (= X20 (+ (* 981 S2) (* 959 S3)))
 (= X20 (- (* 981 S2) (* 959 S3)))
 (= X20 (- (* 959 S2) (* 981 S3)))
 (= X20 (+ (* 981 S2) (* 211 S3)))
 (= X20 (- (* 981 S2) (* 211 S3)))
 (= X20 (- (* 211 S2) (* 981 S3)))
 (= X20 (+ (* 981 S2) (* 643 S3)))
 (= X20 (- (* 981 S2) (* 643 S3)))
 (= X20 (- (* 643 S2) (* 981 S3)))
 (= X20 (+ (* 981 S2) (* 627 S3)))
 (= X20 (- (* 981 S2) (* 627 S3)))
 (= X20 (- (* 627 S2) (* 981 S3)))
 (= X20 (+ (* 981 S2) (* 867 S3)))
 (= X20 (- (* 981 S2) (* 867 S3)))
 (= X20 (- (* 867 S2) (* 981 S3)))
 (= X20 (+ (* 981 S2) (* 315 S3)))
 (= X20 (- (* 981 S2) (* 315 S3)))
 (= X20 (- (* 315 S2) (* 981 S3)))
 (= X20 (+ (* 981 S2) (* X19 S3)))
 (= X20 (- (* 981 S2) (* X19 S3)))
 (= X20 (- (* X19 S2) (* 981 S3)))
 (= X20 (+ (* 959 S2) S3))
 (= X20 (- (* 959 S2) S3))
 (= X20 (- S2 (* 959 S3)))
 (= X20 (+ (* 959 S2) (* 959 S3)))
 (= X20 (- (* 959 S2) (* 959 S3)))
 (= X20 (+ (* 959 S2) (* 211 S3)))
 (= X20 (- (* 959 S2) (* 211 S3)))
 (= X20 (- (* 211 S2) (* 959 S3)))
 (= X20 (+ (* 959 S2) (* 643 S3)))
 (= X20 (- (* 959 S2) (* 643 S3)))
 (= X20 (- (* 643 S2) (* 959 S3)))
 (= X20 (+ (* 959 S2) (* 627 S3)))
 (= X20 (- (* 959 S2) (* 627 S3)))
 (= X20 (- (* 627 S2) (* 959 S3)))
 (= X20 (+ (* 959 S2) (* 867 S3)))
 (= X20 (- (* 959 S2) (* 867 S3)))
 (= X20 (- (* 867 S2) (* 959 S3)))
 (= X20 (+ (* 959 S2) (* 315 S3)))
 (= X20 (- (* 959 S2) (* 315 S3)))
 (= X20 (- (* 315 S2) (* 959 S3)))
 (= X20 (+ (* 959 S2) (* X19 S3)))
 (= X20 (- (* 959 S2) (* X19 S3)))
 (= X20 (- (* X19 S2) (* 959 S3)))
 (= X20 (+ (* 211 S2) S3))
 (= X20 (- (* 211 S2) S3))
 (= X20 (- S2 (* 211 S3)))
 (= X20 (+ (* 211 S2) (* 211 S3)))
 (= X20 (- (* 211 S2) (* 211 S3)))
 (= X20 (+ (* 211 S2) (* 643 S3)))
 (= X20 (- (* 211 S2) (* 643 S3)))
 (= X20 (- (* 643 S2) (* 211 S3)))
 (= X20 (+ (* 211 S2) (* 627 S3)))
 (= X20 (- (* 211 S2) (* 627 S3)))
 (= X20 (- (* 627 S2) (* 211 S3)))
 (= X20 (+ (* 211 S2) (* 867 S3)))
 (= X20 (- (* 211 S2) (* 867 S3)))
 (= X20 (- (* 867 S2) (* 211 S3)))
 (= X20 (+ (* 211 S2) (* 315 S3)))
 (= X20 (- (* 211 S2) (* 315 S3)))
 (= X20 (- (* 315 S2) (* 211 S3)))
 (= X20 (+ (* 211 S2) (* X19 S3)))
 (= X20 (- (* 211 S2) (* X19 S3)))
 (= X20 (- (* X19 S2) (* 211 S3)))
 (= X20 (+ (* 643 S2) S3))
 (= X20 (- (* 643 S2) S3))
 (= X20 (- S2 (* 643 S3)))
 (= X20 (+ (* 643 S2) (* 643 S3)))
 (= X20 (- (* 643 S2) (* 643 S3)))
 (= X20 (+ (* 643 S2) (* 627 S3)))
 (= X20 (- (* 643 S2) (* 627 S3)))
 (= X20 (- (* 627 S2) (* 643 S3)))
 (= X20 (+ (* 643 S2) (* 867 S3)))
 (= X20 (- (* 643 S2) (* 867 S3)))
 (= X20 (- (* 867 S2) (* 643 S3)))
 (= X20 (+ (* 643 S2) (* 315 S3)))
 (= X20 (- (* 643 S2) (* 315 S3)))
 (= X20 (- (* 315 S2) (* 643 S3)))
 (= X20 (+ (* 643 S2) (* X19 S3)))
 (= X20 (- (* 643 S2) (* X19 S3)))
 (= X20 (- (* X19 S2) (* 643 S3)))
 (= X20 (+ (* 627 S2) S3))
 (= X20 (- (* 627 S2) S3))
 (= X20 (- S2 (* 627 S3)))
 (= X20 (+ (* 627 S2) (* 627 S3)))
 (= X20 (- (* 627 S2) (* 627 S3)))
 (= X20 (+ (* 627 S2) (* 867 S3)))
 (= X20 (- (* 627 S2) (* 867 S3)))
 (= X20 (- (* 867 S2) (* 627 S3)))
 (= X20 (+ (* 627 S2) (* 315 S3)))
 (= X20 (- (* 627 S2) (* 315 S3)))
 (= X20 (- (* 315 S2) (* 627 S3)))
 (= X20 (+ (* 627 S2) (* X19 S3)))
 (= X20 (- (* 627 S2) (* X19 S3)))
 (= X20 (- (* X19 S2) (* 627 S3)))
 (= X20 (+ (* 867 S2) S3))
 (= X20 (- (* 867 S2) S3))
 (= X20 (- S2 (* 867 S3)))
 (= X20 (+ (* 867 S2) (* 867 S3)))
 (= X20 (- (* 867 S2) (* 867 S3)))
 (= X20 (+ (* 867 S2) (* 315 S3)))
 (= X20 (- (* 867 S2) (* 315 S3)))
 (= X20 (- (* 315 S2) (* 867 S3)))
 (= X20 (+ (* 867 S2) (* X19 S3)))
 (= X20 (- (* 867 S2) (* X19 S3)))
 (= X20 (- (* X19 S2) (* 867 S3)))
 (= X20 (+ (* 315 S2) S3))
 (= X20 (- (* 315 S2) S3))
 (= X20 (- S2 (* 315 S3)))
 (= X20 (+ (* 315 S2) (* 315 S3)))
 (= X20 (- (* 315 S2) (* 315 S3)))
 (= X20 (+ (* 315 S2) (* X19 S3)))
 (= X20 (- (* 315 S2) (* X19 S3)))
 (= X20 (- (* X19 S2) (* 315 S3)))
 (= X20 (+ (* X19 S2) S3))
 (= X20 (- (* X19 S2) S3))
 (= X20 (- S2 (* X19 S3)))
 (= X20 (+ (* X19 S2) (* X19 S3)))
 (= X20 (- (* X19 S2) (* X19 S3)))
))
(assert (and (> X20 0) (< X20 2048) (power2 S2) (power2 S3)))
(assert
 (= X20 681)
)
(check-sat)
(exit)
