(set-logic QF_NIA)
(set-info :source |
 more info in 'N. P. Lopes, L. Aksoy, V. Manquinho, J. Monteiro.
 Optimally Solving the MCM Problem Using Pseudo-Boolean Satisfiability.
 Technical Report RT/43/2010, INESC-ID, Nov. 2010'. |)
(set-info :smt-lib-version 2.0)
(set-info :category "industrial")
(set-info :status unknown)
(declare-fun X7 () Int)
(declare-fun X8 () Int)
(declare-fun X9 () Int)
(declare-fun S0 () Int)
(declare-fun S1 () Int)
(declare-fun S2 () Int)
(declare-fun S3 () Int)
(declare-fun S4 () Int)
(declare-fun S5 () Int)
(define-fun power2 ((x Int)) Bool
  (or (= x 1024) (= x 512) (= x 256) (= x 128) (= x 64) (= x 32) (= x 16) (= x 8) (= x 4) (= x 2) (= x 1)))
(assert (or
 (= X7 (+ S0 S1))
 (= X7 (- S0 S1))
 (= X7 (+ (* 17 S0) S1))
 (= X7 (- (* 17 S0) S1))
 (= X7 (- S0 (* 17 S1)))
 (= X7 (+ (* 17 S0) (* 17 S1)))
 (= X7 (- (* 17 S0) (* 17 S1)))
 (= X7 (+ (* 17 S0) (* 153 S1)))
 (= X7 (- (* 17 S0) (* 153 S1)))
 (= X7 (- (* 153 S0) (* 17 S1)))
 (= X7 (+ (* 17 S0) (* 103 S1)))
 (= X7 (- (* 17 S0) (* 103 S1)))
 (= X7 (- (* 103 S0) (* 17 S1)))
 (= X7 (+ (* 17 S0) (* 203 S1)))
 (= X7 (- (* 17 S0) (* 203 S1)))
 (= X7 (- (* 203 S0) (* 17 S1)))
 (= X7 (+ (* 17 S0) (* 927 S1)))
 (= X7 (- (* 17 S0) (* 927 S1)))
 (= X7 (- (* 927 S0) (* 17 S1)))
 (= X7 (+ (* 17 S0) (* 791 S1)))
 (= X7 (- (* 17 S0) (* 791 S1)))
 (= X7 (- (* 791 S0) (* 17 S1)))
 (= X7 (+ (* 17 S0) (* 723 S1)))
 (= X7 (- (* 17 S0) (* 723 S1)))
 (= X7 (- (* 723 S0) (* 17 S1)))
 (= X7 (+ (* 153 S0) S1))
 (= X7 (- (* 153 S0) S1))
 (= X7 (- S0 (* 153 S1)))
 (= X7 (+ (* 153 S0) (* 153 S1)))
 (= X7 (- (* 153 S0) (* 153 S1)))
 (= X7 (+ (* 153 S0) (* 103 S1)))
 (= X7 (- (* 153 S0) (* 103 S1)))
 (= X7 (- (* 103 S0) (* 153 S1)))
 (= X7 (+ (* 153 S0) (* 203 S1)))
 (= X7 (- (* 153 S0) (* 203 S1)))
 (= X7 (- (* 203 S0) (* 153 S1)))
 (= X7 (+ (* 153 S0) (* 927 S1)))
 (= X7 (- (* 153 S0) (* 927 S1)))
 (= X7 (- (* 927 S0) (* 153 S1)))
 (= X7 (+ (* 153 S0) (* 791 S1)))
 (= X7 (- (* 153 S0) (* 791 S1)))
 (= X7 (- (* 791 S0) (* 153 S1)))
 (= X7 (+ (* 153 S0) (* 723 S1)))
 (= X7 (- (* 153 S0) (* 723 S1)))
 (= X7 (- (* 723 S0) (* 153 S1)))
 (= X7 (+ (* 103 S0) S1))
 (= X7 (- (* 103 S0) S1))
 (= X7 (- S0 (* 103 S1)))
 (= X7 (+ (* 103 S0) (* 103 S1)))
 (= X7 (- (* 103 S0) (* 103 S1)))
 (= X7 (+ (* 103 S0) (* 203 S1)))
 (= X7 (- (* 103 S0) (* 203 S1)))
 (= X7 (- (* 203 S0) (* 103 S1)))
 (= X7 (+ (* 103 S0) (* 927 S1)))
 (= X7 (- (* 103 S0) (* 927 S1)))
 (= X7 (- (* 927 S0) (* 103 S1)))
 (= X7 (+ (* 103 S0) (* 791 S1)))
 (= X7 (- (* 103 S0) (* 791 S1)))
 (= X7 (- (* 791 S0) (* 103 S1)))
 (= X7 (+ (* 103 S0) (* 723 S1)))
 (= X7 (- (* 103 S0) (* 723 S1)))
 (= X7 (- (* 723 S0) (* 103 S1)))
 (= X7 (+ (* 203 S0) S1))
 (= X7 (- (* 203 S0) S1))
 (= X7 (- S0 (* 203 S1)))
 (= X7 (+ (* 203 S0) (* 203 S1)))
 (= X7 (- (* 203 S0) (* 203 S1)))
 (= X7 (+ (* 203 S0) (* 927 S1)))
 (= X7 (- (* 203 S0) (* 927 S1)))
 (= X7 (- (* 927 S0) (* 203 S1)))
 (= X7 (+ (* 203 S0) (* 791 S1)))
 (= X7 (- (* 203 S0) (* 791 S1)))
 (= X7 (- (* 791 S0) (* 203 S1)))
 (= X7 (+ (* 203 S0) (* 723 S1)))
 (= X7 (- (* 203 S0) (* 723 S1)))
 (= X7 (- (* 723 S0) (* 203 S1)))
 (= X7 (+ (* 927 S0) S1))
 (= X7 (- (* 927 S0) S1))
 (= X7 (- S0 (* 927 S1)))
 (= X7 (+ (* 927 S0) (* 927 S1)))
 (= X7 (- (* 927 S0) (* 927 S1)))
 (= X7 (+ (* 927 S0) (* 791 S1)))
 (= X7 (- (* 927 S0) (* 791 S1)))
 (= X7 (- (* 791 S0) (* 927 S1)))
 (= X7 (+ (* 927 S0) (* 723 S1)))
 (= X7 (- (* 927 S0) (* 723 S1)))
 (= X7 (- (* 723 S0) (* 927 S1)))
 (= X7 (+ (* 791 S0) S1))
 (= X7 (- (* 791 S0) S1))
 (= X7 (- S0 (* 791 S1)))
 (= X7 (+ (* 791 S0) (* 791 S1)))
 (= X7 (- (* 791 S0) (* 791 S1)))
 (= X7 (+ (* 791 S0) (* 723 S1)))
 (= X7 (- (* 791 S0) (* 723 S1)))
 (= X7 (- (* 723 S0) (* 791 S1)))
 (= X7 (+ (* 723 S0) S1))
 (= X7 (- (* 723 S0) S1))
 (= X7 (- S0 (* 723 S1)))
 (= X7 (+ (* 723 S0) (* 723 S1)))
 (= X7 (- (* 723 S0) (* 723 S1)))
))
(assert (and (> X7 0) (< X7 2048) (power2 S0) (power2 S1)))
(assert (or
 (= X8 (+ (* 17 S2) S3))
 (= X8 (- (* 17 S2) S3))
 (= X8 (- S2 (* 17 S3)))
 (= X8 (+ (* 17 S2) (* 17 S3)))
 (= X8 (- (* 17 S2) (* 17 S3)))
 (= X8 (+ (* 17 S2) (* 153 S3)))
 (= X8 (- (* 17 S2) (* 153 S3)))
 (= X8 (- (* 153 S2) (* 17 S3)))
 (= X8 (+ (* 17 S2) (* 103 S3)))
 (= X8 (- (* 17 S2) (* 103 S3)))
 (= X8 (- (* 103 S2) (* 17 S3)))
 (= X8 (+ (* 17 S2) (* 203 S3)))
 (= X8 (- (* 17 S2) (* 203 S3)))
 (= X8 (- (* 203 S2) (* 17 S3)))
 (= X8 (+ (* 17 S2) (* 927 S3)))
 (= X8 (- (* 17 S2) (* 927 S3)))
 (= X8 (- (* 927 S2) (* 17 S3)))
 (= X8 (+ (* 17 S2) (* 791 S3)))
 (= X8 (- (* 17 S2) (* 791 S3)))
 (= X8 (- (* 791 S2) (* 17 S3)))
 (= X8 (+ (* 17 S2) (* 723 S3)))
 (= X8 (- (* 17 S2) (* 723 S3)))
 (= X8 (- (* 723 S2) (* 17 S3)))
 (= X8 (+ (* 17 S2) (* X7 S3)))
 (= X8 (- (* 17 S2) (* X7 S3)))
 (= X8 (- (* X7 S2) (* 17 S3)))
 (= X8 (+ (* 153 S2) S3))
 (= X8 (- (* 153 S2) S3))
 (= X8 (- S2 (* 153 S3)))
 (= X8 (+ (* 153 S2) (* 153 S3)))
 (= X8 (- (* 153 S2) (* 153 S3)))
 (= X8 (+ (* 153 S2) (* 103 S3)))
 (= X8 (- (* 153 S2) (* 103 S3)))
 (= X8 (- (* 103 S2) (* 153 S3)))
 (= X8 (+ (* 153 S2) (* 203 S3)))
 (= X8 (- (* 153 S2) (* 203 S3)))
 (= X8 (- (* 203 S2) (* 153 S3)))
 (= X8 (+ (* 153 S2) (* 927 S3)))
 (= X8 (- (* 153 S2) (* 927 S3)))
 (= X8 (- (* 927 S2) (* 153 S3)))
 (= X8 (+ (* 153 S2) (* 791 S3)))
 (= X8 (- (* 153 S2) (* 791 S3)))
 (= X8 (- (* 791 S2) (* 153 S3)))
 (= X8 (+ (* 153 S2) (* 723 S3)))
 (= X8 (- (* 153 S2) (* 723 S3)))
 (= X8 (- (* 723 S2) (* 153 S3)))
 (= X8 (+ (* 153 S2) (* X7 S3)))
 (= X8 (- (* 153 S2) (* X7 S3)))
 (= X8 (- (* X7 S2) (* 153 S3)))
 (= X8 (+ (* 103 S2) S3))
 (= X8 (- (* 103 S2) S3))
 (= X8 (- S2 (* 103 S3)))
 (= X8 (+ (* 103 S2) (* 103 S3)))
 (= X8 (- (* 103 S2) (* 103 S3)))
 (= X8 (+ (* 103 S2) (* 203 S3)))
 (= X8 (- (* 103 S2) (* 203 S3)))
 (= X8 (- (* 203 S2) (* 103 S3)))
 (= X8 (+ (* 103 S2) (* 927 S3)))
 (= X8 (- (* 103 S2) (* 927 S3)))
 (= X8 (- (* 927 S2) (* 103 S3)))
 (= X8 (+ (* 103 S2) (* 791 S3)))
 (= X8 (- (* 103 S2) (* 791 S3)))
 (= X8 (- (* 791 S2) (* 103 S3)))
 (= X8 (+ (* 103 S2) (* 723 S3)))
 (= X8 (- (* 103 S2) (* 723 S3)))
 (= X8 (- (* 723 S2) (* 103 S3)))
 (= X8 (+ (* 103 S2) (* X7 S3)))
 (= X8 (- (* 103 S2) (* X7 S3)))
 (= X8 (- (* X7 S2) (* 103 S3)))
 (= X8 (+ (* 203 S2) S3))
 (= X8 (- (* 203 S2) S3))
 (= X8 (- S2 (* 203 S3)))
 (= X8 (+ (* 203 S2) (* 203 S3)))
 (= X8 (- (* 203 S2) (* 203 S3)))
 (= X8 (+ (* 203 S2) (* 927 S3)))
 (= X8 (- (* 203 S2) (* 927 S3)))
 (= X8 (- (* 927 S2) (* 203 S3)))
 (= X8 (+ (* 203 S2) (* 791 S3)))
 (= X8 (- (* 203 S2) (* 791 S3)))
 (= X8 (- (* 791 S2) (* 203 S3)))
 (= X8 (+ (* 203 S2) (* 723 S3)))
 (= X8 (- (* 203 S2) (* 723 S3)))
 (= X8 (- (* 723 S2) (* 203 S3)))
 (= X8 (+ (* 203 S2) (* X7 S3)))
 (= X8 (- (* 203 S2) (* X7 S3)))
 (= X8 (- (* X7 S2) (* 203 S3)))
 (= X8 (+ (* 927 S2) S3))
 (= X8 (- (* 927 S2) S3))
 (= X8 (- S2 (* 927 S3)))
 (= X8 (+ (* 927 S2) (* 927 S3)))
 (= X8 (- (* 927 S2) (* 927 S3)))
 (= X8 (+ (* 927 S2) (* 791 S3)))
 (= X8 (- (* 927 S2) (* 791 S3)))
 (= X8 (- (* 791 S2) (* 927 S3)))
 (= X8 (+ (* 927 S2) (* 723 S3)))
 (= X8 (- (* 927 S2) (* 723 S3)))
 (= X8 (- (* 723 S2) (* 927 S3)))
 (= X8 (+ (* 927 S2) (* X7 S3)))
 (= X8 (- (* 927 S2) (* X7 S3)))
 (= X8 (- (* X7 S2) (* 927 S3)))
 (= X8 (+ (* 791 S2) S3))
 (= X8 (- (* 791 S2) S3))
 (= X8 (- S2 (* 791 S3)))
 (= X8 (+ (* 791 S2) (* 791 S3)))
 (= X8 (- (* 791 S2) (* 791 S3)))
 (= X8 (+ (* 791 S2) (* 723 S3)))
 (= X8 (- (* 791 S2) (* 723 S3)))
 (= X8 (- (* 723 S2) (* 791 S3)))
 (= X8 (+ (* 791 S2) (* X7 S3)))
 (= X8 (- (* 791 S2) (* X7 S3)))
 (= X8 (- (* X7 S2) (* 791 S3)))
 (= X8 (+ (* 723 S2) S3))
 (= X8 (- (* 723 S2) S3))
 (= X8 (- S2 (* 723 S3)))
 (= X8 (+ (* 723 S2) (* 723 S3)))
 (= X8 (- (* 723 S2) (* 723 S3)))
 (= X8 (+ (* 723 S2) (* X7 S3)))
 (= X8 (- (* 723 S2) (* X7 S3)))
 (= X8 (- (* X7 S2) (* 723 S3)))
 (= X8 (+ (* X7 S2) S3))
 (= X8 (- (* X7 S2) S3))
 (= X8 (- S2 (* X7 S3)))
 (= X8 (+ (* X7 S2) (* X7 S3)))
 (= X8 (- (* X7 S2) (* X7 S3)))
))
(assert (and (> X8 0) (< X8 2048) (power2 S2) (power2 S3)))
(assert (or
 (= X9 (+ (* 17 S4) S5))
 (= X9 (- (* 17 S4) S5))
 (= X9 (- S4 (* 17 S5)))
 (= X9 (+ (* 17 S4) (* 17 S5)))
 (= X9 (- (* 17 S4) (* 17 S5)))
 (= X9 (+ (* 17 S4) (* 153 S5)))
 (= X9 (- (* 17 S4) (* 153 S5)))
 (= X9 (- (* 153 S4) (* 17 S5)))
 (= X9 (+ (* 17 S4) (* 103 S5)))
 (= X9 (- (* 17 S4) (* 103 S5)))
 (= X9 (- (* 103 S4) (* 17 S5)))
 (= X9 (+ (* 17 S4) (* 203 S5)))
 (= X9 (- (* 17 S4) (* 203 S5)))
 (= X9 (- (* 203 S4) (* 17 S5)))
 (= X9 (+ (* 17 S4) (* 927 S5)))
 (= X9 (- (* 17 S4) (* 927 S5)))
 (= X9 (- (* 927 S4) (* 17 S5)))
 (= X9 (+ (* 17 S4) (* 791 S5)))
 (= X9 (- (* 17 S4) (* 791 S5)))
 (= X9 (- (* 791 S4) (* 17 S5)))
 (= X9 (+ (* 17 S4) (* 723 S5)))
 (= X9 (- (* 17 S4) (* 723 S5)))
 (= X9 (- (* 723 S4) (* 17 S5)))
 (= X9 (+ (* 17 S4) (* X7 S5)))
 (= X9 (- (* 17 S4) (* X7 S5)))
 (= X9 (- (* X7 S4) (* 17 S5)))
 (= X9 (+ (* 17 S4) (* X8 S5)))
 (= X9 (- (* 17 S4) (* X8 S5)))
 (= X9 (- (* X8 S4) (* 17 S5)))
 (= X9 (+ (* 153 S4) S5))
 (= X9 (- (* 153 S4) S5))
 (= X9 (- S4 (* 153 S5)))
 (= X9 (+ (* 153 S4) (* 153 S5)))
 (= X9 (- (* 153 S4) (* 153 S5)))
 (= X9 (+ (* 153 S4) (* 103 S5)))
 (= X9 (- (* 153 S4) (* 103 S5)))
 (= X9 (- (* 103 S4) (* 153 S5)))
 (= X9 (+ (* 153 S4) (* 203 S5)))
 (= X9 (- (* 153 S4) (* 203 S5)))
 (= X9 (- (* 203 S4) (* 153 S5)))
 (= X9 (+ (* 153 S4) (* 927 S5)))
 (= X9 (- (* 153 S4) (* 927 S5)))
 (= X9 (- (* 927 S4) (* 153 S5)))
 (= X9 (+ (* 153 S4) (* 791 S5)))
 (= X9 (- (* 153 S4) (* 791 S5)))
 (= X9 (- (* 791 S4) (* 153 S5)))
 (= X9 (+ (* 153 S4) (* 723 S5)))
 (= X9 (- (* 153 S4) (* 723 S5)))
 (= X9 (- (* 723 S4) (* 153 S5)))
 (= X9 (+ (* 153 S4) (* X7 S5)))
 (= X9 (- (* 153 S4) (* X7 S5)))
 (= X9 (- (* X7 S4) (* 153 S5)))
 (= X9 (+ (* 153 S4) (* X8 S5)))
 (= X9 (- (* 153 S4) (* X8 S5)))
 (= X9 (- (* X8 S4) (* 153 S5)))
 (= X9 (+ (* 103 S4) S5))
 (= X9 (- (* 103 S4) S5))
 (= X9 (- S4 (* 103 S5)))
 (= X9 (+ (* 103 S4) (* 103 S5)))
 (= X9 (- (* 103 S4) (* 103 S5)))
 (= X9 (+ (* 103 S4) (* 203 S5)))
 (= X9 (- (* 103 S4) (* 203 S5)))
 (= X9 (- (* 203 S4) (* 103 S5)))
 (= X9 (+ (* 103 S4) (* 927 S5)))
 (= X9 (- (* 103 S4) (* 927 S5)))
 (= X9 (- (* 927 S4) (* 103 S5)))
 (= X9 (+ (* 103 S4) (* 791 S5)))
 (= X9 (- (* 103 S4) (* 791 S5)))
 (= X9 (- (* 791 S4) (* 103 S5)))
 (= X9 (+ (* 103 S4) (* 723 S5)))
 (= X9 (- (* 103 S4) (* 723 S5)))
 (= X9 (- (* 723 S4) (* 103 S5)))
 (= X9 (+ (* 103 S4) (* X7 S5)))
 (= X9 (- (* 103 S4) (* X7 S5)))
 (= X9 (- (* X7 S4) (* 103 S5)))
 (= X9 (+ (* 103 S4) (* X8 S5)))
 (= X9 (- (* 103 S4) (* X8 S5)))
 (= X9 (- (* X8 S4) (* 103 S5)))
 (= X9 (+ (* 203 S4) S5))
 (= X9 (- (* 203 S4) S5))
 (= X9 (- S4 (* 203 S5)))
 (= X9 (+ (* 203 S4) (* 203 S5)))
 (= X9 (- (* 203 S4) (* 203 S5)))
 (= X9 (+ (* 203 S4) (* 927 S5)))
 (= X9 (- (* 203 S4) (* 927 S5)))
 (= X9 (- (* 927 S4) (* 203 S5)))
 (= X9 (+ (* 203 S4) (* 791 S5)))
 (= X9 (- (* 203 S4) (* 791 S5)))
 (= X9 (- (* 791 S4) (* 203 S5)))
 (= X9 (+ (* 203 S4) (* 723 S5)))
 (= X9 (- (* 203 S4) (* 723 S5)))
 (= X9 (- (* 723 S4) (* 203 S5)))
 (= X9 (+ (* 203 S4) (* X7 S5)))
 (= X9 (- (* 203 S4) (* X7 S5)))
 (= X9 (- (* X7 S4) (* 203 S5)))
 (= X9 (+ (* 203 S4) (* X8 S5)))
 (= X9 (- (* 203 S4) (* X8 S5)))
 (= X9 (- (* X8 S4) (* 203 S5)))
 (= X9 (+ (* 927 S4) S5))
 (= X9 (- (* 927 S4) S5))
 (= X9 (- S4 (* 927 S5)))
 (= X9 (+ (* 927 S4) (* 927 S5)))
 (= X9 (- (* 927 S4) (* 927 S5)))
 (= X9 (+ (* 927 S4) (* 791 S5)))
 (= X9 (- (* 927 S4) (* 791 S5)))
 (= X9 (- (* 791 S4) (* 927 S5)))
 (= X9 (+ (* 927 S4) (* 723 S5)))
 (= X9 (- (* 927 S4) (* 723 S5)))
 (= X9 (- (* 723 S4) (* 927 S5)))
 (= X9 (+ (* 927 S4) (* X7 S5)))
 (= X9 (- (* 927 S4) (* X7 S5)))
 (= X9 (- (* X7 S4) (* 927 S5)))
 (= X9 (+ (* 927 S4) (* X8 S5)))
 (= X9 (- (* 927 S4) (* X8 S5)))
 (= X9 (- (* X8 S4) (* 927 S5)))
 (= X9 (+ (* 791 S4) S5))
 (= X9 (- (* 791 S4) S5))
 (= X9 (- S4 (* 791 S5)))
 (= X9 (+ (* 791 S4) (* 791 S5)))
 (= X9 (- (* 791 S4) (* 791 S5)))
 (= X9 (+ (* 791 S4) (* 723 S5)))
 (= X9 (- (* 791 S4) (* 723 S5)))
 (= X9 (- (* 723 S4) (* 791 S5)))
 (= X9 (+ (* 791 S4) (* X7 S5)))
 (= X9 (- (* 791 S4) (* X7 S5)))
 (= X9 (- (* X7 S4) (* 791 S5)))
 (= X9 (+ (* 791 S4) (* X8 S5)))
 (= X9 (- (* 791 S4) (* X8 S5)))
 (= X9 (- (* X8 S4) (* 791 S5)))
 (= X9 (+ (* 723 S4) S5))
 (= X9 (- (* 723 S4) S5))
 (= X9 (- S4 (* 723 S5)))
 (= X9 (+ (* 723 S4) (* 723 S5)))
 (= X9 (- (* 723 S4) (* 723 S5)))
 (= X9 (+ (* 723 S4) (* X7 S5)))
 (= X9 (- (* 723 S4) (* X7 S5)))
 (= X9 (- (* X7 S4) (* 723 S5)))
 (= X9 (+ (* 723 S4) (* X8 S5)))
 (= X9 (- (* 723 S4) (* X8 S5)))
 (= X9 (- (* X8 S4) (* 723 S5)))
 (= X9 (+ (* X7 S4) S5))
 (= X9 (- (* X7 S4) S5))
 (= X9 (- S4 (* X7 S5)))
 (= X9 (+ (* X7 S4) (* X7 S5)))
 (= X9 (- (* X7 S4) (* X7 S5)))
 (= X9 (+ (* X7 S4) (* X8 S5)))
 (= X9 (- (* X7 S4) (* X8 S5)))
 (= X9 (- (* X8 S4) (* X7 S5)))
 (= X9 (+ (* X8 S4) S5))
 (= X9 (- (* X8 S4) S5))
 (= X9 (- S4 (* X8 S5)))
 (= X9 (+ (* X8 S4) (* X8 S5)))
 (= X9 (- (* X8 S4) (* X8 S5)))
))
(assert (and (> X9 0) (< X9 2048) (power2 S4) (power2 S5)))
(assert (or
 (= X8 213)
 (= X9 213)
))
(assert (or
 (= X8 505)
 (= X9 505)
))
(check-sat)
(exit)
