(set-logic QF_NIA)
(set-info :source |
 more info in 'N. P. Lopes, L. Aksoy, V. Manquinho, J. Monteiro.
 Optimally Solving the MCM Problem Using Pseudo-Boolean Satisfiability.
 Technical Report RT/43/2010, INESC-ID, Nov. 2010'. |)
(set-info :smt-lib-version 2.0)
(set-info :category "industrial")
(set-info :status unknown)
(declare-fun X5 () Int)
(declare-fun X6 () Int)
(declare-fun X7 () Int)
(declare-fun X8 () Int)
(declare-fun X9 () Int)
(declare-fun X10 () Int)
(declare-fun S0 () Int)
(declare-fun S1 () Int)
(declare-fun S2 () Int)
(declare-fun S3 () Int)
(declare-fun S4 () Int)
(declare-fun S5 () Int)
(declare-fun S6 () Int)
(declare-fun S7 () Int)
(declare-fun S8 () Int)
(declare-fun S9 () Int)
(declare-fun S10 () Int)
(declare-fun S11 () Int)
(define-fun power2 ((x Int)) Bool
  (or (= x 512) (= x 256) (= x 128) (= x 64) (= x 32) (= x 16) (= x 8) (= x 4) (= x 2) (= x 1)))
(assert (or
 (= X5 (+ S0 S1))
 (= X5 (- S0 S1))
 (= X5 (+ (* 511 S0) S1))
 (= X5 (- (* 511 S0) S1))
 (= X5 (- S0 (* 511 S1)))
 (= X5 (+ (* 511 S0) (* 511 S1)))
 (= X5 (- (* 511 S0) (* 511 S1)))
 (= X5 (+ (* 511 S0) (* 5 S1)))
 (= X5 (- (* 511 S0) (* 5 S1)))
 (= X5 (- (* 5 S0) (* 511 S1)))
 (= X5 (+ (* 511 S0) (* 63 S1)))
 (= X5 (- (* 511 S0) (* 63 S1)))
 (= X5 (- (* 63 S0) (* 511 S1)))
 (= X5 (+ (* 511 S0) (* 71 S1)))
 (= X5 (- (* 511 S0) (* 71 S1)))
 (= X5 (- (* 71 S0) (* 511 S1)))
 (= X5 (+ (* 511 S0) (* 55 S1)))
 (= X5 (- (* 511 S0) (* 55 S1)))
 (= X5 (- (* 55 S0) (* 511 S1)))
 (= X5 (+ (* 5 S0) S1))
 (= X5 (- (* 5 S0) S1))
 (= X5 (- S0 (* 5 S1)))
 (= X5 (+ (* 5 S0) (* 5 S1)))
 (= X5 (- (* 5 S0) (* 5 S1)))
 (= X5 (+ (* 5 S0) (* 63 S1)))
 (= X5 (- (* 5 S0) (* 63 S1)))
 (= X5 (- (* 63 S0) (* 5 S1)))
 (= X5 (+ (* 5 S0) (* 71 S1)))
 (= X5 (- (* 5 S0) (* 71 S1)))
 (= X5 (- (* 71 S0) (* 5 S1)))
 (= X5 (+ (* 5 S0) (* 55 S1)))
 (= X5 (- (* 5 S0) (* 55 S1)))
 (= X5 (- (* 55 S0) (* 5 S1)))
 (= X5 (+ (* 63 S0) S1))
 (= X5 (- (* 63 S0) S1))
 (= X5 (- S0 (* 63 S1)))
 (= X5 (+ (* 63 S0) (* 63 S1)))
 (= X5 (- (* 63 S0) (* 63 S1)))
 (= X5 (+ (* 63 S0) (* 71 S1)))
 (= X5 (- (* 63 S0) (* 71 S1)))
 (= X5 (- (* 71 S0) (* 63 S1)))
 (= X5 (+ (* 63 S0) (* 55 S1)))
 (= X5 (- (* 63 S0) (* 55 S1)))
 (= X5 (- (* 55 S0) (* 63 S1)))
 (= X5 (+ (* 71 S0) S1))
 (= X5 (- (* 71 S0) S1))
 (= X5 (- S0 (* 71 S1)))
 (= X5 (+ (* 71 S0) (* 71 S1)))
 (= X5 (- (* 71 S0) (* 71 S1)))
 (= X5 (+ (* 71 S0) (* 55 S1)))
 (= X5 (- (* 71 S0) (* 55 S1)))
 (= X5 (- (* 55 S0) (* 71 S1)))
 (= X5 (+ (* 55 S0) S1))
 (= X5 (- (* 55 S0) S1))
 (= X5 (- S0 (* 55 S1)))
 (= X5 (+ (* 55 S0) (* 55 S1)))
 (= X5 (- (* 55 S0) (* 55 S1)))
))
(assert (and (> X5 0) (< X5 1024) (power2 S0) (power2 S1)))
(assert (or
 (= X6 (+ (* 511 S2) S3))
 (= X6 (- (* 511 S2) S3))
 (= X6 (- S2 (* 511 S3)))
 (= X6 (+ (* 511 S2) (* 511 S3)))
 (= X6 (- (* 511 S2) (* 511 S3)))
 (= X6 (+ (* 511 S2) (* 5 S3)))
 (= X6 (- (* 511 S2) (* 5 S3)))
 (= X6 (- (* 5 S2) (* 511 S3)))
 (= X6 (+ (* 511 S2) (* 63 S3)))
 (= X6 (- (* 511 S2) (* 63 S3)))
 (= X6 (- (* 63 S2) (* 511 S3)))
 (= X6 (+ (* 511 S2) (* 71 S3)))
 (= X6 (- (* 511 S2) (* 71 S3)))
 (= X6 (- (* 71 S2) (* 511 S3)))
 (= X6 (+ (* 511 S2) (* 55 S3)))
 (= X6 (- (* 511 S2) (* 55 S3)))
 (= X6 (- (* 55 S2) (* 511 S3)))
 (= X6 (+ (* 511 S2) (* X5 S3)))
 (= X6 (- (* 511 S2) (* X5 S3)))
 (= X6 (- (* X5 S2) (* 511 S3)))
 (= X6 (+ (* 5 S2) S3))
 (= X6 (- (* 5 S2) S3))
 (= X6 (- S2 (* 5 S3)))
 (= X6 (+ (* 5 S2) (* 5 S3)))
 (= X6 (- (* 5 S2) (* 5 S3)))
 (= X6 (+ (* 5 S2) (* 63 S3)))
 (= X6 (- (* 5 S2) (* 63 S3)))
 (= X6 (- (* 63 S2) (* 5 S3)))
 (= X6 (+ (* 5 S2) (* 71 S3)))
 (= X6 (- (* 5 S2) (* 71 S3)))
 (= X6 (- (* 71 S2) (* 5 S3)))
 (= X6 (+ (* 5 S2) (* 55 S3)))
 (= X6 (- (* 5 S2) (* 55 S3)))
 (= X6 (- (* 55 S2) (* 5 S3)))
 (= X6 (+ (* 5 S2) (* X5 S3)))
 (= X6 (- (* 5 S2) (* X5 S3)))
 (= X6 (- (* X5 S2) (* 5 S3)))
 (= X6 (+ (* 63 S2) S3))
 (= X6 (- (* 63 S2) S3))
 (= X6 (- S2 (* 63 S3)))
 (= X6 (+ (* 63 S2) (* 63 S3)))
 (= X6 (- (* 63 S2) (* 63 S3)))
 (= X6 (+ (* 63 S2) (* 71 S3)))
 (= X6 (- (* 63 S2) (* 71 S3)))
 (= X6 (- (* 71 S2) (* 63 S3)))
 (= X6 (+ (* 63 S2) (* 55 S3)))
 (= X6 (- (* 63 S2) (* 55 S3)))
 (= X6 (- (* 55 S2) (* 63 S3)))
 (= X6 (+ (* 63 S2) (* X5 S3)))
 (= X6 (- (* 63 S2) (* X5 S3)))
 (= X6 (- (* X5 S2) (* 63 S3)))
 (= X6 (+ (* 71 S2) S3))
 (= X6 (- (* 71 S2) S3))
 (= X6 (- S2 (* 71 S3)))
 (= X6 (+ (* 71 S2) (* 71 S3)))
 (= X6 (- (* 71 S2) (* 71 S3)))
 (= X6 (+ (* 71 S2) (* 55 S3)))
 (= X6 (- (* 71 S2) (* 55 S3)))
 (= X6 (- (* 55 S2) (* 71 S3)))
 (= X6 (+ (* 71 S2) (* X5 S3)))
 (= X6 (- (* 71 S2) (* X5 S3)))
 (= X6 (- (* X5 S2) (* 71 S3)))
 (= X6 (+ (* 55 S2) S3))
 (= X6 (- (* 55 S2) S3))
 (= X6 (- S2 (* 55 S3)))
 (= X6 (+ (* 55 S2) (* 55 S3)))
 (= X6 (- (* 55 S2) (* 55 S3)))
 (= X6 (+ (* 55 S2) (* X5 S3)))
 (= X6 (- (* 55 S2) (* X5 S3)))
 (= X6 (- (* X5 S2) (* 55 S3)))
 (= X6 (+ (* X5 S2) S3))
 (= X6 (- (* X5 S2) S3))
 (= X6 (- S2 (* X5 S3)))
 (= X6 (+ (* X5 S2) (* X5 S3)))
 (= X6 (- (* X5 S2) (* X5 S3)))
))
(assert (and (> X6 0) (< X6 1024) (power2 S2) (power2 S3)))
(assert (or
 (= X7 (+ (* 511 S4) S5))
 (= X7 (- (* 511 S4) S5))
 (= X7 (- S4 (* 511 S5)))
 (= X7 (+ (* 511 S4) (* 511 S5)))
 (= X7 (- (* 511 S4) (* 511 S5)))
 (= X7 (+ (* 511 S4) (* 5 S5)))
 (= X7 (- (* 511 S4) (* 5 S5)))
 (= X7 (- (* 5 S4) (* 511 S5)))
 (= X7 (+ (* 511 S4) (* 63 S5)))
 (= X7 (- (* 511 S4) (* 63 S5)))
 (= X7 (- (* 63 S4) (* 511 S5)))
 (= X7 (+ (* 511 S4) (* 71 S5)))
 (= X7 (- (* 511 S4) (* 71 S5)))
 (= X7 (- (* 71 S4) (* 511 S5)))
 (= X7 (+ (* 511 S4) (* 55 S5)))
 (= X7 (- (* 511 S4) (* 55 S5)))
 (= X7 (- (* 55 S4) (* 511 S5)))
 (= X7 (+ (* 511 S4) (* X5 S5)))
 (= X7 (- (* 511 S4) (* X5 S5)))
 (= X7 (- (* X5 S4) (* 511 S5)))
 (= X7 (+ (* 511 S4) (* X6 S5)))
 (= X7 (- (* 511 S4) (* X6 S5)))
 (= X7 (- (* X6 S4) (* 511 S5)))
 (= X7 (+ (* 5 S4) S5))
 (= X7 (- (* 5 S4) S5))
 (= X7 (- S4 (* 5 S5)))
 (= X7 (+ (* 5 S4) (* 5 S5)))
 (= X7 (- (* 5 S4) (* 5 S5)))
 (= X7 (+ (* 5 S4) (* 63 S5)))
 (= X7 (- (* 5 S4) (* 63 S5)))
 (= X7 (- (* 63 S4) (* 5 S5)))
 (= X7 (+ (* 5 S4) (* 71 S5)))
 (= X7 (- (* 5 S4) (* 71 S5)))
 (= X7 (- (* 71 S4) (* 5 S5)))
 (= X7 (+ (* 5 S4) (* 55 S5)))
 (= X7 (- (* 5 S4) (* 55 S5)))
 (= X7 (- (* 55 S4) (* 5 S5)))
 (= X7 (+ (* 5 S4) (* X5 S5)))
 (= X7 (- (* 5 S4) (* X5 S5)))
 (= X7 (- (* X5 S4) (* 5 S5)))
 (= X7 (+ (* 5 S4) (* X6 S5)))
 (= X7 (- (* 5 S4) (* X6 S5)))
 (= X7 (- (* X6 S4) (* 5 S5)))
 (= X7 (+ (* 63 S4) S5))
 (= X7 (- (* 63 S4) S5))
 (= X7 (- S4 (* 63 S5)))
 (= X7 (+ (* 63 S4) (* 63 S5)))
 (= X7 (- (* 63 S4) (* 63 S5)))
 (= X7 (+ (* 63 S4) (* 71 S5)))
 (= X7 (- (* 63 S4) (* 71 S5)))
 (= X7 (- (* 71 S4) (* 63 S5)))
 (= X7 (+ (* 63 S4) (* 55 S5)))
 (= X7 (- (* 63 S4) (* 55 S5)))
 (= X7 (- (* 55 S4) (* 63 S5)))
 (= X7 (+ (* 63 S4) (* X5 S5)))
 (= X7 (- (* 63 S4) (* X5 S5)))
 (= X7 (- (* X5 S4) (* 63 S5)))
 (= X7 (+ (* 63 S4) (* X6 S5)))
 (= X7 (- (* 63 S4) (* X6 S5)))
 (= X7 (- (* X6 S4) (* 63 S5)))
 (= X7 (+ (* 71 S4) S5))
 (= X7 (- (* 71 S4) S5))
 (= X7 (- S4 (* 71 S5)))
 (= X7 (+ (* 71 S4) (* 71 S5)))
 (= X7 (- (* 71 S4) (* 71 S5)))
 (= X7 (+ (* 71 S4) (* 55 S5)))
 (= X7 (- (* 71 S4) (* 55 S5)))
 (= X7 (- (* 55 S4) (* 71 S5)))
 (= X7 (+ (* 71 S4) (* X5 S5)))
 (= X7 (- (* 71 S4) (* X5 S5)))
 (= X7 (- (* X5 S4) (* 71 S5)))
 (= X7 (+ (* 71 S4) (* X6 S5)))
 (= X7 (- (* 71 S4) (* X6 S5)))
 (= X7 (- (* X6 S4) (* 71 S5)))
 (= X7 (+ (* 55 S4) S5))
 (= X7 (- (* 55 S4) S5))
 (= X7 (- S4 (* 55 S5)))
 (= X7 (+ (* 55 S4) (* 55 S5)))
 (= X7 (- (* 55 S4) (* 55 S5)))
 (= X7 (+ (* 55 S4) (* X5 S5)))
 (= X7 (- (* 55 S4) (* X5 S5)))
 (= X7 (- (* X5 S4) (* 55 S5)))
 (= X7 (+ (* 55 S4) (* X6 S5)))
 (= X7 (- (* 55 S4) (* X6 S5)))
 (= X7 (- (* X6 S4) (* 55 S5)))
 (= X7 (+ (* X5 S4) S5))
 (= X7 (- (* X5 S4) S5))
 (= X7 (- S4 (* X5 S5)))
 (= X7 (+ (* X5 S4) (* X5 S5)))
 (= X7 (- (* X5 S4) (* X5 S5)))
 (= X7 (+ (* X5 S4) (* X6 S5)))
 (= X7 (- (* X5 S4) (* X6 S5)))
 (= X7 (- (* X6 S4) (* X5 S5)))
 (= X7 (+ (* X6 S4) S5))
 (= X7 (- (* X6 S4) S5))
 (= X7 (- S4 (* X6 S5)))
 (= X7 (+ (* X6 S4) (* X6 S5)))
 (= X7 (- (* X6 S4) (* X6 S5)))
))
(assert (and (> X7 0) (< X7 1024) (power2 S4) (power2 S5)))
(assert (or
 (= X8 (+ (* 511 S6) S7))
 (= X8 (- (* 511 S6) S7))
 (= X8 (- S6 (* 511 S7)))
 (= X8 (+ (* 511 S6) (* 511 S7)))
 (= X8 (- (* 511 S6) (* 511 S7)))
 (= X8 (+ (* 511 S6) (* 5 S7)))
 (= X8 (- (* 511 S6) (* 5 S7)))
 (= X8 (- (* 5 S6) (* 511 S7)))
 (= X8 (+ (* 511 S6) (* 63 S7)))
 (= X8 (- (* 511 S6) (* 63 S7)))
 (= X8 (- (* 63 S6) (* 511 S7)))
 (= X8 (+ (* 511 S6) (* 71 S7)))
 (= X8 (- (* 511 S6) (* 71 S7)))
 (= X8 (- (* 71 S6) (* 511 S7)))
 (= X8 (+ (* 511 S6) (* 55 S7)))
 (= X8 (- (* 511 S6) (* 55 S7)))
 (= X8 (- (* 55 S6) (* 511 S7)))
 (= X8 (+ (* 511 S6) (* X5 S7)))
 (= X8 (- (* 511 S6) (* X5 S7)))
 (= X8 (- (* X5 S6) (* 511 S7)))
 (= X8 (+ (* 511 S6) (* X6 S7)))
 (= X8 (- (* 511 S6) (* X6 S7)))
 (= X8 (- (* X6 S6) (* 511 S7)))
 (= X8 (+ (* 511 S6) (* X7 S7)))
 (= X8 (- (* 511 S6) (* X7 S7)))
 (= X8 (- (* X7 S6) (* 511 S7)))
 (= X8 (+ (* 5 S6) S7))
 (= X8 (- (* 5 S6) S7))
 (= X8 (- S6 (* 5 S7)))
 (= X8 (+ (* 5 S6) (* 5 S7)))
 (= X8 (- (* 5 S6) (* 5 S7)))
 (= X8 (+ (* 5 S6) (* 63 S7)))
 (= X8 (- (* 5 S6) (* 63 S7)))
 (= X8 (- (* 63 S6) (* 5 S7)))
 (= X8 (+ (* 5 S6) (* 71 S7)))
 (= X8 (- (* 5 S6) (* 71 S7)))
 (= X8 (- (* 71 S6) (* 5 S7)))
 (= X8 (+ (* 5 S6) (* 55 S7)))
 (= X8 (- (* 5 S6) (* 55 S7)))
 (= X8 (- (* 55 S6) (* 5 S7)))
 (= X8 (+ (* 5 S6) (* X5 S7)))
 (= X8 (- (* 5 S6) (* X5 S7)))
 (= X8 (- (* X5 S6) (* 5 S7)))
 (= X8 (+ (* 5 S6) (* X6 S7)))
 (= X8 (- (* 5 S6) (* X6 S7)))
 (= X8 (- (* X6 S6) (* 5 S7)))
 (= X8 (+ (* 5 S6) (* X7 S7)))
 (= X8 (- (* 5 S6) (* X7 S7)))
 (= X8 (- (* X7 S6) (* 5 S7)))
 (= X8 (+ (* 63 S6) S7))
 (= X8 (- (* 63 S6) S7))
 (= X8 (- S6 (* 63 S7)))
 (= X8 (+ (* 63 S6) (* 63 S7)))
 (= X8 (- (* 63 S6) (* 63 S7)))
 (= X8 (+ (* 63 S6) (* 71 S7)))
 (= X8 (- (* 63 S6) (* 71 S7)))
 (= X8 (- (* 71 S6) (* 63 S7)))
 (= X8 (+ (* 63 S6) (* 55 S7)))
 (= X8 (- (* 63 S6) (* 55 S7)))
 (= X8 (- (* 55 S6) (* 63 S7)))
 (= X8 (+ (* 63 S6) (* X5 S7)))
 (= X8 (- (* 63 S6) (* X5 S7)))
 (= X8 (- (* X5 S6) (* 63 S7)))
 (= X8 (+ (* 63 S6) (* X6 S7)))
 (= X8 (- (* 63 S6) (* X6 S7)))
 (= X8 (- (* X6 S6) (* 63 S7)))
 (= X8 (+ (* 63 S6) (* X7 S7)))
 (= X8 (- (* 63 S6) (* X7 S7)))
 (= X8 (- (* X7 S6) (* 63 S7)))
 (= X8 (+ (* 71 S6) S7))
 (= X8 (- (* 71 S6) S7))
 (= X8 (- S6 (* 71 S7)))
 (= X8 (+ (* 71 S6) (* 71 S7)))
 (= X8 (- (* 71 S6) (* 71 S7)))
 (= X8 (+ (* 71 S6) (* 55 S7)))
 (= X8 (- (* 71 S6) (* 55 S7)))
 (= X8 (- (* 55 S6) (* 71 S7)))
 (= X8 (+ (* 71 S6) (* X5 S7)))
 (= X8 (- (* 71 S6) (* X5 S7)))
 (= X8 (- (* X5 S6) (* 71 S7)))
 (= X8 (+ (* 71 S6) (* X6 S7)))
 (= X8 (- (* 71 S6) (* X6 S7)))
 (= X8 (- (* X6 S6) (* 71 S7)))
 (= X8 (+ (* 71 S6) (* X7 S7)))
 (= X8 (- (* 71 S6) (* X7 S7)))
 (= X8 (- (* X7 S6) (* 71 S7)))
 (= X8 (+ (* 55 S6) S7))
 (= X8 (- (* 55 S6) S7))
 (= X8 (- S6 (* 55 S7)))
 (= X8 (+ (* 55 S6) (* 55 S7)))
 (= X8 (- (* 55 S6) (* 55 S7)))
 (= X8 (+ (* 55 S6) (* X5 S7)))
 (= X8 (- (* 55 S6) (* X5 S7)))
 (= X8 (- (* X5 S6) (* 55 S7)))
 (= X8 (+ (* 55 S6) (* X6 S7)))
 (= X8 (- (* 55 S6) (* X6 S7)))
 (= X8 (- (* X6 S6) (* 55 S7)))
 (= X8 (+ (* 55 S6) (* X7 S7)))
 (= X8 (- (* 55 S6) (* X7 S7)))
 (= X8 (- (* X7 S6) (* 55 S7)))
 (= X8 (+ (* X5 S6) S7))
 (= X8 (- (* X5 S6) S7))
 (= X8 (- S6 (* X5 S7)))
 (= X8 (+ (* X5 S6) (* X5 S7)))
 (= X8 (- (* X5 S6) (* X5 S7)))
 (= X8 (+ (* X5 S6) (* X6 S7)))
 (= X8 (- (* X5 S6) (* X6 S7)))
 (= X8 (- (* X6 S6) (* X5 S7)))
 (= X8 (+ (* X5 S6) (* X7 S7)))
 (= X8 (- (* X5 S6) (* X7 S7)))
 (= X8 (- (* X7 S6) (* X5 S7)))
 (= X8 (+ (* X6 S6) S7))
 (= X8 (- (* X6 S6) S7))
 (= X8 (- S6 (* X6 S7)))
 (= X8 (+ (* X6 S6) (* X6 S7)))
 (= X8 (- (* X6 S6) (* X6 S7)))
 (= X8 (+ (* X6 S6) (* X7 S7)))
 (= X8 (- (* X6 S6) (* X7 S7)))
 (= X8 (- (* X7 S6) (* X6 S7)))
 (= X8 (+ (* X7 S6) S7))
 (= X8 (- (* X7 S6) S7))
 (= X8 (- S6 (* X7 S7)))
 (= X8 (+ (* X7 S6) (* X7 S7)))
 (= X8 (- (* X7 S6) (* X7 S7)))
))
(assert (and (> X8 0) (< X8 1024) (power2 S6) (power2 S7)))
(assert (or
 (= X9 (+ (* 511 S8) S9))
 (= X9 (- (* 511 S8) S9))
 (= X9 (- S8 (* 511 S9)))
 (= X9 (+ (* 511 S8) (* 511 S9)))
 (= X9 (- (* 511 S8) (* 511 S9)))
 (= X9 (+ (* 511 S8) (* 5 S9)))
 (= X9 (- (* 511 S8) (* 5 S9)))
 (= X9 (- (* 5 S8) (* 511 S9)))
 (= X9 (+ (* 511 S8) (* 63 S9)))
 (= X9 (- (* 511 S8) (* 63 S9)))
 (= X9 (- (* 63 S8) (* 511 S9)))
 (= X9 (+ (* 511 S8) (* 71 S9)))
 (= X9 (- (* 511 S8) (* 71 S9)))
 (= X9 (- (* 71 S8) (* 511 S9)))
 (= X9 (+ (* 511 S8) (* 55 S9)))
 (= X9 (- (* 511 S8) (* 55 S9)))
 (= X9 (- (* 55 S8) (* 511 S9)))
 (= X9 (+ (* 511 S8) (* X5 S9)))
 (= X9 (- (* 511 S8) (* X5 S9)))
 (= X9 (- (* X5 S8) (* 511 S9)))
 (= X9 (+ (* 511 S8) (* X6 S9)))
 (= X9 (- (* 511 S8) (* X6 S9)))
 (= X9 (- (* X6 S8) (* 511 S9)))
 (= X9 (+ (* 511 S8) (* X7 S9)))
 (= X9 (- (* 511 S8) (* X7 S9)))
 (= X9 (- (* X7 S8) (* 511 S9)))
 (= X9 (+ (* 511 S8) (* X8 S9)))
 (= X9 (- (* 511 S8) (* X8 S9)))
 (= X9 (- (* X8 S8) (* 511 S9)))
 (= X9 (+ (* 5 S8) S9))
 (= X9 (- (* 5 S8) S9))
 (= X9 (- S8 (* 5 S9)))
 (= X9 (+ (* 5 S8) (* 5 S9)))
 (= X9 (- (* 5 S8) (* 5 S9)))
 (= X9 (+ (* 5 S8) (* 63 S9)))
 (= X9 (- (* 5 S8) (* 63 S9)))
 (= X9 (- (* 63 S8) (* 5 S9)))
 (= X9 (+ (* 5 S8) (* 71 S9)))
 (= X9 (- (* 5 S8) (* 71 S9)))
 (= X9 (- (* 71 S8) (* 5 S9)))
 (= X9 (+ (* 5 S8) (* 55 S9)))
 (= X9 (- (* 5 S8) (* 55 S9)))
 (= X9 (- (* 55 S8) (* 5 S9)))
 (= X9 (+ (* 5 S8) (* X5 S9)))
 (= X9 (- (* 5 S8) (* X5 S9)))
 (= X9 (- (* X5 S8) (* 5 S9)))
 (= X9 (+ (* 5 S8) (* X6 S9)))
 (= X9 (- (* 5 S8) (* X6 S9)))
 (= X9 (- (* X6 S8) (* 5 S9)))
 (= X9 (+ (* 5 S8) (* X7 S9)))
 (= X9 (- (* 5 S8) (* X7 S9)))
 (= X9 (- (* X7 S8) (* 5 S9)))
 (= X9 (+ (* 5 S8) (* X8 S9)))
 (= X9 (- (* 5 S8) (* X8 S9)))
 (= X9 (- (* X8 S8) (* 5 S9)))
 (= X9 (+ (* 63 S8) S9))
 (= X9 (- (* 63 S8) S9))
 (= X9 (- S8 (* 63 S9)))
 (= X9 (+ (* 63 S8) (* 63 S9)))
 (= X9 (- (* 63 S8) (* 63 S9)))
 (= X9 (+ (* 63 S8) (* 71 S9)))
 (= X9 (- (* 63 S8) (* 71 S9)))
 (= X9 (- (* 71 S8) (* 63 S9)))
 (= X9 (+ (* 63 S8) (* 55 S9)))
 (= X9 (- (* 63 S8) (* 55 S9)))
 (= X9 (- (* 55 S8) (* 63 S9)))
 (= X9 (+ (* 63 S8) (* X5 S9)))
 (= X9 (- (* 63 S8) (* X5 S9)))
 (= X9 (- (* X5 S8) (* 63 S9)))
 (= X9 (+ (* 63 S8) (* X6 S9)))
 (= X9 (- (* 63 S8) (* X6 S9)))
 (= X9 (- (* X6 S8) (* 63 S9)))
 (= X9 (+ (* 63 S8) (* X7 S9)))
 (= X9 (- (* 63 S8) (* X7 S9)))
 (= X9 (- (* X7 S8) (* 63 S9)))
 (= X9 (+ (* 63 S8) (* X8 S9)))
 (= X9 (- (* 63 S8) (* X8 S9)))
 (= X9 (- (* X8 S8) (* 63 S9)))
 (= X9 (+ (* 71 S8) S9))
 (= X9 (- (* 71 S8) S9))
 (= X9 (- S8 (* 71 S9)))
 (= X9 (+ (* 71 S8) (* 71 S9)))
 (= X9 (- (* 71 S8) (* 71 S9)))
 (= X9 (+ (* 71 S8) (* 55 S9)))
 (= X9 (- (* 71 S8) (* 55 S9)))
 (= X9 (- (* 55 S8) (* 71 S9)))
 (= X9 (+ (* 71 S8) (* X5 S9)))
 (= X9 (- (* 71 S8) (* X5 S9)))
 (= X9 (- (* X5 S8) (* 71 S9)))
 (= X9 (+ (* 71 S8) (* X6 S9)))
 (= X9 (- (* 71 S8) (* X6 S9)))
 (= X9 (- (* X6 S8) (* 71 S9)))
 (= X9 (+ (* 71 S8) (* X7 S9)))
 (= X9 (- (* 71 S8) (* X7 S9)))
 (= X9 (- (* X7 S8) (* 71 S9)))
 (= X9 (+ (* 71 S8) (* X8 S9)))
 (= X9 (- (* 71 S8) (* X8 S9)))
 (= X9 (- (* X8 S8) (* 71 S9)))
 (= X9 (+ (* 55 S8) S9))
 (= X9 (- (* 55 S8) S9))
 (= X9 (- S8 (* 55 S9)))
 (= X9 (+ (* 55 S8) (* 55 S9)))
 (= X9 (- (* 55 S8) (* 55 S9)))
 (= X9 (+ (* 55 S8) (* X5 S9)))
 (= X9 (- (* 55 S8) (* X5 S9)))
 (= X9 (- (* X5 S8) (* 55 S9)))
 (= X9 (+ (* 55 S8) (* X6 S9)))
 (= X9 (- (* 55 S8) (* X6 S9)))
 (= X9 (- (* X6 S8) (* 55 S9)))
 (= X9 (+ (* 55 S8) (* X7 S9)))
 (= X9 (- (* 55 S8) (* X7 S9)))
 (= X9 (- (* X7 S8) (* 55 S9)))
 (= X9 (+ (* 55 S8) (* X8 S9)))
 (= X9 (- (* 55 S8) (* X8 S9)))
 (= X9 (- (* X8 S8) (* 55 S9)))
 (= X9 (+ (* X5 S8) S9))
 (= X9 (- (* X5 S8) S9))
 (= X9 (- S8 (* X5 S9)))
 (= X9 (+ (* X5 S8) (* X5 S9)))
 (= X9 (- (* X5 S8) (* X5 S9)))
 (= X9 (+ (* X5 S8) (* X6 S9)))
 (= X9 (- (* X5 S8) (* X6 S9)))
 (= X9 (- (* X6 S8) (* X5 S9)))
 (= X9 (+ (* X5 S8) (* X7 S9)))
 (= X9 (- (* X5 S8) (* X7 S9)))
 (= X9 (- (* X7 S8) (* X5 S9)))
 (= X9 (+ (* X5 S8) (* X8 S9)))
 (= X9 (- (* X5 S8) (* X8 S9)))
 (= X9 (- (* X8 S8) (* X5 S9)))
 (= X9 (+ (* X6 S8) S9))
 (= X9 (- (* X6 S8) S9))
 (= X9 (- S8 (* X6 S9)))
 (= X9 (+ (* X6 S8) (* X6 S9)))
 (= X9 (- (* X6 S8) (* X6 S9)))
 (= X9 (+ (* X6 S8) (* X7 S9)))
 (= X9 (- (* X6 S8) (* X7 S9)))
 (= X9 (- (* X7 S8) (* X6 S9)))
 (= X9 (+ (* X6 S8) (* X8 S9)))
 (= X9 (- (* X6 S8) (* X8 S9)))
 (= X9 (- (* X8 S8) (* X6 S9)))
 (= X9 (+ (* X7 S8) S9))
 (= X9 (- (* X7 S8) S9))
 (= X9 (- S8 (* X7 S9)))
 (= X9 (+ (* X7 S8) (* X7 S9)))
 (= X9 (- (* X7 S8) (* X7 S9)))
 (= X9 (+ (* X7 S8) (* X8 S9)))
 (= X9 (- (* X7 S8) (* X8 S9)))
 (= X9 (- (* X8 S8) (* X7 S9)))
 (= X9 (+ (* X8 S8) S9))
 (= X9 (- (* X8 S8) S9))
 (= X9 (- S8 (* X8 S9)))
 (= X9 (+ (* X8 S8) (* X8 S9)))
 (= X9 (- (* X8 S8) (* X8 S9)))
))
(assert (and (> X9 0) (< X9 1024) (power2 S8) (power2 S9)))
(assert (or
 (= X10 (+ (* 511 S10) S11))
 (= X10 (- (* 511 S10) S11))
 (= X10 (- S10 (* 511 S11)))
 (= X10 (+ (* 511 S10) (* 511 S11)))
 (= X10 (- (* 511 S10) (* 511 S11)))
 (= X10 (+ (* 511 S10) (* 5 S11)))
 (= X10 (- (* 511 S10) (* 5 S11)))
 (= X10 (- (* 5 S10) (* 511 S11)))
 (= X10 (+ (* 511 S10) (* 63 S11)))
 (= X10 (- (* 511 S10) (* 63 S11)))
 (= X10 (- (* 63 S10) (* 511 S11)))
 (= X10 (+ (* 511 S10) (* 71 S11)))
 (= X10 (- (* 511 S10) (* 71 S11)))
 (= X10 (- (* 71 S10) (* 511 S11)))
 (= X10 (+ (* 511 S10) (* 55 S11)))
 (= X10 (- (* 511 S10) (* 55 S11)))
 (= X10 (- (* 55 S10) (* 511 S11)))
 (= X10 (+ (* 511 S10) (* X5 S11)))
 (= X10 (- (* 511 S10) (* X5 S11)))
 (= X10 (- (* X5 S10) (* 511 S11)))
 (= X10 (+ (* 511 S10) (* X6 S11)))
 (= X10 (- (* 511 S10) (* X6 S11)))
 (= X10 (- (* X6 S10) (* 511 S11)))
 (= X10 (+ (* 511 S10) (* X7 S11)))
 (= X10 (- (* 511 S10) (* X7 S11)))
 (= X10 (- (* X7 S10) (* 511 S11)))
 (= X10 (+ (* 511 S10) (* X8 S11)))
 (= X10 (- (* 511 S10) (* X8 S11)))
 (= X10 (- (* X8 S10) (* 511 S11)))
 (= X10 (+ (* 511 S10) (* X9 S11)))
 (= X10 (- (* 511 S10) (* X9 S11)))
 (= X10 (- (* X9 S10) (* 511 S11)))
 (= X10 (+ (* 5 S10) S11))
 (= X10 (- (* 5 S10) S11))
 (= X10 (- S10 (* 5 S11)))
 (= X10 (+ (* 5 S10) (* 5 S11)))
 (= X10 (- (* 5 S10) (* 5 S11)))
 (= X10 (+ (* 5 S10) (* 63 S11)))
 (= X10 (- (* 5 S10) (* 63 S11)))
 (= X10 (- (* 63 S10) (* 5 S11)))
 (= X10 (+ (* 5 S10) (* 71 S11)))
 (= X10 (- (* 5 S10) (* 71 S11)))
 (= X10 (- (* 71 S10) (* 5 S11)))
 (= X10 (+ (* 5 S10) (* 55 S11)))
 (= X10 (- (* 5 S10) (* 55 S11)))
 (= X10 (- (* 55 S10) (* 5 S11)))
 (= X10 (+ (* 5 S10) (* X5 S11)))
 (= X10 (- (* 5 S10) (* X5 S11)))
 (= X10 (- (* X5 S10) (* 5 S11)))
 (= X10 (+ (* 5 S10) (* X6 S11)))
 (= X10 (- (* 5 S10) (* X6 S11)))
 (= X10 (- (* X6 S10) (* 5 S11)))
 (= X10 (+ (* 5 S10) (* X7 S11)))
 (= X10 (- (* 5 S10) (* X7 S11)))
 (= X10 (- (* X7 S10) (* 5 S11)))
 (= X10 (+ (* 5 S10) (* X8 S11)))
 (= X10 (- (* 5 S10) (* X8 S11)))
 (= X10 (- (* X8 S10) (* 5 S11)))
 (= X10 (+ (* 5 S10) (* X9 S11)))
 (= X10 (- (* 5 S10) (* X9 S11)))
 (= X10 (- (* X9 S10) (* 5 S11)))
 (= X10 (+ (* 63 S10) S11))
 (= X10 (- (* 63 S10) S11))
 (= X10 (- S10 (* 63 S11)))
 (= X10 (+ (* 63 S10) (* 63 S11)))
 (= X10 (- (* 63 S10) (* 63 S11)))
 (= X10 (+ (* 63 S10) (* 71 S11)))
 (= X10 (- (* 63 S10) (* 71 S11)))
 (= X10 (- (* 71 S10) (* 63 S11)))
 (= X10 (+ (* 63 S10) (* 55 S11)))
 (= X10 (- (* 63 S10) (* 55 S11)))
 (= X10 (- (* 55 S10) (* 63 S11)))
 (= X10 (+ (* 63 S10) (* X5 S11)))
 (= X10 (- (* 63 S10) (* X5 S11)))
 (= X10 (- (* X5 S10) (* 63 S11)))
 (= X10 (+ (* 63 S10) (* X6 S11)))
 (= X10 (- (* 63 S10) (* X6 S11)))
 (= X10 (- (* X6 S10) (* 63 S11)))
 (= X10 (+ (* 63 S10) (* X7 S11)))
 (= X10 (- (* 63 S10) (* X7 S11)))
 (= X10 (- (* X7 S10) (* 63 S11)))
 (= X10 (+ (* 63 S10) (* X8 S11)))
 (= X10 (- (* 63 S10) (* X8 S11)))
 (= X10 (- (* X8 S10) (* 63 S11)))
 (= X10 (+ (* 63 S10) (* X9 S11)))
 (= X10 (- (* 63 S10) (* X9 S11)))
 (= X10 (- (* X9 S10) (* 63 S11)))
 (= X10 (+ (* 71 S10) S11))
 (= X10 (- (* 71 S10) S11))
 (= X10 (- S10 (* 71 S11)))
 (= X10 (+ (* 71 S10) (* 71 S11)))
 (= X10 (- (* 71 S10) (* 71 S11)))
 (= X10 (+ (* 71 S10) (* 55 S11)))
 (= X10 (- (* 71 S10) (* 55 S11)))
 (= X10 (- (* 55 S10) (* 71 S11)))
 (= X10 (+ (* 71 S10) (* X5 S11)))
 (= X10 (- (* 71 S10) (* X5 S11)))
 (= X10 (- (* X5 S10) (* 71 S11)))
 (= X10 (+ (* 71 S10) (* X6 S11)))
 (= X10 (- (* 71 S10) (* X6 S11)))
 (= X10 (- (* X6 S10) (* 71 S11)))
 (= X10 (+ (* 71 S10) (* X7 S11)))
 (= X10 (- (* 71 S10) (* X7 S11)))
 (= X10 (- (* X7 S10) (* 71 S11)))
 (= X10 (+ (* 71 S10) (* X8 S11)))
 (= X10 (- (* 71 S10) (* X8 S11)))
 (= X10 (- (* X8 S10) (* 71 S11)))
 (= X10 (+ (* 71 S10) (* X9 S11)))
 (= X10 (- (* 71 S10) (* X9 S11)))
 (= X10 (- (* X9 S10) (* 71 S11)))
 (= X10 (+ (* 55 S10) S11))
 (= X10 (- (* 55 S10) S11))
 (= X10 (- S10 (* 55 S11)))
 (= X10 (+ (* 55 S10) (* 55 S11)))
 (= X10 (- (* 55 S10) (* 55 S11)))
 (= X10 (+ (* 55 S10) (* X5 S11)))
 (= X10 (- (* 55 S10) (* X5 S11)))
 (= X10 (- (* X5 S10) (* 55 S11)))
 (= X10 (+ (* 55 S10) (* X6 S11)))
 (= X10 (- (* 55 S10) (* X6 S11)))
 (= X10 (- (* X6 S10) (* 55 S11)))
 (= X10 (+ (* 55 S10) (* X7 S11)))
 (= X10 (- (* 55 S10) (* X7 S11)))
 (= X10 (- (* X7 S10) (* 55 S11)))
 (= X10 (+ (* 55 S10) (* X8 S11)))
 (= X10 (- (* 55 S10) (* X8 S11)))
 (= X10 (- (* X8 S10) (* 55 S11)))
 (= X10 (+ (* 55 S10) (* X9 S11)))
 (= X10 (- (* 55 S10) (* X9 S11)))
 (= X10 (- (* X9 S10) (* 55 S11)))
 (= X10 (+ (* X5 S10) S11))
 (= X10 (- (* X5 S10) S11))
 (= X10 (- S10 (* X5 S11)))
 (= X10 (+ (* X5 S10) (* X5 S11)))
 (= X10 (- (* X5 S10) (* X5 S11)))
 (= X10 (+ (* X5 S10) (* X6 S11)))
 (= X10 (- (* X5 S10) (* X6 S11)))
 (= X10 (- (* X6 S10) (* X5 S11)))
 (= X10 (+ (* X5 S10) (* X7 S11)))
 (= X10 (- (* X5 S10) (* X7 S11)))
 (= X10 (- (* X7 S10) (* X5 S11)))
 (= X10 (+ (* X5 S10) (* X8 S11)))
 (= X10 (- (* X5 S10) (* X8 S11)))
 (= X10 (- (* X8 S10) (* X5 S11)))
 (= X10 (+ (* X5 S10) (* X9 S11)))
 (= X10 (- (* X5 S10) (* X9 S11)))
 (= X10 (- (* X9 S10) (* X5 S11)))
 (= X10 (+ (* X6 S10) S11))
 (= X10 (- (* X6 S10) S11))
 (= X10 (- S10 (* X6 S11)))
 (= X10 (+ (* X6 S10) (* X6 S11)))
 (= X10 (- (* X6 S10) (* X6 S11)))
 (= X10 (+ (* X6 S10) (* X7 S11)))
 (= X10 (- (* X6 S10) (* X7 S11)))
 (= X10 (- (* X7 S10) (* X6 S11)))
 (= X10 (+ (* X6 S10) (* X8 S11)))
 (= X10 (- (* X6 S10) (* X8 S11)))
 (= X10 (- (* X8 S10) (* X6 S11)))
 (= X10 (+ (* X6 S10) (* X9 S11)))
 (= X10 (- (* X6 S10) (* X9 S11)))
 (= X10 (- (* X9 S10) (* X6 S11)))
 (= X10 (+ (* X7 S10) S11))
 (= X10 (- (* X7 S10) S11))
 (= X10 (- S10 (* X7 S11)))
 (= X10 (+ (* X7 S10) (* X7 S11)))
 (= X10 (- (* X7 S10) (* X7 S11)))
 (= X10 (+ (* X7 S10) (* X8 S11)))
 (= X10 (- (* X7 S10) (* X8 S11)))
 (= X10 (- (* X8 S10) (* X7 S11)))
 (= X10 (+ (* X7 S10) (* X9 S11)))
 (= X10 (- (* X7 S10) (* X9 S11)))
 (= X10 (- (* X9 S10) (* X7 S11)))
 (= X10 (+ (* X8 S10) S11))
 (= X10 (- (* X8 S10) S11))
 (= X10 (- S10 (* X8 S11)))
 (= X10 (+ (* X8 S10) (* X8 S11)))
 (= X10 (- (* X8 S10) (* X8 S11)))
 (= X10 (+ (* X8 S10) (* X9 S11)))
 (= X10 (- (* X8 S10) (* X9 S11)))
 (= X10 (- (* X9 S10) (* X8 S11)))
 (= X10 (+ (* X9 S10) S11))
 (= X10 (- (* X9 S10) S11))
 (= X10 (- S10 (* X9 S11)))
 (= X10 (+ (* X9 S10) (* X9 S11)))
 (= X10 (- (* X9 S10) (* X9 S11)))
))
(assert (and (> X10 0) (< X10 1024) (power2 S10) (power2 S11)))
(assert (or
 (= X6 171)
 (= X7 171)
 (= X8 171)
 (= X9 171)
 (= X10 171)
))
(assert (or
 (= X6 455)
 (= X7 455)
 (= X8 455)
 (= X9 455)
 (= X10 455)
))
(assert (or
 (= X6 335)
 (= X7 335)
 (= X8 335)
 (= X9 335)
 (= X10 335)
))
(assert (or
 (= X6 107)
 (= X7 107)
 (= X8 107)
 (= X9 107)
 (= X10 107)
))
(assert (or
 (= X6 485)
 (= X7 485)
 (= X8 485)
 (= X9 485)
 (= X10 485)
))
(check-sat)
(exit)
