(set-logic QF_NIA)
(set-info :source |
 more info in 'N. P. Lopes, L. Aksoy, V. Manquinho, J. Monteiro.
 Optimally Solving the MCM Problem Using Pseudo-Boolean Satisfiability.
 Technical Report RT/43/2010, INESC-ID, Nov. 2010'. |)
(set-info :smt-lib-version 2.0)
(set-info :category "industrial")
(set-info :status unknown)
(declare-fun X3 () Int)
(declare-fun X4 () Int)
(declare-fun X5 () Int)
(declare-fun X6 () Int)
(declare-fun X7 () Int)
(declare-fun X8 () Int)
(declare-fun X9 () Int)
(declare-fun S0 () Int)
(declare-fun S1 () Int)
(declare-fun S2 () Int)
(declare-fun S3 () Int)
(declare-fun S4 () Int)
(declare-fun S5 () Int)
(declare-fun S6 () Int)
(declare-fun S7 () Int)
(declare-fun S8 () Int)
(declare-fun S9 () Int)
(declare-fun S10 () Int)
(declare-fun S11 () Int)
(declare-fun S12 () Int)
(declare-fun S13 () Int)
(define-fun power2 ((x Int)) Bool
  (or (= x 1024) (= x 512) (= x 256) (= x 128) (= x 64) (= x 32) (= x 16) (= x 8) (= x 4) (= x 2) (= x 1)))
(assert (or
 (= X3 (+ S0 S1))
 (= X3 (- S0 S1))
 (= X3 (+ (* 9 S0) S1))
 (= X3 (- (* 9 S0) S1))
 (= X3 (- S0 (* 9 S1)))
 (= X3 (+ (* 9 S0) (* 9 S1)))
 (= X3 (- (* 9 S0) (* 9 S1)))
 (= X3 (+ (* 9 S0) (* 55 S1)))
 (= X3 (- (* 9 S0) (* 55 S1)))
 (= X3 (- (* 55 S0) (* 9 S1)))
 (= X3 (+ (* 9 S0) (* 201 S1)))
 (= X3 (- (* 9 S0) (* 201 S1)))
 (= X3 (- (* 201 S0) (* 9 S1)))
 (= X3 (+ (* 55 S0) S1))
 (= X3 (- (* 55 S0) S1))
 (= X3 (- S0 (* 55 S1)))
 (= X3 (+ (* 55 S0) (* 55 S1)))
 (= X3 (- (* 55 S0) (* 55 S1)))
 (= X3 (+ (* 55 S0) (* 201 S1)))
 (= X3 (- (* 55 S0) (* 201 S1)))
 (= X3 (- (* 201 S0) (* 55 S1)))
 (= X3 (+ (* 201 S0) S1))
 (= X3 (- (* 201 S0) S1))
 (= X3 (- S0 (* 201 S1)))
 (= X3 (+ (* 201 S0) (* 201 S1)))
 (= X3 (- (* 201 S0) (* 201 S1)))
))
(assert (and (> X3 0) (< X3 2048) (power2 S0) (power2 S1)))
(assert (or
 (= X4 (+ (* 9 S2) S3))
 (= X4 (- (* 9 S2) S3))
 (= X4 (- S2 (* 9 S3)))
 (= X4 (+ (* 9 S2) (* 9 S3)))
 (= X4 (- (* 9 S2) (* 9 S3)))
 (= X4 (+ (* 9 S2) (* 55 S3)))
 (= X4 (- (* 9 S2) (* 55 S3)))
 (= X4 (- (* 55 S2) (* 9 S3)))
 (= X4 (+ (* 9 S2) (* 201 S3)))
 (= X4 (- (* 9 S2) (* 201 S3)))
 (= X4 (- (* 201 S2) (* 9 S3)))
 (= X4 (+ (* 9 S2) (* X3 S3)))
 (= X4 (- (* 9 S2) (* X3 S3)))
 (= X4 (- (* X3 S2) (* 9 S3)))
 (= X4 (+ (* 55 S2) S3))
 (= X4 (- (* 55 S2) S3))
 (= X4 (- S2 (* 55 S3)))
 (= X4 (+ (* 55 S2) (* 55 S3)))
 (= X4 (- (* 55 S2) (* 55 S3)))
 (= X4 (+ (* 55 S2) (* 201 S3)))
 (= X4 (- (* 55 S2) (* 201 S3)))
 (= X4 (- (* 201 S2) (* 55 S3)))
 (= X4 (+ (* 55 S2) (* X3 S3)))
 (= X4 (- (* 55 S2) (* X3 S3)))
 (= X4 (- (* X3 S2) (* 55 S3)))
 (= X4 (+ (* 201 S2) S3))
 (= X4 (- (* 201 S2) S3))
 (= X4 (- S2 (* 201 S3)))
 (= X4 (+ (* 201 S2) (* 201 S3)))
 (= X4 (- (* 201 S2) (* 201 S3)))
 (= X4 (+ (* 201 S2) (* X3 S3)))
 (= X4 (- (* 201 S2) (* X3 S3)))
 (= X4 (- (* X3 S2) (* 201 S3)))
 (= X4 (+ (* X3 S2) S3))
 (= X4 (- (* X3 S2) S3))
 (= X4 (- S2 (* X3 S3)))
 (= X4 (+ (* X3 S2) (* X3 S3)))
 (= X4 (- (* X3 S2) (* X3 S3)))
))
(assert (and (> X4 0) (< X4 2048) (power2 S2) (power2 S3)))
(assert (or
 (= X5 (+ (* 9 S4) S5))
 (= X5 (- (* 9 S4) S5))
 (= X5 (- S4 (* 9 S5)))
 (= X5 (+ (* 9 S4) (* 9 S5)))
 (= X5 (- (* 9 S4) (* 9 S5)))
 (= X5 (+ (* 9 S4) (* 55 S5)))
 (= X5 (- (* 9 S4) (* 55 S5)))
 (= X5 (- (* 55 S4) (* 9 S5)))
 (= X5 (+ (* 9 S4) (* 201 S5)))
 (= X5 (- (* 9 S4) (* 201 S5)))
 (= X5 (- (* 201 S4) (* 9 S5)))
 (= X5 (+ (* 9 S4) (* X3 S5)))
 (= X5 (- (* 9 S4) (* X3 S5)))
 (= X5 (- (* X3 S4) (* 9 S5)))
 (= X5 (+ (* 9 S4) (* X4 S5)))
 (= X5 (- (* 9 S4) (* X4 S5)))
 (= X5 (- (* X4 S4) (* 9 S5)))
 (= X5 (+ (* 55 S4) S5))
 (= X5 (- (* 55 S4) S5))
 (= X5 (- S4 (* 55 S5)))
 (= X5 (+ (* 55 S4) (* 55 S5)))
 (= X5 (- (* 55 S4) (* 55 S5)))
 (= X5 (+ (* 55 S4) (* 201 S5)))
 (= X5 (- (* 55 S4) (* 201 S5)))
 (= X5 (- (* 201 S4) (* 55 S5)))
 (= X5 (+ (* 55 S4) (* X3 S5)))
 (= X5 (- (* 55 S4) (* X3 S5)))
 (= X5 (- (* X3 S4) (* 55 S5)))
 (= X5 (+ (* 55 S4) (* X4 S5)))
 (= X5 (- (* 55 S4) (* X4 S5)))
 (= X5 (- (* X4 S4) (* 55 S5)))
 (= X5 (+ (* 201 S4) S5))
 (= X5 (- (* 201 S4) S5))
 (= X5 (- S4 (* 201 S5)))
 (= X5 (+ (* 201 S4) (* 201 S5)))
 (= X5 (- (* 201 S4) (* 201 S5)))
 (= X5 (+ (* 201 S4) (* X3 S5)))
 (= X5 (- (* 201 S4) (* X3 S5)))
 (= X5 (- (* X3 S4) (* 201 S5)))
 (= X5 (+ (* 201 S4) (* X4 S5)))
 (= X5 (- (* 201 S4) (* X4 S5)))
 (= X5 (- (* X4 S4) (* 201 S5)))
 (= X5 (+ (* X3 S4) S5))
 (= X5 (- (* X3 S4) S5))
 (= X5 (- S4 (* X3 S5)))
 (= X5 (+ (* X3 S4) (* X3 S5)))
 (= X5 (- (* X3 S4) (* X3 S5)))
 (= X5 (+ (* X3 S4) (* X4 S5)))
 (= X5 (- (* X3 S4) (* X4 S5)))
 (= X5 (- (* X4 S4) (* X3 S5)))
 (= X5 (+ (* X4 S4) S5))
 (= X5 (- (* X4 S4) S5))
 (= X5 (- S4 (* X4 S5)))
 (= X5 (+ (* X4 S4) (* X4 S5)))
 (= X5 (- (* X4 S4) (* X4 S5)))
))
(assert (and (> X5 0) (< X5 2048) (power2 S4) (power2 S5)))
(assert (or
 (= X6 (+ (* 9 S6) S7))
 (= X6 (- (* 9 S6) S7))
 (= X6 (- S6 (* 9 S7)))
 (= X6 (+ (* 9 S6) (* 9 S7)))
 (= X6 (- (* 9 S6) (* 9 S7)))
 (= X6 (+ (* 9 S6) (* 55 S7)))
 (= X6 (- (* 9 S6) (* 55 S7)))
 (= X6 (- (* 55 S6) (* 9 S7)))
 (= X6 (+ (* 9 S6) (* 201 S7)))
 (= X6 (- (* 9 S6) (* 201 S7)))
 (= X6 (- (* 201 S6) (* 9 S7)))
 (= X6 (+ (* 9 S6) (* X3 S7)))
 (= X6 (- (* 9 S6) (* X3 S7)))
 (= X6 (- (* X3 S6) (* 9 S7)))
 (= X6 (+ (* 9 S6) (* X4 S7)))
 (= X6 (- (* 9 S6) (* X4 S7)))
 (= X6 (- (* X4 S6) (* 9 S7)))
 (= X6 (+ (* 9 S6) (* X5 S7)))
 (= X6 (- (* 9 S6) (* X5 S7)))
 (= X6 (- (* X5 S6) (* 9 S7)))
 (= X6 (+ (* 55 S6) S7))
 (= X6 (- (* 55 S6) S7))
 (= X6 (- S6 (* 55 S7)))
 (= X6 (+ (* 55 S6) (* 55 S7)))
 (= X6 (- (* 55 S6) (* 55 S7)))
 (= X6 (+ (* 55 S6) (* 201 S7)))
 (= X6 (- (* 55 S6) (* 201 S7)))
 (= X6 (- (* 201 S6) (* 55 S7)))
 (= X6 (+ (* 55 S6) (* X3 S7)))
 (= X6 (- (* 55 S6) (* X3 S7)))
 (= X6 (- (* X3 S6) (* 55 S7)))
 (= X6 (+ (* 55 S6) (* X4 S7)))
 (= X6 (- (* 55 S6) (* X4 S7)))
 (= X6 (- (* X4 S6) (* 55 S7)))
 (= X6 (+ (* 55 S6) (* X5 S7)))
 (= X6 (- (* 55 S6) (* X5 S7)))
 (= X6 (- (* X5 S6) (* 55 S7)))
 (= X6 (+ (* 201 S6) S7))
 (= X6 (- (* 201 S6) S7))
 (= X6 (- S6 (* 201 S7)))
 (= X6 (+ (* 201 S6) (* 201 S7)))
 (= X6 (- (* 201 S6) (* 201 S7)))
 (= X6 (+ (* 201 S6) (* X3 S7)))
 (= X6 (- (* 201 S6) (* X3 S7)))
 (= X6 (- (* X3 S6) (* 201 S7)))
 (= X6 (+ (* 201 S6) (* X4 S7)))
 (= X6 (- (* 201 S6) (* X4 S7)))
 (= X6 (- (* X4 S6) (* 201 S7)))
 (= X6 (+ (* 201 S6) (* X5 S7)))
 (= X6 (- (* 201 S6) (* X5 S7)))
 (= X6 (- (* X5 S6) (* 201 S7)))
 (= X6 (+ (* X3 S6) S7))
 (= X6 (- (* X3 S6) S7))
 (= X6 (- S6 (* X3 S7)))
 (= X6 (+ (* X3 S6) (* X3 S7)))
 (= X6 (- (* X3 S6) (* X3 S7)))
 (= X6 (+ (* X3 S6) (* X4 S7)))
 (= X6 (- (* X3 S6) (* X4 S7)))
 (= X6 (- (* X4 S6) (* X3 S7)))
 (= X6 (+ (* X3 S6) (* X5 S7)))
 (= X6 (- (* X3 S6) (* X5 S7)))
 (= X6 (- (* X5 S6) (* X3 S7)))
 (= X6 (+ (* X4 S6) S7))
 (= X6 (- (* X4 S6) S7))
 (= X6 (- S6 (* X4 S7)))
 (= X6 (+ (* X4 S6) (* X4 S7)))
 (= X6 (- (* X4 S6) (* X4 S7)))
 (= X6 (+ (* X4 S6) (* X5 S7)))
 (= X6 (- (* X4 S6) (* X5 S7)))
 (= X6 (- (* X5 S6) (* X4 S7)))
 (= X6 (+ (* X5 S6) S7))
 (= X6 (- (* X5 S6) S7))
 (= X6 (- S6 (* X5 S7)))
 (= X6 (+ (* X5 S6) (* X5 S7)))
 (= X6 (- (* X5 S6) (* X5 S7)))
))
(assert (and (> X6 0) (< X6 2048) (power2 S6) (power2 S7)))
(assert (or
 (= X7 (+ (* 9 S8) S9))
 (= X7 (- (* 9 S8) S9))
 (= X7 (- S8 (* 9 S9)))
 (= X7 (+ (* 9 S8) (* 9 S9)))
 (= X7 (- (* 9 S8) (* 9 S9)))
 (= X7 (+ (* 9 S8) (* 55 S9)))
 (= X7 (- (* 9 S8) (* 55 S9)))
 (= X7 (- (* 55 S8) (* 9 S9)))
 (= X7 (+ (* 9 S8) (* 201 S9)))
 (= X7 (- (* 9 S8) (* 201 S9)))
 (= X7 (- (* 201 S8) (* 9 S9)))
 (= X7 (+ (* 9 S8) (* X3 S9)))
 (= X7 (- (* 9 S8) (* X3 S9)))
 (= X7 (- (* X3 S8) (* 9 S9)))
 (= X7 (+ (* 9 S8) (* X4 S9)))
 (= X7 (- (* 9 S8) (* X4 S9)))
 (= X7 (- (* X4 S8) (* 9 S9)))
 (= X7 (+ (* 9 S8) (* X5 S9)))
 (= X7 (- (* 9 S8) (* X5 S9)))
 (= X7 (- (* X5 S8) (* 9 S9)))
 (= X7 (+ (* 9 S8) (* X6 S9)))
 (= X7 (- (* 9 S8) (* X6 S9)))
 (= X7 (- (* X6 S8) (* 9 S9)))
 (= X7 (+ (* 55 S8) S9))
 (= X7 (- (* 55 S8) S9))
 (= X7 (- S8 (* 55 S9)))
 (= X7 (+ (* 55 S8) (* 55 S9)))
 (= X7 (- (* 55 S8) (* 55 S9)))
 (= X7 (+ (* 55 S8) (* 201 S9)))
 (= X7 (- (* 55 S8) (* 201 S9)))
 (= X7 (- (* 201 S8) (* 55 S9)))
 (= X7 (+ (* 55 S8) (* X3 S9)))
 (= X7 (- (* 55 S8) (* X3 S9)))
 (= X7 (- (* X3 S8) (* 55 S9)))
 (= X7 (+ (* 55 S8) (* X4 S9)))
 (= X7 (- (* 55 S8) (* X4 S9)))
 (= X7 (- (* X4 S8) (* 55 S9)))
 (= X7 (+ (* 55 S8) (* X5 S9)))
 (= X7 (- (* 55 S8) (* X5 S9)))
 (= X7 (- (* X5 S8) (* 55 S9)))
 (= X7 (+ (* 55 S8) (* X6 S9)))
 (= X7 (- (* 55 S8) (* X6 S9)))
 (= X7 (- (* X6 S8) (* 55 S9)))
 (= X7 (+ (* 201 S8) S9))
 (= X7 (- (* 201 S8) S9))
 (= X7 (- S8 (* 201 S9)))
 (= X7 (+ (* 201 S8) (* 201 S9)))
 (= X7 (- (* 201 S8) (* 201 S9)))
 (= X7 (+ (* 201 S8) (* X3 S9)))
 (= X7 (- (* 201 S8) (* X3 S9)))
 (= X7 (- (* X3 S8) (* 201 S9)))
 (= X7 (+ (* 201 S8) (* X4 S9)))
 (= X7 (- (* 201 S8) (* X4 S9)))
 (= X7 (- (* X4 S8) (* 201 S9)))
 (= X7 (+ (* 201 S8) (* X5 S9)))
 (= X7 (- (* 201 S8) (* X5 S9)))
 (= X7 (- (* X5 S8) (* 201 S9)))
 (= X7 (+ (* 201 S8) (* X6 S9)))
 (= X7 (- (* 201 S8) (* X6 S9)))
 (= X7 (- (* X6 S8) (* 201 S9)))
 (= X7 (+ (* X3 S8) S9))
 (= X7 (- (* X3 S8) S9))
 (= X7 (- S8 (* X3 S9)))
 (= X7 (+ (* X3 S8) (* X3 S9)))
 (= X7 (- (* X3 S8) (* X3 S9)))
 (= X7 (+ (* X3 S8) (* X4 S9)))
 (= X7 (- (* X3 S8) (* X4 S9)))
 (= X7 (- (* X4 S8) (* X3 S9)))
 (= X7 (+ (* X3 S8) (* X5 S9)))
 (= X7 (- (* X3 S8) (* X5 S9)))
 (= X7 (- (* X5 S8) (* X3 S9)))
 (= X7 (+ (* X3 S8) (* X6 S9)))
 (= X7 (- (* X3 S8) (* X6 S9)))
 (= X7 (- (* X6 S8) (* X3 S9)))
 (= X7 (+ (* X4 S8) S9))
 (= X7 (- (* X4 S8) S9))
 (= X7 (- S8 (* X4 S9)))
 (= X7 (+ (* X4 S8) (* X4 S9)))
 (= X7 (- (* X4 S8) (* X4 S9)))
 (= X7 (+ (* X4 S8) (* X5 S9)))
 (= X7 (- (* X4 S8) (* X5 S9)))
 (= X7 (- (* X5 S8) (* X4 S9)))
 (= X7 (+ (* X4 S8) (* X6 S9)))
 (= X7 (- (* X4 S8) (* X6 S9)))
 (= X7 (- (* X6 S8) (* X4 S9)))
 (= X7 (+ (* X5 S8) S9))
 (= X7 (- (* X5 S8) S9))
 (= X7 (- S8 (* X5 S9)))
 (= X7 (+ (* X5 S8) (* X5 S9)))
 (= X7 (- (* X5 S8) (* X5 S9)))
 (= X7 (+ (* X5 S8) (* X6 S9)))
 (= X7 (- (* X5 S8) (* X6 S9)))
 (= X7 (- (* X6 S8) (* X5 S9)))
 (= X7 (+ (* X6 S8) S9))
 (= X7 (- (* X6 S8) S9))
 (= X7 (- S8 (* X6 S9)))
 (= X7 (+ (* X6 S8) (* X6 S9)))
 (= X7 (- (* X6 S8) (* X6 S9)))
))
(assert (and (> X7 0) (< X7 2048) (power2 S8) (power2 S9)))
(assert (or
 (= X8 (+ (* 9 S10) S11))
 (= X8 (- (* 9 S10) S11))
 (= X8 (- S10 (* 9 S11)))
 (= X8 (+ (* 9 S10) (* 9 S11)))
 (= X8 (- (* 9 S10) (* 9 S11)))
 (= X8 (+ (* 9 S10) (* 55 S11)))
 (= X8 (- (* 9 S10) (* 55 S11)))
 (= X8 (- (* 55 S10) (* 9 S11)))
 (= X8 (+ (* 9 S10) (* 201 S11)))
 (= X8 (- (* 9 S10) (* 201 S11)))
 (= X8 (- (* 201 S10) (* 9 S11)))
 (= X8 (+ (* 9 S10) (* X3 S11)))
 (= X8 (- (* 9 S10) (* X3 S11)))
 (= X8 (- (* X3 S10) (* 9 S11)))
 (= X8 (+ (* 9 S10) (* X4 S11)))
 (= X8 (- (* 9 S10) (* X4 S11)))
 (= X8 (- (* X4 S10) (* 9 S11)))
 (= X8 (+ (* 9 S10) (* X5 S11)))
 (= X8 (- (* 9 S10) (* X5 S11)))
 (= X8 (- (* X5 S10) (* 9 S11)))
 (= X8 (+ (* 9 S10) (* X6 S11)))
 (= X8 (- (* 9 S10) (* X6 S11)))
 (= X8 (- (* X6 S10) (* 9 S11)))
 (= X8 (+ (* 9 S10) (* X7 S11)))
 (= X8 (- (* 9 S10) (* X7 S11)))
 (= X8 (- (* X7 S10) (* 9 S11)))
 (= X8 (+ (* 55 S10) S11))
 (= X8 (- (* 55 S10) S11))
 (= X8 (- S10 (* 55 S11)))
 (= X8 (+ (* 55 S10) (* 55 S11)))
 (= X8 (- (* 55 S10) (* 55 S11)))
 (= X8 (+ (* 55 S10) (* 201 S11)))
 (= X8 (- (* 55 S10) (* 201 S11)))
 (= X8 (- (* 201 S10) (* 55 S11)))
 (= X8 (+ (* 55 S10) (* X3 S11)))
 (= X8 (- (* 55 S10) (* X3 S11)))
 (= X8 (- (* X3 S10) (* 55 S11)))
 (= X8 (+ (* 55 S10) (* X4 S11)))
 (= X8 (- (* 55 S10) (* X4 S11)))
 (= X8 (- (* X4 S10) (* 55 S11)))
 (= X8 (+ (* 55 S10) (* X5 S11)))
 (= X8 (- (* 55 S10) (* X5 S11)))
 (= X8 (- (* X5 S10) (* 55 S11)))
 (= X8 (+ (* 55 S10) (* X6 S11)))
 (= X8 (- (* 55 S10) (* X6 S11)))
 (= X8 (- (* X6 S10) (* 55 S11)))
 (= X8 (+ (* 55 S10) (* X7 S11)))
 (= X8 (- (* 55 S10) (* X7 S11)))
 (= X8 (- (* X7 S10) (* 55 S11)))
 (= X8 (+ (* 201 S10) S11))
 (= X8 (- (* 201 S10) S11))
 (= X8 (- S10 (* 201 S11)))
 (= X8 (+ (* 201 S10) (* 201 S11)))
 (= X8 (- (* 201 S10) (* 201 S11)))
 (= X8 (+ (* 201 S10) (* X3 S11)))
 (= X8 (- (* 201 S10) (* X3 S11)))
 (= X8 (- (* X3 S10) (* 201 S11)))
 (= X8 (+ (* 201 S10) (* X4 S11)))
 (= X8 (- (* 201 S10) (* X4 S11)))
 (= X8 (- (* X4 S10) (* 201 S11)))
 (= X8 (+ (* 201 S10) (* X5 S11)))
 (= X8 (- (* 201 S10) (* X5 S11)))
 (= X8 (- (* X5 S10) (* 201 S11)))
 (= X8 (+ (* 201 S10) (* X6 S11)))
 (= X8 (- (* 201 S10) (* X6 S11)))
 (= X8 (- (* X6 S10) (* 201 S11)))
 (= X8 (+ (* 201 S10) (* X7 S11)))
 (= X8 (- (* 201 S10) (* X7 S11)))
 (= X8 (- (* X7 S10) (* 201 S11)))
 (= X8 (+ (* X3 S10) S11))
 (= X8 (- (* X3 S10) S11))
 (= X8 (- S10 (* X3 S11)))
 (= X8 (+ (* X3 S10) (* X3 S11)))
 (= X8 (- (* X3 S10) (* X3 S11)))
 (= X8 (+ (* X3 S10) (* X4 S11)))
 (= X8 (- (* X3 S10) (* X4 S11)))
 (= X8 (- (* X4 S10) (* X3 S11)))
 (= X8 (+ (* X3 S10) (* X5 S11)))
 (= X8 (- (* X3 S10) (* X5 S11)))
 (= X8 (- (* X5 S10) (* X3 S11)))
 (= X8 (+ (* X3 S10) (* X6 S11)))
 (= X8 (- (* X3 S10) (* X6 S11)))
 (= X8 (- (* X6 S10) (* X3 S11)))
 (= X8 (+ (* X3 S10) (* X7 S11)))
 (= X8 (- (* X3 S10) (* X7 S11)))
 (= X8 (- (* X7 S10) (* X3 S11)))
 (= X8 (+ (* X4 S10) S11))
 (= X8 (- (* X4 S10) S11))
 (= X8 (- S10 (* X4 S11)))
 (= X8 (+ (* X4 S10) (* X4 S11)))
 (= X8 (- (* X4 S10) (* X4 S11)))
 (= X8 (+ (* X4 S10) (* X5 S11)))
 (= X8 (- (* X4 S10) (* X5 S11)))
 (= X8 (- (* X5 S10) (* X4 S11)))
 (= X8 (+ (* X4 S10) (* X6 S11)))
 (= X8 (- (* X4 S10) (* X6 S11)))
 (= X8 (- (* X6 S10) (* X4 S11)))
 (= X8 (+ (* X4 S10) (* X7 S11)))
 (= X8 (- (* X4 S10) (* X7 S11)))
 (= X8 (- (* X7 S10) (* X4 S11)))
 (= X8 (+ (* X5 S10) S11))
 (= X8 (- (* X5 S10) S11))
 (= X8 (- S10 (* X5 S11)))
 (= X8 (+ (* X5 S10) (* X5 S11)))
 (= X8 (- (* X5 S10) (* X5 S11)))
 (= X8 (+ (* X5 S10) (* X6 S11)))
 (= X8 (- (* X5 S10) (* X6 S11)))
 (= X8 (- (* X6 S10) (* X5 S11)))
 (= X8 (+ (* X5 S10) (* X7 S11)))
 (= X8 (- (* X5 S10) (* X7 S11)))
 (= X8 (- (* X7 S10) (* X5 S11)))
 (= X8 (+ (* X6 S10) S11))
 (= X8 (- (* X6 S10) S11))
 (= X8 (- S10 (* X6 S11)))
 (= X8 (+ (* X6 S10) (* X6 S11)))
 (= X8 (- (* X6 S10) (* X6 S11)))
 (= X8 (+ (* X6 S10) (* X7 S11)))
 (= X8 (- (* X6 S10) (* X7 S11)))
 (= X8 (- (* X7 S10) (* X6 S11)))
 (= X8 (+ (* X7 S10) S11))
 (= X8 (- (* X7 S10) S11))
 (= X8 (- S10 (* X7 S11)))
 (= X8 (+ (* X7 S10) (* X7 S11)))
 (= X8 (- (* X7 S10) (* X7 S11)))
))
(assert (and (> X8 0) (< X8 2048) (power2 S10) (power2 S11)))
(assert (or
 (= X9 (+ (* 9 S12) S13))
 (= X9 (- (* 9 S12) S13))
 (= X9 (- S12 (* 9 S13)))
 (= X9 (+ (* 9 S12) (* 9 S13)))
 (= X9 (- (* 9 S12) (* 9 S13)))
 (= X9 (+ (* 9 S12) (* 55 S13)))
 (= X9 (- (* 9 S12) (* 55 S13)))
 (= X9 (- (* 55 S12) (* 9 S13)))
 (= X9 (+ (* 9 S12) (* 201 S13)))
 (= X9 (- (* 9 S12) (* 201 S13)))
 (= X9 (- (* 201 S12) (* 9 S13)))
 (= X9 (+ (* 9 S12) (* X3 S13)))
 (= X9 (- (* 9 S12) (* X3 S13)))
 (= X9 (- (* X3 S12) (* 9 S13)))
 (= X9 (+ (* 9 S12) (* X4 S13)))
 (= X9 (- (* 9 S12) (* X4 S13)))
 (= X9 (- (* X4 S12) (* 9 S13)))
 (= X9 (+ (* 9 S12) (* X5 S13)))
 (= X9 (- (* 9 S12) (* X5 S13)))
 (= X9 (- (* X5 S12) (* 9 S13)))
 (= X9 (+ (* 9 S12) (* X6 S13)))
 (= X9 (- (* 9 S12) (* X6 S13)))
 (= X9 (- (* X6 S12) (* 9 S13)))
 (= X9 (+ (* 9 S12) (* X7 S13)))
 (= X9 (- (* 9 S12) (* X7 S13)))
 (= X9 (- (* X7 S12) (* 9 S13)))
 (= X9 (+ (* 9 S12) (* X8 S13)))
 (= X9 (- (* 9 S12) (* X8 S13)))
 (= X9 (- (* X8 S12) (* 9 S13)))
 (= X9 (+ (* 55 S12) S13))
 (= X9 (- (* 55 S12) S13))
 (= X9 (- S12 (* 55 S13)))
 (= X9 (+ (* 55 S12) (* 55 S13)))
 (= X9 (- (* 55 S12) (* 55 S13)))
 (= X9 (+ (* 55 S12) (* 201 S13)))
 (= X9 (- (* 55 S12) (* 201 S13)))
 (= X9 (- (* 201 S12) (* 55 S13)))
 (= X9 (+ (* 55 S12) (* X3 S13)))
 (= X9 (- (* 55 S12) (* X3 S13)))
 (= X9 (- (* X3 S12) (* 55 S13)))
 (= X9 (+ (* 55 S12) (* X4 S13)))
 (= X9 (- (* 55 S12) (* X4 S13)))
 (= X9 (- (* X4 S12) (* 55 S13)))
 (= X9 (+ (* 55 S12) (* X5 S13)))
 (= X9 (- (* 55 S12) (* X5 S13)))
 (= X9 (- (* X5 S12) (* 55 S13)))
 (= X9 (+ (* 55 S12) (* X6 S13)))
 (= X9 (- (* 55 S12) (* X6 S13)))
 (= X9 (- (* X6 S12) (* 55 S13)))
 (= X9 (+ (* 55 S12) (* X7 S13)))
 (= X9 (- (* 55 S12) (* X7 S13)))
 (= X9 (- (* X7 S12) (* 55 S13)))
 (= X9 (+ (* 55 S12) (* X8 S13)))
 (= X9 (- (* 55 S12) (* X8 S13)))
 (= X9 (- (* X8 S12) (* 55 S13)))
 (= X9 (+ (* 201 S12) S13))
 (= X9 (- (* 201 S12) S13))
 (= X9 (- S12 (* 201 S13)))
 (= X9 (+ (* 201 S12) (* 201 S13)))
 (= X9 (- (* 201 S12) (* 201 S13)))
 (= X9 (+ (* 201 S12) (* X3 S13)))
 (= X9 (- (* 201 S12) (* X3 S13)))
 (= X9 (- (* X3 S12) (* 201 S13)))
 (= X9 (+ (* 201 S12) (* X4 S13)))
 (= X9 (- (* 201 S12) (* X4 S13)))
 (= X9 (- (* X4 S12) (* 201 S13)))
 (= X9 (+ (* 201 S12) (* X5 S13)))
 (= X9 (- (* 201 S12) (* X5 S13)))
 (= X9 (- (* X5 S12) (* 201 S13)))
 (= X9 (+ (* 201 S12) (* X6 S13)))
 (= X9 (- (* 201 S12) (* X6 S13)))
 (= X9 (- (* X6 S12) (* 201 S13)))
 (= X9 (+ (* 201 S12) (* X7 S13)))
 (= X9 (- (* 201 S12) (* X7 S13)))
 (= X9 (- (* X7 S12) (* 201 S13)))
 (= X9 (+ (* 201 S12) (* X8 S13)))
 (= X9 (- (* 201 S12) (* X8 S13)))
 (= X9 (- (* X8 S12) (* 201 S13)))
 (= X9 (+ (* X3 S12) S13))
 (= X9 (- (* X3 S12) S13))
 (= X9 (- S12 (* X3 S13)))
 (= X9 (+ (* X3 S12) (* X3 S13)))
 (= X9 (- (* X3 S12) (* X3 S13)))
 (= X9 (+ (* X3 S12) (* X4 S13)))
 (= X9 (- (* X3 S12) (* X4 S13)))
 (= X9 (- (* X4 S12) (* X3 S13)))
 (= X9 (+ (* X3 S12) (* X5 S13)))
 (= X9 (- (* X3 S12) (* X5 S13)))
 (= X9 (- (* X5 S12) (* X3 S13)))
 (= X9 (+ (* X3 S12) (* X6 S13)))
 (= X9 (- (* X3 S12) (* X6 S13)))
 (= X9 (- (* X6 S12) (* X3 S13)))
 (= X9 (+ (* X3 S12) (* X7 S13)))
 (= X9 (- (* X3 S12) (* X7 S13)))
 (= X9 (- (* X7 S12) (* X3 S13)))
 (= X9 (+ (* X3 S12) (* X8 S13)))
 (= X9 (- (* X3 S12) (* X8 S13)))
 (= X9 (- (* X8 S12) (* X3 S13)))
 (= X9 (+ (* X4 S12) S13))
 (= X9 (- (* X4 S12) S13))
 (= X9 (- S12 (* X4 S13)))
 (= X9 (+ (* X4 S12) (* X4 S13)))
 (= X9 (- (* X4 S12) (* X4 S13)))
 (= X9 (+ (* X4 S12) (* X5 S13)))
 (= X9 (- (* X4 S12) (* X5 S13)))
 (= X9 (- (* X5 S12) (* X4 S13)))
 (= X9 (+ (* X4 S12) (* X6 S13)))
 (= X9 (- (* X4 S12) (* X6 S13)))
 (= X9 (- (* X6 S12) (* X4 S13)))
 (= X9 (+ (* X4 S12) (* X7 S13)))
 (= X9 (- (* X4 S12) (* X7 S13)))
 (= X9 (- (* X7 S12) (* X4 S13)))
 (= X9 (+ (* X4 S12) (* X8 S13)))
 (= X9 (- (* X4 S12) (* X8 S13)))
 (= X9 (- (* X8 S12) (* X4 S13)))
 (= X9 (+ (* X5 S12) S13))
 (= X9 (- (* X5 S12) S13))
 (= X9 (- S12 (* X5 S13)))
 (= X9 (+ (* X5 S12) (* X5 S13)))
 (= X9 (- (* X5 S12) (* X5 S13)))
 (= X9 (+ (* X5 S12) (* X6 S13)))
 (= X9 (- (* X5 S12) (* X6 S13)))
 (= X9 (- (* X6 S12) (* X5 S13)))
 (= X9 (+ (* X5 S12) (* X7 S13)))
 (= X9 (- (* X5 S12) (* X7 S13)))
 (= X9 (- (* X7 S12) (* X5 S13)))
 (= X9 (+ (* X5 S12) (* X8 S13)))
 (= X9 (- (* X5 S12) (* X8 S13)))
 (= X9 (- (* X8 S12) (* X5 S13)))
 (= X9 (+ (* X6 S12) S13))
 (= X9 (- (* X6 S12) S13))
 (= X9 (- S12 (* X6 S13)))
 (= X9 (+ (* X6 S12) (* X6 S13)))
 (= X9 (- (* X6 S12) (* X6 S13)))
 (= X9 (+ (* X6 S12) (* X7 S13)))
 (= X9 (- (* X6 S12) (* X7 S13)))
 (= X9 (- (* X7 S12) (* X6 S13)))
 (= X9 (+ (* X6 S12) (* X8 S13)))
 (= X9 (- (* X6 S12) (* X8 S13)))
 (= X9 (- (* X8 S12) (* X6 S13)))
 (= X9 (+ (* X7 S12) S13))
 (= X9 (- (* X7 S12) S13))
 (= X9 (- S12 (* X7 S13)))
 (= X9 (+ (* X7 S12) (* X7 S13)))
 (= X9 (- (* X7 S12) (* X7 S13)))
 (= X9 (+ (* X7 S12) (* X8 S13)))
 (= X9 (- (* X7 S12) (* X8 S13)))
 (= X9 (- (* X8 S12) (* X7 S13)))
 (= X9 (+ (* X8 S12) S13))
 (= X9 (- (* X8 S12) S13))
 (= X9 (- S12 (* X8 S13)))
 (= X9 (+ (* X8 S12) (* X8 S13)))
 (= X9 (- (* X8 S12) (* X8 S13)))
))
(assert (and (> X9 0) (< X9 2048) (power2 S12) (power2 S13)))
(assert (or
 (= X4 471)
 (= X5 471)
 (= X6 471)
 (= X7 471)
 (= X8 471)
 (= X9 471)
))
(assert (or
 (= X4 161)
 (= X5 161)
 (= X6 161)
 (= X7 161)
 (= X8 161)
 (= X9 161)
))
(assert (or
 (= X4 921)
 (= X5 921)
 (= X6 921)
 (= X7 921)
 (= X8 921)
 (= X9 921)
))
(assert (or
 (= X4 395)
 (= X5 395)
 (= X6 395)
 (= X7 395)
 (= X8 395)
 (= X9 395)
))
(assert (or
 (= X4 389)
 (= X5 389)
 (= X6 389)
 (= X7 389)
 (= X8 389)
 (= X9 389)
))
(assert (or
 (= X4 123)
 (= X5 123)
 (= X6 123)
 (= X7 123)
 (= X8 123)
 (= X9 123)
))
(check-sat)
(exit)
