(set-logic QF_NIA)
(set-info :source |
 more info in 'N. P. Lopes, L. Aksoy, V. Manquinho, J. Monteiro.
 Optimally Solving the MCM Problem Using Pseudo-Boolean Satisfiability.
 Technical Report RT/43/2010, INESC-ID, Nov. 2010'. |)
(set-info :smt-lib-version 2.0)
(set-info :category "industrial")
(set-info :status unknown)
(declare-fun X8 () Int)
(declare-fun X9 () Int)
(declare-fun X10 () Int)
(declare-fun S0 () Int)
(declare-fun S1 () Int)
(declare-fun S2 () Int)
(declare-fun S3 () Int)
(declare-fun S4 () Int)
(declare-fun S5 () Int)
(define-fun power2 ((x Int)) Bool
  (or (= x 1024) (= x 512) (= x 256) (= x 128) (= x 64) (= x 32) (= x 16) (= x 8) (= x 4) (= x 2) (= x 1)))
(assert (or
 (= X8 (+ S0 S1))
 (= X8 (- S0 S1))
 (= X8 (+ (* 9 S0) S1))
 (= X8 (- (* 9 S0) S1))
 (= X8 (- S0 (* 9 S1)))
 (= X8 (+ (* 9 S0) (* 9 S1)))
 (= X8 (- (* 9 S0) (* 9 S1)))
 (= X8 (+ (* 9 S0) (* 5 S1)))
 (= X8 (- (* 9 S0) (* 5 S1)))
 (= X8 (- (* 5 S0) (* 9 S1)))
 (= X8 (+ (* 9 S0) (* 25 S1)))
 (= X8 (- (* 9 S0) (* 25 S1)))
 (= X8 (- (* 25 S0) (* 9 S1)))
 (= X8 (+ (* 9 S0) (* 297 S1)))
 (= X8 (- (* 9 S0) (* 297 S1)))
 (= X8 (- (* 297 S0) (* 9 S1)))
 (= X8 (+ (* 9 S0) (* 301 S1)))
 (= X8 (- (* 9 S0) (* 301 S1)))
 (= X8 (- (* 301 S0) (* 9 S1)))
 (= X8 (+ (* 9 S0) (* 67 S1)))
 (= X8 (- (* 9 S0) (* 67 S1)))
 (= X8 (- (* 67 S0) (* 9 S1)))
 (= X8 (+ (* 9 S0) (* 615 S1)))
 (= X8 (- (* 9 S0) (* 615 S1)))
 (= X8 (- (* 615 S0) (* 9 S1)))
 (= X8 (+ (* 9 S0) (* 895 S1)))
 (= X8 (- (* 9 S0) (* 895 S1)))
 (= X8 (- (* 895 S0) (* 9 S1)))
 (= X8 (+ (* 5 S0) S1))
 (= X8 (- (* 5 S0) S1))
 (= X8 (- S0 (* 5 S1)))
 (= X8 (+ (* 5 S0) (* 5 S1)))
 (= X8 (- (* 5 S0) (* 5 S1)))
 (= X8 (+ (* 5 S0) (* 25 S1)))
 (= X8 (- (* 5 S0) (* 25 S1)))
 (= X8 (- (* 25 S0) (* 5 S1)))
 (= X8 (+ (* 5 S0) (* 297 S1)))
 (= X8 (- (* 5 S0) (* 297 S1)))
 (= X8 (- (* 297 S0) (* 5 S1)))
 (= X8 (+ (* 5 S0) (* 301 S1)))
 (= X8 (- (* 5 S0) (* 301 S1)))
 (= X8 (- (* 301 S0) (* 5 S1)))
 (= X8 (+ (* 5 S0) (* 67 S1)))
 (= X8 (- (* 5 S0) (* 67 S1)))
 (= X8 (- (* 67 S0) (* 5 S1)))
 (= X8 (+ (* 5 S0) (* 615 S1)))
 (= X8 (- (* 5 S0) (* 615 S1)))
 (= X8 (- (* 615 S0) (* 5 S1)))
 (= X8 (+ (* 5 S0) (* 895 S1)))
 (= X8 (- (* 5 S0) (* 895 S1)))
 (= X8 (- (* 895 S0) (* 5 S1)))
 (= X8 (+ (* 25 S0) S1))
 (= X8 (- (* 25 S0) S1))
 (= X8 (- S0 (* 25 S1)))
 (= X8 (+ (* 25 S0) (* 25 S1)))
 (= X8 (- (* 25 S0) (* 25 S1)))
 (= X8 (+ (* 25 S0) (* 297 S1)))
 (= X8 (- (* 25 S0) (* 297 S1)))
 (= X8 (- (* 297 S0) (* 25 S1)))
 (= X8 (+ (* 25 S0) (* 301 S1)))
 (= X8 (- (* 25 S0) (* 301 S1)))
 (= X8 (- (* 301 S0) (* 25 S1)))
 (= X8 (+ (* 25 S0) (* 67 S1)))
 (= X8 (- (* 25 S0) (* 67 S1)))
 (= X8 (- (* 67 S0) (* 25 S1)))
 (= X8 (+ (* 25 S0) (* 615 S1)))
 (= X8 (- (* 25 S0) (* 615 S1)))
 (= X8 (- (* 615 S0) (* 25 S1)))
 (= X8 (+ (* 25 S0) (* 895 S1)))
 (= X8 (- (* 25 S0) (* 895 S1)))
 (= X8 (- (* 895 S0) (* 25 S1)))
 (= X8 (+ (* 297 S0) S1))
 (= X8 (- (* 297 S0) S1))
 (= X8 (- S0 (* 297 S1)))
 (= X8 (+ (* 297 S0) (* 297 S1)))
 (= X8 (- (* 297 S0) (* 297 S1)))
 (= X8 (+ (* 297 S0) (* 301 S1)))
 (= X8 (- (* 297 S0) (* 301 S1)))
 (= X8 (- (* 301 S0) (* 297 S1)))
 (= X8 (+ (* 297 S0) (* 67 S1)))
 (= X8 (- (* 297 S0) (* 67 S1)))
 (= X8 (- (* 67 S0) (* 297 S1)))
 (= X8 (+ (* 297 S0) (* 615 S1)))
 (= X8 (- (* 297 S0) (* 615 S1)))
 (= X8 (- (* 615 S0) (* 297 S1)))
 (= X8 (+ (* 297 S0) (* 895 S1)))
 (= X8 (- (* 297 S0) (* 895 S1)))
 (= X8 (- (* 895 S0) (* 297 S1)))
 (= X8 (+ (* 301 S0) S1))
 (= X8 (- (* 301 S0) S1))
 (= X8 (- S0 (* 301 S1)))
 (= X8 (+ (* 301 S0) (* 301 S1)))
 (= X8 (- (* 301 S0) (* 301 S1)))
 (= X8 (+ (* 301 S0) (* 67 S1)))
 (= X8 (- (* 301 S0) (* 67 S1)))
 (= X8 (- (* 67 S0) (* 301 S1)))
 (= X8 (+ (* 301 S0) (* 615 S1)))
 (= X8 (- (* 301 S0) (* 615 S1)))
 (= X8 (- (* 615 S0) (* 301 S1)))
 (= X8 (+ (* 301 S0) (* 895 S1)))
 (= X8 (- (* 301 S0) (* 895 S1)))
 (= X8 (- (* 895 S0) (* 301 S1)))
 (= X8 (+ (* 67 S0) S1))
 (= X8 (- (* 67 S0) S1))
 (= X8 (- S0 (* 67 S1)))
 (= X8 (+ (* 67 S0) (* 67 S1)))
 (= X8 (- (* 67 S0) (* 67 S1)))
 (= X8 (+ (* 67 S0) (* 615 S1)))
 (= X8 (- (* 67 S0) (* 615 S1)))
 (= X8 (- (* 615 S0) (* 67 S1)))
 (= X8 (+ (* 67 S0) (* 895 S1)))
 (= X8 (- (* 67 S0) (* 895 S1)))
 (= X8 (- (* 895 S0) (* 67 S1)))
 (= X8 (+ (* 615 S0) S1))
 (= X8 (- (* 615 S0) S1))
 (= X8 (- S0 (* 615 S1)))
 (= X8 (+ (* 615 S0) (* 615 S1)))
 (= X8 (- (* 615 S0) (* 615 S1)))
 (= X8 (+ (* 615 S0) (* 895 S1)))
 (= X8 (- (* 615 S0) (* 895 S1)))
 (= X8 (- (* 895 S0) (* 615 S1)))
 (= X8 (+ (* 895 S0) S1))
 (= X8 (- (* 895 S0) S1))
 (= X8 (- S0 (* 895 S1)))
 (= X8 (+ (* 895 S0) (* 895 S1)))
 (= X8 (- (* 895 S0) (* 895 S1)))
))
(assert (and (> X8 0) (< X8 2048) (power2 S0) (power2 S1)))
(assert (or
 (= X9 (+ (* 9 S2) S3))
 (= X9 (- (* 9 S2) S3))
 (= X9 (- S2 (* 9 S3)))
 (= X9 (+ (* 9 S2) (* 9 S3)))
 (= X9 (- (* 9 S2) (* 9 S3)))
 (= X9 (+ (* 9 S2) (* 5 S3)))
 (= X9 (- (* 9 S2) (* 5 S3)))
 (= X9 (- (* 5 S2) (* 9 S3)))
 (= X9 (+ (* 9 S2) (* 25 S3)))
 (= X9 (- (* 9 S2) (* 25 S3)))
 (= X9 (- (* 25 S2) (* 9 S3)))
 (= X9 (+ (* 9 S2) (* 297 S3)))
 (= X9 (- (* 9 S2) (* 297 S3)))
 (= X9 (- (* 297 S2) (* 9 S3)))
 (= X9 (+ (* 9 S2) (* 301 S3)))
 (= X9 (- (* 9 S2) (* 301 S3)))
 (= X9 (- (* 301 S2) (* 9 S3)))
 (= X9 (+ (* 9 S2) (* 67 S3)))
 (= X9 (- (* 9 S2) (* 67 S3)))
 (= X9 (- (* 67 S2) (* 9 S3)))
 (= X9 (+ (* 9 S2) (* 615 S3)))
 (= X9 (- (* 9 S2) (* 615 S3)))
 (= X9 (- (* 615 S2) (* 9 S3)))
 (= X9 (+ (* 9 S2) (* 895 S3)))
 (= X9 (- (* 9 S2) (* 895 S3)))
 (= X9 (- (* 895 S2) (* 9 S3)))
 (= X9 (+ (* 9 S2) (* X8 S3)))
 (= X9 (- (* 9 S2) (* X8 S3)))
 (= X9 (- (* X8 S2) (* 9 S3)))
 (= X9 (+ (* 5 S2) S3))
 (= X9 (- (* 5 S2) S3))
 (= X9 (- S2 (* 5 S3)))
 (= X9 (+ (* 5 S2) (* 5 S3)))
 (= X9 (- (* 5 S2) (* 5 S3)))
 (= X9 (+ (* 5 S2) (* 25 S3)))
 (= X9 (- (* 5 S2) (* 25 S3)))
 (= X9 (- (* 25 S2) (* 5 S3)))
 (= X9 (+ (* 5 S2) (* 297 S3)))
 (= X9 (- (* 5 S2) (* 297 S3)))
 (= X9 (- (* 297 S2) (* 5 S3)))
 (= X9 (+ (* 5 S2) (* 301 S3)))
 (= X9 (- (* 5 S2) (* 301 S3)))
 (= X9 (- (* 301 S2) (* 5 S3)))
 (= X9 (+ (* 5 S2) (* 67 S3)))
 (= X9 (- (* 5 S2) (* 67 S3)))
 (= X9 (- (* 67 S2) (* 5 S3)))
 (= X9 (+ (* 5 S2) (* 615 S3)))
 (= X9 (- (* 5 S2) (* 615 S3)))
 (= X9 (- (* 615 S2) (* 5 S3)))
 (= X9 (+ (* 5 S2) (* 895 S3)))
 (= X9 (- (* 5 S2) (* 895 S3)))
 (= X9 (- (* 895 S2) (* 5 S3)))
 (= X9 (+ (* 5 S2) (* X8 S3)))
 (= X9 (- (* 5 S2) (* X8 S3)))
 (= X9 (- (* X8 S2) (* 5 S3)))
 (= X9 (+ (* 25 S2) S3))
 (= X9 (- (* 25 S2) S3))
 (= X9 (- S2 (* 25 S3)))
 (= X9 (+ (* 25 S2) (* 25 S3)))
 (= X9 (- (* 25 S2) (* 25 S3)))
 (= X9 (+ (* 25 S2) (* 297 S3)))
 (= X9 (- (* 25 S2) (* 297 S3)))
 (= X9 (- (* 297 S2) (* 25 S3)))
 (= X9 (+ (* 25 S2) (* 301 S3)))
 (= X9 (- (* 25 S2) (* 301 S3)))
 (= X9 (- (* 301 S2) (* 25 S3)))
 (= X9 (+ (* 25 S2) (* 67 S3)))
 (= X9 (- (* 25 S2) (* 67 S3)))
 (= X9 (- (* 67 S2) (* 25 S3)))
 (= X9 (+ (* 25 S2) (* 615 S3)))
 (= X9 (- (* 25 S2) (* 615 S3)))
 (= X9 (- (* 615 S2) (* 25 S3)))
 (= X9 (+ (* 25 S2) (* 895 S3)))
 (= X9 (- (* 25 S2) (* 895 S3)))
 (= X9 (- (* 895 S2) (* 25 S3)))
 (= X9 (+ (* 25 S2) (* X8 S3)))
 (= X9 (- (* 25 S2) (* X8 S3)))
 (= X9 (- (* X8 S2) (* 25 S3)))
 (= X9 (+ (* 297 S2) S3))
 (= X9 (- (* 297 S2) S3))
 (= X9 (- S2 (* 297 S3)))
 (= X9 (+ (* 297 S2) (* 297 S3)))
 (= X9 (- (* 297 S2) (* 297 S3)))
 (= X9 (+ (* 297 S2) (* 301 S3)))
 (= X9 (- (* 297 S2) (* 301 S3)))
 (= X9 (- (* 301 S2) (* 297 S3)))
 (= X9 (+ (* 297 S2) (* 67 S3)))
 (= X9 (- (* 297 S2) (* 67 S3)))
 (= X9 (- (* 67 S2) (* 297 S3)))
 (= X9 (+ (* 297 S2) (* 615 S3)))
 (= X9 (- (* 297 S2) (* 615 S3)))
 (= X9 (- (* 615 S2) (* 297 S3)))
 (= X9 (+ (* 297 S2) (* 895 S3)))
 (= X9 (- (* 297 S2) (* 895 S3)))
 (= X9 (- (* 895 S2) (* 297 S3)))
 (= X9 (+ (* 297 S2) (* X8 S3)))
 (= X9 (- (* 297 S2) (* X8 S3)))
 (= X9 (- (* X8 S2) (* 297 S3)))
 (= X9 (+ (* 301 S2) S3))
 (= X9 (- (* 301 S2) S3))
 (= X9 (- S2 (* 301 S3)))
 (= X9 (+ (* 301 S2) (* 301 S3)))
 (= X9 (- (* 301 S2) (* 301 S3)))
 (= X9 (+ (* 301 S2) (* 67 S3)))
 (= X9 (- (* 301 S2) (* 67 S3)))
 (= X9 (- (* 67 S2) (* 301 S3)))
 (= X9 (+ (* 301 S2) (* 615 S3)))
 (= X9 (- (* 301 S2) (* 615 S3)))
 (= X9 (- (* 615 S2) (* 301 S3)))
 (= X9 (+ (* 301 S2) (* 895 S3)))
 (= X9 (- (* 301 S2) (* 895 S3)))
 (= X9 (- (* 895 S2) (* 301 S3)))
 (= X9 (+ (* 301 S2) (* X8 S3)))
 (= X9 (- (* 301 S2) (* X8 S3)))
 (= X9 (- (* X8 S2) (* 301 S3)))
 (= X9 (+ (* 67 S2) S3))
 (= X9 (- (* 67 S2) S3))
 (= X9 (- S2 (* 67 S3)))
 (= X9 (+ (* 67 S2) (* 67 S3)))
 (= X9 (- (* 67 S2) (* 67 S3)))
 (= X9 (+ (* 67 S2) (* 615 S3)))
 (= X9 (- (* 67 S2) (* 615 S3)))
 (= X9 (- (* 615 S2) (* 67 S3)))
 (= X9 (+ (* 67 S2) (* 895 S3)))
 (= X9 (- (* 67 S2) (* 895 S3)))
 (= X9 (- (* 895 S2) (* 67 S3)))
 (= X9 (+ (* 67 S2) (* X8 S3)))
 (= X9 (- (* 67 S2) (* X8 S3)))
 (= X9 (- (* X8 S2) (* 67 S3)))
 (= X9 (+ (* 615 S2) S3))
 (= X9 (- (* 615 S2) S3))
 (= X9 (- S2 (* 615 S3)))
 (= X9 (+ (* 615 S2) (* 615 S3)))
 (= X9 (- (* 615 S2) (* 615 S3)))
 (= X9 (+ (* 615 S2) (* 895 S3)))
 (= X9 (- (* 615 S2) (* 895 S3)))
 (= X9 (- (* 895 S2) (* 615 S3)))
 (= X9 (+ (* 615 S2) (* X8 S3)))
 (= X9 (- (* 615 S2) (* X8 S3)))
 (= X9 (- (* X8 S2) (* 615 S3)))
 (= X9 (+ (* 895 S2) S3))
 (= X9 (- (* 895 S2) S3))
 (= X9 (- S2 (* 895 S3)))
 (= X9 (+ (* 895 S2) (* 895 S3)))
 (= X9 (- (* 895 S2) (* 895 S3)))
 (= X9 (+ (* 895 S2) (* X8 S3)))
 (= X9 (- (* 895 S2) (* X8 S3)))
 (= X9 (- (* X8 S2) (* 895 S3)))
 (= X9 (+ (* X8 S2) S3))
 (= X9 (- (* X8 S2) S3))
 (= X9 (- S2 (* X8 S3)))
 (= X9 (+ (* X8 S2) (* X8 S3)))
 (= X9 (- (* X8 S2) (* X8 S3)))
))
(assert (and (> X9 0) (< X9 2048) (power2 S2) (power2 S3)))
(assert (or
 (= X10 (+ (* 9 S4) S5))
 (= X10 (- (* 9 S4) S5))
 (= X10 (- S4 (* 9 S5)))
 (= X10 (+ (* 9 S4) (* 9 S5)))
 (= X10 (- (* 9 S4) (* 9 S5)))
 (= X10 (+ (* 9 S4) (* 5 S5)))
 (= X10 (- (* 9 S4) (* 5 S5)))
 (= X10 (- (* 5 S4) (* 9 S5)))
 (= X10 (+ (* 9 S4) (* 25 S5)))
 (= X10 (- (* 9 S4) (* 25 S5)))
 (= X10 (- (* 25 S4) (* 9 S5)))
 (= X10 (+ (* 9 S4) (* 297 S5)))
 (= X10 (- (* 9 S4) (* 297 S5)))
 (= X10 (- (* 297 S4) (* 9 S5)))
 (= X10 (+ (* 9 S4) (* 301 S5)))
 (= X10 (- (* 9 S4) (* 301 S5)))
 (= X10 (- (* 301 S4) (* 9 S5)))
 (= X10 (+ (* 9 S4) (* 67 S5)))
 (= X10 (- (* 9 S4) (* 67 S5)))
 (= X10 (- (* 67 S4) (* 9 S5)))
 (= X10 (+ (* 9 S4) (* 615 S5)))
 (= X10 (- (* 9 S4) (* 615 S5)))
 (= X10 (- (* 615 S4) (* 9 S5)))
 (= X10 (+ (* 9 S4) (* 895 S5)))
 (= X10 (- (* 9 S4) (* 895 S5)))
 (= X10 (- (* 895 S4) (* 9 S5)))
 (= X10 (+ (* 9 S4) (* X8 S5)))
 (= X10 (- (* 9 S4) (* X8 S5)))
 (= X10 (- (* X8 S4) (* 9 S5)))
 (= X10 (+ (* 9 S4) (* X9 S5)))
 (= X10 (- (* 9 S4) (* X9 S5)))
 (= X10 (- (* X9 S4) (* 9 S5)))
 (= X10 (+ (* 5 S4) S5))
 (= X10 (- (* 5 S4) S5))
 (= X10 (- S4 (* 5 S5)))
 (= X10 (+ (* 5 S4) (* 5 S5)))
 (= X10 (- (* 5 S4) (* 5 S5)))
 (= X10 (+ (* 5 S4) (* 25 S5)))
 (= X10 (- (* 5 S4) (* 25 S5)))
 (= X10 (- (* 25 S4) (* 5 S5)))
 (= X10 (+ (* 5 S4) (* 297 S5)))
 (= X10 (- (* 5 S4) (* 297 S5)))
 (= X10 (- (* 297 S4) (* 5 S5)))
 (= X10 (+ (* 5 S4) (* 301 S5)))
 (= X10 (- (* 5 S4) (* 301 S5)))
 (= X10 (- (* 301 S4) (* 5 S5)))
 (= X10 (+ (* 5 S4) (* 67 S5)))
 (= X10 (- (* 5 S4) (* 67 S5)))
 (= X10 (- (* 67 S4) (* 5 S5)))
 (= X10 (+ (* 5 S4) (* 615 S5)))
 (= X10 (- (* 5 S4) (* 615 S5)))
 (= X10 (- (* 615 S4) (* 5 S5)))
 (= X10 (+ (* 5 S4) (* 895 S5)))
 (= X10 (- (* 5 S4) (* 895 S5)))
 (= X10 (- (* 895 S4) (* 5 S5)))
 (= X10 (+ (* 5 S4) (* X8 S5)))
 (= X10 (- (* 5 S4) (* X8 S5)))
 (= X10 (- (* X8 S4) (* 5 S5)))
 (= X10 (+ (* 5 S4) (* X9 S5)))
 (= X10 (- (* 5 S4) (* X9 S5)))
 (= X10 (- (* X9 S4) (* 5 S5)))
 (= X10 (+ (* 25 S4) S5))
 (= X10 (- (* 25 S4) S5))
 (= X10 (- S4 (* 25 S5)))
 (= X10 (+ (* 25 S4) (* 25 S5)))
 (= X10 (- (* 25 S4) (* 25 S5)))
 (= X10 (+ (* 25 S4) (* 297 S5)))
 (= X10 (- (* 25 S4) (* 297 S5)))
 (= X10 (- (* 297 S4) (* 25 S5)))
 (= X10 (+ (* 25 S4) (* 301 S5)))
 (= X10 (- (* 25 S4) (* 301 S5)))
 (= X10 (- (* 301 S4) (* 25 S5)))
 (= X10 (+ (* 25 S4) (* 67 S5)))
 (= X10 (- (* 25 S4) (* 67 S5)))
 (= X10 (- (* 67 S4) (* 25 S5)))
 (= X10 (+ (* 25 S4) (* 615 S5)))
 (= X10 (- (* 25 S4) (* 615 S5)))
 (= X10 (- (* 615 S4) (* 25 S5)))
 (= X10 (+ (* 25 S4) (* 895 S5)))
 (= X10 (- (* 25 S4) (* 895 S5)))
 (= X10 (- (* 895 S4) (* 25 S5)))
 (= X10 (+ (* 25 S4) (* X8 S5)))
 (= X10 (- (* 25 S4) (* X8 S5)))
 (= X10 (- (* X8 S4) (* 25 S5)))
 (= X10 (+ (* 25 S4) (* X9 S5)))
 (= X10 (- (* 25 S4) (* X9 S5)))
 (= X10 (- (* X9 S4) (* 25 S5)))
 (= X10 (+ (* 297 S4) S5))
 (= X10 (- (* 297 S4) S5))
 (= X10 (- S4 (* 297 S5)))
 (= X10 (+ (* 297 S4) (* 297 S5)))
 (= X10 (- (* 297 S4) (* 297 S5)))
 (= X10 (+ (* 297 S4) (* 301 S5)))
 (= X10 (- (* 297 S4) (* 301 S5)))
 (= X10 (- (* 301 S4) (* 297 S5)))
 (= X10 (+ (* 297 S4) (* 67 S5)))
 (= X10 (- (* 297 S4) (* 67 S5)))
 (= X10 (- (* 67 S4) (* 297 S5)))
 (= X10 (+ (* 297 S4) (* 615 S5)))
 (= X10 (- (* 297 S4) (* 615 S5)))
 (= X10 (- (* 615 S4) (* 297 S5)))
 (= X10 (+ (* 297 S4) (* 895 S5)))
 (= X10 (- (* 297 S4) (* 895 S5)))
 (= X10 (- (* 895 S4) (* 297 S5)))
 (= X10 (+ (* 297 S4) (* X8 S5)))
 (= X10 (- (* 297 S4) (* X8 S5)))
 (= X10 (- (* X8 S4) (* 297 S5)))
 (= X10 (+ (* 297 S4) (* X9 S5)))
 (= X10 (- (* 297 S4) (* X9 S5)))
 (= X10 (- (* X9 S4) (* 297 S5)))
 (= X10 (+ (* 301 S4) S5))
 (= X10 (- (* 301 S4) S5))
 (= X10 (- S4 (* 301 S5)))
 (= X10 (+ (* 301 S4) (* 301 S5)))
 (= X10 (- (* 301 S4) (* 301 S5)))
 (= X10 (+ (* 301 S4) (* 67 S5)))
 (= X10 (- (* 301 S4) (* 67 S5)))
 (= X10 (- (* 67 S4) (* 301 S5)))
 (= X10 (+ (* 301 S4) (* 615 S5)))
 (= X10 (- (* 301 S4) (* 615 S5)))
 (= X10 (- (* 615 S4) (* 301 S5)))
 (= X10 (+ (* 301 S4) (* 895 S5)))
 (= X10 (- (* 301 S4) (* 895 S5)))
 (= X10 (- (* 895 S4) (* 301 S5)))
 (= X10 (+ (* 301 S4) (* X8 S5)))
 (= X10 (- (* 301 S4) (* X8 S5)))
 (= X10 (- (* X8 S4) (* 301 S5)))
 (= X10 (+ (* 301 S4) (* X9 S5)))
 (= X10 (- (* 301 S4) (* X9 S5)))
 (= X10 (- (* X9 S4) (* 301 S5)))
 (= X10 (+ (* 67 S4) S5))
 (= X10 (- (* 67 S4) S5))
 (= X10 (- S4 (* 67 S5)))
 (= X10 (+ (* 67 S4) (* 67 S5)))
 (= X10 (- (* 67 S4) (* 67 S5)))
 (= X10 (+ (* 67 S4) (* 615 S5)))
 (= X10 (- (* 67 S4) (* 615 S5)))
 (= X10 (- (* 615 S4) (* 67 S5)))
 (= X10 (+ (* 67 S4) (* 895 S5)))
 (= X10 (- (* 67 S4) (* 895 S5)))
 (= X10 (- (* 895 S4) (* 67 S5)))
 (= X10 (+ (* 67 S4) (* X8 S5)))
 (= X10 (- (* 67 S4) (* X8 S5)))
 (= X10 (- (* X8 S4) (* 67 S5)))
 (= X10 (+ (* 67 S4) (* X9 S5)))
 (= X10 (- (* 67 S4) (* X9 S5)))
 (= X10 (- (* X9 S4) (* 67 S5)))
 (= X10 (+ (* 615 S4) S5))
 (= X10 (- (* 615 S4) S5))
 (= X10 (- S4 (* 615 S5)))
 (= X10 (+ (* 615 S4) (* 615 S5)))
 (= X10 (- (* 615 S4) (* 615 S5)))
 (= X10 (+ (* 615 S4) (* 895 S5)))
 (= X10 (- (* 615 S4) (* 895 S5)))
 (= X10 (- (* 895 S4) (* 615 S5)))
 (= X10 (+ (* 615 S4) (* X8 S5)))
 (= X10 (- (* 615 S4) (* X8 S5)))
 (= X10 (- (* X8 S4) (* 615 S5)))
 (= X10 (+ (* 615 S4) (* X9 S5)))
 (= X10 (- (* 615 S4) (* X9 S5)))
 (= X10 (- (* X9 S4) (* 615 S5)))
 (= X10 (+ (* 895 S4) S5))
 (= X10 (- (* 895 S4) S5))
 (= X10 (- S4 (* 895 S5)))
 (= X10 (+ (* 895 S4) (* 895 S5)))
 (= X10 (- (* 895 S4) (* 895 S5)))
 (= X10 (+ (* 895 S4) (* X8 S5)))
 (= X10 (- (* 895 S4) (* X8 S5)))
 (= X10 (- (* X8 S4) (* 895 S5)))
 (= X10 (+ (* 895 S4) (* X9 S5)))
 (= X10 (- (* 895 S4) (* X9 S5)))
 (= X10 (- (* X9 S4) (* 895 S5)))
 (= X10 (+ (* X8 S4) S5))
 (= X10 (- (* X8 S4) S5))
 (= X10 (- S4 (* X8 S5)))
 (= X10 (+ (* X8 S4) (* X8 S5)))
 (= X10 (- (* X8 S4) (* X8 S5)))
 (= X10 (+ (* X8 S4) (* X9 S5)))
 (= X10 (- (* X8 S4) (* X9 S5)))
 (= X10 (- (* X9 S4) (* X8 S5)))
 (= X10 (+ (* X9 S4) S5))
 (= X10 (- (* X9 S4) S5))
 (= X10 (- S4 (* X9 S5)))
 (= X10 (+ (* X9 S4) (* X9 S5)))
 (= X10 (- (* X9 S4) (* X9 S5)))
))
(assert (and (> X10 0) (< X10 2048) (power2 S4) (power2 S5)))
(assert (or
 (= X9 371)
 (= X10 371)
))
(assert (or
 (= X9 181)
 (= X10 181)
))
(check-sat)
(exit)
