(set-logic QF_NIA)
(set-info :source |
 more info in 'N. P. Lopes, L. Aksoy, V. Manquinho, J. Monteiro.
 Optimally Solving the MCM Problem Using Pseudo-Boolean Satisfiability.
 Technical Report RT/43/2010, INESC-ID, Nov. 2010'. |)
(set-info :smt-lib-version 2.0)
(set-info :category "industrial")
(set-info :status unknown)
(declare-fun X5 () Int)
(declare-fun X6 () Int)
(declare-fun X7 () Int)
(declare-fun X8 () Int)
(declare-fun X9 () Int)
(declare-fun X10 () Int)
(declare-fun S0 () Int)
(declare-fun S1 () Int)
(declare-fun S2 () Int)
(declare-fun S3 () Int)
(declare-fun S4 () Int)
(declare-fun S5 () Int)
(declare-fun S6 () Int)
(declare-fun S7 () Int)
(declare-fun S8 () Int)
(declare-fun S9 () Int)
(declare-fun S10 () Int)
(declare-fun S11 () Int)
(define-fun power2 ((x Int)) Bool
  (or (= x 2048) (= x 1024) (= x 512) (= x 256) (= x 128) (= x 64) (= x 32) (= x 16) (= x 8) (= x 4) (= x 2) (= x 1)))
(assert (or
 (= X5 (+ S0 S1))
 (= X5 (- S0 S1))
 (= X5 (+ (* 31 S0) S1))
 (= X5 (- (* 31 S0) S1))
 (= X5 (- S0 (* 31 S1)))
 (= X5 (+ (* 31 S0) (* 31 S1)))
 (= X5 (- (* 31 S0) (* 31 S1)))
 (= X5 (+ (* 31 S0) (* 63 S1)))
 (= X5 (- (* 31 S0) (* 63 S1)))
 (= X5 (- (* 63 S0) (* 31 S1)))
 (= X5 (+ (* 31 S0) (* 35 S1)))
 (= X5 (- (* 31 S0) (* 35 S1)))
 (= X5 (- (* 35 S0) (* 31 S1)))
 (= X5 (+ (* 31 S0) (* 251 S1)))
 (= X5 (- (* 31 S0) (* 251 S1)))
 (= X5 (- (* 251 S0) (* 31 S1)))
 (= X5 (+ (* 31 S0) (* 105 S1)))
 (= X5 (- (* 31 S0) (* 105 S1)))
 (= X5 (- (* 105 S0) (* 31 S1)))
 (= X5 (+ (* 63 S0) S1))
 (= X5 (- (* 63 S0) S1))
 (= X5 (- S0 (* 63 S1)))
 (= X5 (+ (* 63 S0) (* 63 S1)))
 (= X5 (- (* 63 S0) (* 63 S1)))
 (= X5 (+ (* 63 S0) (* 35 S1)))
 (= X5 (- (* 63 S0) (* 35 S1)))
 (= X5 (- (* 35 S0) (* 63 S1)))
 (= X5 (+ (* 63 S0) (* 251 S1)))
 (= X5 (- (* 63 S0) (* 251 S1)))
 (= X5 (- (* 251 S0) (* 63 S1)))
 (= X5 (+ (* 63 S0) (* 105 S1)))
 (= X5 (- (* 63 S0) (* 105 S1)))
 (= X5 (- (* 105 S0) (* 63 S1)))
 (= X5 (+ (* 35 S0) S1))
 (= X5 (- (* 35 S0) S1))
 (= X5 (- S0 (* 35 S1)))
 (= X5 (+ (* 35 S0) (* 35 S1)))
 (= X5 (- (* 35 S0) (* 35 S1)))
 (= X5 (+ (* 35 S0) (* 251 S1)))
 (= X5 (- (* 35 S0) (* 251 S1)))
 (= X5 (- (* 251 S0) (* 35 S1)))
 (= X5 (+ (* 35 S0) (* 105 S1)))
 (= X5 (- (* 35 S0) (* 105 S1)))
 (= X5 (- (* 105 S0) (* 35 S1)))
 (= X5 (+ (* 251 S0) S1))
 (= X5 (- (* 251 S0) S1))
 (= X5 (- S0 (* 251 S1)))
 (= X5 (+ (* 251 S0) (* 251 S1)))
 (= X5 (- (* 251 S0) (* 251 S1)))
 (= X5 (+ (* 251 S0) (* 105 S1)))
 (= X5 (- (* 251 S0) (* 105 S1)))
 (= X5 (- (* 105 S0) (* 251 S1)))
 (= X5 (+ (* 105 S0) S1))
 (= X5 (- (* 105 S0) S1))
 (= X5 (- S0 (* 105 S1)))
 (= X5 (+ (* 105 S0) (* 105 S1)))
 (= X5 (- (* 105 S0) (* 105 S1)))
))
(assert (and (> X5 0) (< X5 4096) (power2 S0) (power2 S1)))
(assert (or
 (= X6 (+ (* 31 S2) S3))
 (= X6 (- (* 31 S2) S3))
 (= X6 (- S2 (* 31 S3)))
 (= X6 (+ (* 31 S2) (* 31 S3)))
 (= X6 (- (* 31 S2) (* 31 S3)))
 (= X6 (+ (* 31 S2) (* 63 S3)))
 (= X6 (- (* 31 S2) (* 63 S3)))
 (= X6 (- (* 63 S2) (* 31 S3)))
 (= X6 (+ (* 31 S2) (* 35 S3)))
 (= X6 (- (* 31 S2) (* 35 S3)))
 (= X6 (- (* 35 S2) (* 31 S3)))
 (= X6 (+ (* 31 S2) (* 251 S3)))
 (= X6 (- (* 31 S2) (* 251 S3)))
 (= X6 (- (* 251 S2) (* 31 S3)))
 (= X6 (+ (* 31 S2) (* 105 S3)))
 (= X6 (- (* 31 S2) (* 105 S3)))
 (= X6 (- (* 105 S2) (* 31 S3)))
 (= X6 (+ (* 31 S2) (* X5 S3)))
 (= X6 (- (* 31 S2) (* X5 S3)))
 (= X6 (- (* X5 S2) (* 31 S3)))
 (= X6 (+ (* 63 S2) S3))
 (= X6 (- (* 63 S2) S3))
 (= X6 (- S2 (* 63 S3)))
 (= X6 (+ (* 63 S2) (* 63 S3)))
 (= X6 (- (* 63 S2) (* 63 S3)))
 (= X6 (+ (* 63 S2) (* 35 S3)))
 (= X6 (- (* 63 S2) (* 35 S3)))
 (= X6 (- (* 35 S2) (* 63 S3)))
 (= X6 (+ (* 63 S2) (* 251 S3)))
 (= X6 (- (* 63 S2) (* 251 S3)))
 (= X6 (- (* 251 S2) (* 63 S3)))
 (= X6 (+ (* 63 S2) (* 105 S3)))
 (= X6 (- (* 63 S2) (* 105 S3)))
 (= X6 (- (* 105 S2) (* 63 S3)))
 (= X6 (+ (* 63 S2) (* X5 S3)))
 (= X6 (- (* 63 S2) (* X5 S3)))
 (= X6 (- (* X5 S2) (* 63 S3)))
 (= X6 (+ (* 35 S2) S3))
 (= X6 (- (* 35 S2) S3))
 (= X6 (- S2 (* 35 S3)))
 (= X6 (+ (* 35 S2) (* 35 S3)))
 (= X6 (- (* 35 S2) (* 35 S3)))
 (= X6 (+ (* 35 S2) (* 251 S3)))
 (= X6 (- (* 35 S2) (* 251 S3)))
 (= X6 (- (* 251 S2) (* 35 S3)))
 (= X6 (+ (* 35 S2) (* 105 S3)))
 (= X6 (- (* 35 S2) (* 105 S3)))
 (= X6 (- (* 105 S2) (* 35 S3)))
 (= X6 (+ (* 35 S2) (* X5 S3)))
 (= X6 (- (* 35 S2) (* X5 S3)))
 (= X6 (- (* X5 S2) (* 35 S3)))
 (= X6 (+ (* 251 S2) S3))
 (= X6 (- (* 251 S2) S3))
 (= X6 (- S2 (* 251 S3)))
 (= X6 (+ (* 251 S2) (* 251 S3)))
 (= X6 (- (* 251 S2) (* 251 S3)))
 (= X6 (+ (* 251 S2) (* 105 S3)))
 (= X6 (- (* 251 S2) (* 105 S3)))
 (= X6 (- (* 105 S2) (* 251 S3)))
 (= X6 (+ (* 251 S2) (* X5 S3)))
 (= X6 (- (* 251 S2) (* X5 S3)))
 (= X6 (- (* X5 S2) (* 251 S3)))
 (= X6 (+ (* 105 S2) S3))
 (= X6 (- (* 105 S2) S3))
 (= X6 (- S2 (* 105 S3)))
 (= X6 (+ (* 105 S2) (* 105 S3)))
 (= X6 (- (* 105 S2) (* 105 S3)))
 (= X6 (+ (* 105 S2) (* X5 S3)))
 (= X6 (- (* 105 S2) (* X5 S3)))
 (= X6 (- (* X5 S2) (* 105 S3)))
 (= X6 (+ (* X5 S2) S3))
 (= X6 (- (* X5 S2) S3))
 (= X6 (- S2 (* X5 S3)))
 (= X6 (+ (* X5 S2) (* X5 S3)))
 (= X6 (- (* X5 S2) (* X5 S3)))
))
(assert (and (> X6 0) (< X6 4096) (power2 S2) (power2 S3)))
(assert (or
 (= X7 (+ (* 31 S4) S5))
 (= X7 (- (* 31 S4) S5))
 (= X7 (- S4 (* 31 S5)))
 (= X7 (+ (* 31 S4) (* 31 S5)))
 (= X7 (- (* 31 S4) (* 31 S5)))
 (= X7 (+ (* 31 S4) (* 63 S5)))
 (= X7 (- (* 31 S4) (* 63 S5)))
 (= X7 (- (* 63 S4) (* 31 S5)))
 (= X7 (+ (* 31 S4) (* 35 S5)))
 (= X7 (- (* 31 S4) (* 35 S5)))
 (= X7 (- (* 35 S4) (* 31 S5)))
 (= X7 (+ (* 31 S4) (* 251 S5)))
 (= X7 (- (* 31 S4) (* 251 S5)))
 (= X7 (- (* 251 S4) (* 31 S5)))
 (= X7 (+ (* 31 S4) (* 105 S5)))
 (= X7 (- (* 31 S4) (* 105 S5)))
 (= X7 (- (* 105 S4) (* 31 S5)))
 (= X7 (+ (* 31 S4) (* X5 S5)))
 (= X7 (- (* 31 S4) (* X5 S5)))
 (= X7 (- (* X5 S4) (* 31 S5)))
 (= X7 (+ (* 31 S4) (* X6 S5)))
 (= X7 (- (* 31 S4) (* X6 S5)))
 (= X7 (- (* X6 S4) (* 31 S5)))
 (= X7 (+ (* 63 S4) S5))
 (= X7 (- (* 63 S4) S5))
 (= X7 (- S4 (* 63 S5)))
 (= X7 (+ (* 63 S4) (* 63 S5)))
 (= X7 (- (* 63 S4) (* 63 S5)))
 (= X7 (+ (* 63 S4) (* 35 S5)))
 (= X7 (- (* 63 S4) (* 35 S5)))
 (= X7 (- (* 35 S4) (* 63 S5)))
 (= X7 (+ (* 63 S4) (* 251 S5)))
 (= X7 (- (* 63 S4) (* 251 S5)))
 (= X7 (- (* 251 S4) (* 63 S5)))
 (= X7 (+ (* 63 S4) (* 105 S5)))
 (= X7 (- (* 63 S4) (* 105 S5)))
 (= X7 (- (* 105 S4) (* 63 S5)))
 (= X7 (+ (* 63 S4) (* X5 S5)))
 (= X7 (- (* 63 S4) (* X5 S5)))
 (= X7 (- (* X5 S4) (* 63 S5)))
 (= X7 (+ (* 63 S4) (* X6 S5)))
 (= X7 (- (* 63 S4) (* X6 S5)))
 (= X7 (- (* X6 S4) (* 63 S5)))
 (= X7 (+ (* 35 S4) S5))
 (= X7 (- (* 35 S4) S5))
 (= X7 (- S4 (* 35 S5)))
 (= X7 (+ (* 35 S4) (* 35 S5)))
 (= X7 (- (* 35 S4) (* 35 S5)))
 (= X7 (+ (* 35 S4) (* 251 S5)))
 (= X7 (- (* 35 S4) (* 251 S5)))
 (= X7 (- (* 251 S4) (* 35 S5)))
 (= X7 (+ (* 35 S4) (* 105 S5)))
 (= X7 (- (* 35 S4) (* 105 S5)))
 (= X7 (- (* 105 S4) (* 35 S5)))
 (= X7 (+ (* 35 S4) (* X5 S5)))
 (= X7 (- (* 35 S4) (* X5 S5)))
 (= X7 (- (* X5 S4) (* 35 S5)))
 (= X7 (+ (* 35 S4) (* X6 S5)))
 (= X7 (- (* 35 S4) (* X6 S5)))
 (= X7 (- (* X6 S4) (* 35 S5)))
 (= X7 (+ (* 251 S4) S5))
 (= X7 (- (* 251 S4) S5))
 (= X7 (- S4 (* 251 S5)))
 (= X7 (+ (* 251 S4) (* 251 S5)))
 (= X7 (- (* 251 S4) (* 251 S5)))
 (= X7 (+ (* 251 S4) (* 105 S5)))
 (= X7 (- (* 251 S4) (* 105 S5)))
 (= X7 (- (* 105 S4) (* 251 S5)))
 (= X7 (+ (* 251 S4) (* X5 S5)))
 (= X7 (- (* 251 S4) (* X5 S5)))
 (= X7 (- (* X5 S4) (* 251 S5)))
 (= X7 (+ (* 251 S4) (* X6 S5)))
 (= X7 (- (* 251 S4) (* X6 S5)))
 (= X7 (- (* X6 S4) (* 251 S5)))
 (= X7 (+ (* 105 S4) S5))
 (= X7 (- (* 105 S4) S5))
 (= X7 (- S4 (* 105 S5)))
 (= X7 (+ (* 105 S4) (* 105 S5)))
 (= X7 (- (* 105 S4) (* 105 S5)))
 (= X7 (+ (* 105 S4) (* X5 S5)))
 (= X7 (- (* 105 S4) (* X5 S5)))
 (= X7 (- (* X5 S4) (* 105 S5)))
 (= X7 (+ (* 105 S4) (* X6 S5)))
 (= X7 (- (* 105 S4) (* X6 S5)))
 (= X7 (- (* X6 S4) (* 105 S5)))
 (= X7 (+ (* X5 S4) S5))
 (= X7 (- (* X5 S4) S5))
 (= X7 (- S4 (* X5 S5)))
 (= X7 (+ (* X5 S4) (* X5 S5)))
 (= X7 (- (* X5 S4) (* X5 S5)))
 (= X7 (+ (* X5 S4) (* X6 S5)))
 (= X7 (- (* X5 S4) (* X6 S5)))
 (= X7 (- (* X6 S4) (* X5 S5)))
 (= X7 (+ (* X6 S4) S5))
 (= X7 (- (* X6 S4) S5))
 (= X7 (- S4 (* X6 S5)))
 (= X7 (+ (* X6 S4) (* X6 S5)))
 (= X7 (- (* X6 S4) (* X6 S5)))
))
(assert (and (> X7 0) (< X7 4096) (power2 S4) (power2 S5)))
(assert (or
 (= X8 (+ (* 31 S6) S7))
 (= X8 (- (* 31 S6) S7))
 (= X8 (- S6 (* 31 S7)))
 (= X8 (+ (* 31 S6) (* 31 S7)))
 (= X8 (- (* 31 S6) (* 31 S7)))
 (= X8 (+ (* 31 S6) (* 63 S7)))
 (= X8 (- (* 31 S6) (* 63 S7)))
 (= X8 (- (* 63 S6) (* 31 S7)))
 (= X8 (+ (* 31 S6) (* 35 S7)))
 (= X8 (- (* 31 S6) (* 35 S7)))
 (= X8 (- (* 35 S6) (* 31 S7)))
 (= X8 (+ (* 31 S6) (* 251 S7)))
 (= X8 (- (* 31 S6) (* 251 S7)))
 (= X8 (- (* 251 S6) (* 31 S7)))
 (= X8 (+ (* 31 S6) (* 105 S7)))
 (= X8 (- (* 31 S6) (* 105 S7)))
 (= X8 (- (* 105 S6) (* 31 S7)))
 (= X8 (+ (* 31 S6) (* X5 S7)))
 (= X8 (- (* 31 S6) (* X5 S7)))
 (= X8 (- (* X5 S6) (* 31 S7)))
 (= X8 (+ (* 31 S6) (* X6 S7)))
 (= X8 (- (* 31 S6) (* X6 S7)))
 (= X8 (- (* X6 S6) (* 31 S7)))
 (= X8 (+ (* 31 S6) (* X7 S7)))
 (= X8 (- (* 31 S6) (* X7 S7)))
 (= X8 (- (* X7 S6) (* 31 S7)))
 (= X8 (+ (* 63 S6) S7))
 (= X8 (- (* 63 S6) S7))
 (= X8 (- S6 (* 63 S7)))
 (= X8 (+ (* 63 S6) (* 63 S7)))
 (= X8 (- (* 63 S6) (* 63 S7)))
 (= X8 (+ (* 63 S6) (* 35 S7)))
 (= X8 (- (* 63 S6) (* 35 S7)))
 (= X8 (- (* 35 S6) (* 63 S7)))
 (= X8 (+ (* 63 S6) (* 251 S7)))
 (= X8 (- (* 63 S6) (* 251 S7)))
 (= X8 (- (* 251 S6) (* 63 S7)))
 (= X8 (+ (* 63 S6) (* 105 S7)))
 (= X8 (- (* 63 S6) (* 105 S7)))
 (= X8 (- (* 105 S6) (* 63 S7)))
 (= X8 (+ (* 63 S6) (* X5 S7)))
 (= X8 (- (* 63 S6) (* X5 S7)))
 (= X8 (- (* X5 S6) (* 63 S7)))
 (= X8 (+ (* 63 S6) (* X6 S7)))
 (= X8 (- (* 63 S6) (* X6 S7)))
 (= X8 (- (* X6 S6) (* 63 S7)))
 (= X8 (+ (* 63 S6) (* X7 S7)))
 (= X8 (- (* 63 S6) (* X7 S7)))
 (= X8 (- (* X7 S6) (* 63 S7)))
 (= X8 (+ (* 35 S6) S7))
 (= X8 (- (* 35 S6) S7))
 (= X8 (- S6 (* 35 S7)))
 (= X8 (+ (* 35 S6) (* 35 S7)))
 (= X8 (- (* 35 S6) (* 35 S7)))
 (= X8 (+ (* 35 S6) (* 251 S7)))
 (= X8 (- (* 35 S6) (* 251 S7)))
 (= X8 (- (* 251 S6) (* 35 S7)))
 (= X8 (+ (* 35 S6) (* 105 S7)))
 (= X8 (- (* 35 S6) (* 105 S7)))
 (= X8 (- (* 105 S6) (* 35 S7)))
 (= X8 (+ (* 35 S6) (* X5 S7)))
 (= X8 (- (* 35 S6) (* X5 S7)))
 (= X8 (- (* X5 S6) (* 35 S7)))
 (= X8 (+ (* 35 S6) (* X6 S7)))
 (= X8 (- (* 35 S6) (* X6 S7)))
 (= X8 (- (* X6 S6) (* 35 S7)))
 (= X8 (+ (* 35 S6) (* X7 S7)))
 (= X8 (- (* 35 S6) (* X7 S7)))
 (= X8 (- (* X7 S6) (* 35 S7)))
 (= X8 (+ (* 251 S6) S7))
 (= X8 (- (* 251 S6) S7))
 (= X8 (- S6 (* 251 S7)))
 (= X8 (+ (* 251 S6) (* 251 S7)))
 (= X8 (- (* 251 S6) (* 251 S7)))
 (= X8 (+ (* 251 S6) (* 105 S7)))
 (= X8 (- (* 251 S6) (* 105 S7)))
 (= X8 (- (* 105 S6) (* 251 S7)))
 (= X8 (+ (* 251 S6) (* X5 S7)))
 (= X8 (- (* 251 S6) (* X5 S7)))
 (= X8 (- (* X5 S6) (* 251 S7)))
 (= X8 (+ (* 251 S6) (* X6 S7)))
 (= X8 (- (* 251 S6) (* X6 S7)))
 (= X8 (- (* X6 S6) (* 251 S7)))
 (= X8 (+ (* 251 S6) (* X7 S7)))
 (= X8 (- (* 251 S6) (* X7 S7)))
 (= X8 (- (* X7 S6) (* 251 S7)))
 (= X8 (+ (* 105 S6) S7))
 (= X8 (- (* 105 S6) S7))
 (= X8 (- S6 (* 105 S7)))
 (= X8 (+ (* 105 S6) (* 105 S7)))
 (= X8 (- (* 105 S6) (* 105 S7)))
 (= X8 (+ (* 105 S6) (* X5 S7)))
 (= X8 (- (* 105 S6) (* X5 S7)))
 (= X8 (- (* X5 S6) (* 105 S7)))
 (= X8 (+ (* 105 S6) (* X6 S7)))
 (= X8 (- (* 105 S6) (* X6 S7)))
 (= X8 (- (* X6 S6) (* 105 S7)))
 (= X8 (+ (* 105 S6) (* X7 S7)))
 (= X8 (- (* 105 S6) (* X7 S7)))
 (= X8 (- (* X7 S6) (* 105 S7)))
 (= X8 (+ (* X5 S6) S7))
 (= X8 (- (* X5 S6) S7))
 (= X8 (- S6 (* X5 S7)))
 (= X8 (+ (* X5 S6) (* X5 S7)))
 (= X8 (- (* X5 S6) (* X5 S7)))
 (= X8 (+ (* X5 S6) (* X6 S7)))
 (= X8 (- (* X5 S6) (* X6 S7)))
 (= X8 (- (* X6 S6) (* X5 S7)))
 (= X8 (+ (* X5 S6) (* X7 S7)))
 (= X8 (- (* X5 S6) (* X7 S7)))
 (= X8 (- (* X7 S6) (* X5 S7)))
 (= X8 (+ (* X6 S6) S7))
 (= X8 (- (* X6 S6) S7))
 (= X8 (- S6 (* X6 S7)))
 (= X8 (+ (* X6 S6) (* X6 S7)))
 (= X8 (- (* X6 S6) (* X6 S7)))
 (= X8 (+ (* X6 S6) (* X7 S7)))
 (= X8 (- (* X6 S6) (* X7 S7)))
 (= X8 (- (* X7 S6) (* X6 S7)))
 (= X8 (+ (* X7 S6) S7))
 (= X8 (- (* X7 S6) S7))
 (= X8 (- S6 (* X7 S7)))
 (= X8 (+ (* X7 S6) (* X7 S7)))
 (= X8 (- (* X7 S6) (* X7 S7)))
))
(assert (and (> X8 0) (< X8 4096) (power2 S6) (power2 S7)))
(assert (or
 (= X9 (+ (* 31 S8) S9))
 (= X9 (- (* 31 S8) S9))
 (= X9 (- S8 (* 31 S9)))
 (= X9 (+ (* 31 S8) (* 31 S9)))
 (= X9 (- (* 31 S8) (* 31 S9)))
 (= X9 (+ (* 31 S8) (* 63 S9)))
 (= X9 (- (* 31 S8) (* 63 S9)))
 (= X9 (- (* 63 S8) (* 31 S9)))
 (= X9 (+ (* 31 S8) (* 35 S9)))
 (= X9 (- (* 31 S8) (* 35 S9)))
 (= X9 (- (* 35 S8) (* 31 S9)))
 (= X9 (+ (* 31 S8) (* 251 S9)))
 (= X9 (- (* 31 S8) (* 251 S9)))
 (= X9 (- (* 251 S8) (* 31 S9)))
 (= X9 (+ (* 31 S8) (* 105 S9)))
 (= X9 (- (* 31 S8) (* 105 S9)))
 (= X9 (- (* 105 S8) (* 31 S9)))
 (= X9 (+ (* 31 S8) (* X5 S9)))
 (= X9 (- (* 31 S8) (* X5 S9)))
 (= X9 (- (* X5 S8) (* 31 S9)))
 (= X9 (+ (* 31 S8) (* X6 S9)))
 (= X9 (- (* 31 S8) (* X6 S9)))
 (= X9 (- (* X6 S8) (* 31 S9)))
 (= X9 (+ (* 31 S8) (* X7 S9)))
 (= X9 (- (* 31 S8) (* X7 S9)))
 (= X9 (- (* X7 S8) (* 31 S9)))
 (= X9 (+ (* 31 S8) (* X8 S9)))
 (= X9 (- (* 31 S8) (* X8 S9)))
 (= X9 (- (* X8 S8) (* 31 S9)))
 (= X9 (+ (* 63 S8) S9))
 (= X9 (- (* 63 S8) S9))
 (= X9 (- S8 (* 63 S9)))
 (= X9 (+ (* 63 S8) (* 63 S9)))
 (= X9 (- (* 63 S8) (* 63 S9)))
 (= X9 (+ (* 63 S8) (* 35 S9)))
 (= X9 (- (* 63 S8) (* 35 S9)))
 (= X9 (- (* 35 S8) (* 63 S9)))
 (= X9 (+ (* 63 S8) (* 251 S9)))
 (= X9 (- (* 63 S8) (* 251 S9)))
 (= X9 (- (* 251 S8) (* 63 S9)))
 (= X9 (+ (* 63 S8) (* 105 S9)))
 (= X9 (- (* 63 S8) (* 105 S9)))
 (= X9 (- (* 105 S8) (* 63 S9)))
 (= X9 (+ (* 63 S8) (* X5 S9)))
 (= X9 (- (* 63 S8) (* X5 S9)))
 (= X9 (- (* X5 S8) (* 63 S9)))
 (= X9 (+ (* 63 S8) (* X6 S9)))
 (= X9 (- (* 63 S8) (* X6 S9)))
 (= X9 (- (* X6 S8) (* 63 S9)))
 (= X9 (+ (* 63 S8) (* X7 S9)))
 (= X9 (- (* 63 S8) (* X7 S9)))
 (= X9 (- (* X7 S8) (* 63 S9)))
 (= X9 (+ (* 63 S8) (* X8 S9)))
 (= X9 (- (* 63 S8) (* X8 S9)))
 (= X9 (- (* X8 S8) (* 63 S9)))
 (= X9 (+ (* 35 S8) S9))
 (= X9 (- (* 35 S8) S9))
 (= X9 (- S8 (* 35 S9)))
 (= X9 (+ (* 35 S8) (* 35 S9)))
 (= X9 (- (* 35 S8) (* 35 S9)))
 (= X9 (+ (* 35 S8) (* 251 S9)))
 (= X9 (- (* 35 S8) (* 251 S9)))
 (= X9 (- (* 251 S8) (* 35 S9)))
 (= X9 (+ (* 35 S8) (* 105 S9)))
 (= X9 (- (* 35 S8) (* 105 S9)))
 (= X9 (- (* 105 S8) (* 35 S9)))
 (= X9 (+ (* 35 S8) (* X5 S9)))
 (= X9 (- (* 35 S8) (* X5 S9)))
 (= X9 (- (* X5 S8) (* 35 S9)))
 (= X9 (+ (* 35 S8) (* X6 S9)))
 (= X9 (- (* 35 S8) (* X6 S9)))
 (= X9 (- (* X6 S8) (* 35 S9)))
 (= X9 (+ (* 35 S8) (* X7 S9)))
 (= X9 (- (* 35 S8) (* X7 S9)))
 (= X9 (- (* X7 S8) (* 35 S9)))
 (= X9 (+ (* 35 S8) (* X8 S9)))
 (= X9 (- (* 35 S8) (* X8 S9)))
 (= X9 (- (* X8 S8) (* 35 S9)))
 (= X9 (+ (* 251 S8) S9))
 (= X9 (- (* 251 S8) S9))
 (= X9 (- S8 (* 251 S9)))
 (= X9 (+ (* 251 S8) (* 251 S9)))
 (= X9 (- (* 251 S8) (* 251 S9)))
 (= X9 (+ (* 251 S8) (* 105 S9)))
 (= X9 (- (* 251 S8) (* 105 S9)))
 (= X9 (- (* 105 S8) (* 251 S9)))
 (= X9 (+ (* 251 S8) (* X5 S9)))
 (= X9 (- (* 251 S8) (* X5 S9)))
 (= X9 (- (* X5 S8) (* 251 S9)))
 (= X9 (+ (* 251 S8) (* X6 S9)))
 (= X9 (- (* 251 S8) (* X6 S9)))
 (= X9 (- (* X6 S8) (* 251 S9)))
 (= X9 (+ (* 251 S8) (* X7 S9)))
 (= X9 (- (* 251 S8) (* X7 S9)))
 (= X9 (- (* X7 S8) (* 251 S9)))
 (= X9 (+ (* 251 S8) (* X8 S9)))
 (= X9 (- (* 251 S8) (* X8 S9)))
 (= X9 (- (* X8 S8) (* 251 S9)))
 (= X9 (+ (* 105 S8) S9))
 (= X9 (- (* 105 S8) S9))
 (= X9 (- S8 (* 105 S9)))
 (= X9 (+ (* 105 S8) (* 105 S9)))
 (= X9 (- (* 105 S8) (* 105 S9)))
 (= X9 (+ (* 105 S8) (* X5 S9)))
 (= X9 (- (* 105 S8) (* X5 S9)))
 (= X9 (- (* X5 S8) (* 105 S9)))
 (= X9 (+ (* 105 S8) (* X6 S9)))
 (= X9 (- (* 105 S8) (* X6 S9)))
 (= X9 (- (* X6 S8) (* 105 S9)))
 (= X9 (+ (* 105 S8) (* X7 S9)))
 (= X9 (- (* 105 S8) (* X7 S9)))
 (= X9 (- (* X7 S8) (* 105 S9)))
 (= X9 (+ (* 105 S8) (* X8 S9)))
 (= X9 (- (* 105 S8) (* X8 S9)))
 (= X9 (- (* X8 S8) (* 105 S9)))
 (= X9 (+ (* X5 S8) S9))
 (= X9 (- (* X5 S8) S9))
 (= X9 (- S8 (* X5 S9)))
 (= X9 (+ (* X5 S8) (* X5 S9)))
 (= X9 (- (* X5 S8) (* X5 S9)))
 (= X9 (+ (* X5 S8) (* X6 S9)))
 (= X9 (- (* X5 S8) (* X6 S9)))
 (= X9 (- (* X6 S8) (* X5 S9)))
 (= X9 (+ (* X5 S8) (* X7 S9)))
 (= X9 (- (* X5 S8) (* X7 S9)))
 (= X9 (- (* X7 S8) (* X5 S9)))
 (= X9 (+ (* X5 S8) (* X8 S9)))
 (= X9 (- (* X5 S8) (* X8 S9)))
 (= X9 (- (* X8 S8) (* X5 S9)))
 (= X9 (+ (* X6 S8) S9))
 (= X9 (- (* X6 S8) S9))
 (= X9 (- S8 (* X6 S9)))
 (= X9 (+ (* X6 S8) (* X6 S9)))
 (= X9 (- (* X6 S8) (* X6 S9)))
 (= X9 (+ (* X6 S8) (* X7 S9)))
 (= X9 (- (* X6 S8) (* X7 S9)))
 (= X9 (- (* X7 S8) (* X6 S9)))
 (= X9 (+ (* X6 S8) (* X8 S9)))
 (= X9 (- (* X6 S8) (* X8 S9)))
 (= X9 (- (* X8 S8) (* X6 S9)))
 (= X9 (+ (* X7 S8) S9))
 (= X9 (- (* X7 S8) S9))
 (= X9 (- S8 (* X7 S9)))
 (= X9 (+ (* X7 S8) (* X7 S9)))
 (= X9 (- (* X7 S8) (* X7 S9)))
 (= X9 (+ (* X7 S8) (* X8 S9)))
 (= X9 (- (* X7 S8) (* X8 S9)))
 (= X9 (- (* X8 S8) (* X7 S9)))
 (= X9 (+ (* X8 S8) S9))
 (= X9 (- (* X8 S8) S9))
 (= X9 (- S8 (* X8 S9)))
 (= X9 (+ (* X8 S8) (* X8 S9)))
 (= X9 (- (* X8 S8) (* X8 S9)))
))
(assert (and (> X9 0) (< X9 4096) (power2 S8) (power2 S9)))
(assert (or
 (= X10 (+ (* 31 S10) S11))
 (= X10 (- (* 31 S10) S11))
 (= X10 (- S10 (* 31 S11)))
 (= X10 (+ (* 31 S10) (* 31 S11)))
 (= X10 (- (* 31 S10) (* 31 S11)))
 (= X10 (+ (* 31 S10) (* 63 S11)))
 (= X10 (- (* 31 S10) (* 63 S11)))
 (= X10 (- (* 63 S10) (* 31 S11)))
 (= X10 (+ (* 31 S10) (* 35 S11)))
 (= X10 (- (* 31 S10) (* 35 S11)))
 (= X10 (- (* 35 S10) (* 31 S11)))
 (= X10 (+ (* 31 S10) (* 251 S11)))
 (= X10 (- (* 31 S10) (* 251 S11)))
 (= X10 (- (* 251 S10) (* 31 S11)))
 (= X10 (+ (* 31 S10) (* 105 S11)))
 (= X10 (- (* 31 S10) (* 105 S11)))
 (= X10 (- (* 105 S10) (* 31 S11)))
 (= X10 (+ (* 31 S10) (* X5 S11)))
 (= X10 (- (* 31 S10) (* X5 S11)))
 (= X10 (- (* X5 S10) (* 31 S11)))
 (= X10 (+ (* 31 S10) (* X6 S11)))
 (= X10 (- (* 31 S10) (* X6 S11)))
 (= X10 (- (* X6 S10) (* 31 S11)))
 (= X10 (+ (* 31 S10) (* X7 S11)))
 (= X10 (- (* 31 S10) (* X7 S11)))
 (= X10 (- (* X7 S10) (* 31 S11)))
 (= X10 (+ (* 31 S10) (* X8 S11)))
 (= X10 (- (* 31 S10) (* X8 S11)))
 (= X10 (- (* X8 S10) (* 31 S11)))
 (= X10 (+ (* 31 S10) (* X9 S11)))
 (= X10 (- (* 31 S10) (* X9 S11)))
 (= X10 (- (* X9 S10) (* 31 S11)))
 (= X10 (+ (* 63 S10) S11))
 (= X10 (- (* 63 S10) S11))
 (= X10 (- S10 (* 63 S11)))
 (= X10 (+ (* 63 S10) (* 63 S11)))
 (= X10 (- (* 63 S10) (* 63 S11)))
 (= X10 (+ (* 63 S10) (* 35 S11)))
 (= X10 (- (* 63 S10) (* 35 S11)))
 (= X10 (- (* 35 S10) (* 63 S11)))
 (= X10 (+ (* 63 S10) (* 251 S11)))
 (= X10 (- (* 63 S10) (* 251 S11)))
 (= X10 (- (* 251 S10) (* 63 S11)))
 (= X10 (+ (* 63 S10) (* 105 S11)))
 (= X10 (- (* 63 S10) (* 105 S11)))
 (= X10 (- (* 105 S10) (* 63 S11)))
 (= X10 (+ (* 63 S10) (* X5 S11)))
 (= X10 (- (* 63 S10) (* X5 S11)))
 (= X10 (- (* X5 S10) (* 63 S11)))
 (= X10 (+ (* 63 S10) (* X6 S11)))
 (= X10 (- (* 63 S10) (* X6 S11)))
 (= X10 (- (* X6 S10) (* 63 S11)))
 (= X10 (+ (* 63 S10) (* X7 S11)))
 (= X10 (- (* 63 S10) (* X7 S11)))
 (= X10 (- (* X7 S10) (* 63 S11)))
 (= X10 (+ (* 63 S10) (* X8 S11)))
 (= X10 (- (* 63 S10) (* X8 S11)))
 (= X10 (- (* X8 S10) (* 63 S11)))
 (= X10 (+ (* 63 S10) (* X9 S11)))
 (= X10 (- (* 63 S10) (* X9 S11)))
 (= X10 (- (* X9 S10) (* 63 S11)))
 (= X10 (+ (* 35 S10) S11))
 (= X10 (- (* 35 S10) S11))
 (= X10 (- S10 (* 35 S11)))
 (= X10 (+ (* 35 S10) (* 35 S11)))
 (= X10 (- (* 35 S10) (* 35 S11)))
 (= X10 (+ (* 35 S10) (* 251 S11)))
 (= X10 (- (* 35 S10) (* 251 S11)))
 (= X10 (- (* 251 S10) (* 35 S11)))
 (= X10 (+ (* 35 S10) (* 105 S11)))
 (= X10 (- (* 35 S10) (* 105 S11)))
 (= X10 (- (* 105 S10) (* 35 S11)))
 (= X10 (+ (* 35 S10) (* X5 S11)))
 (= X10 (- (* 35 S10) (* X5 S11)))
 (= X10 (- (* X5 S10) (* 35 S11)))
 (= X10 (+ (* 35 S10) (* X6 S11)))
 (= X10 (- (* 35 S10) (* X6 S11)))
 (= X10 (- (* X6 S10) (* 35 S11)))
 (= X10 (+ (* 35 S10) (* X7 S11)))
 (= X10 (- (* 35 S10) (* X7 S11)))
 (= X10 (- (* X7 S10) (* 35 S11)))
 (= X10 (+ (* 35 S10) (* X8 S11)))
 (= X10 (- (* 35 S10) (* X8 S11)))
 (= X10 (- (* X8 S10) (* 35 S11)))
 (= X10 (+ (* 35 S10) (* X9 S11)))
 (= X10 (- (* 35 S10) (* X9 S11)))
 (= X10 (- (* X9 S10) (* 35 S11)))
 (= X10 (+ (* 251 S10) S11))
 (= X10 (- (* 251 S10) S11))
 (= X10 (- S10 (* 251 S11)))
 (= X10 (+ (* 251 S10) (* 251 S11)))
 (= X10 (- (* 251 S10) (* 251 S11)))
 (= X10 (+ (* 251 S10) (* 105 S11)))
 (= X10 (- (* 251 S10) (* 105 S11)))
 (= X10 (- (* 105 S10) (* 251 S11)))
 (= X10 (+ (* 251 S10) (* X5 S11)))
 (= X10 (- (* 251 S10) (* X5 S11)))
 (= X10 (- (* X5 S10) (* 251 S11)))
 (= X10 (+ (* 251 S10) (* X6 S11)))
 (= X10 (- (* 251 S10) (* X6 S11)))
 (= X10 (- (* X6 S10) (* 251 S11)))
 (= X10 (+ (* 251 S10) (* X7 S11)))
 (= X10 (- (* 251 S10) (* X7 S11)))
 (= X10 (- (* X7 S10) (* 251 S11)))
 (= X10 (+ (* 251 S10) (* X8 S11)))
 (= X10 (- (* 251 S10) (* X8 S11)))
 (= X10 (- (* X8 S10) (* 251 S11)))
 (= X10 (+ (* 251 S10) (* X9 S11)))
 (= X10 (- (* 251 S10) (* X9 S11)))
 (= X10 (- (* X9 S10) (* 251 S11)))
 (= X10 (+ (* 105 S10) S11))
 (= X10 (- (* 105 S10) S11))
 (= X10 (- S10 (* 105 S11)))
 (= X10 (+ (* 105 S10) (* 105 S11)))
 (= X10 (- (* 105 S10) (* 105 S11)))
 (= X10 (+ (* 105 S10) (* X5 S11)))
 (= X10 (- (* 105 S10) (* X5 S11)))
 (= X10 (- (* X5 S10) (* 105 S11)))
 (= X10 (+ (* 105 S10) (* X6 S11)))
 (= X10 (- (* 105 S10) (* X6 S11)))
 (= X10 (- (* X6 S10) (* 105 S11)))
 (= X10 (+ (* 105 S10) (* X7 S11)))
 (= X10 (- (* 105 S10) (* X7 S11)))
 (= X10 (- (* X7 S10) (* 105 S11)))
 (= X10 (+ (* 105 S10) (* X8 S11)))
 (= X10 (- (* 105 S10) (* X8 S11)))
 (= X10 (- (* X8 S10) (* 105 S11)))
 (= X10 (+ (* 105 S10) (* X9 S11)))
 (= X10 (- (* 105 S10) (* X9 S11)))
 (= X10 (- (* X9 S10) (* 105 S11)))
 (= X10 (+ (* X5 S10) S11))
 (= X10 (- (* X5 S10) S11))
 (= X10 (- S10 (* X5 S11)))
 (= X10 (+ (* X5 S10) (* X5 S11)))
 (= X10 (- (* X5 S10) (* X5 S11)))
 (= X10 (+ (* X5 S10) (* X6 S11)))
 (= X10 (- (* X5 S10) (* X6 S11)))
 (= X10 (- (* X6 S10) (* X5 S11)))
 (= X10 (+ (* X5 S10) (* X7 S11)))
 (= X10 (- (* X5 S10) (* X7 S11)))
 (= X10 (- (* X7 S10) (* X5 S11)))
 (= X10 (+ (* X5 S10) (* X8 S11)))
 (= X10 (- (* X5 S10) (* X8 S11)))
 (= X10 (- (* X8 S10) (* X5 S11)))
 (= X10 (+ (* X5 S10) (* X9 S11)))
 (= X10 (- (* X5 S10) (* X9 S11)))
 (= X10 (- (* X9 S10) (* X5 S11)))
 (= X10 (+ (* X6 S10) S11))
 (= X10 (- (* X6 S10) S11))
 (= X10 (- S10 (* X6 S11)))
 (= X10 (+ (* X6 S10) (* X6 S11)))
 (= X10 (- (* X6 S10) (* X6 S11)))
 (= X10 (+ (* X6 S10) (* X7 S11)))
 (= X10 (- (* X6 S10) (* X7 S11)))
 (= X10 (- (* X7 S10) (* X6 S11)))
 (= X10 (+ (* X6 S10) (* X8 S11)))
 (= X10 (- (* X6 S10) (* X8 S11)))
 (= X10 (- (* X8 S10) (* X6 S11)))
 (= X10 (+ (* X6 S10) (* X9 S11)))
 (= X10 (- (* X6 S10) (* X9 S11)))
 (= X10 (- (* X9 S10) (* X6 S11)))
 (= X10 (+ (* X7 S10) S11))
 (= X10 (- (* X7 S10) S11))
 (= X10 (- S10 (* X7 S11)))
 (= X10 (+ (* X7 S10) (* X7 S11)))
 (= X10 (- (* X7 S10) (* X7 S11)))
 (= X10 (+ (* X7 S10) (* X8 S11)))
 (= X10 (- (* X7 S10) (* X8 S11)))
 (= X10 (- (* X8 S10) (* X7 S11)))
 (= X10 (+ (* X7 S10) (* X9 S11)))
 (= X10 (- (* X7 S10) (* X9 S11)))
 (= X10 (- (* X9 S10) (* X7 S11)))
 (= X10 (+ (* X8 S10) S11))
 (= X10 (- (* X8 S10) S11))
 (= X10 (- S10 (* X8 S11)))
 (= X10 (+ (* X8 S10) (* X8 S11)))
 (= X10 (- (* X8 S10) (* X8 S11)))
 (= X10 (+ (* X8 S10) (* X9 S11)))
 (= X10 (- (* X8 S10) (* X9 S11)))
 (= X10 (- (* X9 S10) (* X8 S11)))
 (= X10 (+ (* X9 S10) S11))
 (= X10 (- (* X9 S10) S11))
 (= X10 (- S10 (* X9 S11)))
 (= X10 (+ (* X9 S10) (* X9 S11)))
 (= X10 (- (* X9 S10) (* X9 S11)))
))
(assert (and (> X10 0) (< X10 4096) (power2 S10) (power2 S11)))
(assert (or
 (= X6 827)
 (= X7 827)
 (= X8 827)
 (= X9 827)
 (= X10 827)
))
(assert (or
 (= X6 1419)
 (= X7 1419)
 (= X8 1419)
 (= X9 1419)
 (= X10 1419)
))
(assert (or
 (= X6 1745)
 (= X7 1745)
 (= X8 1745)
 (= X9 1745)
 (= X10 1745)
))
(assert (or
 (= X6 1677)
 (= X7 1677)
 (= X8 1677)
 (= X9 1677)
 (= X10 1677)
))
(assert (or
 (= X6 25)
 (= X7 25)
 (= X8 25)
 (= X9 25)
 (= X10 25)
))
(check-sat)
(exit)
