(set-logic QF_NIA)
(set-info :source |

SMT script generated by Ultimate LassoRanker [1].
Ultimate LassoRanker is a tool that analyzes termination and nontermination of
lasso-shaped programs. This script contains the SMT commands that Ultimate 
LassoRanker used while checking if a lasso-shaped program has a geometric 
nontermination argument. (See [2] for a preliminary definition of
geometric nontermination argument.)

This SMT script belongs to a set of SMT scripts that was generated by applying
Ultimate Buchi Automizer [3,4] to benchmarks from the SV-COMP 2016 [5,6] 
which are available at [7]. Ultimate Buchi Automizer takes omega-traces
(lasso-shaped programs) and uses LassoRanker in order to check if the 
lasso-shaped program is terminating.

2016-04-30, Matthias Heizmann (heizmann@informatik.uni-freiburg.de)


[1] https://ultimate.informatik.uni-freiburg.de/LassoRanker/
[2] Jan Leike, Matthias Heizmann: Geometric Series as Nontermination
Arguments for Linear Lasso Programs. CoRR abs/1405.4413 (2014)
http://arxiv.org/abs/1405.4413
[3] http://ultimate.informatik.uni-freiburg.de/BuchiAutomizer/
[4] Matthias Heizmann, Jochen Hoenicke, Andreas Podelski: Software Model
Checking for People Who Love Automata. CAV 2013:36-52
[5] http://sv-comp.sosy-lab.org/2016/
[6] Dirk Beyer: Reliable and Reproducible Competition Results with BenchExec
and Witnesses (Report on SV-COMP 2016). TACAS 2016: 887-904
[7] https://github.com/dbeyer/sv-benchmarks

|)
(set-info :smt-lib-version 2.5)
(set-info :category "industrial")
(set-info :status sat)
(declare-fun init_ULTIMATE.start_main_~a~2 () Int)
(declare-fun honda_ULTIMATE.start_main_~a~2 () Int)
(declare-fun init_ULTIMATE.start_main_~r~2 () Int)
(declare-fun honda_ULTIMATE.start_main_~r~2 () Int)
(declare-fun init_ULTIMATE.start_main_~c~2 () Int)
(declare-fun honda_ULTIMATE.start_main_~c~2 () Int)
(declare-fun |init_ULTIMATE.start_main_#t~nondet3| () Int)
(declare-fun |honda_ULTIMATE.start_main_#t~nondet3| () Int)
(declare-fun init_ULTIMATE.start_main_~b~2 () Int)
(declare-fun honda_ULTIMATE.start_main_~b~2 () Int)
(declare-fun gev_ULTIMATE.start_main_~a~20 () Int)
(declare-fun gev_ULTIMATE.start_main_~r~20 () Int)
(declare-fun gev_ULTIMATE.start_main_~c~20 () Int)
(declare-fun |gev_ULTIMATE.start_main_#t~nondet30| () Int)
(declare-fun gev_ULTIMATE.start_main_~b~20 () Int)
(declare-fun lambda0 () Int)
(declare-fun gev_ULTIMATE.start_main_~a~21 () Int)
(declare-fun gev_ULTIMATE.start_main_~r~21 () Int)
(declare-fun gev_ULTIMATE.start_main_~c~21 () Int)
(declare-fun |gev_ULTIMATE.start_main_#t~nondet31| () Int)
(declare-fun gev_ULTIMATE.start_main_~b~21 () Int)
(declare-fun lambda1 () Int)
(declare-fun gev_ULTIMATE.start_main_~a~22 () Int)
(declare-fun gev_ULTIMATE.start_main_~r~22 () Int)
(declare-fun gev_ULTIMATE.start_main_~c~22 () Int)
(declare-fun |gev_ULTIMATE.start_main_#t~nondet32| () Int)
(declare-fun gev_ULTIMATE.start_main_~b~22 () Int)
(declare-fun lambda2 () Int)
(declare-fun nu0 () Int)
(declare-fun nu1 () Int)
(assert (and true (and (>= (+ (* (+ (* gev_ULTIMATE.start_main_~b~20 lambda0) (* gev_ULTIMATE.start_main_~b~21 nu0)) 0) (* (+ (* gev_ULTIMATE.start_main_~c~20 lambda0) (* gev_ULTIMATE.start_main_~c~21 nu0)) (- 1)) (* (+ (* gev_ULTIMATE.start_main_~r~20 lambda0) (* gev_ULTIMATE.start_main_~r~21 nu0)) 1) (* (+ (* gev_ULTIMATE.start_main_~a~20 lambda0) (* gev_ULTIMATE.start_main_~a~21 nu0)) 0) (* (+ (* |gev_ULTIMATE.start_main_#t~nondet30| lambda0) (* |gev_ULTIMATE.start_main_#t~nondet31| nu0)) 0) (* gev_ULTIMATE.start_main_~b~20 0) (* |gev_ULTIMATE.start_main_#t~nondet30| 0) (* gev_ULTIMATE.start_main_~c~20 1) (* gev_ULTIMATE.start_main_~a~20 0) (* gev_ULTIMATE.start_main_~r~20 0)) 0) (>= (+ (* (+ (* gev_ULTIMATE.start_main_~b~20 lambda0) (* gev_ULTIMATE.start_main_~b~21 nu0)) 0) (* (+ (* gev_ULTIMATE.start_main_~c~20 lambda0) (* gev_ULTIMATE.start_main_~c~21 nu0)) 0) (* (+ (* gev_ULTIMATE.start_main_~r~20 lambda0) (* gev_ULTIMATE.start_main_~r~21 nu0)) 0) (* (+ (* gev_ULTIMATE.start_main_~a~20 lambda0) (* gev_ULTIMATE.start_main_~a~21 nu0)) 0) (* (+ (* |gev_ULTIMATE.start_main_#t~nondet30| lambda0) (* |gev_ULTIMATE.start_main_#t~nondet31| nu0)) 0) (* gev_ULTIMATE.start_main_~b~20 0) (* |gev_ULTIMATE.start_main_#t~nondet30| 0) (* gev_ULTIMATE.start_main_~c~20 (- 1)) (* gev_ULTIMATE.start_main_~a~20 1) (* gev_ULTIMATE.start_main_~r~20 0)) 0) (>= (+ (* (+ (* gev_ULTIMATE.start_main_~b~20 lambda0) (* gev_ULTIMATE.start_main_~b~21 nu0)) 0) (* (+ (* gev_ULTIMATE.start_main_~c~20 lambda0) (* gev_ULTIMATE.start_main_~c~21 nu0)) 1) (* (+ (* gev_ULTIMATE.start_main_~r~20 lambda0) (* gev_ULTIMATE.start_main_~r~21 nu0)) 0) (* (+ (* gev_ULTIMATE.start_main_~a~20 lambda0) (* gev_ULTIMATE.start_main_~a~21 nu0)) (- 1)) (* (+ (* |gev_ULTIMATE.start_main_#t~nondet30| lambda0) (* |gev_ULTIMATE.start_main_#t~nondet31| nu0)) 0) (* gev_ULTIMATE.start_main_~b~20 0) (* |gev_ULTIMATE.start_main_#t~nondet30| 0) (* gev_ULTIMATE.start_main_~c~20 0) (* gev_ULTIMATE.start_main_~a~20 0) (* gev_ULTIMATE.start_main_~r~20 0)) 0) (>= (+ (* (+ (* gev_ULTIMATE.start_main_~b~20 lambda0) (* gev_ULTIMATE.start_main_~b~21 nu0)) 0) (* (+ (* gev_ULTIMATE.start_main_~c~20 lambda0) (* gev_ULTIMATE.start_main_~c~21 nu0)) 0) (* (+ (* gev_ULTIMATE.start_main_~r~20 lambda0) (* gev_ULTIMATE.start_main_~r~21 nu0)) 1) (* (+ (* gev_ULTIMATE.start_main_~a~20 lambda0) (* gev_ULTIMATE.start_main_~a~21 nu0)) 0) (* (+ (* |gev_ULTIMATE.start_main_#t~nondet30| lambda0) (* |gev_ULTIMATE.start_main_#t~nondet31| nu0)) 0) (* gev_ULTIMATE.start_main_~b~20 0) (* |gev_ULTIMATE.start_main_#t~nondet30| (- 1)) (* gev_ULTIMATE.start_main_~c~20 0) (* gev_ULTIMATE.start_main_~a~20 0) (* gev_ULTIMATE.start_main_~r~20 0)) 0) (>= (+ (* (+ (* gev_ULTIMATE.start_main_~b~20 lambda0) (* gev_ULTIMATE.start_main_~b~21 nu0)) 1) (* (+ (* gev_ULTIMATE.start_main_~c~20 lambda0) (* gev_ULTIMATE.start_main_~c~21 nu0)) 0) (* (+ (* gev_ULTIMATE.start_main_~r~20 lambda0) (* gev_ULTIMATE.start_main_~r~21 nu0)) 0) (* (+ (* gev_ULTIMATE.start_main_~a~20 lambda0) (* gev_ULTIMATE.start_main_~a~21 nu0)) 0) (* (+ (* |gev_ULTIMATE.start_main_#t~nondet30| lambda0) (* |gev_ULTIMATE.start_main_#t~nondet31| nu0)) 0) (* gev_ULTIMATE.start_main_~b~20 0) (* |gev_ULTIMATE.start_main_#t~nondet30| 0) (* gev_ULTIMATE.start_main_~c~20 0) (* gev_ULTIMATE.start_main_~a~20 0) (* gev_ULTIMATE.start_main_~r~20 0)) 0) (>= (+ (* (+ (* gev_ULTIMATE.start_main_~b~20 lambda0) (* gev_ULTIMATE.start_main_~b~21 nu0)) 0) (* (+ (* gev_ULTIMATE.start_main_~c~20 lambda0) (* gev_ULTIMATE.start_main_~c~21 nu0)) 1) (* (+ (* gev_ULTIMATE.start_main_~r~20 lambda0) (* gev_ULTIMATE.start_main_~r~21 nu0)) (- 1)) (* (+ (* gev_ULTIMATE.start_main_~a~20 lambda0) (* gev_ULTIMATE.start_main_~a~21 nu0)) 0) (* (+ (* |gev_ULTIMATE.start_main_#t~nondet30| lambda0) (* |gev_ULTIMATE.start_main_#t~nondet31| nu0)) 0) (* gev_ULTIMATE.start_main_~b~20 0) (* |gev_ULTIMATE.start_main_#t~nondet30| 0) (* gev_ULTIMATE.start_main_~c~20 (- 1)) (* gev_ULTIMATE.start_main_~a~20 0) (* gev_ULTIMATE.start_main_~r~20 0)) 0) (>= (+ (* (+ (* gev_ULTIMATE.start_main_~b~20 lambda0) (* gev_ULTIMATE.start_main_~b~21 nu0)) 0) (* (+ (* gev_ULTIMATE.start_main_~c~20 lambda0) (* gev_ULTIMATE.start_main_~c~21 nu0)) 0) (* (+ (* gev_ULTIMATE.start_main_~r~20 lambda0) (* gev_ULTIMATE.start_main_~r~21 nu0)) 0) (* (+ (* gev_ULTIMATE.start_main_~a~20 lambda0) (* gev_ULTIMATE.start_main_~a~21 nu0)) 0) (* (+ (* |gev_ULTIMATE.start_main_#t~nondet30| lambda0) (* |gev_ULTIMATE.start_main_#t~nondet31| nu0)) 0) (* gev_ULTIMATE.start_main_~b~20 0) (* |gev_ULTIMATE.start_main_#t~nondet30| 0) (* gev_ULTIMATE.start_main_~c~20 1) (* gev_ULTIMATE.start_main_~a~20 (- 1)) (* gev_ULTIMATE.start_main_~r~20 0)) 0) (>= (+ (* (+ (* gev_ULTIMATE.start_main_~b~20 lambda0) (* gev_ULTIMATE.start_main_~b~21 nu0)) (- 1)) (* (+ (* gev_ULTIMATE.start_main_~c~20 lambda0) (* gev_ULTIMATE.start_main_~c~21 nu0)) 0) (* (+ (* gev_ULTIMATE.start_main_~r~20 lambda0) (* gev_ULTIMATE.start_main_~r~21 nu0)) 0) (* (+ (* gev_ULTIMATE.start_main_~a~20 lambda0) (* gev_ULTIMATE.start_main_~a~21 nu0)) 0) (* (+ (* |gev_ULTIMATE.start_main_#t~nondet30| lambda0) (* |gev_ULTIMATE.start_main_#t~nondet31| nu0)) 0) (* gev_ULTIMATE.start_main_~b~20 0) (* |gev_ULTIMATE.start_main_#t~nondet30| 0) (* gev_ULTIMATE.start_main_~c~20 0) (* gev_ULTIMATE.start_main_~a~20 0) (* gev_ULTIMATE.start_main_~r~20 0)) 0) (>= (+ (* (+ (* gev_ULTIMATE.start_main_~b~20 lambda0) (* gev_ULTIMATE.start_main_~b~21 nu0)) 0) (* (+ (* gev_ULTIMATE.start_main_~c~20 lambda0) (* gev_ULTIMATE.start_main_~c~21 nu0)) 0) (* (+ (* gev_ULTIMATE.start_main_~r~20 lambda0) (* gev_ULTIMATE.start_main_~r~21 nu0)) (- 1)) (* (+ (* gev_ULTIMATE.start_main_~a~20 lambda0) (* gev_ULTIMATE.start_main_~a~21 nu0)) 0) (* (+ (* |gev_ULTIMATE.start_main_#t~nondet30| lambda0) (* |gev_ULTIMATE.start_main_#t~nondet31| nu0)) 0) (* gev_ULTIMATE.start_main_~b~20 0) (* |gev_ULTIMATE.start_main_#t~nondet30| 1) (* gev_ULTIMATE.start_main_~c~20 0) (* gev_ULTIMATE.start_main_~a~20 0) (* gev_ULTIMATE.start_main_~r~20 0)) 0) (>= (+ (* (+ (* gev_ULTIMATE.start_main_~b~20 lambda0) (* gev_ULTIMATE.start_main_~b~21 nu0)) 0) (* (+ (* gev_ULTIMATE.start_main_~c~20 lambda0) (* gev_ULTIMATE.start_main_~c~21 nu0)) 0) (* (+ (* gev_ULTIMATE.start_main_~r~20 lambda0) (* gev_ULTIMATE.start_main_~r~21 nu0)) 0) (* (+ (* gev_ULTIMATE.start_main_~a~20 lambda0) (* gev_ULTIMATE.start_main_~a~21 nu0)) 0) (* (+ (* |gev_ULTIMATE.start_main_#t~nondet30| lambda0) (* |gev_ULTIMATE.start_main_#t~nondet31| nu0)) 0) (* gev_ULTIMATE.start_main_~b~20 1) (* |gev_ULTIMATE.start_main_#t~nondet30| 0) (* gev_ULTIMATE.start_main_~c~20 (- 1)) (* gev_ULTIMATE.start_main_~a~20 0) (* gev_ULTIMATE.start_main_~r~20 0)) 0) (>= (+ (* (+ (* gev_ULTIMATE.start_main_~b~20 lambda0) (* gev_ULTIMATE.start_main_~b~21 nu0)) 0) (* (+ (* gev_ULTIMATE.start_main_~c~20 lambda0) (* gev_ULTIMATE.start_main_~c~21 nu0)) (- 1)) (* (+ (* gev_ULTIMATE.start_main_~r~20 lambda0) (* gev_ULTIMATE.start_main_~r~21 nu0)) 0) (* (+ (* gev_ULTIMATE.start_main_~a~20 lambda0) (* gev_ULTIMATE.start_main_~a~21 nu0)) 1) (* (+ (* |gev_ULTIMATE.start_main_#t~nondet30| lambda0) (* |gev_ULTIMATE.start_main_#t~nondet31| nu0)) 0) (* gev_ULTIMATE.start_main_~b~20 0) (* |gev_ULTIMATE.start_main_#t~nondet30| 0) (* gev_ULTIMATE.start_main_~c~20 0) (* gev_ULTIMATE.start_main_~a~20 0) (* gev_ULTIMATE.start_main_~r~20 0)) 0) (>= (+ (* (+ (* gev_ULTIMATE.start_main_~b~21 lambda1) (* gev_ULTIMATE.start_main_~b~22 nu1)) 0) (* (+ (* gev_ULTIMATE.start_main_~c~21 lambda1) (* gev_ULTIMATE.start_main_~c~22 nu1)) (- 1)) (* (+ (* gev_ULTIMATE.start_main_~r~21 lambda1) (* gev_ULTIMATE.start_main_~r~22 nu1)) 1) (* (+ (* gev_ULTIMATE.start_main_~a~21 lambda1) (* gev_ULTIMATE.start_main_~a~22 nu1)) 0) (* (+ (* |gev_ULTIMATE.start_main_#t~nondet31| lambda1) (* |gev_ULTIMATE.start_main_#t~nondet32| nu1)) 0) (* gev_ULTIMATE.start_main_~b~21 0) (* |gev_ULTIMATE.start_main_#t~nondet31| 0) (* gev_ULTIMATE.start_main_~c~21 1) (* gev_ULTIMATE.start_main_~a~21 0) (* gev_ULTIMATE.start_main_~r~21 0)) 0) (>= (+ (* (+ (* gev_ULTIMATE.start_main_~b~21 lambda1) (* gev_ULTIMATE.start_main_~b~22 nu1)) 0) (* (+ (* gev_ULTIMATE.start_main_~c~21 lambda1) (* gev_ULTIMATE.start_main_~c~22 nu1)) 0) (* (+ (* gev_ULTIMATE.start_main_~r~21 lambda1) (* gev_ULTIMATE.start_main_~r~22 nu1)) 0) (* (+ (* gev_ULTIMATE.start_main_~a~21 lambda1) (* gev_ULTIMATE.start_main_~a~22 nu1)) 0) (* (+ (* |gev_ULTIMATE.start_main_#t~nondet31| lambda1) (* |gev_ULTIMATE.start_main_#t~nondet32| nu1)) 0) (* gev_ULTIMATE.start_main_~b~21 0) (* |gev_ULTIMATE.start_main_#t~nondet31| 0) (* gev_ULTIMATE.start_main_~c~21 (- 1)) (* gev_ULTIMATE.start_main_~a~21 1) (* gev_ULTIMATE.start_main_~r~21 0)) 0) (>= (+ (* (+ (* gev_ULTIMATE.start_main_~b~21 lambda1) (* gev_ULTIMATE.start_main_~b~22 nu1)) 0) (* (+ (* gev_ULTIMATE.start_main_~c~21 lambda1) (* gev_ULTIMATE.start_main_~c~22 nu1)) 1) (* (+ (* gev_ULTIMATE.start_main_~r~21 lambda1) (* gev_ULTIMATE.start_main_~r~22 nu1)) 0) (* (+ (* gev_ULTIMATE.start_main_~a~21 lambda1) (* gev_ULTIMATE.start_main_~a~22 nu1)) (- 1)) (* (+ (* |gev_ULTIMATE.start_main_#t~nondet31| lambda1) (* |gev_ULTIMATE.start_main_#t~nondet32| nu1)) 0) (* gev_ULTIMATE.start_main_~b~21 0) (* |gev_ULTIMATE.start_main_#t~nondet31| 0) (* gev_ULTIMATE.start_main_~c~21 0) (* gev_ULTIMATE.start_main_~a~21 0) (* gev_ULTIMATE.start_main_~r~21 0)) 0) (>= (+ (* (+ (* gev_ULTIMATE.start_main_~b~21 lambda1) (* gev_ULTIMATE.start_main_~b~22 nu1)) 0) (* (+ (* gev_ULTIMATE.start_main_~c~21 lambda1) (* gev_ULTIMATE.start_main_~c~22 nu1)) 0) (* (+ (* gev_ULTIMATE.start_main_~r~21 lambda1) (* gev_ULTIMATE.start_main_~r~22 nu1)) 1) (* (+ (* gev_ULTIMATE.start_main_~a~21 lambda1) (* gev_ULTIMATE.start_main_~a~22 nu1)) 0) (* (+ (* |gev_ULTIMATE.start_main_#t~nondet31| lambda1) (* |gev_ULTIMATE.start_main_#t~nondet32| nu1)) 0) (* gev_ULTIMATE.start_main_~b~21 0) (* |gev_ULTIMATE.start_main_#t~nondet31| (- 1)) (* gev_ULTIMATE.start_main_~c~21 0) (* gev_ULTIMATE.start_main_~a~21 0) (* gev_ULTIMATE.start_main_~r~21 0)) 0) (>= (+ (* (+ (* gev_ULTIMATE.start_main_~b~21 lambda1) (* gev_ULTIMATE.start_main_~b~22 nu1)) 1) (* (+ (* gev_ULTIMATE.start_main_~c~21 lambda1) (* gev_ULTIMATE.start_main_~c~22 nu1)) 0) (* (+ (* gev_ULTIMATE.start_main_~r~21 lambda1) (* gev_ULTIMATE.start_main_~r~22 nu1)) 0) (* (+ (* gev_ULTIMATE.start_main_~a~21 lambda1) (* gev_ULTIMATE.start_main_~a~22 nu1)) 0) (* (+ (* |gev_ULTIMATE.start_main_#t~nondet31| lambda1) (* |gev_ULTIMATE.start_main_#t~nondet32| nu1)) 0) (* gev_ULTIMATE.start_main_~b~21 0) (* |gev_ULTIMATE.start_main_#t~nondet31| 0) (* gev_ULTIMATE.start_main_~c~21 0) (* gev_ULTIMATE.start_main_~a~21 0) (* gev_ULTIMATE.start_main_~r~21 0)) 0) (>= (+ (* (+ (* gev_ULTIMATE.start_main_~b~21 lambda1) (* gev_ULTIMATE.start_main_~b~22 nu1)) 0) (* (+ (* gev_ULTIMATE.start_main_~c~21 lambda1) (* gev_ULTIMATE.start_main_~c~22 nu1)) 1) (* (+ (* gev_ULTIMATE.start_main_~r~21 lambda1) (* gev_ULTIMATE.start_main_~r~22 nu1)) (- 1)) (* (+ (* gev_ULTIMATE.start_main_~a~21 lambda1) (* gev_ULTIMATE.start_main_~a~22 nu1)) 0) (* (+ (* |gev_ULTIMATE.start_main_#t~nondet31| lambda1) (* |gev_ULTIMATE.start_main_#t~nondet32| nu1)) 0) (* gev_ULTIMATE.start_main_~b~21 0) (* |gev_ULTIMATE.start_main_#t~nondet31| 0) (* gev_ULTIMATE.start_main_~c~21 (- 1)) (* gev_ULTIMATE.start_main_~a~21 0) (* gev_ULTIMATE.start_main_~r~21 0)) 0) (>= (+ (* (+ (* gev_ULTIMATE.start_main_~b~21 lambda1) (* gev_ULTIMATE.start_main_~b~22 nu1)) 0) (* (+ (* gev_ULTIMATE.start_main_~c~21 lambda1) (* gev_ULTIMATE.start_main_~c~22 nu1)) 0) (* (+ (* gev_ULTIMATE.start_main_~r~21 lambda1) (* gev_ULTIMATE.start_main_~r~22 nu1)) 0) (* (+ (* gev_ULTIMATE.start_main_~a~21 lambda1) (* gev_ULTIMATE.start_main_~a~22 nu1)) 0) (* (+ (* |gev_ULTIMATE.start_main_#t~nondet31| lambda1) (* |gev_ULTIMATE.start_main_#t~nondet32| nu1)) 0) (* gev_ULTIMATE.start_main_~b~21 0) (* |gev_ULTIMATE.start_main_#t~nondet31| 0) (* gev_ULTIMATE.start_main_~c~21 1) (* gev_ULTIMATE.start_main_~a~21 (- 1)) (* gev_ULTIMATE.start_main_~r~21 0)) 0) (>= (+ (* (+ (* gev_ULTIMATE.start_main_~b~21 lambda1) (* gev_ULTIMATE.start_main_~b~22 nu1)) (- 1)) (* (+ (* gev_ULTIMATE.start_main_~c~21 lambda1) (* gev_ULTIMATE.start_main_~c~22 nu1)) 0) (* (+ (* gev_ULTIMATE.start_main_~r~21 lambda1) (* gev_ULTIMATE.start_main_~r~22 nu1)) 0) (* (+ (* gev_ULTIMATE.start_main_~a~21 lambda1) (* gev_ULTIMATE.start_main_~a~22 nu1)) 0) (* (+ (* |gev_ULTIMATE.start_main_#t~nondet31| lambda1) (* |gev_ULTIMATE.start_main_#t~nondet32| nu1)) 0) (* gev_ULTIMATE.start_main_~b~21 0) (* |gev_ULTIMATE.start_main_#t~nondet31| 0) (* gev_ULTIMATE.start_main_~c~21 0) (* gev_ULTIMATE.start_main_~a~21 0) (* gev_ULTIMATE.start_main_~r~21 0)) 0) (>= (+ (* (+ (* gev_ULTIMATE.start_main_~b~21 lambda1) (* gev_ULTIMATE.start_main_~b~22 nu1)) 0) (* (+ (* gev_ULTIMATE.start_main_~c~21 lambda1) (* gev_ULTIMATE.start_main_~c~22 nu1)) 0) (* (+ (* gev_ULTIMATE.start_main_~r~21 lambda1) (* gev_ULTIMATE.start_main_~r~22 nu1)) (- 1)) (* (+ (* gev_ULTIMATE.start_main_~a~21 lambda1) (* gev_ULTIMATE.start_main_~a~22 nu1)) 0) (* (+ (* |gev_ULTIMATE.start_main_#t~nondet31| lambda1) (* |gev_ULTIMATE.start_main_#t~nondet32| nu1)) 0) (* gev_ULTIMATE.start_main_~b~21 0) (* |gev_ULTIMATE.start_main_#t~nondet31| 1) (* gev_ULTIMATE.start_main_~c~21 0) (* gev_ULTIMATE.start_main_~a~21 0) (* gev_ULTIMATE.start_main_~r~21 0)) 0) (>= (+ (* (+ (* gev_ULTIMATE.start_main_~b~21 lambda1) (* gev_ULTIMATE.start_main_~b~22 nu1)) 0) (* (+ (* gev_ULTIMATE.start_main_~c~21 lambda1) (* gev_ULTIMATE.start_main_~c~22 nu1)) 0) (* (+ (* gev_ULTIMATE.start_main_~r~21 lambda1) (* gev_ULTIMATE.start_main_~r~22 nu1)) 0) (* (+ (* gev_ULTIMATE.start_main_~a~21 lambda1) (* gev_ULTIMATE.start_main_~a~22 nu1)) 0) (* (+ (* |gev_ULTIMATE.start_main_#t~nondet31| lambda1) (* |gev_ULTIMATE.start_main_#t~nondet32| nu1)) 0) (* gev_ULTIMATE.start_main_~b~21 1) (* |gev_ULTIMATE.start_main_#t~nondet31| 0) (* gev_ULTIMATE.start_main_~c~21 (- 1)) (* gev_ULTIMATE.start_main_~a~21 0) (* gev_ULTIMATE.start_main_~r~21 0)) 0) (>= (+ (* (+ (* gev_ULTIMATE.start_main_~b~21 lambda1) (* gev_ULTIMATE.start_main_~b~22 nu1)) 0) (* (+ (* gev_ULTIMATE.start_main_~c~21 lambda1) (* gev_ULTIMATE.start_main_~c~22 nu1)) (- 1)) (* (+ (* gev_ULTIMATE.start_main_~r~21 lambda1) (* gev_ULTIMATE.start_main_~r~22 nu1)) 0) (* (+ (* gev_ULTIMATE.start_main_~a~21 lambda1) (* gev_ULTIMATE.start_main_~a~22 nu1)) 1) (* (+ (* |gev_ULTIMATE.start_main_#t~nondet31| lambda1) (* |gev_ULTIMATE.start_main_#t~nondet32| nu1)) 0) (* gev_ULTIMATE.start_main_~b~21 0) (* |gev_ULTIMATE.start_main_#t~nondet31| 0) (* gev_ULTIMATE.start_main_~c~21 0) (* gev_ULTIMATE.start_main_~a~21 0) (* gev_ULTIMATE.start_main_~r~21 0)) 0) (>= (+ (* (* gev_ULTIMATE.start_main_~b~22 lambda2) 0) (* (* gev_ULTIMATE.start_main_~c~22 lambda2) (- 1)) (* (* gev_ULTIMATE.start_main_~r~22 lambda2) 1) (* (* gev_ULTIMATE.start_main_~a~22 lambda2) 0) (* (* |gev_ULTIMATE.start_main_#t~nondet32| lambda2) 0) (* gev_ULTIMATE.start_main_~b~22 0) (* |gev_ULTIMATE.start_main_#t~nondet32| 0) (* gev_ULTIMATE.start_main_~c~22 1) (* gev_ULTIMATE.start_main_~a~22 0) (* gev_ULTIMATE.start_main_~r~22 0)) 0) (>= (+ (* (* gev_ULTIMATE.start_main_~b~22 lambda2) 0) (* (* gev_ULTIMATE.start_main_~c~22 lambda2) 0) (* (* gev_ULTIMATE.start_main_~r~22 lambda2) 0) (* (* gev_ULTIMATE.start_main_~a~22 lambda2) 0) (* (* |gev_ULTIMATE.start_main_#t~nondet32| lambda2) 0) (* gev_ULTIMATE.start_main_~b~22 0) (* |gev_ULTIMATE.start_main_#t~nondet32| 0) (* gev_ULTIMATE.start_main_~c~22 (- 1)) (* gev_ULTIMATE.start_main_~a~22 1) (* gev_ULTIMATE.start_main_~r~22 0)) 0) (>= (+ (* (* gev_ULTIMATE.start_main_~b~22 lambda2) 0) (* (* gev_ULTIMATE.start_main_~c~22 lambda2) 1) (* (* gev_ULTIMATE.start_main_~r~22 lambda2) 0) (* (* gev_ULTIMATE.start_main_~a~22 lambda2) (- 1)) (* (* |gev_ULTIMATE.start_main_#t~nondet32| lambda2) 0) (* gev_ULTIMATE.start_main_~b~22 0) (* |gev_ULTIMATE.start_main_#t~nondet32| 0) (* gev_ULTIMATE.start_main_~c~22 0) (* gev_ULTIMATE.start_main_~a~22 0) (* gev_ULTIMATE.start_main_~r~22 0)) 0) (>= (+ (* (* gev_ULTIMATE.start_main_~b~22 lambda2) 0) (* (* gev_ULTIMATE.start_main_~c~22 lambda2) 0) (* (* gev_ULTIMATE.start_main_~r~22 lambda2) 1) (* (* gev_ULTIMATE.start_main_~a~22 lambda2) 0) (* (* |gev_ULTIMATE.start_main_#t~nondet32| lambda2) 0) (* gev_ULTIMATE.start_main_~b~22 0) (* |gev_ULTIMATE.start_main_#t~nondet32| (- 1)) (* gev_ULTIMATE.start_main_~c~22 0) (* gev_ULTIMATE.start_main_~a~22 0) (* gev_ULTIMATE.start_main_~r~22 0)) 0) (>= (+ (* (* gev_ULTIMATE.start_main_~b~22 lambda2) 1) (* (* gev_ULTIMATE.start_main_~c~22 lambda2) 0) (* (* gev_ULTIMATE.start_main_~r~22 lambda2) 0) (* (* gev_ULTIMATE.start_main_~a~22 lambda2) 0) (* (* |gev_ULTIMATE.start_main_#t~nondet32| lambda2) 0) (* gev_ULTIMATE.start_main_~b~22 0) (* |gev_ULTIMATE.start_main_#t~nondet32| 0) (* gev_ULTIMATE.start_main_~c~22 0) (* gev_ULTIMATE.start_main_~a~22 0) (* gev_ULTIMATE.start_main_~r~22 0)) 0) (>= (+ (* (* gev_ULTIMATE.start_main_~b~22 lambda2) 0) (* (* gev_ULTIMATE.start_main_~c~22 lambda2) 1) (* (* gev_ULTIMATE.start_main_~r~22 lambda2) (- 1)) (* (* gev_ULTIMATE.start_main_~a~22 lambda2) 0) (* (* |gev_ULTIMATE.start_main_#t~nondet32| lambda2) 0) (* gev_ULTIMATE.start_main_~b~22 0) (* |gev_ULTIMATE.start_main_#t~nondet32| 0) (* gev_ULTIMATE.start_main_~c~22 (- 1)) (* gev_ULTIMATE.start_main_~a~22 0) (* gev_ULTIMATE.start_main_~r~22 0)) 0) (>= (+ (* (* gev_ULTIMATE.start_main_~b~22 lambda2) 0) (* (* gev_ULTIMATE.start_main_~c~22 lambda2) 0) (* (* gev_ULTIMATE.start_main_~r~22 lambda2) 0) (* (* gev_ULTIMATE.start_main_~a~22 lambda2) 0) (* (* |gev_ULTIMATE.start_main_#t~nondet32| lambda2) 0) (* gev_ULTIMATE.start_main_~b~22 0) (* |gev_ULTIMATE.start_main_#t~nondet32| 0) (* gev_ULTIMATE.start_main_~c~22 1) (* gev_ULTIMATE.start_main_~a~22 (- 1)) (* gev_ULTIMATE.start_main_~r~22 0)) 0) (>= (+ (* (* gev_ULTIMATE.start_main_~b~22 lambda2) (- 1)) (* (* gev_ULTIMATE.start_main_~c~22 lambda2) 0) (* (* gev_ULTIMATE.start_main_~r~22 lambda2) 0) (* (* gev_ULTIMATE.start_main_~a~22 lambda2) 0) (* (* |gev_ULTIMATE.start_main_#t~nondet32| lambda2) 0) (* gev_ULTIMATE.start_main_~b~22 0) (* |gev_ULTIMATE.start_main_#t~nondet32| 0) (* gev_ULTIMATE.start_main_~c~22 0) (* gev_ULTIMATE.start_main_~a~22 0) (* gev_ULTIMATE.start_main_~r~22 0)) 0) (>= (+ (* (* gev_ULTIMATE.start_main_~b~22 lambda2) 0) (* (* gev_ULTIMATE.start_main_~c~22 lambda2) 0) (* (* gev_ULTIMATE.start_main_~r~22 lambda2) (- 1)) (* (* gev_ULTIMATE.start_main_~a~22 lambda2) 0) (* (* |gev_ULTIMATE.start_main_#t~nondet32| lambda2) 0) (* gev_ULTIMATE.start_main_~b~22 0) (* |gev_ULTIMATE.start_main_#t~nondet32| 1) (* gev_ULTIMATE.start_main_~c~22 0) (* gev_ULTIMATE.start_main_~a~22 0) (* gev_ULTIMATE.start_main_~r~22 0)) 0) (>= (+ (* (* gev_ULTIMATE.start_main_~b~22 lambda2) 0) (* (* gev_ULTIMATE.start_main_~c~22 lambda2) 0) (* (* gev_ULTIMATE.start_main_~r~22 lambda2) 0) (* (* gev_ULTIMATE.start_main_~a~22 lambda2) 0) (* (* |gev_ULTIMATE.start_main_#t~nondet32| lambda2) 0) (* gev_ULTIMATE.start_main_~b~22 1) (* |gev_ULTIMATE.start_main_#t~nondet32| 0) (* gev_ULTIMATE.start_main_~c~22 (- 1)) (* gev_ULTIMATE.start_main_~a~22 0) (* gev_ULTIMATE.start_main_~r~22 0)) 0) (>= (+ (* (* gev_ULTIMATE.start_main_~b~22 lambda2) 0) (* (* gev_ULTIMATE.start_main_~c~22 lambda2) (- 1)) (* (* gev_ULTIMATE.start_main_~r~22 lambda2) 0) (* (* gev_ULTIMATE.start_main_~a~22 lambda2) 1) (* (* |gev_ULTIMATE.start_main_#t~nondet32| lambda2) 0) (* gev_ULTIMATE.start_main_~b~22 0) (* |gev_ULTIMATE.start_main_#t~nondet32| 0) (* gev_ULTIMATE.start_main_~c~22 0) (* gev_ULTIMATE.start_main_~a~22 0) (* gev_ULTIMATE.start_main_~r~22 0)) 0) (>= (+ (* (+ honda_ULTIMATE.start_main_~b~2 gev_ULTIMATE.start_main_~b~20 gev_ULTIMATE.start_main_~b~21 gev_ULTIMATE.start_main_~b~22) 0) (* (+ honda_ULTIMATE.start_main_~c~2 gev_ULTIMATE.start_main_~c~20 gev_ULTIMATE.start_main_~c~21 gev_ULTIMATE.start_main_~c~22) (- 1)) (* (+ honda_ULTIMATE.start_main_~r~2 gev_ULTIMATE.start_main_~r~20 gev_ULTIMATE.start_main_~r~21 gev_ULTIMATE.start_main_~r~22) 1) (* (+ honda_ULTIMATE.start_main_~a~2 gev_ULTIMATE.start_main_~a~20 gev_ULTIMATE.start_main_~a~21 gev_ULTIMATE.start_main_~a~22) 0) (* (+ |honda_ULTIMATE.start_main_#t~nondet3| |gev_ULTIMATE.start_main_#t~nondet30| |gev_ULTIMATE.start_main_#t~nondet31| |gev_ULTIMATE.start_main_#t~nondet32|) 0) (* honda_ULTIMATE.start_main_~b~2 0) (* |honda_ULTIMATE.start_main_#t~nondet3| 0) (* honda_ULTIMATE.start_main_~c~2 1) (* honda_ULTIMATE.start_main_~a~2 0) (* honda_ULTIMATE.start_main_~r~2 0) 1) 0) (>= (+ (* (+ honda_ULTIMATE.start_main_~b~2 gev_ULTIMATE.start_main_~b~20 gev_ULTIMATE.start_main_~b~21 gev_ULTIMATE.start_main_~b~22) 0) (* (+ honda_ULTIMATE.start_main_~c~2 gev_ULTIMATE.start_main_~c~20 gev_ULTIMATE.start_main_~c~21 gev_ULTIMATE.start_main_~c~22) 0) (* (+ honda_ULTIMATE.start_main_~r~2 gev_ULTIMATE.start_main_~r~20 gev_ULTIMATE.start_main_~r~21 gev_ULTIMATE.start_main_~r~22) 0) (* (+ honda_ULTIMATE.start_main_~a~2 gev_ULTIMATE.start_main_~a~20 gev_ULTIMATE.start_main_~a~21 gev_ULTIMATE.start_main_~a~22) 0) (* (+ |honda_ULTIMATE.start_main_#t~nondet3| |gev_ULTIMATE.start_main_#t~nondet30| |gev_ULTIMATE.start_main_#t~nondet31| |gev_ULTIMATE.start_main_#t~nondet32|) 0) (* honda_ULTIMATE.start_main_~b~2 0) (* |honda_ULTIMATE.start_main_#t~nondet3| 0) (* honda_ULTIMATE.start_main_~c~2 (- 1)) (* honda_ULTIMATE.start_main_~a~2 1) (* honda_ULTIMATE.start_main_~r~2 0) 0) 0) (>= (+ (* (+ honda_ULTIMATE.start_main_~b~2 gev_ULTIMATE.start_main_~b~20 gev_ULTIMATE.start_main_~b~21 gev_ULTIMATE.start_main_~b~22) 0) (* (+ honda_ULTIMATE.start_main_~c~2 gev_ULTIMATE.start_main_~c~20 gev_ULTIMATE.start_main_~c~21 gev_ULTIMATE.start_main_~c~22) 1) (* (+ honda_ULTIMATE.start_main_~r~2 gev_ULTIMATE.start_main_~r~20 gev_ULTIMATE.start_main_~r~21 gev_ULTIMATE.start_main_~r~22) 0) (* (+ honda_ULTIMATE.start_main_~a~2 gev_ULTIMATE.start_main_~a~20 gev_ULTIMATE.start_main_~a~21 gev_ULTIMATE.start_main_~a~22) (- 1)) (* (+ |honda_ULTIMATE.start_main_#t~nondet3| |gev_ULTIMATE.start_main_#t~nondet30| |gev_ULTIMATE.start_main_#t~nondet31| |gev_ULTIMATE.start_main_#t~nondet32|) 0) (* honda_ULTIMATE.start_main_~b~2 0) (* |honda_ULTIMATE.start_main_#t~nondet3| 0) (* honda_ULTIMATE.start_main_~c~2 0) (* honda_ULTIMATE.start_main_~a~2 0) (* honda_ULTIMATE.start_main_~r~2 0) 0) 0) (>= (+ (* (+ honda_ULTIMATE.start_main_~b~2 gev_ULTIMATE.start_main_~b~20 gev_ULTIMATE.start_main_~b~21 gev_ULTIMATE.start_main_~b~22) 0) (* (+ honda_ULTIMATE.start_main_~c~2 gev_ULTIMATE.start_main_~c~20 gev_ULTIMATE.start_main_~c~21 gev_ULTIMATE.start_main_~c~22) 0) (* (+ honda_ULTIMATE.start_main_~r~2 gev_ULTIMATE.start_main_~r~20 gev_ULTIMATE.start_main_~r~21 gev_ULTIMATE.start_main_~r~22) 1) (* (+ honda_ULTIMATE.start_main_~a~2 gev_ULTIMATE.start_main_~a~20 gev_ULTIMATE.start_main_~a~21 gev_ULTIMATE.start_main_~a~22) 0) (* (+ |honda_ULTIMATE.start_main_#t~nondet3| |gev_ULTIMATE.start_main_#t~nondet30| |gev_ULTIMATE.start_main_#t~nondet31| |gev_ULTIMATE.start_main_#t~nondet32|) 0) (* honda_ULTIMATE.start_main_~b~2 0) (* |honda_ULTIMATE.start_main_#t~nondet3| (- 1)) (* honda_ULTIMATE.start_main_~c~2 0) (* honda_ULTIMATE.start_main_~a~2 0) (* honda_ULTIMATE.start_main_~r~2 0) 0) 0) (>= (+ (* (+ honda_ULTIMATE.start_main_~b~2 gev_ULTIMATE.start_main_~b~20 gev_ULTIMATE.start_main_~b~21 gev_ULTIMATE.start_main_~b~22) 1) (* (+ honda_ULTIMATE.start_main_~c~2 gev_ULTIMATE.start_main_~c~20 gev_ULTIMATE.start_main_~c~21 gev_ULTIMATE.start_main_~c~22) 0) (* (+ honda_ULTIMATE.start_main_~r~2 gev_ULTIMATE.start_main_~r~20 gev_ULTIMATE.start_main_~r~21 gev_ULTIMATE.start_main_~r~22) 0) (* (+ honda_ULTIMATE.start_main_~a~2 gev_ULTIMATE.start_main_~a~20 gev_ULTIMATE.start_main_~a~21 gev_ULTIMATE.start_main_~a~22) 0) (* (+ |honda_ULTIMATE.start_main_#t~nondet3| |gev_ULTIMATE.start_main_#t~nondet30| |gev_ULTIMATE.start_main_#t~nondet31| |gev_ULTIMATE.start_main_#t~nondet32|) 0) (* honda_ULTIMATE.start_main_~b~2 0) (* |honda_ULTIMATE.start_main_#t~nondet3| 0) (* honda_ULTIMATE.start_main_~c~2 0) (* honda_ULTIMATE.start_main_~a~2 0) (* honda_ULTIMATE.start_main_~r~2 0) (- 10)) 0) (>= (+ (* (+ honda_ULTIMATE.start_main_~b~2 gev_ULTIMATE.start_main_~b~20 gev_ULTIMATE.start_main_~b~21 gev_ULTIMATE.start_main_~b~22) 0) (* (+ honda_ULTIMATE.start_main_~c~2 gev_ULTIMATE.start_main_~c~20 gev_ULTIMATE.start_main_~c~21 gev_ULTIMATE.start_main_~c~22) 1) (* (+ honda_ULTIMATE.start_main_~r~2 gev_ULTIMATE.start_main_~r~20 gev_ULTIMATE.start_main_~r~21 gev_ULTIMATE.start_main_~r~22) (- 1)) (* (+ honda_ULTIMATE.start_main_~a~2 gev_ULTIMATE.start_main_~a~20 gev_ULTIMATE.start_main_~a~21 gev_ULTIMATE.start_main_~a~22) 0) (* (+ |honda_ULTIMATE.start_main_#t~nondet3| |gev_ULTIMATE.start_main_#t~nondet30| |gev_ULTIMATE.start_main_#t~nondet31| |gev_ULTIMATE.start_main_#t~nondet32|) 0) (* honda_ULTIMATE.start_main_~b~2 0) (* |honda_ULTIMATE.start_main_#t~nondet3| 0) (* honda_ULTIMATE.start_main_~c~2 (- 1)) (* honda_ULTIMATE.start_main_~a~2 0) (* honda_ULTIMATE.start_main_~r~2 0) (- 1)) 0) (>= (+ (* (+ honda_ULTIMATE.start_main_~b~2 gev_ULTIMATE.start_main_~b~20 gev_ULTIMATE.start_main_~b~21 gev_ULTIMATE.start_main_~b~22) 0) (* (+ honda_ULTIMATE.start_main_~c~2 gev_ULTIMATE.start_main_~c~20 gev_ULTIMATE.start_main_~c~21 gev_ULTIMATE.start_main_~c~22) 0) (* (+ honda_ULTIMATE.start_main_~r~2 gev_ULTIMATE.start_main_~r~20 gev_ULTIMATE.start_main_~r~21 gev_ULTIMATE.start_main_~r~22) 0) (* (+ honda_ULTIMATE.start_main_~a~2 gev_ULTIMATE.start_main_~a~20 gev_ULTIMATE.start_main_~a~21 gev_ULTIMATE.start_main_~a~22) 0) (* (+ |honda_ULTIMATE.start_main_#t~nondet3| |gev_ULTIMATE.start_main_#t~nondet30| |gev_ULTIMATE.start_main_#t~nondet31| |gev_ULTIMATE.start_main_#t~nondet32|) 0) (* honda_ULTIMATE.start_main_~b~2 0) (* |honda_ULTIMATE.start_main_#t~nondet3| 0) (* honda_ULTIMATE.start_main_~c~2 1) (* honda_ULTIMATE.start_main_~a~2 (- 1)) (* honda_ULTIMATE.start_main_~r~2 0) 0) 0) (>= (+ (* (+ honda_ULTIMATE.start_main_~b~2 gev_ULTIMATE.start_main_~b~20 gev_ULTIMATE.start_main_~b~21 gev_ULTIMATE.start_main_~b~22) (- 1)) (* (+ honda_ULTIMATE.start_main_~c~2 gev_ULTIMATE.start_main_~c~20 gev_ULTIMATE.start_main_~c~21 gev_ULTIMATE.start_main_~c~22) 0) (* (+ honda_ULTIMATE.start_main_~r~2 gev_ULTIMATE.start_main_~r~20 gev_ULTIMATE.start_main_~r~21 gev_ULTIMATE.start_main_~r~22) 0) (* (+ honda_ULTIMATE.start_main_~a~2 gev_ULTIMATE.start_main_~a~20 gev_ULTIMATE.start_main_~a~21 gev_ULTIMATE.start_main_~a~22) 0) (* (+ |honda_ULTIMATE.start_main_#t~nondet3| |gev_ULTIMATE.start_main_#t~nondet30| |gev_ULTIMATE.start_main_#t~nondet31| |gev_ULTIMATE.start_main_#t~nondet32|) 0) (* honda_ULTIMATE.start_main_~b~2 0) (* |honda_ULTIMATE.start_main_#t~nondet3| 0) (* honda_ULTIMATE.start_main_~c~2 0) (* honda_ULTIMATE.start_main_~a~2 0) (* honda_ULTIMATE.start_main_~r~2 0) 10) 0) (>= (+ (* (+ honda_ULTIMATE.start_main_~b~2 gev_ULTIMATE.start_main_~b~20 gev_ULTIMATE.start_main_~b~21 gev_ULTIMATE.start_main_~b~22) 0) (* (+ honda_ULTIMATE.start_main_~c~2 gev_ULTIMATE.start_main_~c~20 gev_ULTIMATE.start_main_~c~21 gev_ULTIMATE.start_main_~c~22) 0) (* (+ honda_ULTIMATE.start_main_~r~2 gev_ULTIMATE.start_main_~r~20 gev_ULTIMATE.start_main_~r~21 gev_ULTIMATE.start_main_~r~22) (- 1)) (* (+ honda_ULTIMATE.start_main_~a~2 gev_ULTIMATE.start_main_~a~20 gev_ULTIMATE.start_main_~a~21 gev_ULTIMATE.start_main_~a~22) 0) (* (+ |honda_ULTIMATE.start_main_#t~nondet3| |gev_ULTIMATE.start_main_#t~nondet30| |gev_ULTIMATE.start_main_#t~nondet31| |gev_ULTIMATE.start_main_#t~nondet32|) 0) (* honda_ULTIMATE.start_main_~b~2 0) (* |honda_ULTIMATE.start_main_#t~nondet3| 1) (* honda_ULTIMATE.start_main_~c~2 0) (* honda_ULTIMATE.start_main_~a~2 0) (* honda_ULTIMATE.start_main_~r~2 0) 0) 0) (>= (+ (* (+ honda_ULTIMATE.start_main_~b~2 gev_ULTIMATE.start_main_~b~20 gev_ULTIMATE.start_main_~b~21 gev_ULTIMATE.start_main_~b~22) 0) (* (+ honda_ULTIMATE.start_main_~c~2 gev_ULTIMATE.start_main_~c~20 gev_ULTIMATE.start_main_~c~21 gev_ULTIMATE.start_main_~c~22) 0) (* (+ honda_ULTIMATE.start_main_~r~2 gev_ULTIMATE.start_main_~r~20 gev_ULTIMATE.start_main_~r~21 gev_ULTIMATE.start_main_~r~22) 0) (* (+ honda_ULTIMATE.start_main_~a~2 gev_ULTIMATE.start_main_~a~20 gev_ULTIMATE.start_main_~a~21 gev_ULTIMATE.start_main_~a~22) 0) (* (+ |honda_ULTIMATE.start_main_#t~nondet3| |gev_ULTIMATE.start_main_#t~nondet30| |gev_ULTIMATE.start_main_#t~nondet31| |gev_ULTIMATE.start_main_#t~nondet32|) 0) (* honda_ULTIMATE.start_main_~b~2 1) (* |honda_ULTIMATE.start_main_#t~nondet3| 0) (* honda_ULTIMATE.start_main_~c~2 (- 1)) (* honda_ULTIMATE.start_main_~a~2 0) (* honda_ULTIMATE.start_main_~r~2 0) (- 1)) 0) (>= (+ (* (+ honda_ULTIMATE.start_main_~b~2 gev_ULTIMATE.start_main_~b~20 gev_ULTIMATE.start_main_~b~21 gev_ULTIMATE.start_main_~b~22) 0) (* (+ honda_ULTIMATE.start_main_~c~2 gev_ULTIMATE.start_main_~c~20 gev_ULTIMATE.start_main_~c~21 gev_ULTIMATE.start_main_~c~22) (- 1)) (* (+ honda_ULTIMATE.start_main_~r~2 gev_ULTIMATE.start_main_~r~20 gev_ULTIMATE.start_main_~r~21 gev_ULTIMATE.start_main_~r~22) 0) (* (+ honda_ULTIMATE.start_main_~a~2 gev_ULTIMATE.start_main_~a~20 gev_ULTIMATE.start_main_~a~21 gev_ULTIMATE.start_main_~a~22) 1) (* (+ |honda_ULTIMATE.start_main_#t~nondet3| |gev_ULTIMATE.start_main_#t~nondet30| |gev_ULTIMATE.start_main_#t~nondet31| |gev_ULTIMATE.start_main_#t~nondet32|) 0) (* honda_ULTIMATE.start_main_~b~2 0) (* |honda_ULTIMATE.start_main_#t~nondet3| 0) (* honda_ULTIMATE.start_main_~c~2 0) (* honda_ULTIMATE.start_main_~a~2 0) (* honda_ULTIMATE.start_main_~r~2 0) 0) 0)) (and (or (= nu0 0) (= nu0 1)) (or (= nu1 0) (= nu1 1)) (>= lambda0 0) (>= lambda1 0) (>= lambda2 0))))
(check-sat)
(exit)
