(set-logic QF_NIA)
(set-info
  :source |
SMT script generated by Ultimate LassoRanker [1].
Ultimate LassoRanker is a tool that analyzes termination and nontermination of 
lasso-shaped programs. This script contains the SMT commands that Ultimate 
LassoRanker used while checking if a lasso-shaped program has a geometric 
nontermination argument [2].

This SMT script belongs to a set of SMT scripts that was generated by applying
Ultimate Buchi Automizer [3,4] to the benchmarks from the SV-COMP 2015 [5,6] 
which are available at [7]. Ultimate Buchi Automizer takes omega-traces
(lasso-shaped programs) and uses LassoRanker in order to check if the 
lasso-shaped program is terminating.

2015-04-30, Matthias Heizmann (heizmann@informatik.uni-freiburg.de)


[1] https://ultimate.informatik.uni-freiburg.de/LassoRanker/
[2] Jan Leike, Matthias Heizmann:
Geometric Series as Nontermination Arguments for Linear Lasso Programs. 
CoRR abs/1405.4413 (2014)
http://arxiv.org/abs/1405.4413
[3] http://ultimate.informatik.uni-freiburg.de/BuchiAutomizer/
[4] Matthias Heizmann, Jochen Hoenicke, Andreas Podelski: Software Model 
Checking for People Who Love Automata. CAV 2013:36-52
[5] http://sv-comp.sosy-lab.org/2015/
[6] Dirk Beyer: Software Verification and Verifiable Witnesses - (Report on 
SV-COMP 2015). TACAS 2015: 401-416
[7] https://svn.sosy-lab.org/software/sv-benchmarks/tags/svcomp15/
|)
(set-info :smt-lib-version 2.0)
(set-info :category "industrial")
(set-info :status unsat)
(declare-fun |init_main_#t~malloc2.base| () Int)
(declare-fun |honda_main_#t~malloc2.base| () Int)
(declare-fun |ray_main_#t~malloc2.base| () Int)
(declare-fun |init_main_#t~malloc0.base| () Int)
(declare-fun |honda_main_#t~malloc0.base| () Int)
(declare-fun |ray_main_#t~malloc0.base| () Int)
(declare-fun |init_(ite main_#t~short13 1 0)| () Int)
(declare-fun |honda_(ite main_#t~short13 1 0)| () Int)
(declare-fun |ray_(ite main_#t~short13 1 0)| () Int)
(declare-fun |init_(ite (select #valid 0) 1 0)| () Int)
(declare-fun |honda_(ite (select #valid 0) 1 0)| () Int)
(declare-fun |ray_(ite (select #valid 0) 1 0)| () Int)
(declare-fun |init_main_#t~mem15| () Int)
(declare-fun |honda_main_#t~mem15| () Int)
(declare-fun |ray_main_#t~mem15| () Int)
(declare-fun |init_main_#t~malloc1.offset| () Int)
(declare-fun |honda_main_#t~malloc1.offset| () Int)
(declare-fun |ray_main_#t~malloc1.offset| () Int)
(declare-fun |init_main_#t~nondet7| () Int)
(declare-fun |honda_main_#t~nondet7| () Int)
(declare-fun |ray_main_#t~nondet7| () Int)
(declare-fun |init_main_#t~mem12| () Int)
(declare-fun |honda_main_#t~mem12| () Int)
(declare-fun |ray_main_#t~mem12| () Int)
(declare-fun |init_main_#t~malloc1.base| () Int)
(declare-fun |honda_main_#t~malloc1.base| () Int)
(declare-fun |ray_main_#t~malloc1.base| () Int)
(declare-fun |init_main_#t~nondet3| () Int)
(declare-fun |honda_main_#t~nondet3| () Int)
(declare-fun |ray_main_#t~nondet3| () Int)
(declare-fun init_main_~y~2.offset () Int)
(declare-fun honda_main_~y~2.offset () Int)
(declare-fun ray_main_~y~2.offset () Int)
(declare-fun |init_main_#t~mem10| () Int)
(declare-fun |honda_main_#t~mem10| () Int)
(declare-fun |ray_main_#t~mem10| () Int)
(declare-fun |init_main_#t~nondet24| () Int)
(declare-fun |honda_main_#t~nondet24| () Int)
(declare-fun |ray_main_#t~nondet24| () Int)
(declare-fun |init_main_#t~mem20| () Int)
(declare-fun |honda_main_#t~mem20| () Int)
(declare-fun |ray_main_#t~mem20| () Int)
(declare-fun |init_(ite main_#t~short11 1 0)| () Int)
(declare-fun |honda_(ite main_#t~short11 1 0)| () Int)
(declare-fun |ray_(ite main_#t~short11 1 0)| () Int)
(declare-fun init_main_~z~2.base () Int)
(declare-fun honda_main_~z~2.base () Int)
(declare-fun ray_main_~z~2.base () Int)
(declare-fun |init_main_#t~mem26| () Int)
(declare-fun |honda_main_#t~mem26| () Int)
(declare-fun |ray_main_#t~mem26| () Int)
(declare-fun init_main_~x~2.base () Int)
(declare-fun honda_main_~x~2.base () Int)
(declare-fun ray_main_~x~2.base () Int)
(declare-fun |init_main_#t~malloc2.offset| () Int)
(declare-fun |honda_main_#t~malloc2.offset| () Int)
(declare-fun |ray_main_#t~malloc2.offset| () Int)
(declare-fun |init_main_#t~mem17| () Int)
(declare-fun |honda_main_#t~mem17| () Int)
(declare-fun |ray_main_#t~mem17| () Int)
(declare-fun |init_main_#t~mem9| () Int)
(declare-fun |honda_main_#t~mem9| () Int)
(declare-fun |ray_main_#t~mem9| () Int)
(declare-fun |init_main_#t~mem14| () Int)
(declare-fun |honda_main_#t~mem14| () Int)
(declare-fun |ray_main_#t~mem14| () Int)
(declare-fun init_main_~z~2.offset () Int)
(declare-fun honda_main_~z~2.offset () Int)
(declare-fun ray_main_~z~2.offset () Int)
(declare-fun |init_#NULL.offset| () Int)
(declare-fun |honda_#NULL.offset| () Int)
(declare-fun |ray_#NULL.offset| () Int)
(declare-fun |init_main_#t~malloc0.offset| () Int)
(declare-fun |honda_main_#t~malloc0.offset| () Int)
(declare-fun |ray_main_#t~malloc0.offset| () Int)
(declare-fun init_main_~y~2.base () Int)
(declare-fun honda_main_~y~2.base () Int)
(declare-fun ray_main_~y~2.base () Int)
(declare-fun |init_main_#t~mem22| () Int)
(declare-fun |honda_main_#t~mem22| () Int)
(declare-fun |ray_main_#t~mem22| () Int)
(declare-fun |init_main_#t~nondet5| () Int)
(declare-fun |honda_main_#t~nondet5| () Int)
(declare-fun |ray_main_#t~nondet5| () Int)
(declare-fun |init_main_#t~nondet18| () Int)
(declare-fun |honda_main_#t~nondet18| () Int)
(declare-fun |ray_main_#t~nondet18| () Int)
(declare-fun init_main_~x~2.offset () Int)
(declare-fun honda_main_~x~2.offset () Int)
(declare-fun ray_main_~x~2.offset () Int)
(declare-fun |init_#NULL.base| () Int)
(declare-fun |honda_#NULL.base| () Int)
(declare-fun |ray_#NULL.base| () Int)
(declare-fun
  |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
  () Int)
(declare-fun
  |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)| ()
  Int)
(declare-fun |honda_(select old(#length) main_~z~2.base)| () Int)
(declare-fun |ray_(select old(#length) main_~z~2.base)| () Int)
(declare-fun |honda_(ite (select #valid main_~z~2.base) 1 0)| () Int)
(declare-fun |ray_(ite (select #valid main_~z~2.base) 1 0)| () Int)
(declare-fun |honda_(ite (select old(#valid) 0) 1 0)| () Int)
(declare-fun |ray_(ite (select old(#valid) 0) 1 0)| () Int)
(declare-fun |honda_(ite (select #valid main_~y~2.base) 1 0)| () Int)
(declare-fun |ray_(ite (select #valid main_~y~2.base) 1 0)| () Int)
(declare-fun |honda_(select #length main_~y~2.base)| () Int)
(declare-fun |ray_(select #length main_~y~2.base)| () Int)
(declare-fun |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| () Int)
(declare-fun |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| () Int)
(declare-fun |honda_(select old(#length) main_~y~2.base)| () Int)
(declare-fun |ray_(select old(#length) main_~y~2.base)| () Int)
(declare-fun
  |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| ()
  Int)
(declare-fun
  |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| () Int)
(declare-fun |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| () Int)
(declare-fun |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| () Int)
(declare-fun |honda_(select #length main_~z~2.base)| () Int)
(declare-fun |ray_(select #length main_~z~2.base)| () Int)
(declare-fun
  |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
  () Int)
(declare-fun
  |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)| ()
  Int)
(declare-fun
  |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
  () Int)
(declare-fun
  |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)| ()
  Int)
(declare-fun
  |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| ()
  Int)
(declare-fun
  |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| () Int)
(declare-fun |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| () Int)
(declare-fun |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| () Int)
(declare-fun |honda_(ite (select #valid main_~x~2.base) 1 0)| () Int)
(declare-fun |ray_(ite (select #valid main_~x~2.base) 1 0)| () Int)
(declare-fun |honda_(select old(#length) main_~x~2.base)| () Int)
(declare-fun |ray_(select old(#length) main_~x~2.base)| () Int)
(declare-fun
  |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| ()
  Int)
(declare-fun
  |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| () Int)
(declare-fun |honda_(select #length main_~x~2.base)| () Int)
(declare-fun |ray_(select #length main_~x~2.base)| () Int)
(declare-fun lambda () Int)
(declare-fun aux_288 () Int)
(declare-fun aux_290 () Int)
(declare-fun aux_291 () Int)
(declare-fun aux_292 () Int)
(declare-fun aux_295 () Int)
(declare-fun aux_297 () Int)
(declare-fun aux_298 () Int)
(declare-fun aux_299 () Int)
(declare-fun aux_302 () Int)
(declare-fun aux_304 () Int)
(declare-fun aux_305 () Int)
(declare-fun aux_306 () Int)
(declare-fun aux_309 () Int)
(declare-fun aux_311 () Int)
(declare-fun aux_312 () Int)
(declare-fun aux_313 () Int)
(declare-fun aux_316 () Int)
(declare-fun aux_318 () Int)
(declare-fun aux_319 () Int)
(declare-fun aux_320 () Int)
(declare-fun aux_323 () Int)
(declare-fun aux_325 () Int)
(declare-fun aux_326 () Int)
(declare-fun aux_327 () Int)
(declare-fun aux_330 () Int)
(declare-fun aux_332 () Int)
(declare-fun aux_333 () Int)
(declare-fun aux_334 () Int)
(declare-fun aux_337 () Int)
(declare-fun aux_339 () Int)
(declare-fun aux_340 () Int)
(declare-fun aux_341 () Int)
(declare-fun aux_344 () Int)
(declare-fun aux_346 () Int)
(declare-fun aux_347 () Int)
(declare-fun aux_348 () Int)
(declare-fun aux_351 () Int)
(declare-fun aux_353 () Int)
(declare-fun aux_354 () Int)
(declare-fun aux_355 () Int)
(declare-fun aux_358 () Int)
(declare-fun aux_360 () Int)
(declare-fun aux_361 () Int)
(declare-fun aux_362 () Int)
(declare-fun aux_365 () Int)
(declare-fun aux_367 () Int)
(declare-fun aux_368 () Int)
(declare-fun aux_369 () Int)
(declare-fun aux_372 () Int)
(declare-fun aux_374 () Int)
(declare-fun aux_375 () Int)
(declare-fun aux_376 () Int)
(declare-fun aux_379 () Int)
(declare-fun aux_381 () Int)
(declare-fun aux_382 () Int)
(declare-fun aux_383 () Int)
(declare-fun aux_386 () Int)
(declare-fun aux_388 () Int)
(declare-fun aux_389 () Int)
(declare-fun aux_390 () Int)
(declare-fun aux_393 () Int)
(declare-fun aux_395 () Int)
(declare-fun aux_396 () Int)
(declare-fun aux_397 () Int)
(declare-fun aux_400 () Int)
(declare-fun aux_402 () Int)
(declare-fun aux_403 () Int)
(declare-fun aux_404 () Int)
(declare-fun aux_407 () Int)
(declare-fun aux_409 () Int)
(declare-fun aux_410 () Int)
(declare-fun aux_411 () Int)
(declare-fun aux_414 () Int)
(declare-fun aux_416 () Int)
(declare-fun aux_417 () Int)
(declare-fun aux_418 () Int)
(declare-fun aux_421 () Int)
(declare-fun aux_423 () Int)
(declare-fun aux_424 () Int)
(declare-fun aux_425 () Int)
(declare-fun aux_428 () Int)
(declare-fun aux_430 () Int)
(declare-fun aux_431 () Int)
(declare-fun aux_432 () Int)
(declare-fun aux_435 () Int)
(declare-fun aux_437 () Int)
(declare-fun aux_438 () Int)
(declare-fun aux_439 () Int)
(declare-fun aux_442 () Int)
(declare-fun aux_444 () Int)
(declare-fun aux_445 () Int)
(declare-fun aux_446 () Int)
(declare-fun aux_449 () Int)
(declare-fun aux_451 () Int)
(declare-fun aux_452 () Int)
(declare-fun aux_453 () Int)
(assert
 (and
 (or
 (and (= |init_main_#t~nondet24| |honda_main_#t~nondet24|)
 (= |init_main_#t~mem26| |honda_main_#t~mem26|)
 (= |init_main_#t~mem22| |honda_main_#t~mem22|)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base (- 1)) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_288 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 1)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_288 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 1) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_290 (- 1)) 
 (* aux_291 1) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_292 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_290 1) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 1) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 1)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_292 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| (- 1))
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base (- 1)) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 1) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1))
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_main_#t~nondet24| |honda_main_#t~nondet24|)
 (= |init_main_#t~mem26| |honda_main_#t~mem26|)
 (= |init_main_#t~mem22| |honda_main_#t~mem22|)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_295 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 1)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_295 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_297 (- 1)) 
 (* aux_298 1) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_299 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_297 1) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 1) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 1)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_299 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 1) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base (- 1)) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| (- 1))
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base (- 1)) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 1) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base (- 1)) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1))
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_main_#t~nondet24| |honda_main_#t~nondet24|)
 (= |init_main_#t~mem26| |honda_main_#t~mem26|)
 (= |init_main_#t~mem22| |honda_main_#t~mem22|)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base (- 1)) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_302 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 1)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_302 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_304 (- 1)) 
 (* aux_305 1) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_306 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_304 1) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 1) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 1) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 1)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_306 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| (- 1))
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base (- 1)) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 1) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1))
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_main_#t~nondet24| |honda_main_#t~nondet24|)
 (= |init_main_#t~mem26| |honda_main_#t~mem26|)
 (= |init_main_#t~mem22| |honda_main_#t~mem22|)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_309 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 1)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_309 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_311 (- 1)) 
 (* aux_312 1) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_313 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_311 1) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 1) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 1)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_313 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 1) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base (- 1)) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| (- 1))
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base (- 1)) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 1) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1))
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base (- 1)) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_main_#t~nondet24| |honda_main_#t~nondet24|)
 (= |init_main_#t~mem26| |honda_main_#t~mem26|)
 (= |init_main_#t~mem22| |honda_main_#t~mem22|)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_316 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 1)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_316 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_318 (- 1)) 
 (* aux_319 1) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_320 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_318 1) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 1) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 1)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_320 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| (- 1))
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base (- 1)) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base (- 1)) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 1) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1))
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 1) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base (- 1)) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_main_#t~nondet24| |honda_main_#t~nondet24|)
 (= |init_main_#t~mem26| |honda_main_#t~mem26|)
 (= |init_main_#t~mem22| |honda_main_#t~mem22|)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 1) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_323 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 1)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_323 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_325 (- 1)) 
 (* aux_326 1) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_327 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_325 1) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 1) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 1)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_327 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 1) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base (- 1)) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| (- 1))
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base (- 1)) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1))
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_main_#t~nondet24| |honda_main_#t~nondet24|)
 (= |init_main_#t~mem26| |honda_main_#t~mem26|)
 (= |init_main_#t~mem22| |honda_main_#t~mem22|)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base (- 1)) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_330 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 1)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_330 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_332 (- 1)) 
 (* aux_333 1) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_334 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_332 1) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 1) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 1) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 1)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_334 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| (- 1))
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base (- 1)) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 1) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1))
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_main_#t~nondet24| |honda_main_#t~nondet24|)
 (= |init_main_#t~mem26| |honda_main_#t~mem26|)
 (= |init_main_#t~mem22| |honda_main_#t~mem22|)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 1) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_337 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 1)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_337 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_339 (- 1)) 
 (* aux_340 1) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_341 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_339 1) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 1) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 1)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_341 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| (- 1))
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base (- 1)) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 1) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base (- 1)) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1))
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_main_#t~nondet24| |honda_main_#t~nondet24|)
 (= |init_main_#t~mem26| |honda_main_#t~mem26|)
 (= |init_main_#t~mem22| |honda_main_#t~mem22|)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_344 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 1)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_344 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 1) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_346 (- 1)) 
 (* aux_347 1) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_348 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_346 1) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 1) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 1)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_348 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| (- 1))
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base (- 1)) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 1) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1))
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 1) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base (- 1)) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_main_#t~nondet24| |honda_main_#t~nondet24|)
 (= |init_main_#t~mem26| |honda_main_#t~mem26|)
 (= |init_main_#t~mem22| |honda_main_#t~mem22|)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 1) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_351 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 1)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_351 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_353 (- 1)) 
 (* aux_354 1) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_355 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_353 1) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 1) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 1)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_355 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| (- 1))
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base (- 1)) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 1) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1))
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 1) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base (- 1)) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_main_#t~nondet24| |honda_main_#t~nondet24|)
 (= |init_main_#t~mem26| |honda_main_#t~mem26|)
 (= |init_main_#t~mem22| |honda_main_#t~mem22|)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_358 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 1)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_358 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_360 (- 1)) 
 (* aux_361 1) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_362 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_360 1) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 1) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 1) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 1)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_362 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| (- 1))
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base (- 1)) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 1) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1))
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base (- 1)) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_main_#t~nondet24| |honda_main_#t~nondet24|)
 (= |init_main_#t~mem26| |honda_main_#t~mem26|)
 (= |init_main_#t~mem22| |honda_main_#t~mem22|)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 1) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_365 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 1)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_365 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_367 (- 1)) 
 (* aux_368 1) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_369 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_367 1) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 1) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 1)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_369 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| (- 1))
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1))
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 1) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base (- 1)) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base (- 1)) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_main_#t~nondet24| |honda_main_#t~nondet24|)
 (= |init_main_#t~mem26| |honda_main_#t~mem26|)
 (= |init_main_#t~mem22| |honda_main_#t~mem22|)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base (- 1)) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_372 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 1)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_372 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_374 (- 1)) 
 (* aux_375 1) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_376 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_374 1) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 1) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 1)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_376 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| (- 1))
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base (- 1)) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 1) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base (- 1)) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 1) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1))
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_main_#t~nondet24| |honda_main_#t~nondet24|)
 (= |init_main_#t~mem26| |honda_main_#t~mem26|)
 (= |init_main_#t~mem22| |honda_main_#t~mem22|)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 1) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_379 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 1)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_379 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_381 (- 1)) 
 (* aux_382 1) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_383 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_381 1) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 1) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 1)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_383 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| (- 1))
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base (- 1)) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 1) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1))
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base (- 1)) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_main_#t~nondet24| |honda_main_#t~nondet24|)
 (= |init_main_#t~mem26| |honda_main_#t~mem26|)
 (= |init_main_#t~mem22| |honda_main_#t~mem22|)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_386 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 1)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_386 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_388 (- 1)) 
 (* aux_389 1) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_390 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_388 1) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 1) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 1)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_390 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| (- 1))
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base (- 1)) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 1) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1))
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 1) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base (- 1)) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base (- 1)) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_main_#t~nondet24| |honda_main_#t~nondet24|)
 (= |init_main_#t~mem26| |honda_main_#t~mem26|)
 (= |init_main_#t~mem22| |honda_main_#t~mem22|)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_393 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 1)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_393 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 1) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_395 (- 1)) 
 (* aux_396 1) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_397 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_395 1) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 1) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 1)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_397 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| (- 1))
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base (- 1)) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1))
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 1) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base (- 1)) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_main_#t~nondet24| |honda_main_#t~nondet24|)
 (= |init_main_#t~mem26| |honda_main_#t~mem26|)
 (= |init_main_#t~mem22| |honda_main_#t~mem22|)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_400 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 1)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_400 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_402 (- 1)) 
 (* aux_403 1) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_404 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_402 1) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 1) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 1) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 1)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_404 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 1) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base (- 1)) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| (- 1))
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base (- 1)) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 1) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1))
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_main_#t~nondet24| |honda_main_#t~nondet24|)
 (= |init_main_#t~mem26| |honda_main_#t~mem26|)
 (= |init_main_#t~mem22| |honda_main_#t~mem22|)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 1) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_407 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 1)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_407 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_409 (- 1)) 
 (* aux_410 1) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_411 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_409 1) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 1) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 1)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_411 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 1) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base (- 1)) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| (- 1))
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 1) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base (- 1)) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1))
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_main_#t~nondet24| |honda_main_#t~nondet24|)
 (= |init_main_#t~mem26| |honda_main_#t~mem26|)
 (= |init_main_#t~mem22| |honda_main_#t~mem22|)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_414 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 1)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_414 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_416 (- 1)) 
 (* aux_417 1) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_418 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_416 1) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 1) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 1) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 1)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_418 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| (- 1))
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base (- 1)) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 1) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base (- 1)) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 1) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1))
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_main_#t~nondet24| |honda_main_#t~nondet24|)
 (= |init_main_#t~mem26| |honda_main_#t~mem26|)
 (= |init_main_#t~mem22| |honda_main_#t~mem22|)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base (- 1)) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_421 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 1)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_421 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_423 (- 1)) 
 (* aux_424 1) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_425 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_423 1) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 1) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 1)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_425 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| (- 1))
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base (- 1)) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 1) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 1) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base (- 1)) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1))
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_main_#t~nondet24| |honda_main_#t~nondet24|)
 (= |init_main_#t~mem26| |honda_main_#t~mem26|)
 (= |init_main_#t~mem22| |honda_main_#t~mem22|)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_428 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 1)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_428 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 1) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_430 (- 1)) 
 (* aux_431 1) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_432 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_430 1) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 1) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 1)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_432 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| (- 1))
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base (- 1)) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base (- 1)) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 1) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1))
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_main_#t~nondet24| |honda_main_#t~nondet24|)
 (= |init_main_#t~mem26| |honda_main_#t~mem26|)
 (= |init_main_#t~mem22| |honda_main_#t~mem22|)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_435 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 1)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_435 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_437 (- 1)) 
 (* aux_438 1) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_439 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_437 1) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 1) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 1) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 1)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_439 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 1) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base (- 1)) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| (- 1))
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1))
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base (- 1)) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_main_#t~nondet24| |honda_main_#t~nondet24|)
 (= |init_main_#t~mem26| |honda_main_#t~mem26|)
 (= |init_main_#t~mem22| |honda_main_#t~mem22|)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_442 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 1)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_442 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 1) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_444 (- 1)) 
 (* aux_445 1) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_446 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_444 1) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 1) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 1)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_446 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| (- 1))
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base (- 1)) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 1) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 1) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base (- 1)) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1))
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_main_#t~nondet24| |honda_main_#t~nondet24|)
 (= |init_main_#t~mem26| |honda_main_#t~mem26|)
 (= |init_main_#t~mem22| |honda_main_#t~mem22|)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base (- 1)) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_449 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 1)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_449 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| (- 1))
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 1) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_451 (- 1)) 
 (* aux_452 1) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_453 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_451 1) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 1) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 1)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_453 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| (- 1))
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 1) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base (- 1)) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1))
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short13 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem15| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem12| 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0) 
 (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_main_#t~mem20| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~z~2.base 0) 
 (* |honda_main_#t~mem26| 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem17| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0) 
 (* |honda_main_#t~nondet18| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short13 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_main_#t~mem12| 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem20| 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* init_main_~z~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* |init_main_#t~nondet18| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)))
 (or
 (and
 (= |honda_main_#t~malloc2.base|
 (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|))
 (=
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|))
 (= |honda_main_#t~malloc0.base|
 (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|))
 (= |honda_(select old(#length) main_~z~2.base)|
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_main_#t~malloc1.offset|
 (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|))
 (= |honda_(ite (select #valid main_~z~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|))
 (= |honda_main_#t~nondet7|
 (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_(ite (select #valid main_~y~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|))
 (= |honda_main_#t~malloc1.base|
 (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|))
 (= |honda_main_#t~nondet3|
 (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|))
 (= |honda_(select #length main_~y~2.base)|
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|))
 (= honda_main_~y~2.offset (+ honda_main_~y~2.offset ray_main_~y~2.offset))
 (= |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|))
 (= |honda_(select old(#length) main_~y~2.base)|
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|))
 (= |honda_main_#t~mem20| (+ |honda_main_#t~mem20| |ray_main_#t~mem20|))
 (= |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|))
 (= |honda_(select #length main_~z~2.base)|
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|))
 (=
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|))
 (= honda_main_~z~2.base (+ honda_main_~z~2.base ray_main_~z~2.base))
 (=
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|))
 (= honda_main_~x~2.base (+ honda_main_~x~2.base ray_main_~x~2.base))
 (= |honda_main_#t~malloc2.offset|
 (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|))
 (= |honda_main_#t~mem17| (+ |honda_main_#t~mem17| |ray_main_#t~mem17|))
 (= |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|))
 (= |honda_(ite (select #valid main_~x~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= honda_main_~z~2.offset (+ honda_main_~z~2.offset ray_main_~z~2.offset))
 (= |honda_main_#t~malloc0.offset|
 (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|))
 (= |honda_(select old(#length) main_~x~2.base)|
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|))
 (= honda_main_~y~2.base (+ honda_main_~y~2.base ray_main_~y~2.base))
 (= |honda_main_#t~nondet5|
 (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|))
 (= |honda_main_#t~nondet18|
 (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|))
 (= honda_main_~x~2.offset (+ honda_main_~x~2.offset ray_main_~x~2.offset))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(select #length main_~x~2.base)|
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|))
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 
 (- 1)) (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 1)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) (- 1))
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 1)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| (- 1)) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 1)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 1)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 1)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 1)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1)) (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 1) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 1)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) (- 1))
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 1)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 1)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) (- 1))
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 1)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) (- 1))
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1)) (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 1)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 1) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 1)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 1)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 1) 0)
 (= |ray_main_#t~malloc2.base| (* |ray_main_#t~malloc2.base| lambda))
 (= |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda))
 (= |ray_main_#t~malloc0.base| (* |ray_main_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) main_~z~2.base)|
 (* |ray_(select old(#length) main_~z~2.base)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_main_#t~malloc1.offset| (* |ray_main_#t~malloc1.offset| lambda))
 (= |ray_(ite (select #valid main_~z~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda))
 (= |ray_main_#t~nondet7| (* |ray_main_#t~nondet7| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_(ite (select #valid main_~y~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda))
 (= |ray_main_#t~malloc1.base| (* |ray_main_#t~malloc1.base| lambda))
 (= |ray_main_#t~nondet3| (* |ray_main_#t~nondet3| lambda))
 (= |ray_(select #length main_~y~2.base)|
 (* |ray_(select #length main_~y~2.base)| lambda))
 (= ray_main_~y~2.offset (* ray_main_~y~2.offset lambda))
 (= |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda))
 (= |ray_(select old(#length) main_~y~2.base)|
 (* |ray_(select old(#length) main_~y~2.base)| lambda))
 (= |ray_main_#t~mem20| (* |ray_main_#t~mem20| lambda))
 (= |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda))
 (= |ray_(select #length main_~z~2.base)|
 (* |ray_(select #length main_~z~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda)) (= ray_main_~z~2.base (* ray_main_~z~2.base lambda))
 (= |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda)) (= ray_main_~x~2.base (* ray_main_~x~2.base lambda))
 (= |ray_main_#t~malloc2.offset| (* |ray_main_#t~malloc2.offset| lambda))
 (= |ray_main_#t~mem17| (* |ray_main_#t~mem17| lambda))
 (= |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid main_~x~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= ray_main_~z~2.offset (* ray_main_~z~2.offset lambda))
 (= |ray_main_#t~malloc0.offset| (* |ray_main_#t~malloc0.offset| lambda))
 (= |ray_(select old(#length) main_~x~2.base)|
 (* |ray_(select old(#length) main_~x~2.base)| lambda))
 (= ray_main_~y~2.base (* ray_main_~y~2.base lambda))
 (= |ray_main_#t~nondet5| (* |ray_main_#t~nondet5| lambda))
 (= |ray_main_#t~nondet18| (* |ray_main_#t~nondet18| lambda))
 (= ray_main_~x~2.offset (* ray_main_~x~2.offset lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(select #length main_~x~2.base)|
 (* |ray_(select #length main_~x~2.base)| lambda))
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) (- 1)) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 1)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1)) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) (- 1)) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 1)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| (- 1)) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 1)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1)) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 1)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 1)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 1)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 1) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* ray_main_~z~2.offset lambda) (- 1))
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 1) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 1)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 1) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* ray_main_~z~2.offset lambda) (- 1))
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 1) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 1)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) (- 1))
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 1) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1)) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 1)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 1)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_main_#t~malloc2.base|
 (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|))
 (=
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|))
 (= |honda_main_#t~malloc0.base|
 (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|))
 (= |honda_(select old(#length) main_~z~2.base)|
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_main_#t~malloc1.offset|
 (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|))
 (= |honda_(ite (select #valid main_~z~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|))
 (= |honda_main_#t~nondet7|
 (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_(ite (select #valid main_~y~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|))
 (= |honda_main_#t~malloc1.base|
 (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|))
 (= |honda_main_#t~nondet3|
 (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|))
 (= |honda_(select #length main_~y~2.base)|
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|))
 (= honda_main_~y~2.offset (+ honda_main_~y~2.offset ray_main_~y~2.offset))
 (= |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|))
 (= |honda_(select old(#length) main_~y~2.base)|
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|))
 (= |honda_main_#t~mem20| (+ |honda_main_#t~mem20| |ray_main_#t~mem20|))
 (= |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|))
 (= |honda_(select #length main_~z~2.base)|
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|))
 (=
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|))
 (= honda_main_~z~2.base (+ honda_main_~z~2.base ray_main_~z~2.base))
 (=
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|))
 (= honda_main_~x~2.base (+ honda_main_~x~2.base ray_main_~x~2.base))
 (= |honda_main_#t~malloc2.offset|
 (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|))
 (= |honda_main_#t~mem17| (+ |honda_main_#t~mem17| |ray_main_#t~mem17|))
 (= |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|))
 (= |honda_(ite (select #valid main_~x~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= honda_main_~z~2.offset (+ honda_main_~z~2.offset ray_main_~z~2.offset))
 (= |honda_main_#t~malloc0.offset|
 (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|))
 (= |honda_(select old(#length) main_~x~2.base)|
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|))
 (= honda_main_~y~2.base (+ honda_main_~y~2.base ray_main_~y~2.base))
 (= |honda_main_#t~nondet5|
 (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|))
 (= |honda_main_#t~nondet18|
 (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|))
 (= honda_main_~x~2.offset (+ honda_main_~x~2.offset ray_main_~x~2.offset))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(select #length main_~x~2.base)|
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|))
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 
 (- 1)) (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 1)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) (- 1))
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 1)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| (- 1)) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 1)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 1)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 1)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 1)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1)) (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 1) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 1)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) (- 1))
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 1)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 1)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 1)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) (- 1))
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) (- 1))
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1)) (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 1)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 1) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 1)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 1)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 1) 0)
 (= |ray_main_#t~malloc2.base| (* |ray_main_#t~malloc2.base| lambda))
 (= |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda))
 (= |ray_main_#t~malloc0.base| (* |ray_main_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) main_~z~2.base)|
 (* |ray_(select old(#length) main_~z~2.base)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_main_#t~malloc1.offset| (* |ray_main_#t~malloc1.offset| lambda))
 (= |ray_(ite (select #valid main_~z~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda))
 (= |ray_main_#t~nondet7| (* |ray_main_#t~nondet7| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_(ite (select #valid main_~y~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda))
 (= |ray_main_#t~malloc1.base| (* |ray_main_#t~malloc1.base| lambda))
 (= |ray_main_#t~nondet3| (* |ray_main_#t~nondet3| lambda))
 (= |ray_(select #length main_~y~2.base)|
 (* |ray_(select #length main_~y~2.base)| lambda))
 (= ray_main_~y~2.offset (* ray_main_~y~2.offset lambda))
 (= |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda))
 (= |ray_(select old(#length) main_~y~2.base)|
 (* |ray_(select old(#length) main_~y~2.base)| lambda))
 (= |ray_main_#t~mem20| (* |ray_main_#t~mem20| lambda))
 (= |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda))
 (= |ray_(select #length main_~z~2.base)|
 (* |ray_(select #length main_~z~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda)) (= ray_main_~z~2.base (* ray_main_~z~2.base lambda))
 (= |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda)) (= ray_main_~x~2.base (* ray_main_~x~2.base lambda))
 (= |ray_main_#t~malloc2.offset| (* |ray_main_#t~malloc2.offset| lambda))
 (= |ray_main_#t~mem17| (* |ray_main_#t~mem17| lambda))
 (= |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid main_~x~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= ray_main_~z~2.offset (* ray_main_~z~2.offset lambda))
 (= |ray_main_#t~malloc0.offset| (* |ray_main_#t~malloc0.offset| lambda))
 (= |ray_(select old(#length) main_~x~2.base)|
 (* |ray_(select old(#length) main_~x~2.base)| lambda))
 (= ray_main_~y~2.base (* ray_main_~y~2.base lambda))
 (= |ray_main_#t~nondet5| (* |ray_main_#t~nondet5| lambda))
 (= |ray_main_#t~nondet18| (* |ray_main_#t~nondet18| lambda))
 (= ray_main_~x~2.offset (* ray_main_~x~2.offset lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(select #length main_~x~2.base)|
 (* |ray_(select #length main_~x~2.base)| lambda))
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) (- 1)) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 1)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1)) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) (- 1)) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 1)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| (- 1)) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 1)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1)) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 1)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 1)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 1)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 1) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* ray_main_~z~2.offset lambda) (- 1))
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 1) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 1)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 1) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 1) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) (- 1))
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* ray_main_~z~2.offset lambda) (- 1))
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 1) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 1) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1)) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 1)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 1)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_main_#t~malloc2.base|
 (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|))
 (=
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|))
 (= |honda_main_#t~malloc0.base|
 (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|))
 (= |honda_(select old(#length) main_~z~2.base)|
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_main_#t~malloc1.offset|
 (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|))
 (= |honda_(ite (select #valid main_~z~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|))
 (= |honda_main_#t~nondet7|
 (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_(ite (select #valid main_~y~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|))
 (= |honda_main_#t~malloc1.base|
 (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|))
 (= |honda_main_#t~nondet3|
 (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|))
 (= |honda_(select #length main_~y~2.base)|
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|))
 (= honda_main_~y~2.offset (+ honda_main_~y~2.offset ray_main_~y~2.offset))
 (= |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|))
 (= |honda_(select old(#length) main_~y~2.base)|
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|))
 (= |honda_main_#t~mem20| (+ |honda_main_#t~mem20| |ray_main_#t~mem20|))
 (= |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|))
 (= |honda_(select #length main_~z~2.base)|
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|))
 (=
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|))
 (= honda_main_~z~2.base (+ honda_main_~z~2.base ray_main_~z~2.base))
 (=
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|))
 (= honda_main_~x~2.base (+ honda_main_~x~2.base ray_main_~x~2.base))
 (= |honda_main_#t~malloc2.offset|
 (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|))
 (= |honda_main_#t~mem17| (+ |honda_main_#t~mem17| |ray_main_#t~mem17|))
 (= |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|))
 (= |honda_(ite (select #valid main_~x~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= honda_main_~z~2.offset (+ honda_main_~z~2.offset ray_main_~z~2.offset))
 (= |honda_main_#t~malloc0.offset|
 (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|))
 (= |honda_(select old(#length) main_~x~2.base)|
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|))
 (= honda_main_~y~2.base (+ honda_main_~y~2.base ray_main_~y~2.base))
 (= |honda_main_#t~nondet5|
 (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|))
 (= |honda_main_#t~nondet18|
 (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|))
 (= honda_main_~x~2.offset (+ honda_main_~x~2.offset ray_main_~x~2.offset))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(select #length main_~x~2.base)|
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|))
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 
 (- 1)) (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 1)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) (- 1))
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 1)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| (- 1)) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 1)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 1)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 1)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 1)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1)) (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 1) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 1)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) (- 1))
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 1)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 1)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) (- 1))
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1)) (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 1)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 1) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 1)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) (- 1))
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 1)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 1)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 1) 0)
 (= |ray_main_#t~malloc2.base| (* |ray_main_#t~malloc2.base| lambda))
 (= |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda))
 (= |ray_main_#t~malloc0.base| (* |ray_main_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) main_~z~2.base)|
 (* |ray_(select old(#length) main_~z~2.base)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_main_#t~malloc1.offset| (* |ray_main_#t~malloc1.offset| lambda))
 (= |ray_(ite (select #valid main_~z~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda))
 (= |ray_main_#t~nondet7| (* |ray_main_#t~nondet7| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_(ite (select #valid main_~y~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda))
 (= |ray_main_#t~malloc1.base| (* |ray_main_#t~malloc1.base| lambda))
 (= |ray_main_#t~nondet3| (* |ray_main_#t~nondet3| lambda))
 (= |ray_(select #length main_~y~2.base)|
 (* |ray_(select #length main_~y~2.base)| lambda))
 (= ray_main_~y~2.offset (* ray_main_~y~2.offset lambda))
 (= |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda))
 (= |ray_(select old(#length) main_~y~2.base)|
 (* |ray_(select old(#length) main_~y~2.base)| lambda))
 (= |ray_main_#t~mem20| (* |ray_main_#t~mem20| lambda))
 (= |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda))
 (= |ray_(select #length main_~z~2.base)|
 (* |ray_(select #length main_~z~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda)) (= ray_main_~z~2.base (* ray_main_~z~2.base lambda))
 (= |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda)) (= ray_main_~x~2.base (* ray_main_~x~2.base lambda))
 (= |ray_main_#t~malloc2.offset| (* |ray_main_#t~malloc2.offset| lambda))
 (= |ray_main_#t~mem17| (* |ray_main_#t~mem17| lambda))
 (= |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid main_~x~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= ray_main_~z~2.offset (* ray_main_~z~2.offset lambda))
 (= |ray_main_#t~malloc0.offset| (* |ray_main_#t~malloc0.offset| lambda))
 (= |ray_(select old(#length) main_~x~2.base)|
 (* |ray_(select old(#length) main_~x~2.base)| lambda))
 (= ray_main_~y~2.base (* ray_main_~y~2.base lambda))
 (= |ray_main_#t~nondet5| (* |ray_main_#t~nondet5| lambda))
 (= |ray_main_#t~nondet18| (* |ray_main_#t~nondet18| lambda))
 (= ray_main_~x~2.offset (* ray_main_~x~2.offset lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(select #length main_~x~2.base)|
 (* |ray_(select #length main_~x~2.base)| lambda))
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) (- 1)) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 1)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1)) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) (- 1)) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 1)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| (- 1)) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 1)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1)) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 1)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 1)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 1)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 1) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* ray_main_~z~2.offset lambda) (- 1))
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 1) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 1)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 1) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* ray_main_~z~2.offset lambda) (- 1))
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 1) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 1) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1)) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 1)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) (- 1))
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 1)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 1)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_main_#t~malloc2.base|
 (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|))
 (=
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|))
 (= |honda_main_#t~malloc0.base|
 (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|))
 (= |honda_(select old(#length) main_~z~2.base)|
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_main_#t~malloc1.offset|
 (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|))
 (= |honda_(ite (select #valid main_~z~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|))
 (= |honda_main_#t~nondet7|
 (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_(ite (select #valid main_~y~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|))
 (= |honda_main_#t~malloc1.base|
 (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|))
 (= |honda_main_#t~nondet3|
 (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|))
 (= |honda_(select #length main_~y~2.base)|
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|))
 (= honda_main_~y~2.offset (+ honda_main_~y~2.offset ray_main_~y~2.offset))
 (= |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|))
 (= |honda_(select old(#length) main_~y~2.base)|
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|))
 (= |honda_main_#t~mem20| (+ |honda_main_#t~mem20| |ray_main_#t~mem20|))
 (= |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|))
 (= |honda_(select #length main_~z~2.base)|
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|))
 (=
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|))
 (= honda_main_~z~2.base (+ honda_main_~z~2.base ray_main_~z~2.base))
 (=
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|))
 (= honda_main_~x~2.base (+ honda_main_~x~2.base ray_main_~x~2.base))
 (= |honda_main_#t~malloc2.offset|
 (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|))
 (= |honda_main_#t~mem17| (+ |honda_main_#t~mem17| |ray_main_#t~mem17|))
 (= |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|))
 (= |honda_(ite (select #valid main_~x~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= honda_main_~z~2.offset (+ honda_main_~z~2.offset ray_main_~z~2.offset))
 (= |honda_main_#t~malloc0.offset|
 (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|))
 (= |honda_(select old(#length) main_~x~2.base)|
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|))
 (= honda_main_~y~2.base (+ honda_main_~y~2.base ray_main_~y~2.base))
 (= |honda_main_#t~nondet5|
 (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|))
 (= |honda_main_#t~nondet18|
 (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|))
 (= honda_main_~x~2.offset (+ honda_main_~x~2.offset ray_main_~x~2.offset))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(select #length main_~x~2.base)|
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|))
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 
 (- 1)) (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 1)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) (- 1))
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 1)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| (- 1)) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 1)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 1)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 1)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 1)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1)) (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 1) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 1)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) (- 1))
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 1)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) (- 1))
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 1)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 1)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) (- 1))
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1)) (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 1)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 1) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 1)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 1)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 1) 0)
 (= |ray_main_#t~malloc2.base| (* |ray_main_#t~malloc2.base| lambda))
 (= |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda))
 (= |ray_main_#t~malloc0.base| (* |ray_main_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) main_~z~2.base)|
 (* |ray_(select old(#length) main_~z~2.base)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_main_#t~malloc1.offset| (* |ray_main_#t~malloc1.offset| lambda))
 (= |ray_(ite (select #valid main_~z~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda))
 (= |ray_main_#t~nondet7| (* |ray_main_#t~nondet7| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_(ite (select #valid main_~y~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda))
 (= |ray_main_#t~malloc1.base| (* |ray_main_#t~malloc1.base| lambda))
 (= |ray_main_#t~nondet3| (* |ray_main_#t~nondet3| lambda))
 (= |ray_(select #length main_~y~2.base)|
 (* |ray_(select #length main_~y~2.base)| lambda))
 (= ray_main_~y~2.offset (* ray_main_~y~2.offset lambda))
 (= |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda))
 (= |ray_(select old(#length) main_~y~2.base)|
 (* |ray_(select old(#length) main_~y~2.base)| lambda))
 (= |ray_main_#t~mem20| (* |ray_main_#t~mem20| lambda))
 (= |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda))
 (= |ray_(select #length main_~z~2.base)|
 (* |ray_(select #length main_~z~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda)) (= ray_main_~z~2.base (* ray_main_~z~2.base lambda))
 (= |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda)) (= ray_main_~x~2.base (* ray_main_~x~2.base lambda))
 (= |ray_main_#t~malloc2.offset| (* |ray_main_#t~malloc2.offset| lambda))
 (= |ray_main_#t~mem17| (* |ray_main_#t~mem17| lambda))
 (= |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid main_~x~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= ray_main_~z~2.offset (* ray_main_~z~2.offset lambda))
 (= |ray_main_#t~malloc0.offset| (* |ray_main_#t~malloc0.offset| lambda))
 (= |ray_(select old(#length) main_~x~2.base)|
 (* |ray_(select old(#length) main_~x~2.base)| lambda))
 (= ray_main_~y~2.base (* ray_main_~y~2.base lambda))
 (= |ray_main_#t~nondet5| (* |ray_main_#t~nondet5| lambda))
 (= |ray_main_#t~nondet18| (* |ray_main_#t~nondet18| lambda))
 (= ray_main_~x~2.offset (* ray_main_~x~2.offset lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(select #length main_~x~2.base)|
 (* |ray_(select #length main_~x~2.base)| lambda))
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) (- 1)) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 1)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1)) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) (- 1)) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 1)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| (- 1)) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 1)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1)) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 1)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 1)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 1)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 1) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 1) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) (- 1))
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* ray_main_~z~2.offset lambda) (- 1))
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 1) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 1)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 1) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* ray_main_~z~2.offset lambda) (- 1))
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 1) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 1) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1)) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 1)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 1)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_main_#t~malloc2.base|
 (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|))
 (=
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|))
 (= |honda_main_#t~malloc0.base|
 (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|))
 (= |honda_(select old(#length) main_~z~2.base)|
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_main_#t~malloc1.offset|
 (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|))
 (= |honda_(ite (select #valid main_~z~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|))
 (= |honda_main_#t~nondet7|
 (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_(ite (select #valid main_~y~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|))
 (= |honda_main_#t~malloc1.base|
 (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|))
 (= |honda_main_#t~nondet3|
 (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|))
 (= |honda_(select #length main_~y~2.base)|
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|))
 (= honda_main_~y~2.offset (+ honda_main_~y~2.offset ray_main_~y~2.offset))
 (= |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|))
 (= |honda_(select old(#length) main_~y~2.base)|
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|))
 (= |honda_main_#t~mem20| (+ |honda_main_#t~mem20| |ray_main_#t~mem20|))
 (= |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|))
 (= |honda_(select #length main_~z~2.base)|
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|))
 (=
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|))
 (= honda_main_~z~2.base (+ honda_main_~z~2.base ray_main_~z~2.base))
 (=
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|))
 (= honda_main_~x~2.base (+ honda_main_~x~2.base ray_main_~x~2.base))
 (= |honda_main_#t~malloc2.offset|
 (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|))
 (= |honda_main_#t~mem17| (+ |honda_main_#t~mem17| |ray_main_#t~mem17|))
 (= |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|))
 (= |honda_(ite (select #valid main_~x~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= honda_main_~z~2.offset (+ honda_main_~z~2.offset ray_main_~z~2.offset))
 (= |honda_main_#t~malloc0.offset|
 (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|))
 (= |honda_(select old(#length) main_~x~2.base)|
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|))
 (= honda_main_~y~2.base (+ honda_main_~y~2.base ray_main_~y~2.base))
 (= |honda_main_#t~nondet5|
 (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|))
 (= |honda_main_#t~nondet18|
 (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|))
 (= honda_main_~x~2.offset (+ honda_main_~x~2.offset ray_main_~x~2.offset))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(select #length main_~x~2.base)|
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|))
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 
 (- 1)) (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 1)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| (- 1)) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 1)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 1)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 1)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 1)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1)) (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 1) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 1)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) (- 1))
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 1)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) (- 1))
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 1)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 1)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) (- 1))
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 1)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) (- 1))
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1)) (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 1)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 1) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 1)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 1)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 1) 0)
 (= |ray_main_#t~malloc2.base| (* |ray_main_#t~malloc2.base| lambda))
 (= |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda))
 (= |ray_main_#t~malloc0.base| (* |ray_main_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) main_~z~2.base)|
 (* |ray_(select old(#length) main_~z~2.base)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_main_#t~malloc1.offset| (* |ray_main_#t~malloc1.offset| lambda))
 (= |ray_(ite (select #valid main_~z~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda))
 (= |ray_main_#t~nondet7| (* |ray_main_#t~nondet7| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_(ite (select #valid main_~y~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda))
 (= |ray_main_#t~malloc1.base| (* |ray_main_#t~malloc1.base| lambda))
 (= |ray_main_#t~nondet3| (* |ray_main_#t~nondet3| lambda))
 (= |ray_(select #length main_~y~2.base)|
 (* |ray_(select #length main_~y~2.base)| lambda))
 (= ray_main_~y~2.offset (* ray_main_~y~2.offset lambda))
 (= |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda))
 (= |ray_(select old(#length) main_~y~2.base)|
 (* |ray_(select old(#length) main_~y~2.base)| lambda))
 (= |ray_main_#t~mem20| (* |ray_main_#t~mem20| lambda))
 (= |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda))
 (= |ray_(select #length main_~z~2.base)|
 (* |ray_(select #length main_~z~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda)) (= ray_main_~z~2.base (* ray_main_~z~2.base lambda))
 (= |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda)) (= ray_main_~x~2.base (* ray_main_~x~2.base lambda))
 (= |ray_main_#t~malloc2.offset| (* |ray_main_#t~malloc2.offset| lambda))
 (= |ray_main_#t~mem17| (* |ray_main_#t~mem17| lambda))
 (= |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid main_~x~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= ray_main_~z~2.offset (* ray_main_~z~2.offset lambda))
 (= |ray_main_#t~malloc0.offset| (* |ray_main_#t~malloc0.offset| lambda))
 (= |ray_(select old(#length) main_~x~2.base)|
 (* |ray_(select old(#length) main_~x~2.base)| lambda))
 (= ray_main_~y~2.base (* ray_main_~y~2.base lambda))
 (= |ray_main_#t~nondet5| (* |ray_main_#t~nondet5| lambda))
 (= |ray_main_#t~nondet18| (* |ray_main_#t~nondet18| lambda))
 (= ray_main_~x~2.offset (* ray_main_~x~2.offset lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(select #length main_~x~2.base)|
 (* |ray_(select #length main_~x~2.base)| lambda))
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) (- 1)) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 1)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1)) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| (- 1)) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 1)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1)) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 1)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 1)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 1)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 1) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 1) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) (- 1))
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* ray_main_~z~2.offset lambda) (- 1))
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 1) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 1)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 1) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* ray_main_~z~2.offset lambda) (- 1))
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 1) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 1)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) (- 1))
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 1) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1)) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 1)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 1)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_main_#t~malloc2.base|
 (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|))
 (=
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|))
 (= |honda_main_#t~malloc0.base|
 (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|))
 (= |honda_(select old(#length) main_~z~2.base)|
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_main_#t~malloc1.offset|
 (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|))
 (= |honda_(ite (select #valid main_~z~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|))
 (= |honda_main_#t~nondet7|
 (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_(ite (select #valid main_~y~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|))
 (= |honda_main_#t~malloc1.base|
 (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|))
 (= |honda_main_#t~nondet3|
 (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|))
 (= |honda_(select #length main_~y~2.base)|
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|))
 (= honda_main_~y~2.offset (+ honda_main_~y~2.offset ray_main_~y~2.offset))
 (= |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|))
 (= |honda_(select old(#length) main_~y~2.base)|
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|))
 (= |honda_main_#t~mem20| (+ |honda_main_#t~mem20| |ray_main_#t~mem20|))
 (= |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|))
 (= |honda_(select #length main_~z~2.base)|
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|))
 (=
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|))
 (= honda_main_~z~2.base (+ honda_main_~z~2.base ray_main_~z~2.base))
 (=
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|))
 (= honda_main_~x~2.base (+ honda_main_~x~2.base ray_main_~x~2.base))
 (= |honda_main_#t~malloc2.offset|
 (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|))
 (= |honda_main_#t~mem17| (+ |honda_main_#t~mem17| |ray_main_#t~mem17|))
 (= |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|))
 (= |honda_(ite (select #valid main_~x~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= honda_main_~z~2.offset (+ honda_main_~z~2.offset ray_main_~z~2.offset))
 (= |honda_main_#t~malloc0.offset|
 (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|))
 (= |honda_(select old(#length) main_~x~2.base)|
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|))
 (= honda_main_~y~2.base (+ honda_main_~y~2.base ray_main_~y~2.base))
 (= |honda_main_#t~nondet5|
 (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|))
 (= |honda_main_#t~nondet18|
 (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|))
 (= honda_main_~x~2.offset (+ honda_main_~x~2.offset ray_main_~x~2.offset))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(select #length main_~x~2.base)|
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|))
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 
 (- 1)) (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 1)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| (- 1)) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 1)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 1)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 1)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 1)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1)) (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 1) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 1)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) (- 1))
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 1)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 1)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 1)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) (- 1))
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) (- 1))
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1)) (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 1)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 1) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 1)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) (- 1))
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 1)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~nondet24| |ray_main_#t~nondet24|) 0)
 (* (+ |honda_main_#t~mem20| |ray_main_#t~mem20|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (* (+ |honda_main_#t~mem26| |ray_main_#t~mem26|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 1)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ |honda_main_#t~nondet18| |ray_main_#t~nondet18|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem12| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~nondet24| 0) 
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem26| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_main_#t~mem14| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem22| 0) 1) 0)
 (= |ray_main_#t~malloc2.base| (* |ray_main_#t~malloc2.base| lambda))
 (= |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda))
 (= |ray_main_#t~malloc0.base| (* |ray_main_#t~malloc0.base| lambda))
 (= |ray_(select old(#length) main_~z~2.base)|
 (* |ray_(select old(#length) main_~z~2.base)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_main_#t~malloc1.offset| (* |ray_main_#t~malloc1.offset| lambda))
 (= |ray_(ite (select #valid main_~z~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda))
 (= |ray_main_#t~nondet7| (* |ray_main_#t~nondet7| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_(ite (select #valid main_~y~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda))
 (= |ray_main_#t~malloc1.base| (* |ray_main_#t~malloc1.base| lambda))
 (= |ray_main_#t~nondet3| (* |ray_main_#t~nondet3| lambda))
 (= |ray_(select #length main_~y~2.base)|
 (* |ray_(select #length main_~y~2.base)| lambda))
 (= ray_main_~y~2.offset (* ray_main_~y~2.offset lambda))
 (= |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda))
 (= |ray_(select old(#length) main_~y~2.base)|
 (* |ray_(select old(#length) main_~y~2.base)| lambda))
 (= |ray_main_#t~mem20| (* |ray_main_#t~mem20| lambda))
 (= |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda))
 (= |ray_(select #length main_~z~2.base)|
 (* |ray_(select #length main_~z~2.base)| lambda))
 (= |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda)) (= ray_main_~z~2.base (* ray_main_~z~2.base lambda))
 (= |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda)) (= ray_main_~x~2.base (* ray_main_~x~2.base lambda))
 (= |ray_main_#t~malloc2.offset| (* |ray_main_#t~malloc2.offset| lambda))
 (= |ray_main_#t~mem17| (* |ray_main_#t~mem17| lambda))
 (= |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid main_~x~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= ray_main_~z~2.offset (* ray_main_~z~2.offset lambda))
 (= |ray_main_#t~malloc0.offset| (* |ray_main_#t~malloc0.offset| lambda))
 (= |ray_(select old(#length) main_~x~2.base)|
 (* |ray_(select old(#length) main_~x~2.base)| lambda))
 (= ray_main_~y~2.base (* ray_main_~y~2.base lambda))
 (= |ray_main_#t~nondet5| (* |ray_main_#t~nondet5| lambda))
 (= |ray_main_#t~nondet18| (* |ray_main_#t~nondet18| lambda))
 (= ray_main_~x~2.offset (* ray_main_~x~2.offset lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(select #length main_~x~2.base)|
 (* |ray_(select #length main_~x~2.base)| lambda))
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) (- 1)) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 1)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1)) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| (- 1)) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 1)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1)) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 1)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 1)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 1)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 1) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* ray_main_~z~2.offset lambda) (- 1))
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 1) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 1)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 1) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 1) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) (- 1))
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* ray_main_~z~2.offset lambda) (- 1))
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 1) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 1) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1)) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 1)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) (- 1))
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 1)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0) 
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem10| lambda) 0)
 (* (* |ray_main_#t~nondet24| lambda) 0) 
 (* (* |ray_main_#t~mem20| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0) 
 (* (* |ray_main_#t~mem26| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 1)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_main_#t~nondet18| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* |ray_(ite main_#t~short13 1 0)| 0) 
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem12| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~nondet24| 0) 
 (* |ray_(ite main_#t~short11 1 0)| 0) 
 (* |ray_main_#t~mem26| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |ray_main_#t~mem14| 0) 
 (* |ray_main_#t~mem9| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem22| 0)) 0) 
 (= lambda lambda))) (>= lambda 0)))
(check-sat)
(exit)

