(set-logic QF_NIA)
(set-info
  :source |
SMT script generated by Ultimate LassoRanker [1].
Ultimate LassoRanker is a tool that analyzes termination and nontermination of 
lasso-shaped programs. This script contains the SMT commands that Ultimate 
LassoRanker used while checking if a lasso-shaped program has a geometric 
nontermination argument [2].

This SMT script belongs to a set of SMT scripts that was generated by applying
Ultimate Buchi Automizer [3,4] to the benchmarks from the SV-COMP 2015 [5,6] 
which are available at [7]. Ultimate Buchi Automizer takes omega-traces
(lasso-shaped programs) and uses LassoRanker in order to check if the 
lasso-shaped program is terminating.

2015-04-30, Matthias Heizmann (heizmann@informatik.uni-freiburg.de)


[1] https://ultimate.informatik.uni-freiburg.de/LassoRanker/
[2] Jan Leike, Matthias Heizmann:
Geometric Series as Nontermination Arguments for Linear Lasso Programs. 
CoRR abs/1405.4413 (2014)
http://arxiv.org/abs/1405.4413
[3] http://ultimate.informatik.uni-freiburg.de/BuchiAutomizer/
[4] Matthias Heizmann, Jochen Hoenicke, Andreas Podelski: Software Model 
Checking for People Who Love Automata. CAV 2013:36-52
[5] http://sv-comp.sosy-lab.org/2015/
[6] Dirk Beyer: Software Verification and Verifiable Witnesses - (Report on 
SV-COMP 2015). TACAS 2015: 401-416
[7] https://svn.sosy-lab.org/software/sv-benchmarks/tags/svcomp15/
|)
(set-info :smt-lib-version 2.0)
(set-info :category "industrial")
(set-info :status unsat)
(declare-fun |init_main_#t~malloc2.base| () Int)
(declare-fun |honda_main_#t~malloc2.base| () Int)
(declare-fun |ray_main_#t~malloc2.base| () Int)
(declare-fun |init_main_#t~malloc0.base| () Int)
(declare-fun |honda_main_#t~malloc0.base| () Int)
(declare-fun |ray_main_#t~malloc0.base| () Int)
(declare-fun |init_main_#t~malloc1.offset| () Int)
(declare-fun |honda_main_#t~malloc1.offset| () Int)
(declare-fun |ray_main_#t~malloc1.offset| () Int)
(declare-fun |init_main_#t~nondet7| () Int)
(declare-fun |honda_main_#t~nondet7| () Int)
(declare-fun |ray_main_#t~nondet7| () Int)
(declare-fun |init_main_#t~mem21| () Int)
(declare-fun |honda_main_#t~mem21| () Int)
(declare-fun |ray_main_#t~mem21| () Int)
(declare-fun |init_(ite (select #valid 0) 1 0)| () Int)
(declare-fun |honda_(ite (select #valid 0) 1 0)| () Int)
(declare-fun |ray_(ite (select #valid 0) 1 0)| () Int)
(declare-fun |init_(ite main_#t~short13 1 0)| () Int)
(declare-fun |honda_(ite main_#t~short13 1 0)| () Int)
(declare-fun |ray_(ite main_#t~short13 1 0)| () Int)
(declare-fun init_main_~N~2.base () Int)
(declare-fun honda_main_~N~2.base () Int)
(declare-fun ray_main_~N~2.base () Int)
(declare-fun |init_main_#t~malloc1.base| () Int)
(declare-fun |honda_main_#t~malloc1.base| () Int)
(declare-fun |ray_main_#t~malloc1.base| () Int)
(declare-fun |init_main_#t~nondet3| () Int)
(declare-fun |honda_main_#t~nondet3| () Int)
(declare-fun |ray_main_#t~nondet3| () Int)
(declare-fun |init_main_#t~mem12| () Int)
(declare-fun |honda_main_#t~mem12| () Int)
(declare-fun |ray_main_#t~mem12| () Int)
(declare-fun init_main_~y~2.offset () Int)
(declare-fun honda_main_~y~2.offset () Int)
(declare-fun ray_main_~y~2.offset () Int)
(declare-fun |init_(ite main_#t~short11 1 0)| () Int)
(declare-fun |honda_(ite main_#t~short11 1 0)| () Int)
(declare-fun |ray_(ite main_#t~short11 1 0)| () Int)
(declare-fun |init_main_#t~mem10| () Int)
(declare-fun |honda_main_#t~mem10| () Int)
(declare-fun |ray_main_#t~mem10| () Int)
(declare-fun |init_main_#t~mem16| () Int)
(declare-fun |honda_main_#t~mem16| () Int)
(declare-fun |ray_main_#t~mem16| () Int)
(declare-fun |init_main_#t~nondet20| () Int)
(declare-fun |honda_main_#t~nondet20| () Int)
(declare-fun |ray_main_#t~nondet20| () Int)
(declare-fun |init_main_#t~mem19| () Int)
(declare-fun |honda_main_#t~mem19| () Int)
(declare-fun |ray_main_#t~mem19| () Int)
(declare-fun |init_main_#t~mem18| () Int)
(declare-fun |honda_main_#t~mem18| () Int)
(declare-fun |ray_main_#t~mem18| () Int)
(declare-fun init_main_~N~2.offset () Int)
(declare-fun honda_main_~N~2.offset () Int)
(declare-fun ray_main_~N~2.offset () Int)
(declare-fun |init_main_#t~mem24| () Int)
(declare-fun |honda_main_#t~mem24| () Int)
(declare-fun |ray_main_#t~mem24| () Int)
(declare-fun init_main_~x~2.base () Int)
(declare-fun honda_main_~x~2.base () Int)
(declare-fun ray_main_~x~2.base () Int)
(declare-fun |init_main_#t~malloc2.offset| () Int)
(declare-fun |honda_main_#t~malloc2.offset| () Int)
(declare-fun |ray_main_#t~malloc2.offset| () Int)
(declare-fun |init_main_#t~mem17| () Int)
(declare-fun |honda_main_#t~mem17| () Int)
(declare-fun |ray_main_#t~mem17| () Int)
(declare-fun |init_main_#t~mem9| () Int)
(declare-fun |honda_main_#t~mem9| () Int)
(declare-fun |ray_main_#t~mem9| () Int)
(declare-fun |init_main_#t~mem14| () Int)
(declare-fun |honda_main_#t~mem14| () Int)
(declare-fun |ray_main_#t~mem14| () Int)
(declare-fun |init_#NULL.offset| () Int)
(declare-fun |honda_#NULL.offset| () Int)
(declare-fun |ray_#NULL.offset| () Int)
(declare-fun |init_main_#t~malloc0.offset| () Int)
(declare-fun |honda_main_#t~malloc0.offset| () Int)
(declare-fun |ray_main_#t~malloc0.offset| () Int)
(declare-fun |init_(ite main_#t~short15 1 0)| () Int)
(declare-fun |honda_(ite main_#t~short15 1 0)| () Int)
(declare-fun |ray_(ite main_#t~short15 1 0)| () Int)
(declare-fun init_main_~y~2.base () Int)
(declare-fun honda_main_~y~2.base () Int)
(declare-fun ray_main_~y~2.base () Int)
(declare-fun |init_main_#t~mem22| () Int)
(declare-fun |honda_main_#t~mem22| () Int)
(declare-fun |ray_main_#t~mem22| () Int)
(declare-fun |init_main_#t~nondet5| () Int)
(declare-fun |honda_main_#t~nondet5| () Int)
(declare-fun |ray_main_#t~nondet5| () Int)
(declare-fun init_main_~x~2.offset () Int)
(declare-fun honda_main_~x~2.offset () Int)
(declare-fun ray_main_~x~2.offset () Int)
(declare-fun |init_#NULL.base| () Int)
(declare-fun |honda_#NULL.base| () Int)
(declare-fun |ray_#NULL.base| () Int)
(declare-fun |honda_(select #length main_~y~2.base)| () Int)
(declare-fun |ray_(select #length main_~y~2.base)| () Int)
(declare-fun |honda_(select old(#length) main_~x~2.base)| () Int)
(declare-fun |ray_(select old(#length) main_~x~2.base)| () Int)
(declare-fun |honda_(select #length main_~N~2.base)| () Int)
(declare-fun |ray_(select #length main_~N~2.base)| () Int)
(declare-fun |honda_(select old(#length) main_~N~2.base)| () Int)
(declare-fun |ray_(select old(#length) main_~N~2.base)| () Int)
(declare-fun |honda_(select old(#length) main_~y~2.base)| () Int)
(declare-fun |ray_(select old(#length) main_~y~2.base)| () Int)
(declare-fun
  |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| ()
  Int)
(declare-fun
  |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| () Int)
(declare-fun
  |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
  () Int)
(declare-fun
  |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)| ()
  Int)
(declare-fun |honda_(ite (select old(#valid) 0) 1 0)| () Int)
(declare-fun |ray_(ite (select old(#valid) 0) 1 0)| () Int)
(declare-fun
  |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| ()
  Int)
(declare-fun
  |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| () Int)
(declare-fun |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| () Int)
(declare-fun |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| () Int)
(declare-fun |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| () Int)
(declare-fun |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| () Int)
(declare-fun |honda_(select #length main_~x~2.base)| () Int)
(declare-fun |ray_(select #length main_~x~2.base)| () Int)
(declare-fun
  |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
  () Int)
(declare-fun
  |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)| ()
  Int)
(declare-fun
  |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
  () Int)
(declare-fun
  |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)| ()
  Int)
(declare-fun |honda_(ite (select #valid main_~N~2.base) 1 0)| () Int)
(declare-fun |ray_(ite (select #valid main_~N~2.base) 1 0)| () Int)
(declare-fun |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| () Int)
(declare-fun |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| () Int)
(declare-fun
  |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| ()
  Int)
(declare-fun
  |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| () Int)
(declare-fun |honda_(ite (select #valid main_~x~2.base) 1 0)| () Int)
(declare-fun |ray_(ite (select #valid main_~x~2.base) 1 0)| () Int)
(declare-fun |honda_(ite (select #valid main_~y~2.base) 1 0)| () Int)
(declare-fun |ray_(ite (select #valid main_~y~2.base) 1 0)| () Int)
(declare-fun lambda () Int)
(declare-fun aux_432 () Int)
(declare-fun aux_433 () Int)
(declare-fun aux_434 () Int)
(declare-fun aux_438 () Int)
(declare-fun aux_439 () Int)
(declare-fun aux_440 () Int)
(declare-fun aux_444 () Int)
(declare-fun aux_445 () Int)
(declare-fun aux_446 () Int)
(declare-fun aux_450 () Int)
(declare-fun aux_451 () Int)
(declare-fun aux_452 () Int)
(declare-fun aux_456 () Int)
(declare-fun aux_457 () Int)
(declare-fun aux_458 () Int)
(declare-fun aux_462 () Int)
(declare-fun aux_463 () Int)
(declare-fun aux_464 () Int)
(declare-fun aux_468 () Int)
(declare-fun aux_469 () Int)
(declare-fun aux_470 () Int)
(declare-fun aux_474 () Int)
(declare-fun aux_475 () Int)
(declare-fun aux_476 () Int)
(declare-fun aux_480 () Int)
(declare-fun aux_481 () Int)
(declare-fun aux_482 () Int)
(declare-fun aux_486 () Int)
(declare-fun aux_487 () Int)
(declare-fun aux_488 () Int)
(declare-fun aux_492 () Int)
(declare-fun aux_493 () Int)
(declare-fun aux_494 () Int)
(declare-fun aux_498 () Int)
(declare-fun aux_499 () Int)
(declare-fun aux_500 () Int)
(declare-fun aux_504 () Int)
(declare-fun aux_505 () Int)
(declare-fun aux_506 () Int)
(declare-fun aux_510 () Int)
(declare-fun aux_511 () Int)
(declare-fun aux_512 () Int)
(declare-fun aux_516 () Int)
(declare-fun aux_517 () Int)
(declare-fun aux_518 () Int)
(declare-fun aux_522 () Int)
(declare-fun aux_523 () Int)
(declare-fun aux_524 () Int)
(declare-fun aux_528 () Int)
(declare-fun aux_529 () Int)
(declare-fun aux_530 () Int)
(declare-fun aux_534 () Int)
(declare-fun aux_535 () Int)
(declare-fun aux_536 () Int)
(declare-fun aux_540 () Int)
(declare-fun aux_541 () Int)
(declare-fun aux_542 () Int)
(declare-fun aux_546 () Int)
(declare-fun aux_547 () Int)
(declare-fun aux_548 () Int)
(declare-fun aux_552 () Int)
(declare-fun aux_553 () Int)
(declare-fun aux_554 () Int)
(declare-fun aux_558 () Int)
(declare-fun aux_559 () Int)
(declare-fun aux_560 () Int)
(declare-fun aux_564 () Int)
(declare-fun aux_565 () Int)
(declare-fun aux_566 () Int)
(declare-fun aux_570 () Int)
(declare-fun aux_571 () Int)
(declare-fun aux_572 () Int)
(assert
 (and
 (or
 (and (= |init_main_#t~mem21| |honda_main_#t~mem21|)
 (= |init_main_#t~mem24| |honda_main_#t~mem24|)
 (= |init_main_#t~mem22| |honda_main_#t~mem22|)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 1) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 536870911) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 1)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| (- 1))
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 1)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_432 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_433 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset (- 1)) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset (- 1)) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_434 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 1) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 1)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 1) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 1)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 1) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_432 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1)) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_433 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 536870911) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_434 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0))
 (and (= |init_main_#t~mem21| |honda_main_#t~mem21|)
 (= |init_main_#t~mem24| |honda_main_#t~mem24|)
 (= |init_main_#t~mem22| |honda_main_#t~mem22|)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 1) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 536870911) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 1)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| (- 1))
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 1)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_438 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_439 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset (- 1)) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset (- 1)) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_440 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 1) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 1)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 1) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 1)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 1) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_438 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1)) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_439 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 536870911) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_440 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0))
 (and (= |init_main_#t~mem21| |honda_main_#t~mem21|)
 (= |init_main_#t~mem24| |honda_main_#t~mem24|)
 (= |init_main_#t~mem22| |honda_main_#t~mem22|)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 1) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 536870911) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 1)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| (- 1))
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_444 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_445 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset (- 1)) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset (- 1)) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_446 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 1) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 1)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 1) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 1)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 1) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_444 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1)) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_445 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 536870911) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_446 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0))
 (and (= |init_main_#t~mem21| |honda_main_#t~mem21|)
 (= |init_main_#t~mem24| |honda_main_#t~mem24|)
 (= |init_main_#t~mem22| |honda_main_#t~mem22|)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 1) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 536870911) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 1)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| (- 1))
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_450 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_451 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset (- 1)) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 1)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset (- 1)) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_452 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 1) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 1)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 1) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 1) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_450 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1)) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_451 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 536870911) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_452 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0))
 (and (= |init_main_#t~mem21| |honda_main_#t~mem21|)
 (= |init_main_#t~mem24| |honda_main_#t~mem24|)
 (= |init_main_#t~mem22| |honda_main_#t~mem22|)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 1) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 536870911) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 1)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| (- 1))
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_456 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_457 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 1)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset (- 1)) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset (- 1)) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_458 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 1) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 1)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 1)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 1) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 1) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_456 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1)) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_457 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 536870911) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_458 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0))
 (and (= |init_main_#t~mem21| |honda_main_#t~mem21|)
 (= |init_main_#t~mem24| |honda_main_#t~mem24|)
 (= |init_main_#t~mem22| |honda_main_#t~mem22|)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 1) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 536870911) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 1)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| (- 1))
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_462 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_463 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset (- 1)) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset (- 1)) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_464 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 1) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 1)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 1)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 1) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 1) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_462 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1)) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_463 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 536870911) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_464 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0))
 (and (= |init_main_#t~mem21| |honda_main_#t~mem21|)
 (= |init_main_#t~mem24| |honda_main_#t~mem24|)
 (= |init_main_#t~mem22| |honda_main_#t~mem22|)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 1) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 536870911) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 1)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| (- 1))
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 1)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_468 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_469 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset (- 1)) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset (- 1)) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_470 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 1) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 1)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 1) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 1) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_468 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1)) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_469 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 536870911) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_470 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0))
 (and (= |init_main_#t~mem21| |honda_main_#t~mem21|)
 (= |init_main_#t~mem24| |honda_main_#t~mem24|)
 (= |init_main_#t~mem22| |honda_main_#t~mem22|)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 1) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 536870911) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 1)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| (- 1))
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_474 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_475 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 1)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset (- 1)) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset (- 1)) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_476 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 1) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 1)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 1) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 1) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_474 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1)) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_475 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 536870911) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_476 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0))
 (and (= |init_main_#t~mem21| |honda_main_#t~mem21|)
 (= |init_main_#t~mem24| |honda_main_#t~mem24|)
 (= |init_main_#t~mem22| |honda_main_#t~mem22|)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 1) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 536870911) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 1)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| (- 1))
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_480 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_481 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 1)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset (- 1)) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 1)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset (- 1)) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_482 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 1) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 1)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 1) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 1) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_480 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1)) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_481 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 536870911) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_482 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0))
 (and (= |init_main_#t~mem21| |honda_main_#t~mem21|)
 (= |init_main_#t~mem24| |honda_main_#t~mem24|)
 (= |init_main_#t~mem22| |honda_main_#t~mem22|)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 1) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 536870911) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 1)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 1)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| (- 1))
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 1)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_486 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_487 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset (- 1)) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset (- 1)) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_488 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 1) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 1)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 1) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 1) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_486 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1)) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_487 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 536870911) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_488 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0))
 (and (= |init_main_#t~mem21| |honda_main_#t~mem21|)
 (= |init_main_#t~mem24| |honda_main_#t~mem24|)
 (= |init_main_#t~mem22| |honda_main_#t~mem22|)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 1) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 536870911) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 1)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 1)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| (- 1))
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 1)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_492 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_493 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset (- 1)) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset (- 1)) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_494 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 1) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 1)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 1) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 1) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_492 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1)) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_493 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 536870911) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_494 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0))
 (and (= |init_main_#t~mem21| |honda_main_#t~mem21|)
 (= |init_main_#t~mem24| |honda_main_#t~mem24|)
 (= |init_main_#t~mem22| |honda_main_#t~mem22|)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 1) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 536870911) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 1)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 1)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| (- 1))
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_498 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_499 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset (- 1)) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset (- 1)) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_500 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 1) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 1)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 1) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 1) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_498 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1)) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_499 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 536870911) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_500 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0))
 (and (= |init_main_#t~mem21| |honda_main_#t~mem21|)
 (= |init_main_#t~mem24| |honda_main_#t~mem24|)
 (= |init_main_#t~mem22| |honda_main_#t~mem22|)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 1) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 536870911) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 1)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 1)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| (- 1))
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_504 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_505 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset (- 1)) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 1)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset (- 1)) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_506 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 1) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 1)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 1) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 1) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_504 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1)) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_505 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 536870911) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_506 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0))
 (and (= |init_main_#t~mem21| |honda_main_#t~mem21|)
 (= |init_main_#t~mem24| |honda_main_#t~mem24|)
 (= |init_main_#t~mem22| |honda_main_#t~mem22|)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 1) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 536870911) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 1)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| (- 1))
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_510 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_511 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset (- 1)) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset (- 1)) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_512 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 1) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 1)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 1)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 1) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 1)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 1) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_510 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1)) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_511 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 536870911) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_512 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0))
 (and (= |init_main_#t~mem21| |honda_main_#t~mem21|)
 (= |init_main_#t~mem24| |honda_main_#t~mem24|)
 (= |init_main_#t~mem22| |honda_main_#t~mem22|)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 1) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 536870911) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 1)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| (- 1))
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_516 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_517 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 1)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset (- 1)) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset (- 1)) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_518 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 1) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 1)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 1)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 1) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 1) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_516 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1)) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_517 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 536870911) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_518 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0))
 (and (= |init_main_#t~mem21| |honda_main_#t~mem21|)
 (= |init_main_#t~mem24| |honda_main_#t~mem24|)
 (= |init_main_#t~mem22| |honda_main_#t~mem22|)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 1) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 536870911) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 1)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| (- 1))
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_522 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_523 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset (- 1)) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset (- 1)) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_524 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 1) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 1)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 1)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 1) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 1) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_522 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1)) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_523 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 536870911) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_524 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0))
 (and (= |init_main_#t~mem21| |honda_main_#t~mem21|)
 (= |init_main_#t~mem24| |honda_main_#t~mem24|)
 (= |init_main_#t~mem22| |honda_main_#t~mem22|)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 1) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 536870911) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 1)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| (- 1))
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_528 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_529 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 1)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset (- 1)) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset (- 1)) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_530 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 1) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 1)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 1) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 1) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_528 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1)) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_529 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 536870911) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_530 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0))
 (and (= |init_main_#t~mem21| |honda_main_#t~mem21|)
 (= |init_main_#t~mem24| |honda_main_#t~mem24|)
 (= |init_main_#t~mem22| |honda_main_#t~mem22|)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 1) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 536870911) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 1)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| (- 1))
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_534 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_535 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset (- 1)) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset (- 1)) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_536 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 1) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 1)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 1)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 1) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 1)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 1) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_534 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1)) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_535 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 536870911) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_536 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0))
 (and (= |init_main_#t~mem21| |honda_main_#t~mem21|)
 (= |init_main_#t~mem24| |honda_main_#t~mem24|)
 (= |init_main_#t~mem22| |honda_main_#t~mem22|)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 1) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 536870911) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 1)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| (- 1))
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_540 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_541 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset (- 1)) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset (- 1)) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_542 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 1) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 1)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 1) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 1)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 1) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_540 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1)) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_541 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 536870911) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_542 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0))
 (and (= |init_main_#t~mem21| |honda_main_#t~mem21|)
 (= |init_main_#t~mem24| |honda_main_#t~mem24|)
 (= |init_main_#t~mem22| |honda_main_#t~mem22|)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 1) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 536870911) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 1)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 1)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| (- 1))
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_546 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_547 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset (- 1)) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset (- 1)) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_548 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 1) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 1)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 1) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 1) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_546 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1)) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_547 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 536870911) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_548 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0))
 (and (= |init_main_#t~mem21| |honda_main_#t~mem21|)
 (= |init_main_#t~mem24| |honda_main_#t~mem24|)
 (= |init_main_#t~mem22| |honda_main_#t~mem22|)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 1) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 536870911) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 1)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| (- 1))
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_552 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_553 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset (- 1)) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 1)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset (- 1)) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_554 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 1) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 1)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 1) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 1) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_552 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1)) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_553 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 536870911) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_554 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0))
 (and (= |init_main_#t~mem21| |honda_main_#t~mem21|)
 (= |init_main_#t~mem24| |honda_main_#t~mem24|)
 (= |init_main_#t~mem22| |honda_main_#t~mem22|)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 1) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 536870911) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 1)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| (- 1))
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_558 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_559 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 1)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset (- 1)) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 1)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset (- 1)) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_560 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 1) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 1)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 1) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 1) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_558 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1)) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_559 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 536870911) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_560 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0))
 (and (= |init_main_#t~mem21| |honda_main_#t~mem21|)
 (= |init_main_#t~mem24| |honda_main_#t~mem24|)
 (= |init_main_#t~mem22| |honda_main_#t~mem22|)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 1) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 536870911) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 1)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 1)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| (- 1))
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_564 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_565 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset (- 1)) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 1)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset (- 1)) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_566 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 1) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 1)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 1) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 1) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_564 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1)) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_565 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 536870911) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_566 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0))
 (and (= |init_main_#t~mem21| |honda_main_#t~mem21|)
 (= |init_main_#t~mem24| |honda_main_#t~mem24|)
 (= |init_main_#t~mem22| |honda_main_#t~mem22|)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 1) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 536870911) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 1)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| (- 1))
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| (- 1))
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 1)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_570 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_571 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset (- 1)) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset (- 1)) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_572 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 1) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 1)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 1) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 1) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_570 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1)) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_571 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 536870911) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_572 1) 0) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_(select #length main_~y~2.base)| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc1.offset| 0)
 (* |honda_(select #length main_~N~2.base)| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(ite main_#t~short13 1 0)| 0) 
 (* honda_main_~N~2.base 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(select old(#length) main_~N~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(ite main_#t~short11 1 0)| 0) 
 (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* honda_main_~N~2.offset 0) 
 (* honda_main_~x~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 0) (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc0.offset| 0)
 (* |honda_(select #length main_~x~2.base)| 0) 
 (* honda_main_~y~2.base 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* honda_main_~x~2.offset 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0) (* |honda_#NULL.base| 0)
 (* |honda_(ite (select #valid main_~N~2.base) 1 0)| 0)
 (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem21| 0)
 (* |honda_(ite (select old(#valid) main_~N~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_main_#t~mem12| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~mem10| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem9| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite main_#t~short15 1 0)| 0) 
 (* |honda_main_#t~mem22| 0) 
 (* |honda_main_#t~nondet5| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_(ite main_#t~short13 1 0)| 0) 
 (* init_main_~N~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~mem12| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_(ite main_#t~short11 1 0)| 0) 
 (* |init_main_#t~mem10| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~nondet20| 0) 
 (* |init_main_#t~mem19| 0) 
 (* |init_main_#t~mem18| 0) 
 (* init_main_~N~2.offset 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_main_#t~mem14| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* |init_(ite main_#t~short15 1 0)| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)))
 (or
 (and
 (= |honda_(select #length main_~y~2.base)|
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|))
 (= |honda_(select old(#length) main_~x~2.base)|
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|))
 (= |honda_main_#t~malloc1.offset|
 (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|))
 (= |honda_(select #length main_~N~2.base)|
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|))
 (= |honda_main_#t~nondet7|
 (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|))
 (= |honda_(ite main_#t~short13 1 0)|
 (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|))
 (= honda_main_~N~2.base (+ honda_main_~N~2.base ray_main_~N~2.base))
 (= |honda_main_#t~nondet3|
 (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|))
 (= |honda_main_#t~malloc1.base|
 (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|))
 (= |honda_(select old(#length) main_~y~2.base)|
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|))
 (= |honda_(select old(#length) main_~N~2.base)|
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|))
 (= |honda_(ite main_#t~short11 1 0)|
 (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|))
 (= |honda_main_#t~mem16| (+ |honda_main_#t~mem16| |ray_main_#t~mem16|))
 (= honda_main_~N~2.offset (+ honda_main_~N~2.offset ray_main_~N~2.offset))
 (= honda_main_~x~2.base (+ honda_main_~x~2.base ray_main_~x~2.base))
 (= |honda_main_#t~malloc2.offset|
 (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|))
 (=
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|))
 (= |honda_main_#t~mem17| (+ |honda_main_#t~mem17| |ray_main_#t~mem17|))
 (= |honda_main_#t~mem14| (+ |honda_main_#t~mem14| |ray_main_#t~mem14|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|))
 (= |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|))
 (= |honda_main_#t~malloc0.offset|
 (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|))
 (= |honda_(select #length main_~x~2.base)|
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|))
 (= honda_main_~y~2.base (+ honda_main_~y~2.base ray_main_~y~2.base))
 (=
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|))
 (= honda_main_~x~2.offset (+ honda_main_~x~2.offset ray_main_~x~2.offset))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (=
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|))
 (= |honda_(ite (select #valid main_~N~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|))
 (= |honda_main_#t~malloc2.base|
 (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|))
 (= |honda_main_#t~malloc0.base|
 (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|))
 (= |honda_main_#t~mem12| (+ |honda_main_#t~mem12| |ray_main_#t~mem12|))
 (= honda_main_~y~2.offset (+ honda_main_~y~2.offset ray_main_~y~2.offset))
 (= |honda_main_#t~mem10| (+ |honda_main_#t~mem10| |ray_main_#t~mem10|))
 (= |honda_main_#t~mem9| (+ |honda_main_#t~mem9| |ray_main_#t~mem9|))
 (= |honda_(ite (select #valid main_~x~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|))
 (= |honda_(ite main_#t~short15 1 0)|
 (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|))
 (= |honda_main_#t~nondet5|
 (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|))
 (= |honda_(ite (select #valid main_~y~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|))
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 1)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| (- 1)) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 1)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 2)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 1)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 2)) (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 1)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 1)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) (- 1))
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 1)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 1)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 
 (- 1)) (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 1)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 1)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) (- 1))
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 1)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 1)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) (- 1))
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 
 (- 1)) (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) (- 1))
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 1)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (= |ray_(select #length main_~y~2.base)|
 (* |ray_(select #length main_~y~2.base)| lambda))
 (= |ray_(select old(#length) main_~x~2.base)|
 (* |ray_(select old(#length) main_~x~2.base)| lambda))
 (= |ray_main_#t~malloc1.offset| (* |ray_main_#t~malloc1.offset| lambda))
 (= |ray_(select #length main_~N~2.base)|
 (* |ray_(select #length main_~N~2.base)| lambda))
 (= |ray_main_#t~nondet7| (* |ray_main_#t~nondet7| lambda))
 (= |ray_(ite main_#t~short13 1 0)|
 (* |ray_(ite main_#t~short13 1 0)| lambda))
 (= ray_main_~N~2.base (* ray_main_~N~2.base lambda))
 (= |ray_main_#t~nondet3| (* |ray_main_#t~nondet3| lambda))
 (= |ray_main_#t~malloc1.base| (* |ray_main_#t~malloc1.base| lambda))
 (= |ray_(select old(#length) main_~y~2.base)|
 (* |ray_(select old(#length) main_~y~2.base)| lambda))
 (= |ray_(select old(#length) main_~N~2.base)|
 (* |ray_(select old(#length) main_~N~2.base)| lambda))
 (= |ray_(ite main_#t~short11 1 0)|
 (* |ray_(ite main_#t~short11 1 0)| lambda))
 (= |ray_main_#t~mem16| (* |ray_main_#t~mem16| lambda))
 (= ray_main_~N~2.offset (* ray_main_~N~2.offset lambda))
 (= ray_main_~x~2.base (* ray_main_~x~2.base lambda))
 (= |ray_main_#t~malloc2.offset| (* |ray_main_#t~malloc2.offset| lambda))
 (= |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda)) (= |ray_main_#t~mem17| (* |ray_main_#t~mem17| lambda))
 (= |ray_main_#t~mem14| (* |ray_main_#t~mem14| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda))
 (= |ray_main_#t~malloc0.offset| (* |ray_main_#t~malloc0.offset| lambda))
 (= |ray_(select #length main_~x~2.base)|
 (* |ray_(select #length main_~x~2.base)| lambda))
 (= ray_main_~y~2.base (* ray_main_~y~2.base lambda))
 (= |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda)) (= ray_main_~x~2.offset (* ray_main_~x~2.offset lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda))
 (= |ray_(ite (select #valid main_~N~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda))
 (= |ray_main_#t~malloc2.base| (* |ray_main_#t~malloc2.base| lambda))
 (= |ray_main_#t~malloc0.base| (* |ray_main_#t~malloc0.base| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda))
 (= |ray_main_#t~mem12| (* |ray_main_#t~mem12| lambda))
 (= ray_main_~y~2.offset (* ray_main_~y~2.offset lambda))
 (= |ray_main_#t~mem10| (* |ray_main_#t~mem10| lambda))
 (= |ray_main_#t~mem9| (* |ray_main_#t~mem9| lambda))
 (= |ray_(ite (select #valid main_~x~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda))
 (= |ray_(ite main_#t~short15 1 0)|
 (* |ray_(ite main_#t~short15 1 0)| lambda))
 (= |ray_main_#t~nondet5| (* |ray_main_#t~nondet5| lambda))
 (= |ray_(ite (select #valid main_~y~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda))
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 1)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| (- 1)) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 2)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 1)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 2)) (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 1)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 1) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) (- 1))
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 1)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 1)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) (- 1)) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 1) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 1) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 1)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) (- 1))
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 1)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) (- 1))
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) (- 1))
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 1)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_(select #length main_~y~2.base)|
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|))
 (= |honda_(select old(#length) main_~x~2.base)|
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|))
 (= |honda_main_#t~malloc1.offset|
 (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|))
 (= |honda_(select #length main_~N~2.base)|
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|))
 (= |honda_main_#t~nondet7|
 (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|))
 (= |honda_(ite main_#t~short13 1 0)|
 (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|))
 (= honda_main_~N~2.base (+ honda_main_~N~2.base ray_main_~N~2.base))
 (= |honda_main_#t~nondet3|
 (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|))
 (= |honda_main_#t~malloc1.base|
 (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|))
 (= |honda_(select old(#length) main_~y~2.base)|
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|))
 (= |honda_(select old(#length) main_~N~2.base)|
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|))
 (= |honda_(ite main_#t~short11 1 0)|
 (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|))
 (= |honda_main_#t~mem16| (+ |honda_main_#t~mem16| |ray_main_#t~mem16|))
 (= honda_main_~N~2.offset (+ honda_main_~N~2.offset ray_main_~N~2.offset))
 (= honda_main_~x~2.base (+ honda_main_~x~2.base ray_main_~x~2.base))
 (= |honda_main_#t~malloc2.offset|
 (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|))
 (=
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|))
 (= |honda_main_#t~mem17| (+ |honda_main_#t~mem17| |ray_main_#t~mem17|))
 (= |honda_main_#t~mem14| (+ |honda_main_#t~mem14| |ray_main_#t~mem14|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|))
 (= |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|))
 (= |honda_main_#t~malloc0.offset|
 (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|))
 (= |honda_(select #length main_~x~2.base)|
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|))
 (= honda_main_~y~2.base (+ honda_main_~y~2.base ray_main_~y~2.base))
 (=
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|))
 (= honda_main_~x~2.offset (+ honda_main_~x~2.offset ray_main_~x~2.offset))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (=
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|))
 (= |honda_(ite (select #valid main_~N~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|))
 (= |honda_main_#t~malloc2.base|
 (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|))
 (= |honda_main_#t~malloc0.base|
 (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|))
 (= |honda_main_#t~mem12| (+ |honda_main_#t~mem12| |ray_main_#t~mem12|))
 (= honda_main_~y~2.offset (+ honda_main_~y~2.offset ray_main_~y~2.offset))
 (= |honda_main_#t~mem10| (+ |honda_main_#t~mem10| |ray_main_#t~mem10|))
 (= |honda_main_#t~mem9| (+ |honda_main_#t~mem9| |ray_main_#t~mem9|))
 (= |honda_(ite (select #valid main_~x~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|))
 (= |honda_(ite main_#t~short15 1 0)|
 (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|))
 (= |honda_main_#t~nondet5|
 (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|))
 (= |honda_(ite (select #valid main_~y~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|))
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 1)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| (- 1)) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 1)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 2)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 1)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 2)) (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 1)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 1)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 1)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 
 (- 1)) (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 1)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 1)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 1)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) (- 1))
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 1)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) (- 1))
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) (- 1))
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 1)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 
 (- 1)) (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) (- 1))
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 1)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (= |ray_(select #length main_~y~2.base)|
 (* |ray_(select #length main_~y~2.base)| lambda))
 (= |ray_(select old(#length) main_~x~2.base)|
 (* |ray_(select old(#length) main_~x~2.base)| lambda))
 (= |ray_main_#t~malloc1.offset| (* |ray_main_#t~malloc1.offset| lambda))
 (= |ray_(select #length main_~N~2.base)|
 (* |ray_(select #length main_~N~2.base)| lambda))
 (= |ray_main_#t~nondet7| (* |ray_main_#t~nondet7| lambda))
 (= |ray_(ite main_#t~short13 1 0)|
 (* |ray_(ite main_#t~short13 1 0)| lambda))
 (= ray_main_~N~2.base (* ray_main_~N~2.base lambda))
 (= |ray_main_#t~nondet3| (* |ray_main_#t~nondet3| lambda))
 (= |ray_main_#t~malloc1.base| (* |ray_main_#t~malloc1.base| lambda))
 (= |ray_(select old(#length) main_~y~2.base)|
 (* |ray_(select old(#length) main_~y~2.base)| lambda))
 (= |ray_(select old(#length) main_~N~2.base)|
 (* |ray_(select old(#length) main_~N~2.base)| lambda))
 (= |ray_(ite main_#t~short11 1 0)|
 (* |ray_(ite main_#t~short11 1 0)| lambda))
 (= |ray_main_#t~mem16| (* |ray_main_#t~mem16| lambda))
 (= ray_main_~N~2.offset (* ray_main_~N~2.offset lambda))
 (= ray_main_~x~2.base (* ray_main_~x~2.base lambda))
 (= |ray_main_#t~malloc2.offset| (* |ray_main_#t~malloc2.offset| lambda))
 (= |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda)) (= |ray_main_#t~mem17| (* |ray_main_#t~mem17| lambda))
 (= |ray_main_#t~mem14| (* |ray_main_#t~mem14| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda))
 (= |ray_main_#t~malloc0.offset| (* |ray_main_#t~malloc0.offset| lambda))
 (= |ray_(select #length main_~x~2.base)|
 (* |ray_(select #length main_~x~2.base)| lambda))
 (= ray_main_~y~2.base (* ray_main_~y~2.base lambda))
 (= |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda)) (= ray_main_~x~2.offset (* ray_main_~x~2.offset lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda))
 (= |ray_(ite (select #valid main_~N~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda))
 (= |ray_main_#t~malloc2.base| (* |ray_main_#t~malloc2.base| lambda))
 (= |ray_main_#t~malloc0.base| (* |ray_main_#t~malloc0.base| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda))
 (= |ray_main_#t~mem12| (* |ray_main_#t~mem12| lambda))
 (= ray_main_~y~2.offset (* ray_main_~y~2.offset lambda))
 (= |ray_main_#t~mem10| (* |ray_main_#t~mem10| lambda))
 (= |ray_main_#t~mem9| (* |ray_main_#t~mem9| lambda))
 (= |ray_(ite (select #valid main_~x~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda))
 (= |ray_(ite main_#t~short15 1 0)|
 (* |ray_(ite main_#t~short15 1 0)| lambda))
 (= |ray_main_#t~nondet5| (* |ray_main_#t~nondet5| lambda))
 (= |ray_(ite (select #valid main_~y~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda))
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 1)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| (- 1)) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 2)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 1)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 2)) (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 1)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 1)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 1)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) (- 1)) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 1) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 1) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 1)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 1)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) (- 1))
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 1)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) (- 1))
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) (- 1))
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) (- 1))
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 1)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_(select #length main_~y~2.base)|
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|))
 (= |honda_(select old(#length) main_~x~2.base)|
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|))
 (= |honda_main_#t~malloc1.offset|
 (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|))
 (= |honda_(select #length main_~N~2.base)|
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|))
 (= |honda_main_#t~nondet7|
 (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|))
 (= |honda_(ite main_#t~short13 1 0)|
 (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|))
 (= honda_main_~N~2.base (+ honda_main_~N~2.base ray_main_~N~2.base))
 (= |honda_main_#t~nondet3|
 (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|))
 (= |honda_main_#t~malloc1.base|
 (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|))
 (= |honda_(select old(#length) main_~y~2.base)|
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|))
 (= |honda_(select old(#length) main_~N~2.base)|
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|))
 (= |honda_(ite main_#t~short11 1 0)|
 (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|))
 (= |honda_main_#t~mem16| (+ |honda_main_#t~mem16| |ray_main_#t~mem16|))
 (= honda_main_~N~2.offset (+ honda_main_~N~2.offset ray_main_~N~2.offset))
 (= honda_main_~x~2.base (+ honda_main_~x~2.base ray_main_~x~2.base))
 (= |honda_main_#t~malloc2.offset|
 (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|))
 (=
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|))
 (= |honda_main_#t~mem17| (+ |honda_main_#t~mem17| |ray_main_#t~mem17|))
 (= |honda_main_#t~mem14| (+ |honda_main_#t~mem14| |ray_main_#t~mem14|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|))
 (= |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|))
 (= |honda_main_#t~malloc0.offset|
 (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|))
 (= |honda_(select #length main_~x~2.base)|
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|))
 (= honda_main_~y~2.base (+ honda_main_~y~2.base ray_main_~y~2.base))
 (=
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|))
 (= honda_main_~x~2.offset (+ honda_main_~x~2.offset ray_main_~x~2.offset))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (=
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|))
 (= |honda_(ite (select #valid main_~N~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|))
 (= |honda_main_#t~malloc2.base|
 (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|))
 (= |honda_main_#t~malloc0.base|
 (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|))
 (= |honda_main_#t~mem12| (+ |honda_main_#t~mem12| |ray_main_#t~mem12|))
 (= honda_main_~y~2.offset (+ honda_main_~y~2.offset ray_main_~y~2.offset))
 (= |honda_main_#t~mem10| (+ |honda_main_#t~mem10| |ray_main_#t~mem10|))
 (= |honda_main_#t~mem9| (+ |honda_main_#t~mem9| |ray_main_#t~mem9|))
 (= |honda_(ite (select #valid main_~x~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|))
 (= |honda_(ite main_#t~short15 1 0)|
 (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|))
 (= |honda_main_#t~nondet5|
 (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|))
 (= |honda_(ite (select #valid main_~y~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|))
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 1)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) (- 1))
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 1)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| (- 1)) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 1)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 2)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 1)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 2)) (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 1)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 1)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) (- 1))
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 1)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 1)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 
 (- 1)) (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 1)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 1)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 1)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) (- 1))
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 
 (- 1)) (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) (- 1))
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 1)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (= |ray_(select #length main_~y~2.base)|
 (* |ray_(select #length main_~y~2.base)| lambda))
 (= |ray_(select old(#length) main_~x~2.base)|
 (* |ray_(select old(#length) main_~x~2.base)| lambda))
 (= |ray_main_#t~malloc1.offset| (* |ray_main_#t~malloc1.offset| lambda))
 (= |ray_(select #length main_~N~2.base)|
 (* |ray_(select #length main_~N~2.base)| lambda))
 (= |ray_main_#t~nondet7| (* |ray_main_#t~nondet7| lambda))
 (= |ray_(ite main_#t~short13 1 0)|
 (* |ray_(ite main_#t~short13 1 0)| lambda))
 (= ray_main_~N~2.base (* ray_main_~N~2.base lambda))
 (= |ray_main_#t~nondet3| (* |ray_main_#t~nondet3| lambda))
 (= |ray_main_#t~malloc1.base| (* |ray_main_#t~malloc1.base| lambda))
 (= |ray_(select old(#length) main_~y~2.base)|
 (* |ray_(select old(#length) main_~y~2.base)| lambda))
 (= |ray_(select old(#length) main_~N~2.base)|
 (* |ray_(select old(#length) main_~N~2.base)| lambda))
 (= |ray_(ite main_#t~short11 1 0)|
 (* |ray_(ite main_#t~short11 1 0)| lambda))
 (= |ray_main_#t~mem16| (* |ray_main_#t~mem16| lambda))
 (= ray_main_~N~2.offset (* ray_main_~N~2.offset lambda))
 (= ray_main_~x~2.base (* ray_main_~x~2.base lambda))
 (= |ray_main_#t~malloc2.offset| (* |ray_main_#t~malloc2.offset| lambda))
 (= |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda)) (= |ray_main_#t~mem17| (* |ray_main_#t~mem17| lambda))
 (= |ray_main_#t~mem14| (* |ray_main_#t~mem14| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda))
 (= |ray_main_#t~malloc0.offset| (* |ray_main_#t~malloc0.offset| lambda))
 (= |ray_(select #length main_~x~2.base)|
 (* |ray_(select #length main_~x~2.base)| lambda))
 (= ray_main_~y~2.base (* ray_main_~y~2.base lambda))
 (= |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda)) (= ray_main_~x~2.offset (* ray_main_~x~2.offset lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda))
 (= |ray_(ite (select #valid main_~N~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda))
 (= |ray_main_#t~malloc2.base| (* |ray_main_#t~malloc2.base| lambda))
 (= |ray_main_#t~malloc0.base| (* |ray_main_#t~malloc0.base| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda))
 (= |ray_main_#t~mem12| (* |ray_main_#t~mem12| lambda))
 (= ray_main_~y~2.offset (* ray_main_~y~2.offset lambda))
 (= |ray_main_#t~mem10| (* |ray_main_#t~mem10| lambda))
 (= |ray_main_#t~mem9| (* |ray_main_#t~mem9| lambda))
 (= |ray_(ite (select #valid main_~x~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda))
 (= |ray_(ite main_#t~short15 1 0)|
 (* |ray_(ite main_#t~short15 1 0)| lambda))
 (= |ray_main_#t~nondet5| (* |ray_main_#t~nondet5| lambda))
 (= |ray_(ite (select #valid main_~y~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda))
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 1)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) (- 1))
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 1)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| (- 1)) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 2)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 1)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 2)) (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 1)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 1) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) (- 1))
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 1)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 1)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) (- 1)) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 1) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 1) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 1)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 1)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) (- 1))
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) (- 1))
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 1)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_(select #length main_~y~2.base)|
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|))
 (= |honda_(select old(#length) main_~x~2.base)|
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|))
 (= |honda_main_#t~malloc1.offset|
 (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|))
 (= |honda_(select #length main_~N~2.base)|
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|))
 (= |honda_main_#t~nondet7|
 (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|))
 (= |honda_(ite main_#t~short13 1 0)|
 (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|))
 (= honda_main_~N~2.base (+ honda_main_~N~2.base ray_main_~N~2.base))
 (= |honda_main_#t~nondet3|
 (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|))
 (= |honda_main_#t~malloc1.base|
 (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|))
 (= |honda_(select old(#length) main_~y~2.base)|
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|))
 (= |honda_(select old(#length) main_~N~2.base)|
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|))
 (= |honda_(ite main_#t~short11 1 0)|
 (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|))
 (= |honda_main_#t~mem16| (+ |honda_main_#t~mem16| |ray_main_#t~mem16|))
 (= honda_main_~N~2.offset (+ honda_main_~N~2.offset ray_main_~N~2.offset))
 (= honda_main_~x~2.base (+ honda_main_~x~2.base ray_main_~x~2.base))
 (= |honda_main_#t~malloc2.offset|
 (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|))
 (=
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|))
 (= |honda_main_#t~mem17| (+ |honda_main_#t~mem17| |ray_main_#t~mem17|))
 (= |honda_main_#t~mem14| (+ |honda_main_#t~mem14| |ray_main_#t~mem14|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|))
 (= |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|))
 (= |honda_main_#t~malloc0.offset|
 (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|))
 (= |honda_(select #length main_~x~2.base)|
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|))
 (= honda_main_~y~2.base (+ honda_main_~y~2.base ray_main_~y~2.base))
 (=
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|))
 (= honda_main_~x~2.offset (+ honda_main_~x~2.offset ray_main_~x~2.offset))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (=
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|))
 (= |honda_(ite (select #valid main_~N~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|))
 (= |honda_main_#t~malloc2.base|
 (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|))
 (= |honda_main_#t~malloc0.base|
 (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|))
 (= |honda_main_#t~mem12| (+ |honda_main_#t~mem12| |ray_main_#t~mem12|))
 (= honda_main_~y~2.offset (+ honda_main_~y~2.offset ray_main_~y~2.offset))
 (= |honda_main_#t~mem10| (+ |honda_main_#t~mem10| |ray_main_#t~mem10|))
 (= |honda_main_#t~mem9| (+ |honda_main_#t~mem9| |ray_main_#t~mem9|))
 (= |honda_(ite (select #valid main_~x~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|))
 (= |honda_(ite main_#t~short15 1 0)|
 (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|))
 (= |honda_main_#t~nondet5|
 (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|))
 (= |honda_(ite (select #valid main_~y~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|))
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 1)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| (- 1)) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 1)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 2)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 1)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 2)) (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 1)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 1)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 1)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 
 (- 1)) (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 1)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 1)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) (- 1))
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 1)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 1)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) (- 1))
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 1)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) (- 1))
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 
 (- 1)) (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) (- 1))
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 1)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (= |ray_(select #length main_~y~2.base)|
 (* |ray_(select #length main_~y~2.base)| lambda))
 (= |ray_(select old(#length) main_~x~2.base)|
 (* |ray_(select old(#length) main_~x~2.base)| lambda))
 (= |ray_main_#t~malloc1.offset| (* |ray_main_#t~malloc1.offset| lambda))
 (= |ray_(select #length main_~N~2.base)|
 (* |ray_(select #length main_~N~2.base)| lambda))
 (= |ray_main_#t~nondet7| (* |ray_main_#t~nondet7| lambda))
 (= |ray_(ite main_#t~short13 1 0)|
 (* |ray_(ite main_#t~short13 1 0)| lambda))
 (= ray_main_~N~2.base (* ray_main_~N~2.base lambda))
 (= |ray_main_#t~nondet3| (* |ray_main_#t~nondet3| lambda))
 (= |ray_main_#t~malloc1.base| (* |ray_main_#t~malloc1.base| lambda))
 (= |ray_(select old(#length) main_~y~2.base)|
 (* |ray_(select old(#length) main_~y~2.base)| lambda))
 (= |ray_(select old(#length) main_~N~2.base)|
 (* |ray_(select old(#length) main_~N~2.base)| lambda))
 (= |ray_(ite main_#t~short11 1 0)|
 (* |ray_(ite main_#t~short11 1 0)| lambda))
 (= |ray_main_#t~mem16| (* |ray_main_#t~mem16| lambda))
 (= ray_main_~N~2.offset (* ray_main_~N~2.offset lambda))
 (= ray_main_~x~2.base (* ray_main_~x~2.base lambda))
 (= |ray_main_#t~malloc2.offset| (* |ray_main_#t~malloc2.offset| lambda))
 (= |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda)) (= |ray_main_#t~mem17| (* |ray_main_#t~mem17| lambda))
 (= |ray_main_#t~mem14| (* |ray_main_#t~mem14| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda))
 (= |ray_main_#t~malloc0.offset| (* |ray_main_#t~malloc0.offset| lambda))
 (= |ray_(select #length main_~x~2.base)|
 (* |ray_(select #length main_~x~2.base)| lambda))
 (= ray_main_~y~2.base (* ray_main_~y~2.base lambda))
 (= |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda)) (= ray_main_~x~2.offset (* ray_main_~x~2.offset lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda))
 (= |ray_(ite (select #valid main_~N~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda))
 (= |ray_main_#t~malloc2.base| (* |ray_main_#t~malloc2.base| lambda))
 (= |ray_main_#t~malloc0.base| (* |ray_main_#t~malloc0.base| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda))
 (= |ray_main_#t~mem12| (* |ray_main_#t~mem12| lambda))
 (= ray_main_~y~2.offset (* ray_main_~y~2.offset lambda))
 (= |ray_main_#t~mem10| (* |ray_main_#t~mem10| lambda))
 (= |ray_main_#t~mem9| (* |ray_main_#t~mem9| lambda))
 (= |ray_(ite (select #valid main_~x~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda))
 (= |ray_(ite main_#t~short15 1 0)|
 (* |ray_(ite main_#t~short15 1 0)| lambda))
 (= |ray_main_#t~nondet5| (* |ray_main_#t~nondet5| lambda))
 (= |ray_(ite (select #valid main_~y~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda))
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 1)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| (- 1)) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 2)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 1)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 2)) (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 1)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 1)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 1)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) (- 1)) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 1) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 1) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) (- 1))
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 1) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 1)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 1)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) (- 1))
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 1)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) (- 1))
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) (- 1))
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 1)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_(select #length main_~y~2.base)|
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|))
 (= |honda_(select old(#length) main_~x~2.base)|
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|))
 (= |honda_main_#t~malloc1.offset|
 (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|))
 (= |honda_(select #length main_~N~2.base)|
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|))
 (= |honda_main_#t~nondet7|
 (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|))
 (= |honda_(ite main_#t~short13 1 0)|
 (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|))
 (= honda_main_~N~2.base (+ honda_main_~N~2.base ray_main_~N~2.base))
 (= |honda_main_#t~nondet3|
 (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|))
 (= |honda_main_#t~malloc1.base|
 (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|))
 (= |honda_(select old(#length) main_~y~2.base)|
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|))
 (= |honda_(select old(#length) main_~N~2.base)|
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|))
 (= |honda_(ite main_#t~short11 1 0)|
 (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|))
 (= |honda_main_#t~mem16| (+ |honda_main_#t~mem16| |ray_main_#t~mem16|))
 (= honda_main_~N~2.offset (+ honda_main_~N~2.offset ray_main_~N~2.offset))
 (= honda_main_~x~2.base (+ honda_main_~x~2.base ray_main_~x~2.base))
 (= |honda_main_#t~malloc2.offset|
 (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|))
 (=
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|))
 (= |honda_main_#t~mem17| (+ |honda_main_#t~mem17| |ray_main_#t~mem17|))
 (= |honda_main_#t~mem14| (+ |honda_main_#t~mem14| |ray_main_#t~mem14|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|))
 (= |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|))
 (= |honda_main_#t~malloc0.offset|
 (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|))
 (= |honda_(select #length main_~x~2.base)|
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|))
 (= honda_main_~y~2.base (+ honda_main_~y~2.base ray_main_~y~2.base))
 (=
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|))
 (= honda_main_~x~2.offset (+ honda_main_~x~2.offset ray_main_~x~2.offset))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (=
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|))
 (= |honda_(ite (select #valid main_~N~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|))
 (= |honda_main_#t~malloc2.base|
 (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|))
 (= |honda_main_#t~malloc0.base|
 (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|))
 (= |honda_main_#t~mem12| (+ |honda_main_#t~mem12| |ray_main_#t~mem12|))
 (= honda_main_~y~2.offset (+ honda_main_~y~2.offset ray_main_~y~2.offset))
 (= |honda_main_#t~mem10| (+ |honda_main_#t~mem10| |ray_main_#t~mem10|))
 (= |honda_main_#t~mem9| (+ |honda_main_#t~mem9| |ray_main_#t~mem9|))
 (= |honda_(ite (select #valid main_~x~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|))
 (= |honda_(ite main_#t~short15 1 0)|
 (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|))
 (= |honda_main_#t~nondet5|
 (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|))
 (= |honda_(ite (select #valid main_~y~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|))
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 1)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) (- 1))
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 1)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 1) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 1)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 2)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 1)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 2)) (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 1)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 1)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) (- 1))
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 1)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 1)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 
 (- 1)) (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 1)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 1)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 1)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) (- 1))
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 
 (- 1)) (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) (- 1))
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 1)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (= |ray_(select #length main_~y~2.base)|
 (* |ray_(select #length main_~y~2.base)| lambda))
 (= |ray_(select old(#length) main_~x~2.base)|
 (* |ray_(select old(#length) main_~x~2.base)| lambda))
 (= |ray_main_#t~malloc1.offset| (* |ray_main_#t~malloc1.offset| lambda))
 (= |ray_(select #length main_~N~2.base)|
 (* |ray_(select #length main_~N~2.base)| lambda))
 (= |ray_main_#t~nondet7| (* |ray_main_#t~nondet7| lambda))
 (= |ray_(ite main_#t~short13 1 0)|
 (* |ray_(ite main_#t~short13 1 0)| lambda))
 (= ray_main_~N~2.base (* ray_main_~N~2.base lambda))
 (= |ray_main_#t~nondet3| (* |ray_main_#t~nondet3| lambda))
 (= |ray_main_#t~malloc1.base| (* |ray_main_#t~malloc1.base| lambda))
 (= |ray_(select old(#length) main_~y~2.base)|
 (* |ray_(select old(#length) main_~y~2.base)| lambda))
 (= |ray_(select old(#length) main_~N~2.base)|
 (* |ray_(select old(#length) main_~N~2.base)| lambda))
 (= |ray_(ite main_#t~short11 1 0)|
 (* |ray_(ite main_#t~short11 1 0)| lambda))
 (= |ray_main_#t~mem16| (* |ray_main_#t~mem16| lambda))
 (= ray_main_~N~2.offset (* ray_main_~N~2.offset lambda))
 (= ray_main_~x~2.base (* ray_main_~x~2.base lambda))
 (= |ray_main_#t~malloc2.offset| (* |ray_main_#t~malloc2.offset| lambda))
 (= |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda)) (= |ray_main_#t~mem17| (* |ray_main_#t~mem17| lambda))
 (= |ray_main_#t~mem14| (* |ray_main_#t~mem14| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda))
 (= |ray_main_#t~malloc0.offset| (* |ray_main_#t~malloc0.offset| lambda))
 (= |ray_(select #length main_~x~2.base)|
 (* |ray_(select #length main_~x~2.base)| lambda))
 (= ray_main_~y~2.base (* ray_main_~y~2.base lambda))
 (= |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda)) (= ray_main_~x~2.offset (* ray_main_~x~2.offset lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda))
 (= |ray_(ite (select #valid main_~N~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda))
 (= |ray_main_#t~malloc2.base| (* |ray_main_#t~malloc2.base| lambda))
 (= |ray_main_#t~malloc0.base| (* |ray_main_#t~malloc0.base| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda))
 (= |ray_main_#t~mem12| (* |ray_main_#t~mem12| lambda))
 (= ray_main_~y~2.offset (* ray_main_~y~2.offset lambda))
 (= |ray_main_#t~mem10| (* |ray_main_#t~mem10| lambda))
 (= |ray_main_#t~mem9| (* |ray_main_#t~mem9| lambda))
 (= |ray_(ite (select #valid main_~x~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda))
 (= |ray_(ite main_#t~short15 1 0)|
 (* |ray_(ite main_#t~short15 1 0)| lambda))
 (= |ray_main_#t~nondet5| (* |ray_main_#t~nondet5| lambda))
 (= |ray_(ite (select #valid main_~y~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda))
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 1)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) (- 1))
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 1)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 1) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 2)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 1)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 2)) (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 1)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 1) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) (- 1))
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 1)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 1)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) (- 1)) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 1) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 1) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 1)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 1)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) (- 1))
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) (- 1))
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 1)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_(select #length main_~y~2.base)|
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|))
 (= |honda_(select old(#length) main_~x~2.base)|
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|))
 (= |honda_main_#t~malloc1.offset|
 (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|))
 (= |honda_(select #length main_~N~2.base)|
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|))
 (= |honda_main_#t~nondet7|
 (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|))
 (= |honda_(ite main_#t~short13 1 0)|
 (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|))
 (= honda_main_~N~2.base (+ honda_main_~N~2.base ray_main_~N~2.base))
 (= |honda_main_#t~nondet3|
 (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|))
 (= |honda_main_#t~malloc1.base|
 (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|))
 (= |honda_(select old(#length) main_~y~2.base)|
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|))
 (= |honda_(select old(#length) main_~N~2.base)|
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|))
 (= |honda_(ite main_#t~short11 1 0)|
 (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|))
 (= |honda_main_#t~mem16| (+ |honda_main_#t~mem16| |ray_main_#t~mem16|))
 (= honda_main_~N~2.offset (+ honda_main_~N~2.offset ray_main_~N~2.offset))
 (= honda_main_~x~2.base (+ honda_main_~x~2.base ray_main_~x~2.base))
 (= |honda_main_#t~malloc2.offset|
 (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|))
 (=
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|))
 (= |honda_main_#t~mem17| (+ |honda_main_#t~mem17| |ray_main_#t~mem17|))
 (= |honda_main_#t~mem14| (+ |honda_main_#t~mem14| |ray_main_#t~mem14|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|))
 (= |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|))
 (= |honda_main_#t~malloc0.offset|
 (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|))
 (= |honda_(select #length main_~x~2.base)|
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|))
 (= honda_main_~y~2.base (+ honda_main_~y~2.base ray_main_~y~2.base))
 (=
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|))
 (= honda_main_~x~2.offset (+ honda_main_~x~2.offset ray_main_~x~2.offset))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (=
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|))
 (= |honda_(ite (select #valid main_~N~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|))
 (= |honda_main_#t~malloc2.base|
 (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|))
 (= |honda_main_#t~malloc0.base|
 (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|))
 (= |honda_main_#t~mem12| (+ |honda_main_#t~mem12| |ray_main_#t~mem12|))
 (= honda_main_~y~2.offset (+ honda_main_~y~2.offset ray_main_~y~2.offset))
 (= |honda_main_#t~mem10| (+ |honda_main_#t~mem10| |ray_main_#t~mem10|))
 (= |honda_main_#t~mem9| (+ |honda_main_#t~mem9| |ray_main_#t~mem9|))
 (= |honda_(ite (select #valid main_~x~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|))
 (= |honda_(ite main_#t~short15 1 0)|
 (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|))
 (= |honda_main_#t~nondet5|
 (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|))
 (= |honda_(ite (select #valid main_~y~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|))
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 1)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 1) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 1)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 2)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 1)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 2)) (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 1)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 1)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) (- 1))
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 1)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 1)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 
 (- 1)) (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 1)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 1)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) (- 1))
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 1)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 1)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) (- 1))
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 
 (- 1)) (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) (- 1))
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 1)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (= |ray_(select #length main_~y~2.base)|
 (* |ray_(select #length main_~y~2.base)| lambda))
 (= |ray_(select old(#length) main_~x~2.base)|
 (* |ray_(select old(#length) main_~x~2.base)| lambda))
 (= |ray_main_#t~malloc1.offset| (* |ray_main_#t~malloc1.offset| lambda))
 (= |ray_(select #length main_~N~2.base)|
 (* |ray_(select #length main_~N~2.base)| lambda))
 (= |ray_main_#t~nondet7| (* |ray_main_#t~nondet7| lambda))
 (= |ray_(ite main_#t~short13 1 0)|
 (* |ray_(ite main_#t~short13 1 0)| lambda))
 (= ray_main_~N~2.base (* ray_main_~N~2.base lambda))
 (= |ray_main_#t~nondet3| (* |ray_main_#t~nondet3| lambda))
 (= |ray_main_#t~malloc1.base| (* |ray_main_#t~malloc1.base| lambda))
 (= |ray_(select old(#length) main_~y~2.base)|
 (* |ray_(select old(#length) main_~y~2.base)| lambda))
 (= |ray_(select old(#length) main_~N~2.base)|
 (* |ray_(select old(#length) main_~N~2.base)| lambda))
 (= |ray_(ite main_#t~short11 1 0)|
 (* |ray_(ite main_#t~short11 1 0)| lambda))
 (= |ray_main_#t~mem16| (* |ray_main_#t~mem16| lambda))
 (= ray_main_~N~2.offset (* ray_main_~N~2.offset lambda))
 (= ray_main_~x~2.base (* ray_main_~x~2.base lambda))
 (= |ray_main_#t~malloc2.offset| (* |ray_main_#t~malloc2.offset| lambda))
 (= |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda)) (= |ray_main_#t~mem17| (* |ray_main_#t~mem17| lambda))
 (= |ray_main_#t~mem14| (* |ray_main_#t~mem14| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda))
 (= |ray_main_#t~malloc0.offset| (* |ray_main_#t~malloc0.offset| lambda))
 (= |ray_(select #length main_~x~2.base)|
 (* |ray_(select #length main_~x~2.base)| lambda))
 (= ray_main_~y~2.base (* ray_main_~y~2.base lambda))
 (= |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda)) (= ray_main_~x~2.offset (* ray_main_~x~2.offset lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda))
 (= |ray_(ite (select #valid main_~N~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda))
 (= |ray_main_#t~malloc2.base| (* |ray_main_#t~malloc2.base| lambda))
 (= |ray_main_#t~malloc0.base| (* |ray_main_#t~malloc0.base| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda))
 (= |ray_main_#t~mem12| (* |ray_main_#t~mem12| lambda))
 (= ray_main_~y~2.offset (* ray_main_~y~2.offset lambda))
 (= |ray_main_#t~mem10| (* |ray_main_#t~mem10| lambda))
 (= |ray_main_#t~mem9| (* |ray_main_#t~mem9| lambda))
 (= |ray_(ite (select #valid main_~x~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda))
 (= |ray_(ite main_#t~short15 1 0)|
 (* |ray_(ite main_#t~short15 1 0)| lambda))
 (= |ray_main_#t~nondet5| (* |ray_main_#t~nondet5| lambda))
 (= |ray_(ite (select #valid main_~y~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda))
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 1)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 1) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 2)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 1)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 2)) (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 1)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 1) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) (- 1))
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 1)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 1)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) (- 1)) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 1) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 1) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 1)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) (- 1))
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 1)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) (- 1))
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) (- 1))
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 1)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_(select #length main_~y~2.base)|
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|))
 (= |honda_(select old(#length) main_~x~2.base)|
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|))
 (= |honda_main_#t~malloc1.offset|
 (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|))
 (= |honda_(select #length main_~N~2.base)|
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|))
 (= |honda_main_#t~nondet7|
 (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|))
 (= |honda_(ite main_#t~short13 1 0)|
 (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|))
 (= honda_main_~N~2.base (+ honda_main_~N~2.base ray_main_~N~2.base))
 (= |honda_main_#t~nondet3|
 (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|))
 (= |honda_main_#t~malloc1.base|
 (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|))
 (= |honda_(select old(#length) main_~y~2.base)|
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|))
 (= |honda_(select old(#length) main_~N~2.base)|
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|))
 (= |honda_(ite main_#t~short11 1 0)|
 (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|))
 (= |honda_main_#t~mem16| (+ |honda_main_#t~mem16| |ray_main_#t~mem16|))
 (= honda_main_~N~2.offset (+ honda_main_~N~2.offset ray_main_~N~2.offset))
 (= honda_main_~x~2.base (+ honda_main_~x~2.base ray_main_~x~2.base))
 (= |honda_main_#t~malloc2.offset|
 (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|))
 (=
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|))
 (= |honda_main_#t~mem17| (+ |honda_main_#t~mem17| |ray_main_#t~mem17|))
 (= |honda_main_#t~mem14| (+ |honda_main_#t~mem14| |ray_main_#t~mem14|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|))
 (= |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|))
 (= |honda_main_#t~malloc0.offset|
 (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|))
 (= |honda_(select #length main_~x~2.base)|
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|))
 (= honda_main_~y~2.base (+ honda_main_~y~2.base ray_main_~y~2.base))
 (=
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|))
 (= honda_main_~x~2.offset (+ honda_main_~x~2.offset ray_main_~x~2.offset))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (=
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|))
 (= |honda_(ite (select #valid main_~N~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|))
 (= |honda_main_#t~malloc2.base|
 (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|))
 (= |honda_main_#t~malloc0.base|
 (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|))
 (= |honda_main_#t~mem12| (+ |honda_main_#t~mem12| |ray_main_#t~mem12|))
 (= honda_main_~y~2.offset (+ honda_main_~y~2.offset ray_main_~y~2.offset))
 (= |honda_main_#t~mem10| (+ |honda_main_#t~mem10| |ray_main_#t~mem10|))
 (= |honda_main_#t~mem9| (+ |honda_main_#t~mem9| |ray_main_#t~mem9|))
 (= |honda_(ite (select #valid main_~x~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|))
 (= |honda_(ite main_#t~short15 1 0)|
 (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|))
 (= |honda_main_#t~nondet5|
 (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|))
 (= |honda_(ite (select #valid main_~y~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|))
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 1)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 1) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 1)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 2)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 1)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 2)) (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 1)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 1)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 1)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 
 (- 1)) (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 1)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 1)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 1)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) (- 1))
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 1)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) (- 1))
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) (- 1))
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 1)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 
 (- 1)) (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) (- 1))
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 1)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (= |ray_(select #length main_~y~2.base)|
 (* |ray_(select #length main_~y~2.base)| lambda))
 (= |ray_(select old(#length) main_~x~2.base)|
 (* |ray_(select old(#length) main_~x~2.base)| lambda))
 (= |ray_main_#t~malloc1.offset| (* |ray_main_#t~malloc1.offset| lambda))
 (= |ray_(select #length main_~N~2.base)|
 (* |ray_(select #length main_~N~2.base)| lambda))
 (= |ray_main_#t~nondet7| (* |ray_main_#t~nondet7| lambda))
 (= |ray_(ite main_#t~short13 1 0)|
 (* |ray_(ite main_#t~short13 1 0)| lambda))
 (= ray_main_~N~2.base (* ray_main_~N~2.base lambda))
 (= |ray_main_#t~nondet3| (* |ray_main_#t~nondet3| lambda))
 (= |ray_main_#t~malloc1.base| (* |ray_main_#t~malloc1.base| lambda))
 (= |ray_(select old(#length) main_~y~2.base)|
 (* |ray_(select old(#length) main_~y~2.base)| lambda))
 (= |ray_(select old(#length) main_~N~2.base)|
 (* |ray_(select old(#length) main_~N~2.base)| lambda))
 (= |ray_(ite main_#t~short11 1 0)|
 (* |ray_(ite main_#t~short11 1 0)| lambda))
 (= |ray_main_#t~mem16| (* |ray_main_#t~mem16| lambda))
 (= ray_main_~N~2.offset (* ray_main_~N~2.offset lambda))
 (= ray_main_~x~2.base (* ray_main_~x~2.base lambda))
 (= |ray_main_#t~malloc2.offset| (* |ray_main_#t~malloc2.offset| lambda))
 (= |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda)) (= |ray_main_#t~mem17| (* |ray_main_#t~mem17| lambda))
 (= |ray_main_#t~mem14| (* |ray_main_#t~mem14| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda))
 (= |ray_main_#t~malloc0.offset| (* |ray_main_#t~malloc0.offset| lambda))
 (= |ray_(select #length main_~x~2.base)|
 (* |ray_(select #length main_~x~2.base)| lambda))
 (= ray_main_~y~2.base (* ray_main_~y~2.base lambda))
 (= |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda)) (= ray_main_~x~2.offset (* ray_main_~x~2.offset lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda))
 (= |ray_(ite (select #valid main_~N~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda))
 (= |ray_main_#t~malloc2.base| (* |ray_main_#t~malloc2.base| lambda))
 (= |ray_main_#t~malloc0.base| (* |ray_main_#t~malloc0.base| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda))
 (= |ray_main_#t~mem12| (* |ray_main_#t~mem12| lambda))
 (= ray_main_~y~2.offset (* ray_main_~y~2.offset lambda))
 (= |ray_main_#t~mem10| (* |ray_main_#t~mem10| lambda))
 (= |ray_main_#t~mem9| (* |ray_main_#t~mem9| lambda))
 (= |ray_(ite (select #valid main_~x~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda))
 (= |ray_(ite main_#t~short15 1 0)|
 (* |ray_(ite main_#t~short15 1 0)| lambda))
 (= |ray_main_#t~nondet5| (* |ray_main_#t~nondet5| lambda))
 (= |ray_(ite (select #valid main_~y~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda))
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 1)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 1) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 2)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 1)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 2)) (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 1)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 1)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 1)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) (- 1)) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 1) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 1) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 1)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 1)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) (- 1))
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 1)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) (- 1))
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) (- 1))
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) (- 1))
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 1)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_(select #length main_~y~2.base)|
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|))
 (= |honda_(select old(#length) main_~x~2.base)|
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|))
 (= |honda_main_#t~malloc1.offset|
 (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|))
 (= |honda_(select #length main_~N~2.base)|
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|))
 (= |honda_main_#t~nondet7|
 (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|))
 (= |honda_(ite main_#t~short13 1 0)|
 (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|))
 (= honda_main_~N~2.base (+ honda_main_~N~2.base ray_main_~N~2.base))
 (= |honda_main_#t~nondet3|
 (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|))
 (= |honda_main_#t~malloc1.base|
 (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|))
 (= |honda_(select old(#length) main_~y~2.base)|
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|))
 (= |honda_(select old(#length) main_~N~2.base)|
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|))
 (= |honda_(ite main_#t~short11 1 0)|
 (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|))
 (= |honda_main_#t~mem16| (+ |honda_main_#t~mem16| |ray_main_#t~mem16|))
 (= honda_main_~N~2.offset (+ honda_main_~N~2.offset ray_main_~N~2.offset))
 (= honda_main_~x~2.base (+ honda_main_~x~2.base ray_main_~x~2.base))
 (= |honda_main_#t~malloc2.offset|
 (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|))
 (=
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|))
 (= |honda_main_#t~mem17| (+ |honda_main_#t~mem17| |ray_main_#t~mem17|))
 (= |honda_main_#t~mem14| (+ |honda_main_#t~mem14| |ray_main_#t~mem14|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|))
 (= |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|))
 (= |honda_main_#t~malloc0.offset|
 (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|))
 (= |honda_(select #length main_~x~2.base)|
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|))
 (= honda_main_~y~2.base (+ honda_main_~y~2.base ray_main_~y~2.base))
 (=
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|))
 (= honda_main_~x~2.offset (+ honda_main_~x~2.offset ray_main_~x~2.offset))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (=
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|))
 (= |honda_(ite (select #valid main_~N~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|))
 (= |honda_main_#t~malloc2.base|
 (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|))
 (= |honda_main_#t~malloc0.base|
 (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|))
 (= |honda_main_#t~mem12| (+ |honda_main_#t~mem12| |ray_main_#t~mem12|))
 (= honda_main_~y~2.offset (+ honda_main_~y~2.offset ray_main_~y~2.offset))
 (= |honda_main_#t~mem10| (+ |honda_main_#t~mem10| |ray_main_#t~mem10|))
 (= |honda_main_#t~mem9| (+ |honda_main_#t~mem9| |ray_main_#t~mem9|))
 (= |honda_(ite (select #valid main_~x~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|))
 (= |honda_(ite main_#t~short15 1 0)|
 (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|))
 (= |honda_main_#t~nondet5|
 (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|))
 (= |honda_(ite (select #valid main_~y~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|))
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 1)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 1) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 1)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 2)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 1)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 2)) (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 1)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 1)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 1)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 
 (- 1)) (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 1)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 1)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) (- 1))
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 1)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 1)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) (- 1))
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) (- 1))
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 1)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 
 (- 1)) (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) (- 1))
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 1)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (= |ray_(select #length main_~y~2.base)|
 (* |ray_(select #length main_~y~2.base)| lambda))
 (= |ray_(select old(#length) main_~x~2.base)|
 (* |ray_(select old(#length) main_~x~2.base)| lambda))
 (= |ray_main_#t~malloc1.offset| (* |ray_main_#t~malloc1.offset| lambda))
 (= |ray_(select #length main_~N~2.base)|
 (* |ray_(select #length main_~N~2.base)| lambda))
 (= |ray_main_#t~nondet7| (* |ray_main_#t~nondet7| lambda))
 (= |ray_(ite main_#t~short13 1 0)|
 (* |ray_(ite main_#t~short13 1 0)| lambda))
 (= ray_main_~N~2.base (* ray_main_~N~2.base lambda))
 (= |ray_main_#t~nondet3| (* |ray_main_#t~nondet3| lambda))
 (= |ray_main_#t~malloc1.base| (* |ray_main_#t~malloc1.base| lambda))
 (= |ray_(select old(#length) main_~y~2.base)|
 (* |ray_(select old(#length) main_~y~2.base)| lambda))
 (= |ray_(select old(#length) main_~N~2.base)|
 (* |ray_(select old(#length) main_~N~2.base)| lambda))
 (= |ray_(ite main_#t~short11 1 0)|
 (* |ray_(ite main_#t~short11 1 0)| lambda))
 (= |ray_main_#t~mem16| (* |ray_main_#t~mem16| lambda))
 (= ray_main_~N~2.offset (* ray_main_~N~2.offset lambda))
 (= ray_main_~x~2.base (* ray_main_~x~2.base lambda))
 (= |ray_main_#t~malloc2.offset| (* |ray_main_#t~malloc2.offset| lambda))
 (= |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda)) (= |ray_main_#t~mem17| (* |ray_main_#t~mem17| lambda))
 (= |ray_main_#t~mem14| (* |ray_main_#t~mem14| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda))
 (= |ray_main_#t~malloc0.offset| (* |ray_main_#t~malloc0.offset| lambda))
 (= |ray_(select #length main_~x~2.base)|
 (* |ray_(select #length main_~x~2.base)| lambda))
 (= ray_main_~y~2.base (* ray_main_~y~2.base lambda))
 (= |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda)) (= ray_main_~x~2.offset (* ray_main_~x~2.offset lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda))
 (= |ray_(ite (select #valid main_~N~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda))
 (= |ray_main_#t~malloc2.base| (* |ray_main_#t~malloc2.base| lambda))
 (= |ray_main_#t~malloc0.base| (* |ray_main_#t~malloc0.base| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda))
 (= |ray_main_#t~mem12| (* |ray_main_#t~mem12| lambda))
 (= ray_main_~y~2.offset (* ray_main_~y~2.offset lambda))
 (= |ray_main_#t~mem10| (* |ray_main_#t~mem10| lambda))
 (= |ray_main_#t~mem9| (* |ray_main_#t~mem9| lambda))
 (= |ray_(ite (select #valid main_~x~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda))
 (= |ray_(ite main_#t~short15 1 0)|
 (* |ray_(ite main_#t~short15 1 0)| lambda))
 (= |ray_main_#t~nondet5| (* |ray_main_#t~nondet5| lambda))
 (= |ray_(ite (select #valid main_~y~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda))
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 1)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 1) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 2)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 1)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 2)) (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 1)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 1)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 1)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) (- 1)) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 1) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 1) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) (- 1))
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 1) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 1)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 1)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) (- 1))
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) (- 1))
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) (- 1))
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 1)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_(select #length main_~y~2.base)|
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|))
 (= |honda_(select old(#length) main_~x~2.base)|
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|))
 (= |honda_main_#t~malloc1.offset|
 (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|))
 (= |honda_(select #length main_~N~2.base)|
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|))
 (= |honda_main_#t~nondet7|
 (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|))
 (= |honda_(ite main_#t~short13 1 0)|
 (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|))
 (= honda_main_~N~2.base (+ honda_main_~N~2.base ray_main_~N~2.base))
 (= |honda_main_#t~nondet3|
 (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|))
 (= |honda_main_#t~malloc1.base|
 (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|))
 (= |honda_(select old(#length) main_~y~2.base)|
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|))
 (= |honda_(select old(#length) main_~N~2.base)|
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|))
 (= |honda_(ite main_#t~short11 1 0)|
 (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|))
 (= |honda_main_#t~mem16| (+ |honda_main_#t~mem16| |ray_main_#t~mem16|))
 (= honda_main_~N~2.offset (+ honda_main_~N~2.offset ray_main_~N~2.offset))
 (= honda_main_~x~2.base (+ honda_main_~x~2.base ray_main_~x~2.base))
 (= |honda_main_#t~malloc2.offset|
 (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|))
 (=
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|))
 (= |honda_main_#t~mem17| (+ |honda_main_#t~mem17| |ray_main_#t~mem17|))
 (= |honda_main_#t~mem14| (+ |honda_main_#t~mem14| |ray_main_#t~mem14|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|))
 (= |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|))
 (= |honda_main_#t~malloc0.offset|
 (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|))
 (= |honda_(select #length main_~x~2.base)|
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|))
 (= honda_main_~y~2.base (+ honda_main_~y~2.base ray_main_~y~2.base))
 (=
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|))
 (= honda_main_~x~2.offset (+ honda_main_~x~2.offset ray_main_~x~2.offset))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (=
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|))
 (= |honda_(ite (select #valid main_~N~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|))
 (= |honda_main_#t~malloc2.base|
 (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|))
 (= |honda_main_#t~malloc0.base|
 (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|))
 (= |honda_main_#t~mem12| (+ |honda_main_#t~mem12| |ray_main_#t~mem12|))
 (= honda_main_~y~2.offset (+ honda_main_~y~2.offset ray_main_~y~2.offset))
 (= |honda_main_#t~mem10| (+ |honda_main_#t~mem10| |ray_main_#t~mem10|))
 (= |honda_main_#t~mem9| (+ |honda_main_#t~mem9| |ray_main_#t~mem9|))
 (= |honda_(ite (select #valid main_~x~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|))
 (= |honda_(ite main_#t~short15 1 0)|
 (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|))
 (= |honda_main_#t~nondet5|
 (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|))
 (= |honda_(ite (select #valid main_~y~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|))
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 1)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) (- 1))
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 1)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| (- 1)) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 1)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 2)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 1)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 2)) (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 1)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 1)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 1)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 
 (- 1)) (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 1)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 1)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) (- 1))
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 1)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 1)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) (- 1))
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 
 (- 1)) (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) (- 1))
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 1)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (= |ray_(select #length main_~y~2.base)|
 (* |ray_(select #length main_~y~2.base)| lambda))
 (= |ray_(select old(#length) main_~x~2.base)|
 (* |ray_(select old(#length) main_~x~2.base)| lambda))
 (= |ray_main_#t~malloc1.offset| (* |ray_main_#t~malloc1.offset| lambda))
 (= |ray_(select #length main_~N~2.base)|
 (* |ray_(select #length main_~N~2.base)| lambda))
 (= |ray_main_#t~nondet7| (* |ray_main_#t~nondet7| lambda))
 (= |ray_(ite main_#t~short13 1 0)|
 (* |ray_(ite main_#t~short13 1 0)| lambda))
 (= ray_main_~N~2.base (* ray_main_~N~2.base lambda))
 (= |ray_main_#t~nondet3| (* |ray_main_#t~nondet3| lambda))
 (= |ray_main_#t~malloc1.base| (* |ray_main_#t~malloc1.base| lambda))
 (= |ray_(select old(#length) main_~y~2.base)|
 (* |ray_(select old(#length) main_~y~2.base)| lambda))
 (= |ray_(select old(#length) main_~N~2.base)|
 (* |ray_(select old(#length) main_~N~2.base)| lambda))
 (= |ray_(ite main_#t~short11 1 0)|
 (* |ray_(ite main_#t~short11 1 0)| lambda))
 (= |ray_main_#t~mem16| (* |ray_main_#t~mem16| lambda))
 (= ray_main_~N~2.offset (* ray_main_~N~2.offset lambda))
 (= ray_main_~x~2.base (* ray_main_~x~2.base lambda))
 (= |ray_main_#t~malloc2.offset| (* |ray_main_#t~malloc2.offset| lambda))
 (= |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda)) (= |ray_main_#t~mem17| (* |ray_main_#t~mem17| lambda))
 (= |ray_main_#t~mem14| (* |ray_main_#t~mem14| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda))
 (= |ray_main_#t~malloc0.offset| (* |ray_main_#t~malloc0.offset| lambda))
 (= |ray_(select #length main_~x~2.base)|
 (* |ray_(select #length main_~x~2.base)| lambda))
 (= ray_main_~y~2.base (* ray_main_~y~2.base lambda))
 (= |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda)) (= ray_main_~x~2.offset (* ray_main_~x~2.offset lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda))
 (= |ray_(ite (select #valid main_~N~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda))
 (= |ray_main_#t~malloc2.base| (* |ray_main_#t~malloc2.base| lambda))
 (= |ray_main_#t~malloc0.base| (* |ray_main_#t~malloc0.base| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda))
 (= |ray_main_#t~mem12| (* |ray_main_#t~mem12| lambda))
 (= ray_main_~y~2.offset (* ray_main_~y~2.offset lambda))
 (= |ray_main_#t~mem10| (* |ray_main_#t~mem10| lambda))
 (= |ray_main_#t~mem9| (* |ray_main_#t~mem9| lambda))
 (= |ray_(ite (select #valid main_~x~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda))
 (= |ray_(ite main_#t~short15 1 0)|
 (* |ray_(ite main_#t~short15 1 0)| lambda))
 (= |ray_main_#t~nondet5| (* |ray_main_#t~nondet5| lambda))
 (= |ray_(ite (select #valid main_~y~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda))
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 1)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) (- 1))
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 1)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| (- 1)) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 2)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 1)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 2)) (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 1)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 1)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 1)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) (- 1)) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 1) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 1) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 1)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) (- 1))
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 1)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) (- 1))
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) (- 1))
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 1)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_(select #length main_~y~2.base)|
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|))
 (= |honda_(select old(#length) main_~x~2.base)|
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|))
 (= |honda_main_#t~malloc1.offset|
 (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|))
 (= |honda_(select #length main_~N~2.base)|
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|))
 (= |honda_main_#t~nondet7|
 (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|))
 (= |honda_(ite main_#t~short13 1 0)|
 (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|))
 (= honda_main_~N~2.base (+ honda_main_~N~2.base ray_main_~N~2.base))
 (= |honda_main_#t~nondet3|
 (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|))
 (= |honda_main_#t~malloc1.base|
 (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|))
 (= |honda_(select old(#length) main_~y~2.base)|
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|))
 (= |honda_(select old(#length) main_~N~2.base)|
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|))
 (= |honda_(ite main_#t~short11 1 0)|
 (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|))
 (= |honda_main_#t~mem16| (+ |honda_main_#t~mem16| |ray_main_#t~mem16|))
 (= honda_main_~N~2.offset (+ honda_main_~N~2.offset ray_main_~N~2.offset))
 (= honda_main_~x~2.base (+ honda_main_~x~2.base ray_main_~x~2.base))
 (= |honda_main_#t~malloc2.offset|
 (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|))
 (=
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|))
 (= |honda_main_#t~mem17| (+ |honda_main_#t~mem17| |ray_main_#t~mem17|))
 (= |honda_main_#t~mem14| (+ |honda_main_#t~mem14| |ray_main_#t~mem14|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|))
 (= |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|))
 (= |honda_main_#t~malloc0.offset|
 (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|))
 (= |honda_(select #length main_~x~2.base)|
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|))
 (= honda_main_~y~2.base (+ honda_main_~y~2.base ray_main_~y~2.base))
 (=
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|))
 (= honda_main_~x~2.offset (+ honda_main_~x~2.offset ray_main_~x~2.offset))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (=
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|))
 (= |honda_(ite (select #valid main_~N~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|))
 (= |honda_main_#t~malloc2.base|
 (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|))
 (= |honda_main_#t~malloc0.base|
 (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|))
 (= |honda_main_#t~mem12| (+ |honda_main_#t~mem12| |ray_main_#t~mem12|))
 (= honda_main_~y~2.offset (+ honda_main_~y~2.offset ray_main_~y~2.offset))
 (= |honda_main_#t~mem10| (+ |honda_main_#t~mem10| |ray_main_#t~mem10|))
 (= |honda_main_#t~mem9| (+ |honda_main_#t~mem9| |ray_main_#t~mem9|))
 (= |honda_(ite (select #valid main_~x~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|))
 (= |honda_(ite main_#t~short15 1 0)|
 (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|))
 (= |honda_main_#t~nondet5|
 (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|))
 (= |honda_(ite (select #valid main_~y~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|))
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 1)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) (- 1))
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 1)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 1) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 1)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 2)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 1)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 2)) (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 1)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 1)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 1)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 
 (- 1)) (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 1)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 1)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) (- 1))
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 1)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 1)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) (- 1))
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 
 (- 1)) (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) (- 1))
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 1)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (= |ray_(select #length main_~y~2.base)|
 (* |ray_(select #length main_~y~2.base)| lambda))
 (= |ray_(select old(#length) main_~x~2.base)|
 (* |ray_(select old(#length) main_~x~2.base)| lambda))
 (= |ray_main_#t~malloc1.offset| (* |ray_main_#t~malloc1.offset| lambda))
 (= |ray_(select #length main_~N~2.base)|
 (* |ray_(select #length main_~N~2.base)| lambda))
 (= |ray_main_#t~nondet7| (* |ray_main_#t~nondet7| lambda))
 (= |ray_(ite main_#t~short13 1 0)|
 (* |ray_(ite main_#t~short13 1 0)| lambda))
 (= ray_main_~N~2.base (* ray_main_~N~2.base lambda))
 (= |ray_main_#t~nondet3| (* |ray_main_#t~nondet3| lambda))
 (= |ray_main_#t~malloc1.base| (* |ray_main_#t~malloc1.base| lambda))
 (= |ray_(select old(#length) main_~y~2.base)|
 (* |ray_(select old(#length) main_~y~2.base)| lambda))
 (= |ray_(select old(#length) main_~N~2.base)|
 (* |ray_(select old(#length) main_~N~2.base)| lambda))
 (= |ray_(ite main_#t~short11 1 0)|
 (* |ray_(ite main_#t~short11 1 0)| lambda))
 (= |ray_main_#t~mem16| (* |ray_main_#t~mem16| lambda))
 (= ray_main_~N~2.offset (* ray_main_~N~2.offset lambda))
 (= ray_main_~x~2.base (* ray_main_~x~2.base lambda))
 (= |ray_main_#t~malloc2.offset| (* |ray_main_#t~malloc2.offset| lambda))
 (= |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda)) (= |ray_main_#t~mem17| (* |ray_main_#t~mem17| lambda))
 (= |ray_main_#t~mem14| (* |ray_main_#t~mem14| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda))
 (= |ray_main_#t~malloc0.offset| (* |ray_main_#t~malloc0.offset| lambda))
 (= |ray_(select #length main_~x~2.base)|
 (* |ray_(select #length main_~x~2.base)| lambda))
 (= ray_main_~y~2.base (* ray_main_~y~2.base lambda))
 (= |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda)) (= ray_main_~x~2.offset (* ray_main_~x~2.offset lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda))
 (= |ray_(ite (select #valid main_~N~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda))
 (= |ray_main_#t~malloc2.base| (* |ray_main_#t~malloc2.base| lambda))
 (= |ray_main_#t~malloc0.base| (* |ray_main_#t~malloc0.base| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda))
 (= |ray_main_#t~mem12| (* |ray_main_#t~mem12| lambda))
 (= ray_main_~y~2.offset (* ray_main_~y~2.offset lambda))
 (= |ray_main_#t~mem10| (* |ray_main_#t~mem10| lambda))
 (= |ray_main_#t~mem9| (* |ray_main_#t~mem9| lambda))
 (= |ray_(ite (select #valid main_~x~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda))
 (= |ray_(ite main_#t~short15 1 0)|
 (* |ray_(ite main_#t~short15 1 0)| lambda))
 (= |ray_main_#t~nondet5| (* |ray_main_#t~nondet5| lambda))
 (= |ray_(ite (select #valid main_~y~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda))
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 1)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) (- 1))
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 1)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 1) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 2)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 1)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 2)) (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 1)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 1)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 1)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) (- 1)) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 1) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 1) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 1)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) (- 1))
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 1)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) (- 1))
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) (- 1))
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 1)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_(select #length main_~y~2.base)|
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|))
 (= |honda_(select old(#length) main_~x~2.base)|
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|))
 (= |honda_main_#t~malloc1.offset|
 (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|))
 (= |honda_(select #length main_~N~2.base)|
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|))
 (= |honda_main_#t~nondet7|
 (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|))
 (= |honda_(ite main_#t~short13 1 0)|
 (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|))
 (= honda_main_~N~2.base (+ honda_main_~N~2.base ray_main_~N~2.base))
 (= |honda_main_#t~nondet3|
 (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|))
 (= |honda_main_#t~malloc1.base|
 (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|))
 (= |honda_(select old(#length) main_~y~2.base)|
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|))
 (= |honda_(select old(#length) main_~N~2.base)|
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|))
 (= |honda_(ite main_#t~short11 1 0)|
 (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|))
 (= |honda_main_#t~mem16| (+ |honda_main_#t~mem16| |ray_main_#t~mem16|))
 (= honda_main_~N~2.offset (+ honda_main_~N~2.offset ray_main_~N~2.offset))
 (= honda_main_~x~2.base (+ honda_main_~x~2.base ray_main_~x~2.base))
 (= |honda_main_#t~malloc2.offset|
 (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|))
 (=
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|))
 (= |honda_main_#t~mem17| (+ |honda_main_#t~mem17| |ray_main_#t~mem17|))
 (= |honda_main_#t~mem14| (+ |honda_main_#t~mem14| |ray_main_#t~mem14|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|))
 (= |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|))
 (= |honda_main_#t~malloc0.offset|
 (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|))
 (= |honda_(select #length main_~x~2.base)|
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|))
 (= honda_main_~y~2.base (+ honda_main_~y~2.base ray_main_~y~2.base))
 (=
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|))
 (= honda_main_~x~2.offset (+ honda_main_~x~2.offset ray_main_~x~2.offset))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (=
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|))
 (= |honda_(ite (select #valid main_~N~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|))
 (= |honda_main_#t~malloc2.base|
 (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|))
 (= |honda_main_#t~malloc0.base|
 (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|))
 (= |honda_main_#t~mem12| (+ |honda_main_#t~mem12| |ray_main_#t~mem12|))
 (= honda_main_~y~2.offset (+ honda_main_~y~2.offset ray_main_~y~2.offset))
 (= |honda_main_#t~mem10| (+ |honda_main_#t~mem10| |ray_main_#t~mem10|))
 (= |honda_main_#t~mem9| (+ |honda_main_#t~mem9| |ray_main_#t~mem9|))
 (= |honda_(ite (select #valid main_~x~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|))
 (= |honda_(ite main_#t~short15 1 0)|
 (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|))
 (= |honda_main_#t~nondet5|
 (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|))
 (= |honda_(ite (select #valid main_~y~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|))
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 1)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| (- 1)) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 1)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 2)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 1)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 2)) (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 1)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 1)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 1)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 
 (- 1)) (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 1)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 1)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) (- 1))
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 1)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 1)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) (- 1))
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) (- 1))
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 1)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 
 (- 1)) (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) (- 1))
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 1)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (= |ray_(select #length main_~y~2.base)|
 (* |ray_(select #length main_~y~2.base)| lambda))
 (= |ray_(select old(#length) main_~x~2.base)|
 (* |ray_(select old(#length) main_~x~2.base)| lambda))
 (= |ray_main_#t~malloc1.offset| (* |ray_main_#t~malloc1.offset| lambda))
 (= |ray_(select #length main_~N~2.base)|
 (* |ray_(select #length main_~N~2.base)| lambda))
 (= |ray_main_#t~nondet7| (* |ray_main_#t~nondet7| lambda))
 (= |ray_(ite main_#t~short13 1 0)|
 (* |ray_(ite main_#t~short13 1 0)| lambda))
 (= ray_main_~N~2.base (* ray_main_~N~2.base lambda))
 (= |ray_main_#t~nondet3| (* |ray_main_#t~nondet3| lambda))
 (= |ray_main_#t~malloc1.base| (* |ray_main_#t~malloc1.base| lambda))
 (= |ray_(select old(#length) main_~y~2.base)|
 (* |ray_(select old(#length) main_~y~2.base)| lambda))
 (= |ray_(select old(#length) main_~N~2.base)|
 (* |ray_(select old(#length) main_~N~2.base)| lambda))
 (= |ray_(ite main_#t~short11 1 0)|
 (* |ray_(ite main_#t~short11 1 0)| lambda))
 (= |ray_main_#t~mem16| (* |ray_main_#t~mem16| lambda))
 (= ray_main_~N~2.offset (* ray_main_~N~2.offset lambda))
 (= ray_main_~x~2.base (* ray_main_~x~2.base lambda))
 (= |ray_main_#t~malloc2.offset| (* |ray_main_#t~malloc2.offset| lambda))
 (= |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda)) (= |ray_main_#t~mem17| (* |ray_main_#t~mem17| lambda))
 (= |ray_main_#t~mem14| (* |ray_main_#t~mem14| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda))
 (= |ray_main_#t~malloc0.offset| (* |ray_main_#t~malloc0.offset| lambda))
 (= |ray_(select #length main_~x~2.base)|
 (* |ray_(select #length main_~x~2.base)| lambda))
 (= ray_main_~y~2.base (* ray_main_~y~2.base lambda))
 (= |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda)) (= ray_main_~x~2.offset (* ray_main_~x~2.offset lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda))
 (= |ray_(ite (select #valid main_~N~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda))
 (= |ray_main_#t~malloc2.base| (* |ray_main_#t~malloc2.base| lambda))
 (= |ray_main_#t~malloc0.base| (* |ray_main_#t~malloc0.base| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda))
 (= |ray_main_#t~mem12| (* |ray_main_#t~mem12| lambda))
 (= ray_main_~y~2.offset (* ray_main_~y~2.offset lambda))
 (= |ray_main_#t~mem10| (* |ray_main_#t~mem10| lambda))
 (= |ray_main_#t~mem9| (* |ray_main_#t~mem9| lambda))
 (= |ray_(ite (select #valid main_~x~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda))
 (= |ray_(ite main_#t~short15 1 0)|
 (* |ray_(ite main_#t~short15 1 0)| lambda))
 (= |ray_main_#t~nondet5| (* |ray_main_#t~nondet5| lambda))
 (= |ray_(ite (select #valid main_~y~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda))
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 1)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| (- 1)) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 2)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 1)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 2)) (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 1)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 1)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 1)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) (- 1)) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 1) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 1) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) (- 1))
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 1) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 1)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 1)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) (- 1))
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) (- 1))
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 1)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) (- 1))
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 1)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_(select #length main_~y~2.base)|
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|))
 (= |honda_(select old(#length) main_~x~2.base)|
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|))
 (= |honda_main_#t~malloc1.offset|
 (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|))
 (= |honda_(select #length main_~N~2.base)|
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|))
 (= |honda_main_#t~nondet7|
 (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|))
 (= |honda_(ite main_#t~short13 1 0)|
 (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|))
 (= honda_main_~N~2.base (+ honda_main_~N~2.base ray_main_~N~2.base))
 (= |honda_main_#t~nondet3|
 (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|))
 (= |honda_main_#t~malloc1.base|
 (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|))
 (= |honda_(select old(#length) main_~y~2.base)|
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|))
 (= |honda_(select old(#length) main_~N~2.base)|
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|))
 (= |honda_(ite main_#t~short11 1 0)|
 (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|))
 (= |honda_main_#t~mem16| (+ |honda_main_#t~mem16| |ray_main_#t~mem16|))
 (= honda_main_~N~2.offset (+ honda_main_~N~2.offset ray_main_~N~2.offset))
 (= honda_main_~x~2.base (+ honda_main_~x~2.base ray_main_~x~2.base))
 (= |honda_main_#t~malloc2.offset|
 (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|))
 (=
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|))
 (= |honda_main_#t~mem17| (+ |honda_main_#t~mem17| |ray_main_#t~mem17|))
 (= |honda_main_#t~mem14| (+ |honda_main_#t~mem14| |ray_main_#t~mem14|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|))
 (= |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|))
 (= |honda_main_#t~malloc0.offset|
 (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|))
 (= |honda_(select #length main_~x~2.base)|
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|))
 (= honda_main_~y~2.base (+ honda_main_~y~2.base ray_main_~y~2.base))
 (=
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|))
 (= honda_main_~x~2.offset (+ honda_main_~x~2.offset ray_main_~x~2.offset))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (=
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|))
 (= |honda_(ite (select #valid main_~N~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|))
 (= |honda_main_#t~malloc2.base|
 (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|))
 (= |honda_main_#t~malloc0.base|
 (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|))
 (= |honda_main_#t~mem12| (+ |honda_main_#t~mem12| |ray_main_#t~mem12|))
 (= honda_main_~y~2.offset (+ honda_main_~y~2.offset ray_main_~y~2.offset))
 (= |honda_main_#t~mem10| (+ |honda_main_#t~mem10| |ray_main_#t~mem10|))
 (= |honda_main_#t~mem9| (+ |honda_main_#t~mem9| |ray_main_#t~mem9|))
 (= |honda_(ite (select #valid main_~x~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|))
 (= |honda_(ite main_#t~short15 1 0)|
 (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|))
 (= |honda_main_#t~nondet5|
 (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|))
 (= |honda_(ite (select #valid main_~y~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|))
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 1)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 1) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 1)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 2)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1)) (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 1)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 2)) (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 1)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 1)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 1)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 
 (- 1)) (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 1) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 1)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 1)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) (- 1))
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 1)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 1)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) (- 1))
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 1)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) (- 1))
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 
 (- 1)) (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) (- 1))
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select #length main_~N~2.base)|
 |ray_(select #length main_~N~2.base)|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (* (+ |honda_(ite main_#t~short13 1 0)| |ray_(ite main_#t~short13 1 0)|) 0)
 (* (+ honda_main_~N~2.base ray_main_~N~2.base) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~N~2.base)|
 |ray_(select old(#length) main_~N~2.base)|) 0)
 (* (+ |honda_(ite main_#t~short11 1 0)| |ray_(ite main_#t~short11 1 0)|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (* (+ |honda_main_#t~nondet20| |ray_main_#t~nondet20|) 0)
 (* (+ |honda_main_#t~mem19| |ray_main_#t~mem19|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~N~2.offset ray_main_~N~2.offset) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~N~2.base) 1 0)|
 |ray_(ite (select #valid main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_main_#t~mem21| |ray_main_#t~mem21|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~N~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem12| |ray_main_#t~mem12|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|) 0)
 (* (+ |honda_main_#t~mem24| |ray_main_#t~mem24|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 1)
 (* (+ |honda_(ite main_#t~short15 1 0)| |ray_(ite main_#t~short15 1 0)|) 0)
 (* (+ |honda_main_#t~mem22| |ray_main_#t~mem22|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* |honda_main_#t~nondet20| 0) 
 (* |honda_main_#t~mem19| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~mem21| 0)
 (* |honda_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |honda_main_#t~mem24| 0) 
 (* |honda_main_#t~mem22| 0) 
 (- 1)) 0)
 (= |ray_(select #length main_~y~2.base)|
 (* |ray_(select #length main_~y~2.base)| lambda))
 (= |ray_(select old(#length) main_~x~2.base)|
 (* |ray_(select old(#length) main_~x~2.base)| lambda))
 (= |ray_main_#t~malloc1.offset| (* |ray_main_#t~malloc1.offset| lambda))
 (= |ray_(select #length main_~N~2.base)|
 (* |ray_(select #length main_~N~2.base)| lambda))
 (= |ray_main_#t~nondet7| (* |ray_main_#t~nondet7| lambda))
 (= |ray_(ite main_#t~short13 1 0)|
 (* |ray_(ite main_#t~short13 1 0)| lambda))
 (= ray_main_~N~2.base (* ray_main_~N~2.base lambda))
 (= |ray_main_#t~nondet3| (* |ray_main_#t~nondet3| lambda))
 (= |ray_main_#t~malloc1.base| (* |ray_main_#t~malloc1.base| lambda))
 (= |ray_(select old(#length) main_~y~2.base)|
 (* |ray_(select old(#length) main_~y~2.base)| lambda))
 (= |ray_(select old(#length) main_~N~2.base)|
 (* |ray_(select old(#length) main_~N~2.base)| lambda))
 (= |ray_(ite main_#t~short11 1 0)|
 (* |ray_(ite main_#t~short11 1 0)| lambda))
 (= |ray_main_#t~mem16| (* |ray_main_#t~mem16| lambda))
 (= ray_main_~N~2.offset (* ray_main_~N~2.offset lambda))
 (= ray_main_~x~2.base (* ray_main_~x~2.base lambda))
 (= |ray_main_#t~malloc2.offset| (* |ray_main_#t~malloc2.offset| lambda))
 (= |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda)) (= |ray_main_#t~mem17| (* |ray_main_#t~mem17| lambda))
 (= |ray_main_#t~mem14| (* |ray_main_#t~mem14| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda))
 (= |ray_main_#t~malloc0.offset| (* |ray_main_#t~malloc0.offset| lambda))
 (= |ray_(select #length main_~x~2.base)|
 (* |ray_(select #length main_~x~2.base)| lambda))
 (= ray_main_~y~2.base (* ray_main_~y~2.base lambda))
 (= |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda)) (= ray_main_~x~2.offset (* ray_main_~x~2.offset lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda))
 (= |ray_(ite (select #valid main_~N~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda))
 (= |ray_main_#t~malloc2.base| (* |ray_main_#t~malloc2.base| lambda))
 (= |ray_main_#t~malloc0.base| (* |ray_main_#t~malloc0.base| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) main_~N~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda))
 (= |ray_main_#t~mem12| (* |ray_main_#t~mem12| lambda))
 (= ray_main_~y~2.offset (* ray_main_~y~2.offset lambda))
 (= |ray_main_#t~mem10| (* |ray_main_#t~mem10| lambda))
 (= |ray_main_#t~mem9| (* |ray_main_#t~mem9| lambda))
 (= |ray_(ite (select #valid main_~x~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda))
 (= |ray_(ite main_#t~short15 1 0)|
 (* |ray_(ite main_#t~short15 1 0)| lambda))
 (= |ray_main_#t~nondet5| (* |ray_main_#t~nondet5| lambda))
 (= |ray_(ite (select #valid main_~y~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda))
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 1)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 1) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 (- 1)) (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 2)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1)) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 1)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 2)) (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 1)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 1)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 1)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) (- 1)) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 1) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 1) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) (- 1))
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 1) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 1)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 1)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) (- 1))
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 1)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) (- 1))
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 1)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) (- 1))
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 1)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0)
 (>=
 (+ (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select #length main_~N~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(ite main_#t~short13 1 0)| lambda) 0)
 (* (* ray_main_~N~2.base lambda) 0) 
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~N~2.base)| lambda) 0)
 (* (* |ray_(ite main_#t~short11 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem16| lambda) 0) 
 (* (* |ray_main_#t~nondet20| lambda) 0) 
 (* (* |ray_main_#t~mem19| lambda) 0) 
 (* (* |ray_main_#t~mem18| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~N~2.offset lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.offset lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_main_#t~mem21| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~N~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem12| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem10| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem24| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite main_#t~short15 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem22| lambda) 0) 
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* |ray_main_#t~nondet20| 0) 
 (* |ray_main_#t~mem19| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_main_#t~mem21| 0)
 (* |ray_(select (select #memory_int main_~N~2.base) main_~N~2.offset)| 0)
 (* |ray_main_#t~mem24| 0) 
 (* |ray_main_#t~mem22| 0)) 0) 
 (= lambda lambda))) (>= lambda 0)))
(check-sat)
(exit)

