(set-logic QF_NIA)
(set-info
  :source |
SMT script generated by Ultimate LassoRanker [1].
Ultimate LassoRanker is a tool that analyzes termination and nontermination of 
lasso-shaped programs. This script contains the SMT commands that Ultimate 
LassoRanker used while checking if a lasso-shaped program has a geometric 
nontermination argument [2].

This SMT script belongs to a set of SMT scripts that was generated by applying
Ultimate Buchi Automizer [3,4] to the benchmarks from the SV-COMP 2015 [5,6] 
which are available at [7]. Ultimate Buchi Automizer takes omega-traces
(lasso-shaped programs) and uses LassoRanker in order to check if the 
lasso-shaped program is terminating.

2015-04-30, Matthias Heizmann (heizmann@informatik.uni-freiburg.de)


[1] https://ultimate.informatik.uni-freiburg.de/LassoRanker/
[2] Jan Leike, Matthias Heizmann:
Geometric Series as Nontermination Arguments for Linear Lasso Programs. 
CoRR abs/1405.4413 (2014)
http://arxiv.org/abs/1405.4413
[3] http://ultimate.informatik.uni-freiburg.de/BuchiAutomizer/
[4] Matthias Heizmann, Jochen Hoenicke, Andreas Podelski: Software Model 
Checking for People Who Love Automata. CAV 2013:36-52
[5] http://sv-comp.sosy-lab.org/2015/
[6] Dirk Beyer: Software Verification and Verifiable Witnesses - (Report on 
SV-COMP 2015). TACAS 2015: 401-416
[7] https://svn.sosy-lab.org/software/sv-benchmarks/tags/svcomp15/
|)
(set-info :smt-lib-version 2.0)
(set-info :category "industrial")
(set-info :status sat)
(declare-fun |init_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)|
  () Int)
(declare-fun
  |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| () Int)
(declare-fun |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)|
  () Int)
(declare-fun |init_(ite (select #valid gcd_~y2.base) 1 0)| () Int)
(declare-fun |honda_(ite (select #valid gcd_~y2.base) 1 0)| () Int)
(declare-fun |ray_(ite (select #valid gcd_~y2.base) 1 0)| () Int)
(declare-fun init_gcd_~y1.base () Int)
(declare-fun honda_gcd_~y1.base () Int)
(declare-fun ray_gcd_~y1.base () Int)
(declare-fun |init_gcd_#t~mem0| () Int)
(declare-fun |honda_gcd_#t~mem0| () Int)
(declare-fun |ray_gcd_#t~mem0| () Int)
(declare-fun |init_gcd_#t~mem5| () Int)
(declare-fun |honda_gcd_#t~mem5| () Int)
(declare-fun |ray_gcd_#t~mem5| () Int)
(declare-fun init_gcd_~y1.offset () Int)
(declare-fun honda_gcd_~y1.offset () Int)
(declare-fun ray_gcd_~y1.offset () Int)
(declare-fun init_gcd_~y2.offset () Int)
(declare-fun honda_gcd_~y2.offset () Int)
(declare-fun ray_gcd_~y2.offset () Int)
(declare-fun init_gcd_~y2.base () Int)
(declare-fun honda_gcd_~y2.base () Int)
(declare-fun ray_gcd_~y2.base () Int)
(declare-fun |init_gcd_#t~mem3| () Int)
(declare-fun |honda_gcd_#t~mem3| () Int)
(declare-fun |ray_gcd_#t~mem3| () Int)
(declare-fun |init_#NULL.offset| () Int)
(declare-fun |honda_#NULL.offset| () Int)
(declare-fun |ray_#NULL.offset| () Int)
(declare-fun |init_gcd_#in~y1.offset| () Int)
(declare-fun |honda_gcd_#in~y1.offset| () Int)
(declare-fun |ray_gcd_#in~y1.offset| () Int)
(declare-fun |init_gcd_#in~y2.offset| () Int)
(declare-fun |honda_gcd_#in~y2.offset| () Int)
(declare-fun |ray_gcd_#in~y2.offset| () Int)
(declare-fun |init_(select #length gcd_~y1.base)| () Int)
(declare-fun |honda_(select #length gcd_~y1.base)| () Int)
(declare-fun |ray_(select #length gcd_~y1.base)| () Int)
(declare-fun |init_gcd_#t~mem2| () Int)
(declare-fun |honda_gcd_#t~mem2| () Int)
(declare-fun |ray_gcd_#t~mem2| () Int)
(declare-fun |init_(ite (select #valid 0) 1 0)| () Int)
(declare-fun |honda_(ite (select #valid 0) 1 0)| () Int)
(declare-fun |ray_(ite (select #valid 0) 1 0)| () Int)
(declare-fun |init_(ite (select #valid gcd_~y1.base) 1 0)| () Int)
(declare-fun |honda_(ite (select #valid gcd_~y1.base) 1 0)| () Int)
(declare-fun |ray_(ite (select #valid gcd_~y1.base) 1 0)| () Int)
(declare-fun |init_(select #length gcd_~y2.base)| () Int)
(declare-fun |honda_(select #length gcd_~y2.base)| () Int)
(declare-fun |ray_(select #length gcd_~y2.base)| () Int)
(declare-fun |init_gcd_#t~mem1| () Int)
(declare-fun |honda_gcd_#t~mem1| () Int)
(declare-fun |ray_gcd_#t~mem1| () Int)
(declare-fun |init_gcd_#t~mem4| () Int)
(declare-fun |honda_gcd_#t~mem4| () Int)
(declare-fun |ray_gcd_#t~mem4| () Int)
(declare-fun |init_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)|
  () Int)
(declare-fun
  |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| () Int)
(declare-fun |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)|
  () Int)
(declare-fun |init_#NULL.base| () Int)
(declare-fun |honda_#NULL.base| () Int)
(declare-fun |ray_#NULL.base| () Int)
(declare-fun |init_gcd_#in~y1.base| () Int)
(declare-fun |honda_gcd_#in~y1.base| () Int)
(declare-fun |ray_gcd_#in~y1.base| () Int)
(declare-fun |init_gcd_#in~y2.base| () Int)
(declare-fun |honda_gcd_#in~y2.base| () Int)
(declare-fun |ray_gcd_#in~y2.base| () Int)
(declare-fun |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| ()
  Int)
(declare-fun |ray_(select (select old(#memory_int) gcd_#in~y2.base) 0)| ()
  Int)
(declare-fun |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| () Int)
(declare-fun |ray_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| () Int)
(declare-fun |honda_(select old(#length) gcd_#in~y1.base)| () Int)
(declare-fun |ray_(select old(#length) gcd_#in~y1.base)| () Int)
(declare-fun |honda_(select #length gcd_#in~y2.base)| () Int)
(declare-fun |ray_(select #length gcd_#in~y2.base)| () Int)
(declare-fun |honda_(ite (select old(#valid) 0) 1 0)| () Int)
(declare-fun |ray_(ite (select old(#valid) 0) 1 0)| () Int)
(declare-fun |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| () Int)
(declare-fun |ray_(ite (select #valid gcd_#in~y1.base) 1 0)| () Int)
(declare-fun |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| ()
  Int)
(declare-fun |ray_(select (select old(#memory_int) gcd_#in~y1.base) 0)| ()
  Int)
(declare-fun |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| () Int)
(declare-fun |ray_(ite (select #valid gcd_#in~y2.base) 1 0)| () Int)
(declare-fun |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| () Int)
(declare-fun |ray_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| () Int)
(declare-fun |honda_(select #length gcd_#in~y1.base)| () Int)
(declare-fun |ray_(select #length gcd_#in~y1.base)| () Int)
(declare-fun |honda_(select (select #memory_int gcd_#in~y1.base) 0)| () Int)
(declare-fun |ray_(select (select #memory_int gcd_#in~y1.base) 0)| () Int)
(declare-fun |honda_(select old(#length) gcd_#in~y2.base)| () Int)
(declare-fun |ray_(select old(#length) gcd_#in~y2.base)| () Int)
(declare-fun |honda_(select (select #memory_int gcd_#in~y2.base) 0)| () Int)
(declare-fun |ray_(select (select #memory_int gcd_#in~y2.base) 0)| () Int)
(declare-fun lambda () Int)
(declare-fun aux_744 () Int)
(declare-fun aux_746 () Int)
(declare-fun aux_748 () Int)
(declare-fun aux_750 () Int)
(declare-fun aux_752 () Int)
(declare-fun aux_754 () Int)
(declare-fun aux_756 () Int)
(declare-fun aux_758 () Int)
(declare-fun aux_760 () Int)
(declare-fun aux_762 () Int)
(declare-fun aux_764 () Int)
(declare-fun aux_766 () Int)
(assert
 (and
 (or
 (and
 (= |init_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)|
 |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)|)
 (= |init_(ite (select #valid gcd_~y2.base) 1 0)|
 |honda_(ite (select #valid gcd_~y2.base) 1 0)|)
 (= |init_gcd_#t~mem0| |honda_gcd_#t~mem0|)
 (= |init_gcd_#t~mem5| |honda_gcd_#t~mem5|)
 (= |init_gcd_#t~mem3| |honda_gcd_#t~mem3|)
 (= |init_(select #length gcd_~y1.base)|
 |honda_(select #length gcd_~y1.base)|)
 (= |init_gcd_#t~mem2| |honda_gcd_#t~mem2|)
 (= |init_(ite (select #valid gcd_~y1.base) 1 0)|
 |honda_(ite (select #valid gcd_~y1.base) 1 0)|)
 (= |init_(select #length gcd_~y2.base)|
 |honda_(select #length gcd_~y2.base)|)
 (= |init_gcd_#t~mem1| |honda_gcd_#t~mem1|)
 (= |init_gcd_#t~mem4| |honda_gcd_#t~mem4|)
 (= |init_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)|
 |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)|)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 1)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 1)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| (- 1))
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 
 (* aux_744 1) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 1) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base (- 1))
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 1)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 1)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| (- 1))
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| (- 1))
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| (- 1))
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 1)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1)) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 1) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| (- 1))
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 1)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 
 (* aux_744 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| (- 1))
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 1) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| (- 1)) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 1) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 1) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| (- 1))
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| (- 1)) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 1) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| (- 1))
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 1) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| (- 1))
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 1)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| (- 1))
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| (- 1))
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 1)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 1) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base (- 1)) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0)
 (* |honda_#NULL.offset| (- 1)) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0)
 (* |honda_(select #length gcd_#in~y2.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset (- 1))
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 1) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 1)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 1) 
 (* |honda_gcd_#in~y1.base| (- 1))
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| (- 1)) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 1)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 
 (* aux_746 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 1) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| (- 1)) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset (- 1)) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 1) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| (- 1))
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 
 (* aux_746 1) 0) 0))
 (and
 (= |init_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)|
 |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)|)
 (= |init_(ite (select #valid gcd_~y2.base) 1 0)|
 |honda_(ite (select #valid gcd_~y2.base) 1 0)|)
 (= |init_gcd_#t~mem0| |honda_gcd_#t~mem0|)
 (= |init_gcd_#t~mem5| |honda_gcd_#t~mem5|)
 (= |init_gcd_#t~mem3| |honda_gcd_#t~mem3|)
 (= |init_(select #length gcd_~y1.base)|
 |honda_(select #length gcd_~y1.base)|)
 (= |init_gcd_#t~mem2| |honda_gcd_#t~mem2|)
 (= |init_(ite (select #valid gcd_~y1.base) 1 0)|
 |honda_(ite (select #valid gcd_~y1.base) 1 0)|)
 (= |init_(select #length gcd_~y2.base)|
 |honda_(select #length gcd_~y2.base)|)
 (= |init_gcd_#t~mem1| |honda_gcd_#t~mem1|)
 (= |init_gcd_#t~mem4| |honda_gcd_#t~mem4|)
 (= |init_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)|
 |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)|)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 1)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 1)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| (- 1))
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 
 (* aux_748 1) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 1) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base (- 1))
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 1)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 1)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| (- 1))
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| (- 1))
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| (- 1))
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 1)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1)) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 1) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| (- 1))
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 1)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 
 (* aux_748 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| (- 1))
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 1) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| (- 1)) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 1) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 1) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| (- 1))
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| (- 1)) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 1) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| (- 1))
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 1) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| (- 1))
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| (- 1)) 
 (* |honda_gcd_#in~y1.base| 1)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 1)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| (- 1))
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| (- 1))
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 1)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 1) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base (- 1)) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0)
 (* |honda_#NULL.offset| (- 1)) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0)
 (* |honda_(select #length gcd_#in~y2.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset (- 1))
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 1) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 1)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 1)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 
 (* aux_750 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 1) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| (- 1)) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset (- 1)) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 1) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| (- 1))
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 
 (* aux_750 1) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| (- 1))
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 
 (- 1)) 0))
 (and
 (= |init_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)|
 |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)|)
 (= |init_(ite (select #valid gcd_~y2.base) 1 0)|
 |honda_(ite (select #valid gcd_~y2.base) 1 0)|)
 (= |init_gcd_#t~mem0| |honda_gcd_#t~mem0|)
 (= |init_gcd_#t~mem5| |honda_gcd_#t~mem5|)
 (= |init_gcd_#t~mem3| |honda_gcd_#t~mem3|)
 (= |init_(select #length gcd_~y1.base)|
 |honda_(select #length gcd_~y1.base)|)
 (= |init_gcd_#t~mem2| |honda_gcd_#t~mem2|)
 (= |init_(ite (select #valid gcd_~y1.base) 1 0)|
 |honda_(ite (select #valid gcd_~y1.base) 1 0)|)
 (= |init_(select #length gcd_~y2.base)|
 |honda_(select #length gcd_~y2.base)|)
 (= |init_gcd_#t~mem1| |honda_gcd_#t~mem1|)
 (= |init_gcd_#t~mem4| |honda_gcd_#t~mem4|)
 (= |init_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)|
 |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)|)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 1)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 1)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| (- 1))
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 
 (* aux_752 1) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 1) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base (- 1))
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 1)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 1)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| (- 1))
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| (- 1))
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 1) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| (- 1))
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 1)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1)) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 1) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| (- 1))
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 1)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 
 (* aux_752 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| (- 1))
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 1) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| (- 1)) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 1) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 1) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| (- 1))
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| (- 1)) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 1) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| (- 1))
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 1) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| (- 1))
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| (- 1)) 
 (* |honda_gcd_#in~y1.base| 1)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 1)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| (- 1))
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| (- 1))
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 1)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 1) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base (- 1)) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0)
 (* |honda_#NULL.offset| (- 1)) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0)
 (* |honda_(select #length gcd_#in~y2.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset (- 1))
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 1) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 1)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 1)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 
 (* aux_754 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 1) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| (- 1)) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset (- 1)) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 1) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| (- 1))
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 
 (* aux_754 1) 0) 0))
 (and
 (= |init_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)|
 |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)|)
 (= |init_(ite (select #valid gcd_~y2.base) 1 0)|
 |honda_(ite (select #valid gcd_~y2.base) 1 0)|)
 (= |init_gcd_#t~mem0| |honda_gcd_#t~mem0|)
 (= |init_gcd_#t~mem5| |honda_gcd_#t~mem5|)
 (= |init_gcd_#t~mem3| |honda_gcd_#t~mem3|)
 (= |init_(select #length gcd_~y1.base)|
 |honda_(select #length gcd_~y1.base)|)
 (= |init_gcd_#t~mem2| |honda_gcd_#t~mem2|)
 (= |init_(ite (select #valid gcd_~y1.base) 1 0)|
 |honda_(ite (select #valid gcd_~y1.base) 1 0)|)
 (= |init_(select #length gcd_~y2.base)|
 |honda_(select #length gcd_~y2.base)|)
 (= |init_gcd_#t~mem1| |honda_gcd_#t~mem1|)
 (= |init_gcd_#t~mem4| |honda_gcd_#t~mem4|)
 (= |init_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)|
 |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)|)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 1)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 1)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 1)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| (- 1))
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 
 (* aux_756 1) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 1) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base (- 1))
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 1)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 1)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| (- 1))
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| (- 1))
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| (- 1))
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 1)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1)) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 1) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| (- 1))
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 1)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 
 (* aux_756 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| (- 1))
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 1) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| (- 1)) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 1) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 1) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| (- 1))
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| (- 1)) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 1) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| (- 1))
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 1) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| (- 1))
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 1)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| (- 1))
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| (- 1))
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 1)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 1) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base (- 1)) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0)
 (* |honda_#NULL.offset| (- 1)) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0)
 (* |honda_(select #length gcd_#in~y2.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset (- 1))
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 1) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 1)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 1) 
 (* |honda_gcd_#in~y1.base| (- 1))
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 1)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 
 (* aux_758 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 1) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| (- 1)) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset (- 1)) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 1) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| (- 1))
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 
 (* aux_758 1) 0) 0))
 (and
 (= |init_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)|
 |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)|)
 (= |init_(ite (select #valid gcd_~y2.base) 1 0)|
 |honda_(ite (select #valid gcd_~y2.base) 1 0)|)
 (= |init_gcd_#t~mem0| |honda_gcd_#t~mem0|)
 (= |init_gcd_#t~mem5| |honda_gcd_#t~mem5|)
 (= |init_gcd_#t~mem3| |honda_gcd_#t~mem3|)
 (= |init_(select #length gcd_~y1.base)|
 |honda_(select #length gcd_~y1.base)|)
 (= |init_gcd_#t~mem2| |honda_gcd_#t~mem2|)
 (= |init_(ite (select #valid gcd_~y1.base) 1 0)|
 |honda_(ite (select #valid gcd_~y1.base) 1 0)|)
 (= |init_(select #length gcd_~y2.base)|
 |honda_(select #length gcd_~y2.base)|)
 (= |init_gcd_#t~mem1| |honda_gcd_#t~mem1|)
 (= |init_gcd_#t~mem4| |honda_gcd_#t~mem4|)
 (= |init_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)|
 |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)|)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 1)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 1)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| (- 1))
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 
 (* aux_760 1) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 1) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base (- 1))
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 1)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 1)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| (- 1))
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| (- 1))
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 1) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| (- 1))
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 1)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1)) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 1) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| (- 1))
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 1)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 
 (* aux_760 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| (- 1))
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 1) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| (- 1)) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 1) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 1) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| (- 1))
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| (- 1)) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 1) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| (- 1))
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 1) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| (- 1))
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 1)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| (- 1))
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| (- 1))
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 1)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 1) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base (- 1)) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0)
 (* |honda_#NULL.offset| (- 1)) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0)
 (* |honda_(select #length gcd_#in~y2.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset (- 1))
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 1) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 1)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 1)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 
 (* aux_762 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 1) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| (- 1)) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset (- 1)) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 1) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| (- 1))
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 
 (* aux_762 1) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| (- 1))
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 
 (- 1)) 0))
 (and
 (= |init_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)|
 |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)|)
 (= |init_(ite (select #valid gcd_~y2.base) 1 0)|
 |honda_(ite (select #valid gcd_~y2.base) 1 0)|)
 (= |init_gcd_#t~mem0| |honda_gcd_#t~mem0|)
 (= |init_gcd_#t~mem5| |honda_gcd_#t~mem5|)
 (= |init_gcd_#t~mem3| |honda_gcd_#t~mem3|)
 (= |init_(select #length gcd_~y1.base)|
 |honda_(select #length gcd_~y1.base)|)
 (= |init_gcd_#t~mem2| |honda_gcd_#t~mem2|)
 (= |init_(ite (select #valid gcd_~y1.base) 1 0)|
 |honda_(ite (select #valid gcd_~y1.base) 1 0)|)
 (= |init_(select #length gcd_~y2.base)|
 |honda_(select #length gcd_~y2.base)|)
 (= |init_gcd_#t~mem1| |honda_gcd_#t~mem1|)
 (= |init_gcd_#t~mem4| |honda_gcd_#t~mem4|)
 (= |init_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)|
 |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)|)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 1)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 1)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 1)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| (- 1))
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 
 (* aux_764 1) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 1) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base (- 1))
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 1)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 1)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| (- 1))
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| (- 1))
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| (- 1))
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 1)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1)) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 1) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| (- 1))
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 1)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 
 (* aux_764 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| (- 1))
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 1) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| (- 1)) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 1) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 1) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| (- 1))
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| (- 1)) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 1) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| (- 1))
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 1) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| (- 1))
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 1)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| (- 1))
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| (- 1))
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 1)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 1) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base (- 1)) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0)
 (* |honda_#NULL.offset| (- 1)) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0)
 (* |honda_(select #length gcd_#in~y2.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 4) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset (- 1))
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 1) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 1)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| (- 1)) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 1)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 
 (* aux_766 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 1) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| (- 1)) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset (- 1)) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 1) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 1)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| 0)
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| 0)
 (* honda_gcd_~y1.base 0) 
 (* |honda_(select old(#length) gcd_#in~y1.base)| 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* honda_gcd_~y1.offset 0) 
 (* |honda_(select #length gcd_#in~y2.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0) 
 (* |honda_gcd_#t~mem3| 0)
 (* |honda_(ite (select #valid gcd_#in~y1.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length gcd_~y2.base)| 0)
 (* |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)| 0)
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_gcd_#in~y2.base| 0) 
 (* |honda_gcd_#in~y1.base| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_(ite (select #valid gcd_~y2.base) 1 0)| 0)
 (* |honda_(ite (select #valid gcd_#in~y2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* honda_gcd_~y2.offset 0) 
 (* honda_gcd_~y2.base 0) 
 (* |honda_(select #length gcd_#in~y1.base)| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_gcd_#in~y1.offset| 0) 
 (* |honda_gcd_#in~y2.offset| 0) 
 (* |honda_(select #length gcd_~y1.base)| 0) 
 (* |honda_gcd_#t~mem2| 0)
 (* |honda_(ite (select #valid gcd_~y1.base) 1 0)| 0)
 (* |honda_(select (select #memory_int gcd_#in~y1.base) 0)| 0)
 (* |honda_(select old(#length) gcd_#in~y2.base)| 0)
 (* |honda_gcd_#t~mem1| 0) 
 (* |honda_#NULL.base| 0)
 (* |honda_(select (select #memory_int gcd_#in~y2.base) 0)| (- 1))
 (* init_gcd_~y1.base 0) (* init_gcd_~y1.offset 0) 
 (* init_gcd_~y2.offset 0) 
 (* init_gcd_~y2.base 0) (* |init_#NULL.offset| 0)
 (* |init_gcd_#in~y1.offset| 0) 
 (* |init_gcd_#in~y2.offset| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_#NULL.base| 0) (* |init_gcd_#in~y1.base| 0)
 (* |init_gcd_#in~y2.base| 0) 
 (* aux_766 1) 0) 0)))
 (or
 (and
 (= |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)|
 (+ |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)|
 |ray_(select (select old(#memory_int) gcd_#in~y2.base) 0)|))
 (= |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)|
 (+ |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)|
 |ray_(ite (select old(#valid) gcd_#in~y1.base) 1 0)|))
 (= honda_gcd_~y1.base (+ honda_gcd_~y1.base ray_gcd_~y1.base))
 (= |honda_(select old(#length) gcd_#in~y1.base)|
 (+ |honda_(select old(#length) gcd_#in~y1.base)|
 |ray_(select old(#length) gcd_#in~y1.base)|))
 (= honda_gcd_~y1.offset (+ honda_gcd_~y1.offset ray_gcd_~y1.offset))
 (= |honda_(select #length gcd_#in~y2.base)|
 (+ |honda_(select #length gcd_#in~y2.base)|
 |ray_(select #length gcd_#in~y2.base)|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_(ite (select #valid gcd_#in~y1.base) 1 0)|
 (+ |honda_(ite (select #valid gcd_#in~y1.base) 1 0)|
 |ray_(ite (select #valid gcd_#in~y1.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)|
 (+ |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)|
 |ray_(select (select old(#memory_int) gcd_#in~y1.base) 0)|))
 (= |honda_(select #length gcd_~y2.base)|
 (+ |honda_(select #length gcd_~y2.base)|
 |ray_(select #length gcd_~y2.base)|))
 (= |honda_gcd_#in~y1.base|
 (+ |honda_gcd_#in~y1.base| |ray_gcd_#in~y1.base|))
 (= |honda_gcd_#in~y2.base|
 (+ |honda_gcd_#in~y2.base| |ray_gcd_#in~y2.base|))
 (= |honda_(ite (select #valid gcd_~y2.base) 1 0)|
 (+ |honda_(ite (select #valid gcd_~y2.base) 1 0)|
 |ray_(ite (select #valid gcd_~y2.base) 1 0)|))
 (= |honda_(ite (select #valid gcd_#in~y2.base) 1 0)|
 (+ |honda_(ite (select #valid gcd_#in~y2.base) 1 0)|
 |ray_(ite (select #valid gcd_#in~y2.base) 1 0)|))
 (= |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)|
 |ray_(ite (select old(#valid) gcd_#in~y2.base) 1 0)|))
 (= honda_gcd_~y2.offset (+ honda_gcd_~y2.offset ray_gcd_~y2.offset))
 (= honda_gcd_~y2.base (+ honda_gcd_~y2.base ray_gcd_~y2.base))
 (= |honda_(select #length gcd_#in~y1.base)|
 (+ |honda_(select #length gcd_#in~y1.base)|
 |ray_(select #length gcd_#in~y1.base)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_gcd_#in~y1.offset|
 (+ |honda_gcd_#in~y1.offset| |ray_gcd_#in~y1.offset|))
 (= |honda_gcd_#in~y2.offset|
 (+ |honda_gcd_#in~y2.offset| |ray_gcd_#in~y2.offset|))
 (= |honda_(select #length gcd_~y1.base)|
 (+ |honda_(select #length gcd_~y1.base)|
 |ray_(select #length gcd_~y1.base)|))
 (= |honda_(ite (select #valid gcd_~y1.base) 1 0)|
 (+ |honda_(ite (select #valid gcd_~y1.base) 1 0)|
 |ray_(ite (select #valid gcd_~y1.base) 1 0)|))
 (= |honda_(select (select #memory_int gcd_#in~y1.base) 0)|
 (+ |honda_(select (select #memory_int gcd_#in~y1.base) 0)|
 |ray_(select (select #memory_int gcd_#in~y1.base) 0)|))
 (= |honda_(select old(#length) gcd_#in~y2.base)|
 (+ |honda_(select old(#length) gcd_#in~y2.base)|
 |ray_(select old(#length) gcd_#in~y2.base)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(select (select #memory_int gcd_#in~y2.base) 0)|
 (+ |honda_(select (select #memory_int gcd_#in~y2.base) 0)|
 |ray_(select (select #memory_int gcd_#in~y2.base) 0)|))
 (>=
 (+
 (*
 (+ |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)|
 |ray_(select (select old(#memory_int) gcd_#in~y2.base) 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)|
 |ray_(ite (select old(#valid) gcd_#in~y1.base) 1 0)|) 0)
 (* (+ honda_gcd_~y1.base ray_gcd_~y1.base) 0)
 (*
 (+ |honda_(select old(#length) gcd_#in~y1.base)|
 |ray_(select old(#length) gcd_#in~y1.base)|) 0)
 (* (+ |honda_gcd_#t~mem5| |ray_gcd_#t~mem5|) 0)
 (* (+ honda_gcd_~y1.offset ray_gcd_~y1.offset) 1)
 (*
 (+ |honda_(select #length gcd_#in~y2.base)|
 |ray_(select #length gcd_#in~y2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_#in~y1.base) 1 0)|
 |ray_(ite (select #valid gcd_#in~y1.base) 1 0)|) 0)
 (* (+ |honda_gcd_#t~mem3| |ray_gcd_#t~mem3|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)|
 |ray_(select (select old(#memory_int) gcd_#in~y1.base) 0)|) 0)
 (*
 (+ |honda_(select #length gcd_~y2.base)|
 |ray_(select #length gcd_~y2.base)|) 0)
 (* (+ |honda_gcd_#in~y1.base| |ray_gcd_#in~y1.base|) 0)
 (* (+ |honda_gcd_#in~y2.base| |ray_gcd_#in~y2.base|) 0)
 (* (+ |honda_gcd_#t~mem4| |ray_gcd_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)|
 |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)|
 |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_~y2.base) 1 0)|
 |ray_(ite (select #valid gcd_~y2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_#in~y2.base) 1 0)|
 |ray_(ite (select #valid gcd_#in~y2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)|
 |ray_(ite (select old(#valid) gcd_#in~y2.base) 1 0)|) 0)
 (* (+ |honda_gcd_#t~mem0| |ray_gcd_#t~mem0|) 0)
 (* (+ honda_gcd_~y2.offset ray_gcd_~y2.offset) (- 1))
 (* (+ honda_gcd_~y2.base ray_gcd_~y2.base) 0)
 (*
 (+ |honda_(select #length gcd_#in~y1.base)|
 |ray_(select #length gcd_#in~y1.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_gcd_#in~y1.offset| |ray_gcd_#in~y1.offset|) 0)
 (* (+ |honda_gcd_#in~y2.offset| |ray_gcd_#in~y2.offset|) 0)
 (*
 (+ |honda_(select #length gcd_~y1.base)|
 |ray_(select #length gcd_~y1.base)|) 0)
 (* (+ |honda_gcd_#t~mem2| |ray_gcd_#t~mem2|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_~y1.base) 1 0)|
 |ray_(ite (select #valid gcd_~y1.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_#in~y1.base) 0)|
 |ray_(select (select #memory_int gcd_#in~y1.base) 0)|) 0)
 (*
 (+ |honda_(select old(#length) gcd_#in~y2.base)|
 |ray_(select old(#length) gcd_#in~y2.base)|) 0)
 (* (+ |honda_gcd_#t~mem1| |ray_gcd_#t~mem1|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_#in~y2.base) 0)|
 |ray_(select (select #memory_int gcd_#in~y2.base) 0)|) 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* |honda_gcd_#t~mem3| 0) 
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* |honda_gcd_#t~mem2| 0) 
 (* |honda_gcd_#t~mem1| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)|
 |ray_(select (select old(#memory_int) gcd_#in~y2.base) 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)|
 |ray_(ite (select old(#valid) gcd_#in~y1.base) 1 0)|) 0)
 (* (+ honda_gcd_~y1.base ray_gcd_~y1.base) 0)
 (*
 (+ |honda_(select old(#length) gcd_#in~y1.base)|
 |ray_(select old(#length) gcd_#in~y1.base)|) 0)
 (* (+ |honda_gcd_#t~mem5| |ray_gcd_#t~mem5|) 0)
 (* (+ honda_gcd_~y1.offset ray_gcd_~y1.offset) 0)
 (*
 (+ |honda_(select #length gcd_#in~y2.base)|
 |ray_(select #length gcd_#in~y2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_#in~y1.base) 1 0)|
 |ray_(ite (select #valid gcd_#in~y1.base) 1 0)|) 0)
 (* (+ |honda_gcd_#t~mem3| |ray_gcd_#t~mem3|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)|
 |ray_(select (select old(#memory_int) gcd_#in~y1.base) 0)|) 0)
 (*
 (+ |honda_(select #length gcd_~y2.base)|
 |ray_(select #length gcd_~y2.base)|) 0)
 (* (+ |honda_gcd_#in~y1.base| |ray_gcd_#in~y1.base|) 0)
 (* (+ |honda_gcd_#in~y2.base| |ray_gcd_#in~y2.base|) 0)
 (* (+ |honda_gcd_#t~mem4| |ray_gcd_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)|
 |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)|
 |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_~y2.base) 1 0)|
 |ray_(ite (select #valid gcd_~y2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_#in~y2.base) 1 0)|
 |ray_(ite (select #valid gcd_#in~y2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)|
 |ray_(ite (select old(#valid) gcd_#in~y2.base) 1 0)|) 0)
 (* (+ |honda_gcd_#t~mem0| |ray_gcd_#t~mem0|) 0)
 (* (+ honda_gcd_~y2.offset ray_gcd_~y2.offset) 0)
 (* (+ honda_gcd_~y2.base ray_gcd_~y2.base) 0)
 (*
 (+ |honda_(select #length gcd_#in~y1.base)|
 |ray_(select #length gcd_#in~y1.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_gcd_#in~y1.offset| |ray_gcd_#in~y1.offset|) 0)
 (* (+ |honda_gcd_#in~y2.offset| |ray_gcd_#in~y2.offset|) 0)
 (*
 (+ |honda_(select #length gcd_~y1.base)|
 |ray_(select #length gcd_~y1.base)|) 0)
 (* (+ |honda_gcd_#t~mem2| |ray_gcd_#t~mem2|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_~y1.base) 1 0)|
 |ray_(ite (select #valid gcd_~y1.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_#in~y1.base) 0)|
 |ray_(select (select #memory_int gcd_#in~y1.base) 0)|) 0)
 (*
 (+ |honda_(select old(#length) gcd_#in~y2.base)|
 |ray_(select old(#length) gcd_#in~y2.base)|) 0)
 (* (+ |honda_gcd_#t~mem1| |ray_gcd_#t~mem1|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_#in~y2.base) 0)|
 |ray_(select (select #memory_int gcd_#in~y2.base) 0)|) 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* |honda_gcd_#t~mem3| 0) 
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| (- 1))
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 1)
 (* |honda_gcd_#t~mem0| 0) 
 (* |honda_gcd_#t~mem2| 0) 
 (* |honda_gcd_#t~mem1| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)|
 |ray_(select (select old(#memory_int) gcd_#in~y2.base) 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)|
 |ray_(ite (select old(#valid) gcd_#in~y1.base) 1 0)|) 0)
 (* (+ honda_gcd_~y1.base ray_gcd_~y1.base) 0)
 (*
 (+ |honda_(select old(#length) gcd_#in~y1.base)|
 |ray_(select old(#length) gcd_#in~y1.base)|) 0)
 (* (+ |honda_gcd_#t~mem5| |ray_gcd_#t~mem5|) 0)
 (* (+ honda_gcd_~y1.offset ray_gcd_~y1.offset) 0)
 (*
 (+ |honda_(select #length gcd_#in~y2.base)|
 |ray_(select #length gcd_#in~y2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_#in~y1.base) 1 0)|
 |ray_(ite (select #valid gcd_#in~y1.base) 1 0)|) 0)
 (* (+ |honda_gcd_#t~mem3| |ray_gcd_#t~mem3|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)|
 |ray_(select (select old(#memory_int) gcd_#in~y1.base) 0)|) 0)
 (*
 (+ |honda_(select #length gcd_~y2.base)|
 |ray_(select #length gcd_~y2.base)|) 0)
 (* (+ |honda_gcd_#in~y1.base| |ray_gcd_#in~y1.base|) 0)
 (* (+ |honda_gcd_#in~y2.base| |ray_gcd_#in~y2.base|) 0)
 (* (+ |honda_gcd_#t~mem4| |ray_gcd_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)|
 |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)|) 1)
 (*
 (+ |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)|
 |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_~y2.base) 1 0)|
 |ray_(ite (select #valid gcd_~y2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_#in~y2.base) 1 0)|
 |ray_(ite (select #valid gcd_#in~y2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)|
 |ray_(ite (select old(#valid) gcd_#in~y2.base) 1 0)|) 0)
 (* (+ |honda_gcd_#t~mem0| |ray_gcd_#t~mem0|) 0)
 (* (+ honda_gcd_~y2.offset ray_gcd_~y2.offset) 0)
 (* (+ honda_gcd_~y2.base ray_gcd_~y2.base) 0)
 (*
 (+ |honda_(select #length gcd_#in~y1.base)|
 |ray_(select #length gcd_#in~y1.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_gcd_#in~y1.offset| |ray_gcd_#in~y1.offset|) 0)
 (* (+ |honda_gcd_#in~y2.offset| |ray_gcd_#in~y2.offset|) 0)
 (*
 (+ |honda_(select #length gcd_~y1.base)|
 |ray_(select #length gcd_~y1.base)|) 0)
 (* (+ |honda_gcd_#t~mem2| |ray_gcd_#t~mem2|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_~y1.base) 1 0)|
 |ray_(ite (select #valid gcd_~y1.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_#in~y1.base) 0)|
 |ray_(select (select #memory_int gcd_#in~y1.base) 0)|) 0)
 (*
 (+ |honda_(select old(#length) gcd_#in~y2.base)|
 |ray_(select old(#length) gcd_#in~y2.base)|) 0)
 (* (+ |honda_gcd_#t~mem1| |ray_gcd_#t~mem1|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_#in~y2.base) 0)|
 |ray_(select (select #memory_int gcd_#in~y2.base) 0)|) 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* |honda_gcd_#t~mem3| 0) 
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| (- 1))
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* |honda_gcd_#t~mem2| 0) 
 (* |honda_gcd_#t~mem1| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)|
 |ray_(select (select old(#memory_int) gcd_#in~y2.base) 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)|
 |ray_(ite (select old(#valid) gcd_#in~y1.base) 1 0)|) 0)
 (* (+ honda_gcd_~y1.base ray_gcd_~y1.base) 0)
 (*
 (+ |honda_(select old(#length) gcd_#in~y1.base)|
 |ray_(select old(#length) gcd_#in~y1.base)|) 0)
 (* (+ |honda_gcd_#t~mem5| |ray_gcd_#t~mem5|) 0)
 (* (+ honda_gcd_~y1.offset ray_gcd_~y1.offset) 0)
 (*
 (+ |honda_(select #length gcd_#in~y2.base)|
 |ray_(select #length gcd_#in~y2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_#in~y1.base) 1 0)|
 |ray_(ite (select #valid gcd_#in~y1.base) 1 0)|) 0)
 (* (+ |honda_gcd_#t~mem3| |ray_gcd_#t~mem3|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)|
 |ray_(select (select old(#memory_int) gcd_#in~y1.base) 0)|) 0)
 (*
 (+ |honda_(select #length gcd_~y2.base)|
 |ray_(select #length gcd_~y2.base)|) 0)
 (* (+ |honda_gcd_#in~y1.base| |ray_gcd_#in~y1.base|) 0)
 (* (+ |honda_gcd_#in~y2.base| |ray_gcd_#in~y2.base|) 0)
 (* (+ |honda_gcd_#t~mem4| |ray_gcd_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)|
 |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)|
 |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_~y2.base) 1 0)|
 |ray_(ite (select #valid gcd_~y2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_#in~y2.base) 1 0)|
 |ray_(ite (select #valid gcd_#in~y2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)|
 |ray_(ite (select old(#valid) gcd_#in~y2.base) 1 0)|) 0)
 (* (+ |honda_gcd_#t~mem0| |ray_gcd_#t~mem0|) 0)
 (* (+ honda_gcd_~y2.offset ray_gcd_~y2.offset) 0)
 (* (+ honda_gcd_~y2.base ray_gcd_~y2.base) 0)
 (*
 (+ |honda_(select #length gcd_#in~y1.base)|
 |ray_(select #length gcd_#in~y1.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_gcd_#in~y1.offset| |ray_gcd_#in~y1.offset|) 0)
 (* (+ |honda_gcd_#in~y2.offset| |ray_gcd_#in~y2.offset|) 0)
 (*
 (+ |honda_(select #length gcd_~y1.base)|
 |ray_(select #length gcd_~y1.base)|) 0)
 (* (+ |honda_gcd_#t~mem2| |ray_gcd_#t~mem2|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_~y1.base) 1 0)|
 |ray_(ite (select #valid gcd_~y1.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_#in~y1.base) 0)|
 |ray_(select (select #memory_int gcd_#in~y1.base) 0)|) 0)
 (*
 (+ |honda_(select old(#length) gcd_#in~y2.base)|
 |ray_(select old(#length) gcd_#in~y2.base)|) 0)
 (* (+ |honda_gcd_#t~mem1| |ray_gcd_#t~mem1|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_#in~y2.base) 0)|
 |ray_(select (select #memory_int gcd_#in~y2.base) 0)|) 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* |honda_gcd_#t~mem3| 0) 
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 1)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* |honda_gcd_#t~mem2| 0) 
 (* |honda_gcd_#t~mem1| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)|
 |ray_(select (select old(#memory_int) gcd_#in~y2.base) 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)|
 |ray_(ite (select old(#valid) gcd_#in~y1.base) 1 0)|) 0)
 (* (+ honda_gcd_~y1.base ray_gcd_~y1.base) 0)
 (*
 (+ |honda_(select old(#length) gcd_#in~y1.base)|
 |ray_(select old(#length) gcd_#in~y1.base)|) 0)
 (* (+ |honda_gcd_#t~mem5| |ray_gcd_#t~mem5|) 0)
 (* (+ honda_gcd_~y1.offset ray_gcd_~y1.offset) 0)
 (*
 (+ |honda_(select #length gcd_#in~y2.base)|
 |ray_(select #length gcd_#in~y2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_#in~y1.base) 1 0)|
 |ray_(ite (select #valid gcd_#in~y1.base) 1 0)|) 0)
 (* (+ |honda_gcd_#t~mem3| |ray_gcd_#t~mem3|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)|
 |ray_(select (select old(#memory_int) gcd_#in~y1.base) 0)|) 0)
 (*
 (+ |honda_(select #length gcd_~y2.base)|
 |ray_(select #length gcd_~y2.base)|) 0)
 (* (+ |honda_gcd_#in~y1.base| |ray_gcd_#in~y1.base|) 0)
 (* (+ |honda_gcd_#in~y2.base| |ray_gcd_#in~y2.base|) 0)
 (* (+ |honda_gcd_#t~mem4| |ray_gcd_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)|
 |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)|
 |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid gcd_~y2.base) 1 0)|
 |ray_(ite (select #valid gcd_~y2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_#in~y2.base) 1 0)|
 |ray_(ite (select #valid gcd_#in~y2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)|
 |ray_(ite (select old(#valid) gcd_#in~y2.base) 1 0)|) 0)
 (* (+ |honda_gcd_#t~mem0| |ray_gcd_#t~mem0|) 0)
 (* (+ honda_gcd_~y2.offset ray_gcd_~y2.offset) 0)
 (* (+ honda_gcd_~y2.base ray_gcd_~y2.base) 0)
 (*
 (+ |honda_(select #length gcd_#in~y1.base)|
 |ray_(select #length gcd_#in~y1.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_gcd_#in~y1.offset| |ray_gcd_#in~y1.offset|) 0)
 (* (+ |honda_gcd_#in~y2.offset| |ray_gcd_#in~y2.offset|) 0)
 (*
 (+ |honda_(select #length gcd_~y1.base)|
 |ray_(select #length gcd_~y1.base)|) 0)
 (* (+ |honda_gcd_#t~mem2| |ray_gcd_#t~mem2|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_~y1.base) 1 0)|
 |ray_(ite (select #valid gcd_~y1.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_#in~y1.base) 0)|
 |ray_(select (select #memory_int gcd_#in~y1.base) 0)|) 0)
 (*
 (+ |honda_(select old(#length) gcd_#in~y2.base)|
 |ray_(select old(#length) gcd_#in~y2.base)|) 0)
 (* (+ |honda_gcd_#t~mem1| |ray_gcd_#t~mem1|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_#in~y2.base) 0)|
 |ray_(select (select #memory_int gcd_#in~y2.base) 0)|) 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* |honda_gcd_#t~mem3| 0) 
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 1)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| (- 1))
 (* |honda_gcd_#t~mem0| 0) 
 (* |honda_gcd_#t~mem2| 0) 
 (* |honda_gcd_#t~mem1| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)|
 |ray_(select (select old(#memory_int) gcd_#in~y2.base) 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)|
 |ray_(ite (select old(#valid) gcd_#in~y1.base) 1 0)|) 0)
 (* (+ honda_gcd_~y1.base ray_gcd_~y1.base) 0)
 (*
 (+ |honda_(select old(#length) gcd_#in~y1.base)|
 |ray_(select old(#length) gcd_#in~y1.base)|) 0)
 (* (+ |honda_gcd_#t~mem5| |ray_gcd_#t~mem5|) 0)
 (* (+ honda_gcd_~y1.offset ray_gcd_~y1.offset) (- 1))
 (*
 (+ |honda_(select #length gcd_#in~y2.base)|
 |ray_(select #length gcd_#in~y2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_#in~y1.base) 1 0)|
 |ray_(ite (select #valid gcd_#in~y1.base) 1 0)|) 0)
 (* (+ |honda_gcd_#t~mem3| |ray_gcd_#t~mem3|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)|
 |ray_(select (select old(#memory_int) gcd_#in~y1.base) 0)|) 0)
 (*
 (+ |honda_(select #length gcd_~y2.base)|
 |ray_(select #length gcd_~y2.base)|) 0)
 (* (+ |honda_gcd_#in~y1.base| |ray_gcd_#in~y1.base|) 0)
 (* (+ |honda_gcd_#in~y2.base| |ray_gcd_#in~y2.base|) 0)
 (* (+ |honda_gcd_#t~mem4| |ray_gcd_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)|
 |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)|
 |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_~y2.base) 1 0)|
 |ray_(ite (select #valid gcd_~y2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_#in~y2.base) 1 0)|
 |ray_(ite (select #valid gcd_#in~y2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)|
 |ray_(ite (select old(#valid) gcd_#in~y2.base) 1 0)|) 0)
 (* (+ |honda_gcd_#t~mem0| |ray_gcd_#t~mem0|) 0)
 (* (+ honda_gcd_~y2.offset ray_gcd_~y2.offset) 0)
 (* (+ honda_gcd_~y2.base ray_gcd_~y2.base) 0)
 (*
 (+ |honda_(select #length gcd_#in~y1.base)|
 |ray_(select #length gcd_#in~y1.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_gcd_#in~y1.offset| |ray_gcd_#in~y1.offset|) 0)
 (* (+ |honda_gcd_#in~y2.offset| |ray_gcd_#in~y2.offset|) 0)
 (*
 (+ |honda_(select #length gcd_~y1.base)|
 |ray_(select #length gcd_~y1.base)|) 1)
 (* (+ |honda_gcd_#t~mem2| |ray_gcd_#t~mem2|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_~y1.base) 1 0)|
 |ray_(ite (select #valid gcd_~y1.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_#in~y1.base) 0)|
 |ray_(select (select #memory_int gcd_#in~y1.base) 0)|) 0)
 (*
 (+ |honda_(select old(#length) gcd_#in~y2.base)|
 |ray_(select old(#length) gcd_#in~y2.base)|) 0)
 (* (+ |honda_gcd_#t~mem1| |ray_gcd_#t~mem1|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_#in~y2.base) 0)|
 |ray_(select (select #memory_int gcd_#in~y2.base) 0)|) 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* |honda_gcd_#t~mem3| 0) 
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* |honda_gcd_#t~mem2| 0) 
 (* |honda_gcd_#t~mem1| 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)|
 |ray_(select (select old(#memory_int) gcd_#in~y2.base) 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)|
 |ray_(ite (select old(#valid) gcd_#in~y1.base) 1 0)|) 0)
 (* (+ honda_gcd_~y1.base ray_gcd_~y1.base) 1)
 (*
 (+ |honda_(select old(#length) gcd_#in~y1.base)|
 |ray_(select old(#length) gcd_#in~y1.base)|) 0)
 (* (+ |honda_gcd_#t~mem5| |ray_gcd_#t~mem5|) 0)
 (* (+ honda_gcd_~y1.offset ray_gcd_~y1.offset) 0)
 (*
 (+ |honda_(select #length gcd_#in~y2.base)|
 |ray_(select #length gcd_#in~y2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_#in~y1.base) 1 0)|
 |ray_(ite (select #valid gcd_#in~y1.base) 1 0)|) 0)
 (* (+ |honda_gcd_#t~mem3| |ray_gcd_#t~mem3|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)|
 |ray_(select (select old(#memory_int) gcd_#in~y1.base) 0)|) 0)
 (*
 (+ |honda_(select #length gcd_~y2.base)|
 |ray_(select #length gcd_~y2.base)|) 0)
 (* (+ |honda_gcd_#in~y1.base| |ray_gcd_#in~y1.base|) 0)
 (* (+ |honda_gcd_#in~y2.base| |ray_gcd_#in~y2.base|) 0)
 (* (+ |honda_gcd_#t~mem4| |ray_gcd_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)|
 |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)|
 |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_~y2.base) 1 0)|
 |ray_(ite (select #valid gcd_~y2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_#in~y2.base) 1 0)|
 |ray_(ite (select #valid gcd_#in~y2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)|
 |ray_(ite (select old(#valid) gcd_#in~y2.base) 1 0)|) 0)
 (* (+ |honda_gcd_#t~mem0| |ray_gcd_#t~mem0|) 0)
 (* (+ honda_gcd_~y2.offset ray_gcd_~y2.offset) 0)
 (* (+ honda_gcd_~y2.base ray_gcd_~y2.base) (- 1))
 (*
 (+ |honda_(select #length gcd_#in~y1.base)|
 |ray_(select #length gcd_#in~y1.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_gcd_#in~y1.offset| |ray_gcd_#in~y1.offset|) 0)
 (* (+ |honda_gcd_#in~y2.offset| |ray_gcd_#in~y2.offset|) 0)
 (*
 (+ |honda_(select #length gcd_~y1.base)|
 |ray_(select #length gcd_~y1.base)|) 0)
 (* (+ |honda_gcd_#t~mem2| |ray_gcd_#t~mem2|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_~y1.base) 1 0)|
 |ray_(ite (select #valid gcd_~y1.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_#in~y1.base) 0)|
 |ray_(select (select #memory_int gcd_#in~y1.base) 0)|) 0)
 (*
 (+ |honda_(select old(#length) gcd_#in~y2.base)|
 |ray_(select old(#length) gcd_#in~y2.base)|) 0)
 (* (+ |honda_gcd_#t~mem1| |ray_gcd_#t~mem1|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_#in~y2.base) 0)|
 |ray_(select (select #memory_int gcd_#in~y2.base) 0)|) 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* |honda_gcd_#t~mem3| 0) 
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* |honda_gcd_#t~mem2| 0) 
 (* |honda_gcd_#t~mem1| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)|
 |ray_(select (select old(#memory_int) gcd_#in~y2.base) 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)|
 |ray_(ite (select old(#valid) gcd_#in~y1.base) 1 0)|) 0)
 (* (+ honda_gcd_~y1.base ray_gcd_~y1.base) 0)
 (*
 (+ |honda_(select old(#length) gcd_#in~y1.base)|
 |ray_(select old(#length) gcd_#in~y1.base)|) 0)
 (* (+ |honda_gcd_#t~mem5| |ray_gcd_#t~mem5|) 0)
 (* (+ honda_gcd_~y1.offset ray_gcd_~y1.offset) (- 1))
 (*
 (+ |honda_(select #length gcd_#in~y2.base)|
 |ray_(select #length gcd_#in~y2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_#in~y1.base) 1 0)|
 |ray_(ite (select #valid gcd_#in~y1.base) 1 0)|) 0)
 (* (+ |honda_gcd_#t~mem3| |ray_gcd_#t~mem3|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)|
 |ray_(select (select old(#memory_int) gcd_#in~y1.base) 0)|) 0)
 (*
 (+ |honda_(select #length gcd_~y2.base)|
 |ray_(select #length gcd_~y2.base)|) 0)
 (* (+ |honda_gcd_#in~y1.base| |ray_gcd_#in~y1.base|) 0)
 (* (+ |honda_gcd_#in~y2.base| |ray_gcd_#in~y2.base|) 0)
 (* (+ |honda_gcd_#t~mem4| |ray_gcd_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)|
 |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)|
 |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_~y2.base) 1 0)|
 |ray_(ite (select #valid gcd_~y2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_#in~y2.base) 1 0)|
 |ray_(ite (select #valid gcd_#in~y2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)|
 |ray_(ite (select old(#valid) gcd_#in~y2.base) 1 0)|) 0)
 (* (+ |honda_gcd_#t~mem0| |ray_gcd_#t~mem0|) 0)
 (* (+ honda_gcd_~y2.offset ray_gcd_~y2.offset) 1)
 (* (+ honda_gcd_~y2.base ray_gcd_~y2.base) 0)
 (*
 (+ |honda_(select #length gcd_#in~y1.base)|
 |ray_(select #length gcd_#in~y1.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_gcd_#in~y1.offset| |ray_gcd_#in~y1.offset|) 0)
 (* (+ |honda_gcd_#in~y2.offset| |ray_gcd_#in~y2.offset|) 0)
 (*
 (+ |honda_(select #length gcd_~y1.base)|
 |ray_(select #length gcd_~y1.base)|) 0)
 (* (+ |honda_gcd_#t~mem2| |ray_gcd_#t~mem2|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_~y1.base) 1 0)|
 |ray_(ite (select #valid gcd_~y1.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_#in~y1.base) 0)|
 |ray_(select (select #memory_int gcd_#in~y1.base) 0)|) 0)
 (*
 (+ |honda_(select old(#length) gcd_#in~y2.base)|
 |ray_(select old(#length) gcd_#in~y2.base)|) 0)
 (* (+ |honda_gcd_#t~mem1| |ray_gcd_#t~mem1|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_#in~y2.base) 0)|
 |ray_(select (select #memory_int gcd_#in~y2.base) 0)|) 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* |honda_gcd_#t~mem3| 0) 
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* |honda_gcd_#t~mem2| 0) 
 (* |honda_gcd_#t~mem1| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)|
 |ray_(select (select old(#memory_int) gcd_#in~y2.base) 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)|
 |ray_(ite (select old(#valid) gcd_#in~y1.base) 1 0)|) 0)
 (* (+ honda_gcd_~y1.base ray_gcd_~y1.base) 0)
 (*
 (+ |honda_(select old(#length) gcd_#in~y1.base)|
 |ray_(select old(#length) gcd_#in~y1.base)|) 0)
 (* (+ |honda_gcd_#t~mem5| |ray_gcd_#t~mem5|) 0)
 (* (+ honda_gcd_~y1.offset ray_gcd_~y1.offset) 0)
 (*
 (+ |honda_(select #length gcd_#in~y2.base)|
 |ray_(select #length gcd_#in~y2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_#in~y1.base) 1 0)|
 |ray_(ite (select #valid gcd_#in~y1.base) 1 0)|) 0)
 (* (+ |honda_gcd_#t~mem3| |ray_gcd_#t~mem3|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)|
 |ray_(select (select old(#memory_int) gcd_#in~y1.base) 0)|) 0)
 (*
 (+ |honda_(select #length gcd_~y2.base)|
 |ray_(select #length gcd_~y2.base)|) 0)
 (* (+ |honda_gcd_#in~y1.base| |ray_gcd_#in~y1.base|) 0)
 (* (+ |honda_gcd_#in~y2.base| |ray_gcd_#in~y2.base|) 0)
 (* (+ |honda_gcd_#t~mem4| |ray_gcd_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)|
 |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)|
 |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_~y2.base) 1 0)|
 |ray_(ite (select #valid gcd_~y2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_#in~y2.base) 1 0)|
 |ray_(ite (select #valid gcd_#in~y2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)|
 |ray_(ite (select old(#valid) gcd_#in~y2.base) 1 0)|) 0)
 (* (+ |honda_gcd_#t~mem0| |ray_gcd_#t~mem0|) 0)
 (* (+ honda_gcd_~y2.offset ray_gcd_~y2.offset) 0)
 (* (+ honda_gcd_~y2.base ray_gcd_~y2.base) 0)
 (*
 (+ |honda_(select #length gcd_#in~y1.base)|
 |ray_(select #length gcd_#in~y1.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_gcd_#in~y1.offset| |ray_gcd_#in~y1.offset|) 0)
 (* (+ |honda_gcd_#in~y2.offset| |ray_gcd_#in~y2.offset|) 0)
 (*
 (+ |honda_(select #length gcd_~y1.base)|
 |ray_(select #length gcd_~y1.base)|) 0)
 (* (+ |honda_gcd_#t~mem2| |ray_gcd_#t~mem2|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_~y1.base) 1 0)|
 |ray_(ite (select #valid gcd_~y1.base) 1 0)|) 1)
 (*
 (+ |honda_(select (select #memory_int gcd_#in~y1.base) 0)|
 |ray_(select (select #memory_int gcd_#in~y1.base) 0)|) 0)
 (*
 (+ |honda_(select old(#length) gcd_#in~y2.base)|
 |ray_(select old(#length) gcd_#in~y2.base)|) 0)
 (* (+ |honda_gcd_#t~mem1| |ray_gcd_#t~mem1|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_#in~y2.base) 0)|
 |ray_(select (select #memory_int gcd_#in~y2.base) 0)|) 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* |honda_gcd_#t~mem3| 0) 
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* |honda_gcd_#t~mem2| 0) 
 (* |honda_gcd_#t~mem1| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)|
 |ray_(select (select old(#memory_int) gcd_#in~y2.base) 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)|
 |ray_(ite (select old(#valid) gcd_#in~y1.base) 1 0)|) 0)
 (* (+ honda_gcd_~y1.base ray_gcd_~y1.base) 0)
 (*
 (+ |honda_(select old(#length) gcd_#in~y1.base)|
 |ray_(select old(#length) gcd_#in~y1.base)|) 0)
 (* (+ |honda_gcd_#t~mem5| |ray_gcd_#t~mem5|) 0)
 (* (+ honda_gcd_~y1.offset ray_gcd_~y1.offset) 0)
 (*
 (+ |honda_(select #length gcd_#in~y2.base)|
 |ray_(select #length gcd_#in~y2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_#in~y1.base) 1 0)|
 |ray_(ite (select #valid gcd_#in~y1.base) 1 0)|) 0)
 (* (+ |honda_gcd_#t~mem3| |ray_gcd_#t~mem3|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)|
 |ray_(select (select old(#memory_int) gcd_#in~y1.base) 0)|) 0)
 (*
 (+ |honda_(select #length gcd_~y2.base)|
 |ray_(select #length gcd_~y2.base)|) 1)
 (* (+ |honda_gcd_#in~y1.base| |ray_gcd_#in~y1.base|) 0)
 (* (+ |honda_gcd_#in~y2.base| |ray_gcd_#in~y2.base|) 0)
 (* (+ |honda_gcd_#t~mem4| |ray_gcd_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)|
 |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)|
 |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_~y2.base) 1 0)|
 |ray_(ite (select #valid gcd_~y2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_#in~y2.base) 1 0)|
 |ray_(ite (select #valid gcd_#in~y2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)|
 |ray_(ite (select old(#valid) gcd_#in~y2.base) 1 0)|) 0)
 (* (+ |honda_gcd_#t~mem0| |ray_gcd_#t~mem0|) 0)
 (* (+ honda_gcd_~y2.offset ray_gcd_~y2.offset) (- 1))
 (* (+ honda_gcd_~y2.base ray_gcd_~y2.base) 0)
 (*
 (+ |honda_(select #length gcd_#in~y1.base)|
 |ray_(select #length gcd_#in~y1.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_gcd_#in~y1.offset| |ray_gcd_#in~y1.offset|) 0)
 (* (+ |honda_gcd_#in~y2.offset| |ray_gcd_#in~y2.offset|) 0)
 (*
 (+ |honda_(select #length gcd_~y1.base)|
 |ray_(select #length gcd_~y1.base)|) 0)
 (* (+ |honda_gcd_#t~mem2| |ray_gcd_#t~mem2|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_~y1.base) 1 0)|
 |ray_(ite (select #valid gcd_~y1.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_#in~y1.base) 0)|
 |ray_(select (select #memory_int gcd_#in~y1.base) 0)|) 0)
 (*
 (+ |honda_(select old(#length) gcd_#in~y2.base)|
 |ray_(select old(#length) gcd_#in~y2.base)|) 0)
 (* (+ |honda_gcd_#t~mem1| |ray_gcd_#t~mem1|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_#in~y2.base) 0)|
 |ray_(select (select #memory_int gcd_#in~y2.base) 0)|) 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* |honda_gcd_#t~mem3| 0) 
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* |honda_gcd_#t~mem2| 0) 
 (* |honda_gcd_#t~mem1| 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)|
 |ray_(select (select old(#memory_int) gcd_#in~y2.base) 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)|
 |ray_(ite (select old(#valid) gcd_#in~y1.base) 1 0)|) 0)
 (* (+ honda_gcd_~y1.base ray_gcd_~y1.base) 0)
 (*
 (+ |honda_(select old(#length) gcd_#in~y1.base)|
 |ray_(select old(#length) gcd_#in~y1.base)|) 0)
 (* (+ |honda_gcd_#t~mem5| |ray_gcd_#t~mem5|) 0)
 (* (+ honda_gcd_~y1.offset ray_gcd_~y1.offset) 0)
 (*
 (+ |honda_(select #length gcd_#in~y2.base)|
 |ray_(select #length gcd_#in~y2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_#in~y1.base) 1 0)|
 |ray_(ite (select #valid gcd_#in~y1.base) 1 0)|) 0)
 (* (+ |honda_gcd_#t~mem3| |ray_gcd_#t~mem3|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)|
 |ray_(select (select old(#memory_int) gcd_#in~y1.base) 0)|) 0)
 (*
 (+ |honda_(select #length gcd_~y2.base)|
 |ray_(select #length gcd_~y2.base)|) 0)
 (* (+ |honda_gcd_#in~y1.base| |ray_gcd_#in~y1.base|) 0)
 (* (+ |honda_gcd_#in~y2.base| |ray_gcd_#in~y2.base|) 0)
 (* (+ |honda_gcd_#t~mem4| |ray_gcd_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)|
 |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)|
 |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)|) 
 (- 1))
 (*
 (+ |honda_(ite (select #valid gcd_~y2.base) 1 0)|
 |ray_(ite (select #valid gcd_~y2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_#in~y2.base) 1 0)|
 |ray_(ite (select #valid gcd_#in~y2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)|
 |ray_(ite (select old(#valid) gcd_#in~y2.base) 1 0)|) 0)
 (* (+ |honda_gcd_#t~mem0| |ray_gcd_#t~mem0|) 0)
 (* (+ honda_gcd_~y2.offset ray_gcd_~y2.offset) 0)
 (* (+ honda_gcd_~y2.base ray_gcd_~y2.base) 0)
 (*
 (+ |honda_(select #length gcd_#in~y1.base)|
 |ray_(select #length gcd_#in~y1.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_gcd_#in~y1.offset| |ray_gcd_#in~y1.offset|) 0)
 (* (+ |honda_gcd_#in~y2.offset| |ray_gcd_#in~y2.offset|) 0)
 (*
 (+ |honda_(select #length gcd_~y1.base)|
 |ray_(select #length gcd_~y1.base)|) 0)
 (* (+ |honda_gcd_#t~mem2| |ray_gcd_#t~mem2|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_~y1.base) 1 0)|
 |ray_(ite (select #valid gcd_~y1.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_#in~y1.base) 0)|
 |ray_(select (select #memory_int gcd_#in~y1.base) 0)|) 0)
 (*
 (+ |honda_(select old(#length) gcd_#in~y2.base)|
 |ray_(select old(#length) gcd_#in~y2.base)|) 0)
 (* (+ |honda_gcd_#t~mem1| |ray_gcd_#t~mem1|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_#in~y2.base) 0)|
 |ray_(select (select #memory_int gcd_#in~y2.base) 0)|) 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* |honda_gcd_#t~mem3| 0) 
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| (- 1))
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 1)
 (* |honda_gcd_#t~mem0| 0) 
 (* |honda_gcd_#t~mem2| 0) 
 (* |honda_gcd_#t~mem1| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)|
 |ray_(select (select old(#memory_int) gcd_#in~y2.base) 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)|
 |ray_(ite (select old(#valid) gcd_#in~y1.base) 1 0)|) 0)
 (* (+ honda_gcd_~y1.base ray_gcd_~y1.base) 0)
 (*
 (+ |honda_(select old(#length) gcd_#in~y1.base)|
 |ray_(select old(#length) gcd_#in~y1.base)|) 0)
 (* (+ |honda_gcd_#t~mem5| |ray_gcd_#t~mem5|) 0)
 (* (+ honda_gcd_~y1.offset ray_gcd_~y1.offset) 0)
 (*
 (+ |honda_(select #length gcd_#in~y2.base)|
 |ray_(select #length gcd_#in~y2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_#in~y1.base) 1 0)|
 |ray_(ite (select #valid gcd_#in~y1.base) 1 0)|) 0)
 (* (+ |honda_gcd_#t~mem3| |ray_gcd_#t~mem3|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)|
 |ray_(select (select old(#memory_int) gcd_#in~y1.base) 0)|) 0)
 (*
 (+ |honda_(select #length gcd_~y2.base)|
 |ray_(select #length gcd_~y2.base)|) 0)
 (* (+ |honda_gcd_#in~y1.base| |ray_gcd_#in~y1.base|) 0)
 (* (+ |honda_gcd_#in~y2.base| |ray_gcd_#in~y2.base|) 0)
 (* (+ |honda_gcd_#t~mem4| |ray_gcd_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)|
 |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)|
 |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_~y2.base) 1 0)|
 |ray_(ite (select #valid gcd_~y2.base) 1 0)|) 1)
 (*
 (+ |honda_(ite (select #valid gcd_#in~y2.base) 1 0)|
 |ray_(ite (select #valid gcd_#in~y2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)|
 |ray_(ite (select old(#valid) gcd_#in~y2.base) 1 0)|) 0)
 (* (+ |honda_gcd_#t~mem0| |ray_gcd_#t~mem0|) 0)
 (* (+ honda_gcd_~y2.offset ray_gcd_~y2.offset) 0)
 (* (+ honda_gcd_~y2.base ray_gcd_~y2.base) 0)
 (*
 (+ |honda_(select #length gcd_#in~y1.base)|
 |ray_(select #length gcd_#in~y1.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_gcd_#in~y1.offset| |ray_gcd_#in~y1.offset|) 0)
 (* (+ |honda_gcd_#in~y2.offset| |ray_gcd_#in~y2.offset|) 0)
 (*
 (+ |honda_(select #length gcd_~y1.base)|
 |ray_(select #length gcd_~y1.base)|) 0)
 (* (+ |honda_gcd_#t~mem2| |ray_gcd_#t~mem2|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_~y1.base) 1 0)|
 |ray_(ite (select #valid gcd_~y1.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_#in~y1.base) 0)|
 |ray_(select (select #memory_int gcd_#in~y1.base) 0)|) 0)
 (*
 (+ |honda_(select old(#length) gcd_#in~y2.base)|
 |ray_(select old(#length) gcd_#in~y2.base)|) 0)
 (* (+ |honda_gcd_#t~mem1| |ray_gcd_#t~mem1|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_#in~y2.base) 0)|
 |ray_(select (select #memory_int gcd_#in~y2.base) 0)|) 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* |honda_gcd_#t~mem3| 0) 
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* |honda_gcd_#t~mem2| 0) 
 (* |honda_gcd_#t~mem1| 0) 
 (- 1)) 0)
 (= |ray_(select (select old(#memory_int) gcd_#in~y2.base) 0)|
 (* |ray_(select (select old(#memory_int) gcd_#in~y2.base) 0)| lambda))
 (= |ray_(ite (select old(#valid) gcd_#in~y1.base) 1 0)|
 (* |ray_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| lambda))
 (= ray_gcd_~y1.base (* ray_gcd_~y1.base lambda))
 (= |ray_(select old(#length) gcd_#in~y1.base)|
 (* |ray_(select old(#length) gcd_#in~y1.base)| lambda))
 (= ray_gcd_~y1.offset (* ray_gcd_~y1.offset lambda))
 (= |ray_(select #length gcd_#in~y2.base)|
 (* |ray_(select #length gcd_#in~y2.base)| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_(ite (select #valid gcd_#in~y1.base) 1 0)|
 (* |ray_(ite (select #valid gcd_#in~y1.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(select (select old(#memory_int) gcd_#in~y1.base) 0)|
 (* |ray_(select (select old(#memory_int) gcd_#in~y1.base) 0)| lambda))
 (= |ray_(select #length gcd_~y2.base)|
 (* |ray_(select #length gcd_~y2.base)| lambda))
 (= |ray_gcd_#in~y1.base| (* |ray_gcd_#in~y1.base| lambda))
 (= |ray_gcd_#in~y2.base| (* |ray_gcd_#in~y2.base| lambda))
 (= |ray_(ite (select #valid gcd_~y2.base) 1 0)|
 (* |ray_(ite (select #valid gcd_~y2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid gcd_#in~y2.base) 1 0)|
 (* |ray_(ite (select #valid gcd_#in~y2.base) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) gcd_#in~y2.base) 1 0)|
 (* |ray_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| lambda))
 (= ray_gcd_~y2.offset (* ray_gcd_~y2.offset lambda))
 (= ray_gcd_~y2.base (* ray_gcd_~y2.base lambda))
 (= |ray_(select #length gcd_#in~y1.base)|
 (* |ray_(select #length gcd_#in~y1.base)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_gcd_#in~y1.offset| (* |ray_gcd_#in~y1.offset| lambda))
 (= |ray_gcd_#in~y2.offset| (* |ray_gcd_#in~y2.offset| lambda))
 (= |ray_(select #length gcd_~y1.base)|
 (* |ray_(select #length gcd_~y1.base)| lambda))
 (= |ray_(ite (select #valid gcd_~y1.base) 1 0)|
 (* |ray_(ite (select #valid gcd_~y1.base) 1 0)| lambda))
 (= |ray_(select (select #memory_int gcd_#in~y1.base) 0)|
 (* |ray_(select (select #memory_int gcd_#in~y1.base) 0)| lambda))
 (= |ray_(select old(#length) gcd_#in~y2.base)|
 (* |ray_(select old(#length) gcd_#in~y2.base)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(select (select #memory_int gcd_#in~y2.base) 0)|
 (* |ray_(select (select #memory_int gcd_#in~y2.base) 0)| lambda))
 (>=
 (+
 (* (* |ray_(select (select old(#memory_int) gcd_#in~y2.base) 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| lambda) 0)
 (* (* ray_gcd_~y1.base lambda) 0)
 (* (* |ray_(select old(#length) gcd_#in~y1.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem5| lambda) 0) 
 (* (* ray_gcd_~y1.offset lambda) 1)
 (* (* |ray_(select #length gcd_#in~y2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_#in~y1.base) 1 0)| lambda) 0)
 (* (* |ray_gcd_#t~mem3| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select (select old(#memory_int) gcd_#in~y1.base) 0)| lambda) 0)
 (* (* |ray_(select #length gcd_~y2.base)| lambda) 0)
 (* (* |ray_gcd_#in~y1.base| lambda) 0)
 (* (* |ray_gcd_#in~y2.base| lambda) 0) 
 (* (* |ray_gcd_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| lambda)
 0)
 (*
 (* |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| lambda)
 0) (* (* |ray_(ite (select #valid gcd_~y2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_#in~y2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| lambda) 0)
 (* (* |ray_gcd_#t~mem0| lambda) 0) 
 (* (* ray_gcd_~y2.offset lambda) (- 1)) 
 (* (* ray_gcd_~y2.base lambda) 0)
 (* (* |ray_(select #length gcd_#in~y1.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_gcd_#in~y1.offset| lambda) 0)
 (* (* |ray_gcd_#in~y2.offset| lambda) 0)
 (* (* |ray_(select #length gcd_~y1.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem2| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_~y1.base) 1 0)| lambda) 0)
 (* (* |ray_(select (select #memory_int gcd_#in~y1.base) 0)| lambda) 0)
 (* (* |ray_(select old(#length) gcd_#in~y2.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem1| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select (select #memory_int gcd_#in~y2.base) 0)| lambda) 0)
 (* |ray_gcd_#t~mem5| 0) (* |ray_gcd_#t~mem3| 0) 
 (* |ray_gcd_#t~mem4| 0)
 (* |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |ray_gcd_#t~mem0| 0) (* |ray_gcd_#t~mem2| 0) 
 (* |ray_gcd_#t~mem1| 0)) 0)
 (>=
 (+
 (* (* |ray_(select (select old(#memory_int) gcd_#in~y2.base) 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| lambda) 0)
 (* (* ray_gcd_~y1.base lambda) 0)
 (* (* |ray_(select old(#length) gcd_#in~y1.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem5| lambda) 0) 
 (* (* ray_gcd_~y1.offset lambda) 0)
 (* (* |ray_(select #length gcd_#in~y2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_#in~y1.base) 1 0)| lambda) 0)
 (* (* |ray_gcd_#t~mem3| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select (select old(#memory_int) gcd_#in~y1.base) 0)| lambda) 0)
 (* (* |ray_(select #length gcd_~y2.base)| lambda) 0)
 (* (* |ray_gcd_#in~y1.base| lambda) 0)
 (* (* |ray_gcd_#in~y2.base| lambda) 0) 
 (* (* |ray_gcd_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| lambda)
 0)
 (*
 (* |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| lambda)
 0) (* (* |ray_(ite (select #valid gcd_~y2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_#in~y2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| lambda) 0)
 (* (* |ray_gcd_#t~mem0| lambda) 0) 
 (* (* ray_gcd_~y2.offset lambda) 0) 
 (* (* ray_gcd_~y2.base lambda) 0)
 (* (* |ray_(select #length gcd_#in~y1.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_gcd_#in~y1.offset| lambda) 0)
 (* (* |ray_gcd_#in~y2.offset| lambda) 0)
 (* (* |ray_(select #length gcd_~y1.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem2| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_~y1.base) 1 0)| lambda) 0)
 (* (* |ray_(select (select #memory_int gcd_#in~y1.base) 0)| lambda) 0)
 (* (* |ray_(select old(#length) gcd_#in~y2.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem1| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select (select #memory_int gcd_#in~y2.base) 0)| lambda) 0)
 (* |ray_gcd_#t~mem5| 0) (* |ray_gcd_#t~mem3| 0) 
 (* |ray_gcd_#t~mem4| 0)
 (* |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| (- 1))
 (* |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 1)
 (* |ray_gcd_#t~mem0| 0) (* |ray_gcd_#t~mem2| 0) 
 (* |ray_gcd_#t~mem1| 0)) 0)
 (>=
 (+
 (* (* |ray_(select (select old(#memory_int) gcd_#in~y2.base) 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| lambda) 0)
 (* (* ray_gcd_~y1.base lambda) 0)
 (* (* |ray_(select old(#length) gcd_#in~y1.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem5| lambda) 0) 
 (* (* ray_gcd_~y1.offset lambda) 0)
 (* (* |ray_(select #length gcd_#in~y2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_#in~y1.base) 1 0)| lambda) 0)
 (* (* |ray_gcd_#t~mem3| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select (select old(#memory_int) gcd_#in~y1.base) 0)| lambda) 0)
 (* (* |ray_(select #length gcd_~y2.base)| lambda) 0)
 (* (* |ray_gcd_#in~y1.base| lambda) 0)
 (* (* |ray_gcd_#in~y2.base| lambda) 0) 
 (* (* |ray_gcd_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| lambda)
 1)
 (*
 (* |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| lambda)
 0) (* (* |ray_(ite (select #valid gcd_~y2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_#in~y2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| lambda) 0)
 (* (* |ray_gcd_#t~mem0| lambda) 0) 
 (* (* ray_gcd_~y2.offset lambda) 0) 
 (* (* ray_gcd_~y2.base lambda) 0)
 (* (* |ray_(select #length gcd_#in~y1.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_gcd_#in~y1.offset| lambda) 0)
 (* (* |ray_gcd_#in~y2.offset| lambda) 0)
 (* (* |ray_(select #length gcd_~y1.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem2| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_~y1.base) 1 0)| lambda) 0)
 (* (* |ray_(select (select #memory_int gcd_#in~y1.base) 0)| lambda) 0)
 (* (* |ray_(select old(#length) gcd_#in~y2.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem1| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select (select #memory_int gcd_#in~y2.base) 0)| lambda) 0)
 (* |ray_gcd_#t~mem5| 0) (* |ray_gcd_#t~mem3| 0) 
 (* |ray_gcd_#t~mem4| 0)
 (* |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| (- 1))
 (* |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |ray_gcd_#t~mem0| 0) (* |ray_gcd_#t~mem2| 0) 
 (* |ray_gcd_#t~mem1| 0)) 0)
 (>=
 (+
 (* (* |ray_(select (select old(#memory_int) gcd_#in~y2.base) 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| lambda) 0)
 (* (* ray_gcd_~y1.base lambda) 0)
 (* (* |ray_(select old(#length) gcd_#in~y1.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem5| lambda) 0) 
 (* (* ray_gcd_~y1.offset lambda) 0)
 (* (* |ray_(select #length gcd_#in~y2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_#in~y1.base) 1 0)| lambda) 0)
 (* (* |ray_gcd_#t~mem3| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select (select old(#memory_int) gcd_#in~y1.base) 0)| lambda) 0)
 (* (* |ray_(select #length gcd_~y2.base)| lambda) 0)
 (* (* |ray_gcd_#in~y1.base| lambda) 0)
 (* (* |ray_gcd_#in~y2.base| lambda) 0) 
 (* (* |ray_gcd_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| lambda)
 (- 1))
 (*
 (* |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| lambda)
 0) (* (* |ray_(ite (select #valid gcd_~y2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_#in~y2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| lambda) 0)
 (* (* |ray_gcd_#t~mem0| lambda) 0) 
 (* (* ray_gcd_~y2.offset lambda) 0) 
 (* (* ray_gcd_~y2.base lambda) 0)
 (* (* |ray_(select #length gcd_#in~y1.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_gcd_#in~y1.offset| lambda) 0)
 (* (* |ray_gcd_#in~y2.offset| lambda) 0)
 (* (* |ray_(select #length gcd_~y1.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem2| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_~y1.base) 1 0)| lambda) 0)
 (* (* |ray_(select (select #memory_int gcd_#in~y1.base) 0)| lambda) 0)
 (* (* |ray_(select old(#length) gcd_#in~y2.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem1| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select (select #memory_int gcd_#in~y2.base) 0)| lambda) 0)
 (* |ray_gcd_#t~mem5| 0) (* |ray_gcd_#t~mem3| 0) 
 (* |ray_gcd_#t~mem4| 0)
 (* |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 1)
 (* |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |ray_gcd_#t~mem0| 0) (* |ray_gcd_#t~mem2| 0) 
 (* |ray_gcd_#t~mem1| 0)) 0)
 (>=
 (+
 (* (* |ray_(select (select old(#memory_int) gcd_#in~y2.base) 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| lambda) 0)
 (* (* ray_gcd_~y1.base lambda) 0)
 (* (* |ray_(select old(#length) gcd_#in~y1.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem5| lambda) 0) 
 (* (* ray_gcd_~y1.offset lambda) 0)
 (* (* |ray_(select #length gcd_#in~y2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_#in~y1.base) 1 0)| lambda) 0)
 (* (* |ray_gcd_#t~mem3| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select (select old(#memory_int) gcd_#in~y1.base) 0)| lambda) 0)
 (* (* |ray_(select #length gcd_~y2.base)| lambda) 0)
 (* (* |ray_gcd_#in~y1.base| lambda) 0)
 (* (* |ray_gcd_#in~y2.base| lambda) 0) 
 (* (* |ray_gcd_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| lambda)
 0)
 (*
 (* |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| lambda)
 1) (* (* |ray_(ite (select #valid gcd_~y2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_#in~y2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| lambda) 0)
 (* (* |ray_gcd_#t~mem0| lambda) 0) 
 (* (* ray_gcd_~y2.offset lambda) 0) 
 (* (* ray_gcd_~y2.base lambda) 0)
 (* (* |ray_(select #length gcd_#in~y1.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_gcd_#in~y1.offset| lambda) 0)
 (* (* |ray_gcd_#in~y2.offset| lambda) 0)
 (* (* |ray_(select #length gcd_~y1.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem2| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_~y1.base) 1 0)| lambda) 0)
 (* (* |ray_(select (select #memory_int gcd_#in~y1.base) 0)| lambda) 0)
 (* (* |ray_(select old(#length) gcd_#in~y2.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem1| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select (select #memory_int gcd_#in~y2.base) 0)| lambda) 0)
 (* |ray_gcd_#t~mem5| 0) (* |ray_gcd_#t~mem3| 0) 
 (* |ray_gcd_#t~mem4| 0)
 (* |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 1)
 (* |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| (- 1))
 (* |ray_gcd_#t~mem0| 0) (* |ray_gcd_#t~mem2| 0) 
 (* |ray_gcd_#t~mem1| 0)) 0)
 (>=
 (+
 (* (* |ray_(select (select old(#memory_int) gcd_#in~y2.base) 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| lambda) 0)
 (* (* ray_gcd_~y1.base lambda) 0)
 (* (* |ray_(select old(#length) gcd_#in~y1.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem5| lambda) 0) 
 (* (* ray_gcd_~y1.offset lambda) (- 1))
 (* (* |ray_(select #length gcd_#in~y2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_#in~y1.base) 1 0)| lambda) 0)
 (* (* |ray_gcd_#t~mem3| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select (select old(#memory_int) gcd_#in~y1.base) 0)| lambda) 0)
 (* (* |ray_(select #length gcd_~y2.base)| lambda) 0)
 (* (* |ray_gcd_#in~y1.base| lambda) 0)
 (* (* |ray_gcd_#in~y2.base| lambda) 0) 
 (* (* |ray_gcd_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| lambda)
 0)
 (*
 (* |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| lambda)
 0) (* (* |ray_(ite (select #valid gcd_~y2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_#in~y2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| lambda) 0)
 (* (* |ray_gcd_#t~mem0| lambda) 0) 
 (* (* ray_gcd_~y2.offset lambda) 0) 
 (* (* ray_gcd_~y2.base lambda) 0)
 (* (* |ray_(select #length gcd_#in~y1.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_gcd_#in~y1.offset| lambda) 0)
 (* (* |ray_gcd_#in~y2.offset| lambda) 0)
 (* (* |ray_(select #length gcd_~y1.base)| lambda) 1)
 (* (* |ray_gcd_#t~mem2| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_~y1.base) 1 0)| lambda) 0)
 (* (* |ray_(select (select #memory_int gcd_#in~y1.base) 0)| lambda) 0)
 (* (* |ray_(select old(#length) gcd_#in~y2.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem1| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select (select #memory_int gcd_#in~y2.base) 0)| lambda) 0)
 (* |ray_gcd_#t~mem5| 0) (* |ray_gcd_#t~mem3| 0) 
 (* |ray_gcd_#t~mem4| 0)
 (* |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |ray_gcd_#t~mem0| 0) (* |ray_gcd_#t~mem2| 0) 
 (* |ray_gcd_#t~mem1| 0)) 0)
 (>=
 (+
 (* (* |ray_(select (select old(#memory_int) gcd_#in~y2.base) 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| lambda) 0)
 (* (* ray_gcd_~y1.base lambda) 1)
 (* (* |ray_(select old(#length) gcd_#in~y1.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem5| lambda) 0) 
 (* (* ray_gcd_~y1.offset lambda) 0)
 (* (* |ray_(select #length gcd_#in~y2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_#in~y1.base) 1 0)| lambda) 0)
 (* (* |ray_gcd_#t~mem3| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select (select old(#memory_int) gcd_#in~y1.base) 0)| lambda) 0)
 (* (* |ray_(select #length gcd_~y2.base)| lambda) 0)
 (* (* |ray_gcd_#in~y1.base| lambda) 0)
 (* (* |ray_gcd_#in~y2.base| lambda) 0) 
 (* (* |ray_gcd_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| lambda)
 0)
 (*
 (* |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| lambda)
 0) (* (* |ray_(ite (select #valid gcd_~y2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_#in~y2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| lambda) 0)
 (* (* |ray_gcd_#t~mem0| lambda) 0) 
 (* (* ray_gcd_~y2.offset lambda) 0) 
 (* (* ray_gcd_~y2.base lambda) (- 1))
 (* (* |ray_(select #length gcd_#in~y1.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_gcd_#in~y1.offset| lambda) 0)
 (* (* |ray_gcd_#in~y2.offset| lambda) 0)
 (* (* |ray_(select #length gcd_~y1.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem2| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_~y1.base) 1 0)| lambda) 0)
 (* (* |ray_(select (select #memory_int gcd_#in~y1.base) 0)| lambda) 0)
 (* (* |ray_(select old(#length) gcd_#in~y2.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem1| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select (select #memory_int gcd_#in~y2.base) 0)| lambda) 0)
 (* |ray_gcd_#t~mem5| 0) (* |ray_gcd_#t~mem3| 0) 
 (* |ray_gcd_#t~mem4| 0)
 (* |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |ray_gcd_#t~mem0| 0) (* |ray_gcd_#t~mem2| 0) 
 (* |ray_gcd_#t~mem1| 0)) 0)
 (>=
 (+
 (* (* |ray_(select (select old(#memory_int) gcd_#in~y2.base) 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| lambda) 0)
 (* (* ray_gcd_~y1.base lambda) 0)
 (* (* |ray_(select old(#length) gcd_#in~y1.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem5| lambda) 0) 
 (* (* ray_gcd_~y1.offset lambda) (- 1))
 (* (* |ray_(select #length gcd_#in~y2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_#in~y1.base) 1 0)| lambda) 0)
 (* (* |ray_gcd_#t~mem3| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select (select old(#memory_int) gcd_#in~y1.base) 0)| lambda) 0)
 (* (* |ray_(select #length gcd_~y2.base)| lambda) 0)
 (* (* |ray_gcd_#in~y1.base| lambda) 0)
 (* (* |ray_gcd_#in~y2.base| lambda) 0) 
 (* (* |ray_gcd_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| lambda)
 0)
 (*
 (* |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| lambda)
 0) (* (* |ray_(ite (select #valid gcd_~y2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_#in~y2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| lambda) 0)
 (* (* |ray_gcd_#t~mem0| lambda) 0) 
 (* (* ray_gcd_~y2.offset lambda) 1) 
 (* (* ray_gcd_~y2.base lambda) 0)
 (* (* |ray_(select #length gcd_#in~y1.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_gcd_#in~y1.offset| lambda) 0)
 (* (* |ray_gcd_#in~y2.offset| lambda) 0)
 (* (* |ray_(select #length gcd_~y1.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem2| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_~y1.base) 1 0)| lambda) 0)
 (* (* |ray_(select (select #memory_int gcd_#in~y1.base) 0)| lambda) 0)
 (* (* |ray_(select old(#length) gcd_#in~y2.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem1| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select (select #memory_int gcd_#in~y2.base) 0)| lambda) 0)
 (* |ray_gcd_#t~mem5| 0) (* |ray_gcd_#t~mem3| 0) 
 (* |ray_gcd_#t~mem4| 0)
 (* |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |ray_gcd_#t~mem0| 0) (* |ray_gcd_#t~mem2| 0) 
 (* |ray_gcd_#t~mem1| 0)) 0)
 (>=
 (+
 (* (* |ray_(select (select old(#memory_int) gcd_#in~y2.base) 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| lambda) 0)
 (* (* ray_gcd_~y1.base lambda) 0)
 (* (* |ray_(select old(#length) gcd_#in~y1.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem5| lambda) 0) 
 (* (* ray_gcd_~y1.offset lambda) 0)
 (* (* |ray_(select #length gcd_#in~y2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_#in~y1.base) 1 0)| lambda) 0)
 (* (* |ray_gcd_#t~mem3| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select (select old(#memory_int) gcd_#in~y1.base) 0)| lambda) 0)
 (* (* |ray_(select #length gcd_~y2.base)| lambda) 0)
 (* (* |ray_gcd_#in~y1.base| lambda) 0)
 (* (* |ray_gcd_#in~y2.base| lambda) 0) 
 (* (* |ray_gcd_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| lambda)
 0)
 (*
 (* |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| lambda)
 0) (* (* |ray_(ite (select #valid gcd_~y2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_#in~y2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| lambda) 0)
 (* (* |ray_gcd_#t~mem0| lambda) 0) 
 (* (* ray_gcd_~y2.offset lambda) 0) 
 (* (* ray_gcd_~y2.base lambda) 0)
 (* (* |ray_(select #length gcd_#in~y1.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_gcd_#in~y1.offset| lambda) 0)
 (* (* |ray_gcd_#in~y2.offset| lambda) 0)
 (* (* |ray_(select #length gcd_~y1.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem2| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_~y1.base) 1 0)| lambda) 1)
 (* (* |ray_(select (select #memory_int gcd_#in~y1.base) 0)| lambda) 0)
 (* (* |ray_(select old(#length) gcd_#in~y2.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem1| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select (select #memory_int gcd_#in~y2.base) 0)| lambda) 0)
 (* |ray_gcd_#t~mem5| 0) (* |ray_gcd_#t~mem3| 0) 
 (* |ray_gcd_#t~mem4| 0)
 (* |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |ray_gcd_#t~mem0| 0) (* |ray_gcd_#t~mem2| 0) 
 (* |ray_gcd_#t~mem1| 0)) 0)
 (>=
 (+
 (* (* |ray_(select (select old(#memory_int) gcd_#in~y2.base) 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| lambda) 0)
 (* (* ray_gcd_~y1.base lambda) 0)
 (* (* |ray_(select old(#length) gcd_#in~y1.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem5| lambda) 0) 
 (* (* ray_gcd_~y1.offset lambda) 0)
 (* (* |ray_(select #length gcd_#in~y2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_#in~y1.base) 1 0)| lambda) 0)
 (* (* |ray_gcd_#t~mem3| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select (select old(#memory_int) gcd_#in~y1.base) 0)| lambda) 0)
 (* (* |ray_(select #length gcd_~y2.base)| lambda) 1)
 (* (* |ray_gcd_#in~y1.base| lambda) 0)
 (* (* |ray_gcd_#in~y2.base| lambda) 0) 
 (* (* |ray_gcd_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| lambda)
 0)
 (*
 (* |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| lambda)
 0) (* (* |ray_(ite (select #valid gcd_~y2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_#in~y2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| lambda) 0)
 (* (* |ray_gcd_#t~mem0| lambda) 0) 
 (* (* ray_gcd_~y2.offset lambda) (- 1)) 
 (* (* ray_gcd_~y2.base lambda) 0)
 (* (* |ray_(select #length gcd_#in~y1.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_gcd_#in~y1.offset| lambda) 0)
 (* (* |ray_gcd_#in~y2.offset| lambda) 0)
 (* (* |ray_(select #length gcd_~y1.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem2| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_~y1.base) 1 0)| lambda) 0)
 (* (* |ray_(select (select #memory_int gcd_#in~y1.base) 0)| lambda) 0)
 (* (* |ray_(select old(#length) gcd_#in~y2.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem1| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select (select #memory_int gcd_#in~y2.base) 0)| lambda) 0)
 (* |ray_gcd_#t~mem5| 0) (* |ray_gcd_#t~mem3| 0) 
 (* |ray_gcd_#t~mem4| 0)
 (* |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |ray_gcd_#t~mem0| 0) (* |ray_gcd_#t~mem2| 0) 
 (* |ray_gcd_#t~mem1| 0)) 0)
 (>=
 (+
 (* (* |ray_(select (select old(#memory_int) gcd_#in~y2.base) 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| lambda) 0)
 (* (* ray_gcd_~y1.base lambda) 0)
 (* (* |ray_(select old(#length) gcd_#in~y1.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem5| lambda) 0) 
 (* (* ray_gcd_~y1.offset lambda) 0)
 (* (* |ray_(select #length gcd_#in~y2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_#in~y1.base) 1 0)| lambda) 0)
 (* (* |ray_gcd_#t~mem3| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select (select old(#memory_int) gcd_#in~y1.base) 0)| lambda) 0)
 (* (* |ray_(select #length gcd_~y2.base)| lambda) 0)
 (* (* |ray_gcd_#in~y1.base| lambda) 0)
 (* (* |ray_gcd_#in~y2.base| lambda) 0) 
 (* (* |ray_gcd_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| lambda)
 0)
 (*
 (* |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| lambda)
 (- 1)) (* (* |ray_(ite (select #valid gcd_~y2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_#in~y2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| lambda) 0)
 (* (* |ray_gcd_#t~mem0| lambda) 0) 
 (* (* ray_gcd_~y2.offset lambda) 0) 
 (* (* ray_gcd_~y2.base lambda) 0)
 (* (* |ray_(select #length gcd_#in~y1.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_gcd_#in~y1.offset| lambda) 0)
 (* (* |ray_gcd_#in~y2.offset| lambda) 0)
 (* (* |ray_(select #length gcd_~y1.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem2| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_~y1.base) 1 0)| lambda) 0)
 (* (* |ray_(select (select #memory_int gcd_#in~y1.base) 0)| lambda) 0)
 (* (* |ray_(select old(#length) gcd_#in~y2.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem1| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select (select #memory_int gcd_#in~y2.base) 0)| lambda) 0)
 (* |ray_gcd_#t~mem5| 0) (* |ray_gcd_#t~mem3| 0) 
 (* |ray_gcd_#t~mem4| 0)
 (* |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| (- 1))
 (* |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 1)
 (* |ray_gcd_#t~mem0| 0) (* |ray_gcd_#t~mem2| 0) 
 (* |ray_gcd_#t~mem1| 0)) 0)
 (>=
 (+
 (* (* |ray_(select (select old(#memory_int) gcd_#in~y2.base) 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| lambda) 0)
 (* (* ray_gcd_~y1.base lambda) 0)
 (* (* |ray_(select old(#length) gcd_#in~y1.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem5| lambda) 0) 
 (* (* ray_gcd_~y1.offset lambda) 0)
 (* (* |ray_(select #length gcd_#in~y2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_#in~y1.base) 1 0)| lambda) 0)
 (* (* |ray_gcd_#t~mem3| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select (select old(#memory_int) gcd_#in~y1.base) 0)| lambda) 0)
 (* (* |ray_(select #length gcd_~y2.base)| lambda) 0)
 (* (* |ray_gcd_#in~y1.base| lambda) 0)
 (* (* |ray_gcd_#in~y2.base| lambda) 0) 
 (* (* |ray_gcd_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| lambda)
 0)
 (*
 (* |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| lambda)
 0) (* (* |ray_(ite (select #valid gcd_~y2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid gcd_#in~y2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| lambda) 0)
 (* (* |ray_gcd_#t~mem0| lambda) 0) 
 (* (* ray_gcd_~y2.offset lambda) 0) 
 (* (* ray_gcd_~y2.base lambda) 0)
 (* (* |ray_(select #length gcd_#in~y1.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_gcd_#in~y1.offset| lambda) 0)
 (* (* |ray_gcd_#in~y2.offset| lambda) 0)
 (* (* |ray_(select #length gcd_~y1.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem2| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_~y1.base) 1 0)| lambda) 0)
 (* (* |ray_(select (select #memory_int gcd_#in~y1.base) 0)| lambda) 0)
 (* (* |ray_(select old(#length) gcd_#in~y2.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem1| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select (select #memory_int gcd_#in~y2.base) 0)| lambda) 0)
 (* |ray_gcd_#t~mem5| 0) (* |ray_gcd_#t~mem3| 0) 
 (* |ray_gcd_#t~mem4| 0)
 (* |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |ray_gcd_#t~mem0| 0) (* |ray_gcd_#t~mem2| 0) 
 (* |ray_gcd_#t~mem1| 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)|
 (+ |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)|
 |ray_(select (select old(#memory_int) gcd_#in~y2.base) 0)|))
 (= |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)|
 (+ |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)|
 |ray_(ite (select old(#valid) gcd_#in~y1.base) 1 0)|))
 (= honda_gcd_~y1.base (+ honda_gcd_~y1.base ray_gcd_~y1.base))
 (= |honda_(select old(#length) gcd_#in~y1.base)|
 (+ |honda_(select old(#length) gcd_#in~y1.base)|
 |ray_(select old(#length) gcd_#in~y1.base)|))
 (= honda_gcd_~y1.offset (+ honda_gcd_~y1.offset ray_gcd_~y1.offset))
 (= |honda_(select #length gcd_#in~y2.base)|
 (+ |honda_(select #length gcd_#in~y2.base)|
 |ray_(select #length gcd_#in~y2.base)|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_(ite (select #valid gcd_#in~y1.base) 1 0)|
 (+ |honda_(ite (select #valid gcd_#in~y1.base) 1 0)|
 |ray_(ite (select #valid gcd_#in~y1.base) 1 0)|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)|
 (+ |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)|
 |ray_(select (select old(#memory_int) gcd_#in~y1.base) 0)|))
 (= |honda_(select #length gcd_~y2.base)|
 (+ |honda_(select #length gcd_~y2.base)|
 |ray_(select #length gcd_~y2.base)|))
 (= |honda_gcd_#in~y1.base|
 (+ |honda_gcd_#in~y1.base| |ray_gcd_#in~y1.base|))
 (= |honda_gcd_#in~y2.base|
 (+ |honda_gcd_#in~y2.base| |ray_gcd_#in~y2.base|))
 (= |honda_(ite (select #valid gcd_~y2.base) 1 0)|
 (+ |honda_(ite (select #valid gcd_~y2.base) 1 0)|
 |ray_(ite (select #valid gcd_~y2.base) 1 0)|))
 (= |honda_(ite (select #valid gcd_#in~y2.base) 1 0)|
 (+ |honda_(ite (select #valid gcd_#in~y2.base) 1 0)|
 |ray_(ite (select #valid gcd_#in~y2.base) 1 0)|))
 (= |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)|
 |ray_(ite (select old(#valid) gcd_#in~y2.base) 1 0)|))
 (= honda_gcd_~y2.offset (+ honda_gcd_~y2.offset ray_gcd_~y2.offset))
 (= honda_gcd_~y2.base (+ honda_gcd_~y2.base ray_gcd_~y2.base))
 (= |honda_(select #length gcd_#in~y1.base)|
 (+ |honda_(select #length gcd_#in~y1.base)|
 |ray_(select #length gcd_#in~y1.base)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_gcd_#in~y1.offset|
 (+ |honda_gcd_#in~y1.offset| |ray_gcd_#in~y1.offset|))
 (= |honda_gcd_#in~y2.offset|
 (+ |honda_gcd_#in~y2.offset| |ray_gcd_#in~y2.offset|))
 (= |honda_(select #length gcd_~y1.base)|
 (+ |honda_(select #length gcd_~y1.base)|
 |ray_(select #length gcd_~y1.base)|))
 (= |honda_(ite (select #valid gcd_~y1.base) 1 0)|
 (+ |honda_(ite (select #valid gcd_~y1.base) 1 0)|
 |ray_(ite (select #valid gcd_~y1.base) 1 0)|))
 (= |honda_(select (select #memory_int gcd_#in~y1.base) 0)|
 (+ |honda_(select (select #memory_int gcd_#in~y1.base) 0)|
 |ray_(select (select #memory_int gcd_#in~y1.base) 0)|))
 (= |honda_(select old(#length) gcd_#in~y2.base)|
 (+ |honda_(select old(#length) gcd_#in~y2.base)|
 |ray_(select old(#length) gcd_#in~y2.base)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= |honda_(select (select #memory_int gcd_#in~y2.base) 0)|
 (+ |honda_(select (select #memory_int gcd_#in~y2.base) 0)|
 |ray_(select (select #memory_int gcd_#in~y2.base) 0)|))
 (>=
 (+
 (*
 (+ |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)|
 |ray_(select (select old(#memory_int) gcd_#in~y2.base) 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)|
 |ray_(ite (select old(#valid) gcd_#in~y1.base) 1 0)|) 0)
 (* (+ honda_gcd_~y1.base ray_gcd_~y1.base) 0)
 (*
 (+ |honda_(select old(#length) gcd_#in~y1.base)|
 |ray_(select old(#length) gcd_#in~y1.base)|) 0)
 (* (+ |honda_gcd_#t~mem5| |ray_gcd_#t~mem5|) 0)
 (* (+ honda_gcd_~y1.offset ray_gcd_~y1.offset) 1)
 (*
 (+ |honda_(select #length gcd_#in~y2.base)|
 |ray_(select #length gcd_#in~y2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_#in~y1.base) 1 0)|
 |ray_(ite (select #valid gcd_#in~y1.base) 1 0)|) 0)
 (* (+ |honda_gcd_#t~mem3| |ray_gcd_#t~mem3|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)|
 |ray_(select (select old(#memory_int) gcd_#in~y1.base) 0)|) 0)
 (*
 (+ |honda_(select #length gcd_~y2.base)|
 |ray_(select #length gcd_~y2.base)|) 0)
 (* (+ |honda_gcd_#in~y1.base| |ray_gcd_#in~y1.base|) 0)
 (* (+ |honda_gcd_#in~y2.base| |ray_gcd_#in~y2.base|) 0)
 (* (+ |honda_gcd_#t~mem4| |ray_gcd_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)|
 |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)|
 |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_~y2.base) 1 0)|
 |ray_(ite (select #valid gcd_~y2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_#in~y2.base) 1 0)|
 |ray_(ite (select #valid gcd_#in~y2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)|
 |ray_(ite (select old(#valid) gcd_#in~y2.base) 1 0)|) 0)
 (* (+ |honda_gcd_#t~mem0| |ray_gcd_#t~mem0|) 0)
 (* (+ honda_gcd_~y2.offset ray_gcd_~y2.offset) (- 1))
 (* (+ honda_gcd_~y2.base ray_gcd_~y2.base) 0)
 (*
 (+ |honda_(select #length gcd_#in~y1.base)|
 |ray_(select #length gcd_#in~y1.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_gcd_#in~y1.offset| |ray_gcd_#in~y1.offset|) 0)
 (* (+ |honda_gcd_#in~y2.offset| |ray_gcd_#in~y2.offset|) 0)
 (*
 (+ |honda_(select #length gcd_~y1.base)|
 |ray_(select #length gcd_~y1.base)|) 0)
 (* (+ |honda_gcd_#t~mem2| |ray_gcd_#t~mem2|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_~y1.base) 1 0)|
 |ray_(ite (select #valid gcd_~y1.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_#in~y1.base) 0)|
 |ray_(select (select #memory_int gcd_#in~y1.base) 0)|) 0)
 (*
 (+ |honda_(select old(#length) gcd_#in~y2.base)|
 |ray_(select old(#length) gcd_#in~y2.base)|) 0)
 (* (+ |honda_gcd_#t~mem1| |ray_gcd_#t~mem1|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_#in~y2.base) 0)|
 |ray_(select (select #memory_int gcd_#in~y2.base) 0)|) 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* |honda_gcd_#t~mem3| 0) 
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* |honda_gcd_#t~mem2| 0) 
 (* |honda_gcd_#t~mem1| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)|
 |ray_(select (select old(#memory_int) gcd_#in~y2.base) 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)|
 |ray_(ite (select old(#valid) gcd_#in~y1.base) 1 0)|) 0)
 (* (+ honda_gcd_~y1.base ray_gcd_~y1.base) 0)
 (*
 (+ |honda_(select old(#length) gcd_#in~y1.base)|
 |ray_(select old(#length) gcd_#in~y1.base)|) 0)
 (* (+ |honda_gcd_#t~mem5| |ray_gcd_#t~mem5|) 0)
 (* (+ honda_gcd_~y1.offset ray_gcd_~y1.offset) 0)
 (*
 (+ |honda_(select #length gcd_#in~y2.base)|
 |ray_(select #length gcd_#in~y2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_#in~y1.base) 1 0)|
 |ray_(ite (select #valid gcd_#in~y1.base) 1 0)|) 0)
 (* (+ |honda_gcd_#t~mem3| |ray_gcd_#t~mem3|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)|
 |ray_(select (select old(#memory_int) gcd_#in~y1.base) 0)|) 0)
 (*
 (+ |honda_(select #length gcd_~y2.base)|
 |ray_(select #length gcd_~y2.base)|) 0)
 (* (+ |honda_gcd_#in~y1.base| |ray_gcd_#in~y1.base|) 0)
 (* (+ |honda_gcd_#in~y2.base| |ray_gcd_#in~y2.base|) 0)
 (* (+ |honda_gcd_#t~mem4| |ray_gcd_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)|
 |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)|
 |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_~y2.base) 1 0)|
 |ray_(ite (select #valid gcd_~y2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_#in~y2.base) 1 0)|
 |ray_(ite (select #valid gcd_#in~y2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)|
 |ray_(ite (select old(#valid) gcd_#in~y2.base) 1 0)|) 0)
 (* (+ |honda_gcd_#t~mem0| |ray_gcd_#t~mem0|) 0)
 (* (+ honda_gcd_~y2.offset ray_gcd_~y2.offset) 0)
 (* (+ honda_gcd_~y2.base ray_gcd_~y2.base) 0)
 (*
 (+ |honda_(select #length gcd_#in~y1.base)|
 |ray_(select #length gcd_#in~y1.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_gcd_#in~y1.offset| |ray_gcd_#in~y1.offset|) 0)
 (* (+ |honda_gcd_#in~y2.offset| |ray_gcd_#in~y2.offset|) 0)
 (*
 (+ |honda_(select #length gcd_~y1.base)|
 |ray_(select #length gcd_~y1.base)|) 0)
 (* (+ |honda_gcd_#t~mem2| |ray_gcd_#t~mem2|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_~y1.base) 1 0)|
 |ray_(ite (select #valid gcd_~y1.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_#in~y1.base) 0)|
 |ray_(select (select #memory_int gcd_#in~y1.base) 0)|) 0)
 (*
 (+ |honda_(select old(#length) gcd_#in~y2.base)|
 |ray_(select old(#length) gcd_#in~y2.base)|) 0)
 (* (+ |honda_gcd_#t~mem1| |ray_gcd_#t~mem1|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_#in~y2.base) 0)|
 |ray_(select (select #memory_int gcd_#in~y2.base) 0)|) 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* |honda_gcd_#t~mem3| 0) 
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| (- 1))
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 1)
 (* |honda_gcd_#t~mem0| 0) 
 (* |honda_gcd_#t~mem2| 0) 
 (* |honda_gcd_#t~mem1| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)|
 |ray_(select (select old(#memory_int) gcd_#in~y2.base) 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)|
 |ray_(ite (select old(#valid) gcd_#in~y1.base) 1 0)|) 0)
 (* (+ honda_gcd_~y1.base ray_gcd_~y1.base) 0)
 (*
 (+ |honda_(select old(#length) gcd_#in~y1.base)|
 |ray_(select old(#length) gcd_#in~y1.base)|) 0)
 (* (+ |honda_gcd_#t~mem5| |ray_gcd_#t~mem5|) 0)
 (* (+ honda_gcd_~y1.offset ray_gcd_~y1.offset) 0)
 (*
 (+ |honda_(select #length gcd_#in~y2.base)|
 |ray_(select #length gcd_#in~y2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_#in~y1.base) 1 0)|
 |ray_(ite (select #valid gcd_#in~y1.base) 1 0)|) 0)
 (* (+ |honda_gcd_#t~mem3| |ray_gcd_#t~mem3|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)|
 |ray_(select (select old(#memory_int) gcd_#in~y1.base) 0)|) 0)
 (*
 (+ |honda_(select #length gcd_~y2.base)|
 |ray_(select #length gcd_~y2.base)|) 0)
 (* (+ |honda_gcd_#in~y1.base| |ray_gcd_#in~y1.base|) 0)
 (* (+ |honda_gcd_#in~y2.base| |ray_gcd_#in~y2.base|) 0)
 (* (+ |honda_gcd_#t~mem4| |ray_gcd_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)|
 |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)|) 1)
 (*
 (+ |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)|
 |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_~y2.base) 1 0)|
 |ray_(ite (select #valid gcd_~y2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_#in~y2.base) 1 0)|
 |ray_(ite (select #valid gcd_#in~y2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)|
 |ray_(ite (select old(#valid) gcd_#in~y2.base) 1 0)|) 0)
 (* (+ |honda_gcd_#t~mem0| |ray_gcd_#t~mem0|) 0)
 (* (+ honda_gcd_~y2.offset ray_gcd_~y2.offset) 0)
 (* (+ honda_gcd_~y2.base ray_gcd_~y2.base) 0)
 (*
 (+ |honda_(select #length gcd_#in~y1.base)|
 |ray_(select #length gcd_#in~y1.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_gcd_#in~y1.offset| |ray_gcd_#in~y1.offset|) 0)
 (* (+ |honda_gcd_#in~y2.offset| |ray_gcd_#in~y2.offset|) 0)
 (*
 (+ |honda_(select #length gcd_~y1.base)|
 |ray_(select #length gcd_~y1.base)|) 0)
 (* (+ |honda_gcd_#t~mem2| |ray_gcd_#t~mem2|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_~y1.base) 1 0)|
 |ray_(ite (select #valid gcd_~y1.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_#in~y1.base) 0)|
 |ray_(select (select #memory_int gcd_#in~y1.base) 0)|) 0)
 (*
 (+ |honda_(select old(#length) gcd_#in~y2.base)|
 |ray_(select old(#length) gcd_#in~y2.base)|) 0)
 (* (+ |honda_gcd_#t~mem1| |ray_gcd_#t~mem1|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_#in~y2.base) 0)|
 |ray_(select (select #memory_int gcd_#in~y2.base) 0)|) 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* |honda_gcd_#t~mem3| 0) 
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| (- 1))
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* |honda_gcd_#t~mem2| 0) 
 (* |honda_gcd_#t~mem1| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)|
 |ray_(select (select old(#memory_int) gcd_#in~y2.base) 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)|
 |ray_(ite (select old(#valid) gcd_#in~y1.base) 1 0)|) 0)
 (* (+ honda_gcd_~y1.base ray_gcd_~y1.base) 0)
 (*
 (+ |honda_(select old(#length) gcd_#in~y1.base)|
 |ray_(select old(#length) gcd_#in~y1.base)|) 0)
 (* (+ |honda_gcd_#t~mem5| |ray_gcd_#t~mem5|) 0)
 (* (+ honda_gcd_~y1.offset ray_gcd_~y1.offset) 0)
 (*
 (+ |honda_(select #length gcd_#in~y2.base)|
 |ray_(select #length gcd_#in~y2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_#in~y1.base) 1 0)|
 |ray_(ite (select #valid gcd_#in~y1.base) 1 0)|) 0)
 (* (+ |honda_gcd_#t~mem3| |ray_gcd_#t~mem3|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)|
 |ray_(select (select old(#memory_int) gcd_#in~y1.base) 0)|) 0)
 (*
 (+ |honda_(select #length gcd_~y2.base)|
 |ray_(select #length gcd_~y2.base)|) 0)
 (* (+ |honda_gcd_#in~y1.base| |ray_gcd_#in~y1.base|) 0)
 (* (+ |honda_gcd_#in~y2.base| |ray_gcd_#in~y2.base|) 0)
 (* (+ |honda_gcd_#t~mem4| |ray_gcd_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)|
 |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)|
 |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_~y2.base) 1 0)|
 |ray_(ite (select #valid gcd_~y2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_#in~y2.base) 1 0)|
 |ray_(ite (select #valid gcd_#in~y2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)|
 |ray_(ite (select old(#valid) gcd_#in~y2.base) 1 0)|) 0)
 (* (+ |honda_gcd_#t~mem0| |ray_gcd_#t~mem0|) 0)
 (* (+ honda_gcd_~y2.offset ray_gcd_~y2.offset) 0)
 (* (+ honda_gcd_~y2.base ray_gcd_~y2.base) 0)
 (*
 (+ |honda_(select #length gcd_#in~y1.base)|
 |ray_(select #length gcd_#in~y1.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_gcd_#in~y1.offset| |ray_gcd_#in~y1.offset|) 0)
 (* (+ |honda_gcd_#in~y2.offset| |ray_gcd_#in~y2.offset|) 0)
 (*
 (+ |honda_(select #length gcd_~y1.base)|
 |ray_(select #length gcd_~y1.base)|) 0)
 (* (+ |honda_gcd_#t~mem2| |ray_gcd_#t~mem2|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_~y1.base) 1 0)|
 |ray_(ite (select #valid gcd_~y1.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_#in~y1.base) 0)|
 |ray_(select (select #memory_int gcd_#in~y1.base) 0)|) 0)
 (*
 (+ |honda_(select old(#length) gcd_#in~y2.base)|
 |ray_(select old(#length) gcd_#in~y2.base)|) 0)
 (* (+ |honda_gcd_#t~mem1| |ray_gcd_#t~mem1|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_#in~y2.base) 0)|
 |ray_(select (select #memory_int gcd_#in~y2.base) 0)|) 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* |honda_gcd_#t~mem3| 0) 
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 1)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* |honda_gcd_#t~mem2| 0) 
 (* |honda_gcd_#t~mem1| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)|
 |ray_(select (select old(#memory_int) gcd_#in~y2.base) 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)|
 |ray_(ite (select old(#valid) gcd_#in~y1.base) 1 0)|) 0)
 (* (+ honda_gcd_~y1.base ray_gcd_~y1.base) 0)
 (*
 (+ |honda_(select old(#length) gcd_#in~y1.base)|
 |ray_(select old(#length) gcd_#in~y1.base)|) 0)
 (* (+ |honda_gcd_#t~mem5| |ray_gcd_#t~mem5|) 0)
 (* (+ honda_gcd_~y1.offset ray_gcd_~y1.offset) 0)
 (*
 (+ |honda_(select #length gcd_#in~y2.base)|
 |ray_(select #length gcd_#in~y2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_#in~y1.base) 1 0)|
 |ray_(ite (select #valid gcd_#in~y1.base) 1 0)|) 0)
 (* (+ |honda_gcd_#t~mem3| |ray_gcd_#t~mem3|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)|
 |ray_(select (select old(#memory_int) gcd_#in~y1.base) 0)|) 0)
 (*
 (+ |honda_(select #length gcd_~y2.base)|
 |ray_(select #length gcd_~y2.base)|) 0)
 (* (+ |honda_gcd_#in~y1.base| |ray_gcd_#in~y1.base|) 0)
 (* (+ |honda_gcd_#in~y2.base| |ray_gcd_#in~y2.base|) 0)
 (* (+ |honda_gcd_#t~mem4| |ray_gcd_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)|
 |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)|
 |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid gcd_~y2.base) 1 0)|
 |ray_(ite (select #valid gcd_~y2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_#in~y2.base) 1 0)|
 |ray_(ite (select #valid gcd_#in~y2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)|
 |ray_(ite (select old(#valid) gcd_#in~y2.base) 1 0)|) 0)
 (* (+ |honda_gcd_#t~mem0| |ray_gcd_#t~mem0|) 0)
 (* (+ honda_gcd_~y2.offset ray_gcd_~y2.offset) 0)
 (* (+ honda_gcd_~y2.base ray_gcd_~y2.base) 0)
 (*
 (+ |honda_(select #length gcd_#in~y1.base)|
 |ray_(select #length gcd_#in~y1.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_gcd_#in~y1.offset| |ray_gcd_#in~y1.offset|) 0)
 (* (+ |honda_gcd_#in~y2.offset| |ray_gcd_#in~y2.offset|) 0)
 (*
 (+ |honda_(select #length gcd_~y1.base)|
 |ray_(select #length gcd_~y1.base)|) 0)
 (* (+ |honda_gcd_#t~mem2| |ray_gcd_#t~mem2|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_~y1.base) 1 0)|
 |ray_(ite (select #valid gcd_~y1.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_#in~y1.base) 0)|
 |ray_(select (select #memory_int gcd_#in~y1.base) 0)|) 0)
 (*
 (+ |honda_(select old(#length) gcd_#in~y2.base)|
 |ray_(select old(#length) gcd_#in~y2.base)|) 0)
 (* (+ |honda_gcd_#t~mem1| |ray_gcd_#t~mem1|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_#in~y2.base) 0)|
 |ray_(select (select #memory_int gcd_#in~y2.base) 0)|) 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* |honda_gcd_#t~mem3| 0) 
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 1)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| (- 1))
 (* |honda_gcd_#t~mem0| 0) 
 (* |honda_gcd_#t~mem2| 0) 
 (* |honda_gcd_#t~mem1| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)|
 |ray_(select (select old(#memory_int) gcd_#in~y2.base) 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)|
 |ray_(ite (select old(#valid) gcd_#in~y1.base) 1 0)|) 0)
 (* (+ honda_gcd_~y1.base ray_gcd_~y1.base) 0)
 (*
 (+ |honda_(select old(#length) gcd_#in~y1.base)|
 |ray_(select old(#length) gcd_#in~y1.base)|) 0)
 (* (+ |honda_gcd_#t~mem5| |ray_gcd_#t~mem5|) 0)
 (* (+ honda_gcd_~y1.offset ray_gcd_~y1.offset) (- 1))
 (*
 (+ |honda_(select #length gcd_#in~y2.base)|
 |ray_(select #length gcd_#in~y2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_#in~y1.base) 1 0)|
 |ray_(ite (select #valid gcd_#in~y1.base) 1 0)|) 0)
 (* (+ |honda_gcd_#t~mem3| |ray_gcd_#t~mem3|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)|
 |ray_(select (select old(#memory_int) gcd_#in~y1.base) 0)|) 0)
 (*
 (+ |honda_(select #length gcd_~y2.base)|
 |ray_(select #length gcd_~y2.base)|) 0)
 (* (+ |honda_gcd_#in~y1.base| |ray_gcd_#in~y1.base|) 0)
 (* (+ |honda_gcd_#in~y2.base| |ray_gcd_#in~y2.base|) 0)
 (* (+ |honda_gcd_#t~mem4| |ray_gcd_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)|
 |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)|
 |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_~y2.base) 1 0)|
 |ray_(ite (select #valid gcd_~y2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_#in~y2.base) 1 0)|
 |ray_(ite (select #valid gcd_#in~y2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)|
 |ray_(ite (select old(#valid) gcd_#in~y2.base) 1 0)|) 0)
 (* (+ |honda_gcd_#t~mem0| |ray_gcd_#t~mem0|) 0)
 (* (+ honda_gcd_~y2.offset ray_gcd_~y2.offset) 0)
 (* (+ honda_gcd_~y2.base ray_gcd_~y2.base) 0)
 (*
 (+ |honda_(select #length gcd_#in~y1.base)|
 |ray_(select #length gcd_#in~y1.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_gcd_#in~y1.offset| |ray_gcd_#in~y1.offset|) 0)
 (* (+ |honda_gcd_#in~y2.offset| |ray_gcd_#in~y2.offset|) 0)
 (*
 (+ |honda_(select #length gcd_~y1.base)|
 |ray_(select #length gcd_~y1.base)|) 1)
 (* (+ |honda_gcd_#t~mem2| |ray_gcd_#t~mem2|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_~y1.base) 1 0)|
 |ray_(ite (select #valid gcd_~y1.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_#in~y1.base) 0)|
 |ray_(select (select #memory_int gcd_#in~y1.base) 0)|) 0)
 (*
 (+ |honda_(select old(#length) gcd_#in~y2.base)|
 |ray_(select old(#length) gcd_#in~y2.base)|) 0)
 (* (+ |honda_gcd_#t~mem1| |ray_gcd_#t~mem1|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_#in~y2.base) 0)|
 |ray_(select (select #memory_int gcd_#in~y2.base) 0)|) 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* |honda_gcd_#t~mem3| 0) 
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* |honda_gcd_#t~mem2| 0) 
 (* |honda_gcd_#t~mem1| 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)|
 |ray_(select (select old(#memory_int) gcd_#in~y2.base) 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)|
 |ray_(ite (select old(#valid) gcd_#in~y1.base) 1 0)|) 0)
 (* (+ honda_gcd_~y1.base ray_gcd_~y1.base) (- 1))
 (*
 (+ |honda_(select old(#length) gcd_#in~y1.base)|
 |ray_(select old(#length) gcd_#in~y1.base)|) 0)
 (* (+ |honda_gcd_#t~mem5| |ray_gcd_#t~mem5|) 0)
 (* (+ honda_gcd_~y1.offset ray_gcd_~y1.offset) 0)
 (*
 (+ |honda_(select #length gcd_#in~y2.base)|
 |ray_(select #length gcd_#in~y2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_#in~y1.base) 1 0)|
 |ray_(ite (select #valid gcd_#in~y1.base) 1 0)|) 0)
 (* (+ |honda_gcd_#t~mem3| |ray_gcd_#t~mem3|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)|
 |ray_(select (select old(#memory_int) gcd_#in~y1.base) 0)|) 0)
 (*
 (+ |honda_(select #length gcd_~y2.base)|
 |ray_(select #length gcd_~y2.base)|) 0)
 (* (+ |honda_gcd_#in~y1.base| |ray_gcd_#in~y1.base|) 0)
 (* (+ |honda_gcd_#in~y2.base| |ray_gcd_#in~y2.base|) 0)
 (* (+ |honda_gcd_#t~mem4| |ray_gcd_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)|
 |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)|
 |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_~y2.base) 1 0)|
 |ray_(ite (select #valid gcd_~y2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_#in~y2.base) 1 0)|
 |ray_(ite (select #valid gcd_#in~y2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)|
 |ray_(ite (select old(#valid) gcd_#in~y2.base) 1 0)|) 0)
 (* (+ |honda_gcd_#t~mem0| |ray_gcd_#t~mem0|) 0)
 (* (+ honda_gcd_~y2.offset ray_gcd_~y2.offset) 0)
 (* (+ honda_gcd_~y2.base ray_gcd_~y2.base) 1)
 (*
 (+ |honda_(select #length gcd_#in~y1.base)|
 |ray_(select #length gcd_#in~y1.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_gcd_#in~y1.offset| |ray_gcd_#in~y1.offset|) 0)
 (* (+ |honda_gcd_#in~y2.offset| |ray_gcd_#in~y2.offset|) 0)
 (*
 (+ |honda_(select #length gcd_~y1.base)|
 |ray_(select #length gcd_~y1.base)|) 0)
 (* (+ |honda_gcd_#t~mem2| |ray_gcd_#t~mem2|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_~y1.base) 1 0)|
 |ray_(ite (select #valid gcd_~y1.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_#in~y1.base) 0)|
 |ray_(select (select #memory_int gcd_#in~y1.base) 0)|) 0)
 (*
 (+ |honda_(select old(#length) gcd_#in~y2.base)|
 |ray_(select old(#length) gcd_#in~y2.base)|) 0)
 (* (+ |honda_gcd_#t~mem1| |ray_gcd_#t~mem1|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_#in~y2.base) 0)|
 |ray_(select (select #memory_int gcd_#in~y2.base) 0)|) 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* |honda_gcd_#t~mem3| 0) 
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* |honda_gcd_#t~mem2| 0) 
 (* |honda_gcd_#t~mem1| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)|
 |ray_(select (select old(#memory_int) gcd_#in~y2.base) 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)|
 |ray_(ite (select old(#valid) gcd_#in~y1.base) 1 0)|) 0)
 (* (+ honda_gcd_~y1.base ray_gcd_~y1.base) 0)
 (*
 (+ |honda_(select old(#length) gcd_#in~y1.base)|
 |ray_(select old(#length) gcd_#in~y1.base)|) 0)
 (* (+ |honda_gcd_#t~mem5| |ray_gcd_#t~mem5|) 0)
 (* (+ honda_gcd_~y1.offset ray_gcd_~y1.offset) (- 1))
 (*
 (+ |honda_(select #length gcd_#in~y2.base)|
 |ray_(select #length gcd_#in~y2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_#in~y1.base) 1 0)|
 |ray_(ite (select #valid gcd_#in~y1.base) 1 0)|) 0)
 (* (+ |honda_gcd_#t~mem3| |ray_gcd_#t~mem3|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)|
 |ray_(select (select old(#memory_int) gcd_#in~y1.base) 0)|) 0)
 (*
 (+ |honda_(select #length gcd_~y2.base)|
 |ray_(select #length gcd_~y2.base)|) 0)
 (* (+ |honda_gcd_#in~y1.base| |ray_gcd_#in~y1.base|) 0)
 (* (+ |honda_gcd_#in~y2.base| |ray_gcd_#in~y2.base|) 0)
 (* (+ |honda_gcd_#t~mem4| |ray_gcd_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)|
 |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)|
 |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_~y2.base) 1 0)|
 |ray_(ite (select #valid gcd_~y2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_#in~y2.base) 1 0)|
 |ray_(ite (select #valid gcd_#in~y2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)|
 |ray_(ite (select old(#valid) gcd_#in~y2.base) 1 0)|) 0)
 (* (+ |honda_gcd_#t~mem0| |ray_gcd_#t~mem0|) 0)
 (* (+ honda_gcd_~y2.offset ray_gcd_~y2.offset) 1)
 (* (+ honda_gcd_~y2.base ray_gcd_~y2.base) 0)
 (*
 (+ |honda_(select #length gcd_#in~y1.base)|
 |ray_(select #length gcd_#in~y1.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_gcd_#in~y1.offset| |ray_gcd_#in~y1.offset|) 0)
 (* (+ |honda_gcd_#in~y2.offset| |ray_gcd_#in~y2.offset|) 0)
 (*
 (+ |honda_(select #length gcd_~y1.base)|
 |ray_(select #length gcd_~y1.base)|) 0)
 (* (+ |honda_gcd_#t~mem2| |ray_gcd_#t~mem2|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_~y1.base) 1 0)|
 |ray_(ite (select #valid gcd_~y1.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_#in~y1.base) 0)|
 |ray_(select (select #memory_int gcd_#in~y1.base) 0)|) 0)
 (*
 (+ |honda_(select old(#length) gcd_#in~y2.base)|
 |ray_(select old(#length) gcd_#in~y2.base)|) 0)
 (* (+ |honda_gcd_#t~mem1| |ray_gcd_#t~mem1|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_#in~y2.base) 0)|
 |ray_(select (select #memory_int gcd_#in~y2.base) 0)|) 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* |honda_gcd_#t~mem3| 0) 
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* |honda_gcd_#t~mem2| 0) 
 (* |honda_gcd_#t~mem1| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)|
 |ray_(select (select old(#memory_int) gcd_#in~y2.base) 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)|
 |ray_(ite (select old(#valid) gcd_#in~y1.base) 1 0)|) 0)
 (* (+ honda_gcd_~y1.base ray_gcd_~y1.base) 0)
 (*
 (+ |honda_(select old(#length) gcd_#in~y1.base)|
 |ray_(select old(#length) gcd_#in~y1.base)|) 0)
 (* (+ |honda_gcd_#t~mem5| |ray_gcd_#t~mem5|) 0)
 (* (+ honda_gcd_~y1.offset ray_gcd_~y1.offset) 0)
 (*
 (+ |honda_(select #length gcd_#in~y2.base)|
 |ray_(select #length gcd_#in~y2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_#in~y1.base) 1 0)|
 |ray_(ite (select #valid gcd_#in~y1.base) 1 0)|) 0)
 (* (+ |honda_gcd_#t~mem3| |ray_gcd_#t~mem3|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)|
 |ray_(select (select old(#memory_int) gcd_#in~y1.base) 0)|) 0)
 (*
 (+ |honda_(select #length gcd_~y2.base)|
 |ray_(select #length gcd_~y2.base)|) 0)
 (* (+ |honda_gcd_#in~y1.base| |ray_gcd_#in~y1.base|) 0)
 (* (+ |honda_gcd_#in~y2.base| |ray_gcd_#in~y2.base|) 0)
 (* (+ |honda_gcd_#t~mem4| |ray_gcd_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)|
 |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)|
 |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_~y2.base) 1 0)|
 |ray_(ite (select #valid gcd_~y2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_#in~y2.base) 1 0)|
 |ray_(ite (select #valid gcd_#in~y2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)|
 |ray_(ite (select old(#valid) gcd_#in~y2.base) 1 0)|) 0)
 (* (+ |honda_gcd_#t~mem0| |ray_gcd_#t~mem0|) 0)
 (* (+ honda_gcd_~y2.offset ray_gcd_~y2.offset) 0)
 (* (+ honda_gcd_~y2.base ray_gcd_~y2.base) 0)
 (*
 (+ |honda_(select #length gcd_#in~y1.base)|
 |ray_(select #length gcd_#in~y1.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_gcd_#in~y1.offset| |ray_gcd_#in~y1.offset|) 0)
 (* (+ |honda_gcd_#in~y2.offset| |ray_gcd_#in~y2.offset|) 0)
 (*
 (+ |honda_(select #length gcd_~y1.base)|
 |ray_(select #length gcd_~y1.base)|) 0)
 (* (+ |honda_gcd_#t~mem2| |ray_gcd_#t~mem2|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_~y1.base) 1 0)|
 |ray_(ite (select #valid gcd_~y1.base) 1 0)|) 1)
 (*
 (+ |honda_(select (select #memory_int gcd_#in~y1.base) 0)|
 |ray_(select (select #memory_int gcd_#in~y1.base) 0)|) 0)
 (*
 (+ |honda_(select old(#length) gcd_#in~y2.base)|
 |ray_(select old(#length) gcd_#in~y2.base)|) 0)
 (* (+ |honda_gcd_#t~mem1| |ray_gcd_#t~mem1|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_#in~y2.base) 0)|
 |ray_(select (select #memory_int gcd_#in~y2.base) 0)|) 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* |honda_gcd_#t~mem3| 0) 
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* |honda_gcd_#t~mem2| 0) 
 (* |honda_gcd_#t~mem1| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+ |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)|
 |ray_(select (select old(#memory_int) gcd_#in~y2.base) 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)|
 |ray_(ite (select old(#valid) gcd_#in~y1.base) 1 0)|) 0)
 (* (+ honda_gcd_~y1.base ray_gcd_~y1.base) 0)
 (*
 (+ |honda_(select old(#length) gcd_#in~y1.base)|
 |ray_(select old(#length) gcd_#in~y1.base)|) 0)
 (* (+ |honda_gcd_#t~mem5| |ray_gcd_#t~mem5|) 0)
 (* (+ honda_gcd_~y1.offset ray_gcd_~y1.offset) 0)
 (*
 (+ |honda_(select #length gcd_#in~y2.base)|
 |ray_(select #length gcd_#in~y2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_#in~y1.base) 1 0)|
 |ray_(ite (select #valid gcd_#in~y1.base) 1 0)|) 0)
 (* (+ |honda_gcd_#t~mem3| |ray_gcd_#t~mem3|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)|
 |ray_(select (select old(#memory_int) gcd_#in~y1.base) 0)|) 0)
 (*
 (+ |honda_(select #length gcd_~y2.base)|
 |ray_(select #length gcd_~y2.base)|) 1)
 (* (+ |honda_gcd_#in~y1.base| |ray_gcd_#in~y1.base|) 0)
 (* (+ |honda_gcd_#in~y2.base| |ray_gcd_#in~y2.base|) 0)
 (* (+ |honda_gcd_#t~mem4| |ray_gcd_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)|
 |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)|
 |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_~y2.base) 1 0)|
 |ray_(ite (select #valid gcd_~y2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_#in~y2.base) 1 0)|
 |ray_(ite (select #valid gcd_#in~y2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)|
 |ray_(ite (select old(#valid) gcd_#in~y2.base) 1 0)|) 0)
 (* (+ |honda_gcd_#t~mem0| |ray_gcd_#t~mem0|) 0)
 (* (+ honda_gcd_~y2.offset ray_gcd_~y2.offset) (- 1))
 (* (+ honda_gcd_~y2.base ray_gcd_~y2.base) 0)
 (*
 (+ |honda_(select #length gcd_#in~y1.base)|
 |ray_(select #length gcd_#in~y1.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_gcd_#in~y1.offset| |ray_gcd_#in~y1.offset|) 0)
 (* (+ |honda_gcd_#in~y2.offset| |ray_gcd_#in~y2.offset|) 0)
 (*
 (+ |honda_(select #length gcd_~y1.base)|
 |ray_(select #length gcd_~y1.base)|) 0)
 (* (+ |honda_gcd_#t~mem2| |ray_gcd_#t~mem2|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_~y1.base) 1 0)|
 |ray_(ite (select #valid gcd_~y1.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_#in~y1.base) 0)|
 |ray_(select (select #memory_int gcd_#in~y1.base) 0)|) 0)
 (*
 (+ |honda_(select old(#length) gcd_#in~y2.base)|
 |ray_(select old(#length) gcd_#in~y2.base)|) 0)
 (* (+ |honda_gcd_#t~mem1| |ray_gcd_#t~mem1|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_#in~y2.base) 0)|
 |ray_(select (select #memory_int gcd_#in~y2.base) 0)|) 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* |honda_gcd_#t~mem3| 0) 
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* |honda_gcd_#t~mem2| 0) 
 (* |honda_gcd_#t~mem1| 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 (+ |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)|
 |ray_(select (select old(#memory_int) gcd_#in~y2.base) 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)|
 |ray_(ite (select old(#valid) gcd_#in~y1.base) 1 0)|) 0)
 (* (+ honda_gcd_~y1.base ray_gcd_~y1.base) 0)
 (*
 (+ |honda_(select old(#length) gcd_#in~y1.base)|
 |ray_(select old(#length) gcd_#in~y1.base)|) 0)
 (* (+ |honda_gcd_#t~mem5| |ray_gcd_#t~mem5|) 0)
 (* (+ honda_gcd_~y1.offset ray_gcd_~y1.offset) 0)
 (*
 (+ |honda_(select #length gcd_#in~y2.base)|
 |ray_(select #length gcd_#in~y2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_#in~y1.base) 1 0)|
 |ray_(ite (select #valid gcd_#in~y1.base) 1 0)|) 0)
 (* (+ |honda_gcd_#t~mem3| |ray_gcd_#t~mem3|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)|
 |ray_(select (select old(#memory_int) gcd_#in~y1.base) 0)|) 0)
 (*
 (+ |honda_(select #length gcd_~y2.base)|
 |ray_(select #length gcd_~y2.base)|) 0)
 (* (+ |honda_gcd_#in~y1.base| |ray_gcd_#in~y1.base|) 0)
 (* (+ |honda_gcd_#in~y2.base| |ray_gcd_#in~y2.base|) 0)
 (* (+ |honda_gcd_#t~mem4| |ray_gcd_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)|
 |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)|
 |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)|) 
 (- 1))
 (*
 (+ |honda_(ite (select #valid gcd_~y2.base) 1 0)|
 |ray_(ite (select #valid gcd_~y2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_#in~y2.base) 1 0)|
 |ray_(ite (select #valid gcd_#in~y2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)|
 |ray_(ite (select old(#valid) gcd_#in~y2.base) 1 0)|) 0)
 (* (+ |honda_gcd_#t~mem0| |ray_gcd_#t~mem0|) 0)
 (* (+ honda_gcd_~y2.offset ray_gcd_~y2.offset) 0)
 (* (+ honda_gcd_~y2.base ray_gcd_~y2.base) 0)
 (*
 (+ |honda_(select #length gcd_#in~y1.base)|
 |ray_(select #length gcd_#in~y1.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_gcd_#in~y1.offset| |ray_gcd_#in~y1.offset|) 0)
 (* (+ |honda_gcd_#in~y2.offset| |ray_gcd_#in~y2.offset|) 0)
 (*
 (+ |honda_(select #length gcd_~y1.base)|
 |ray_(select #length gcd_~y1.base)|) 0)
 (* (+ |honda_gcd_#t~mem2| |ray_gcd_#t~mem2|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_~y1.base) 1 0)|
 |ray_(ite (select #valid gcd_~y1.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_#in~y1.base) 0)|
 |ray_(select (select #memory_int gcd_#in~y1.base) 0)|) 0)
 (*
 (+ |honda_(select old(#length) gcd_#in~y2.base)|
 |ray_(select old(#length) gcd_#in~y2.base)|) 0)
 (* (+ |honda_gcd_#t~mem1| |ray_gcd_#t~mem1|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_#in~y2.base) 0)|
 |ray_(select (select #memory_int gcd_#in~y2.base) 0)|) 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* |honda_gcd_#t~mem3| 0) 
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| (- 1))
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 1)
 (* |honda_gcd_#t~mem0| 0) 
 (* |honda_gcd_#t~mem2| 0) 
 (* |honda_gcd_#t~mem1| 0) 0) 0)
 (>=
 (+
 (*
 (+ |honda_(select (select old(#memory_int) gcd_#in~y2.base) 0)|
 |ray_(select (select old(#memory_int) gcd_#in~y2.base) 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) gcd_#in~y1.base) 1 0)|
 |ray_(ite (select old(#valid) gcd_#in~y1.base) 1 0)|) 0)
 (* (+ honda_gcd_~y1.base ray_gcd_~y1.base) 0)
 (*
 (+ |honda_(select old(#length) gcd_#in~y1.base)|
 |ray_(select old(#length) gcd_#in~y1.base)|) 0)
 (* (+ |honda_gcd_#t~mem5| |ray_gcd_#t~mem5|) 0)
 (* (+ honda_gcd_~y1.offset ray_gcd_~y1.offset) 0)
 (*
 (+ |honda_(select #length gcd_#in~y2.base)|
 |ray_(select #length gcd_#in~y2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_#in~y1.base) 1 0)|
 |ray_(ite (select #valid gcd_#in~y1.base) 1 0)|) 0)
 (* (+ |honda_gcd_#t~mem3| |ray_gcd_#t~mem3|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select (select old(#memory_int) gcd_#in~y1.base) 0)|
 |ray_(select (select old(#memory_int) gcd_#in~y1.base) 0)|) 0)
 (*
 (+ |honda_(select #length gcd_~y2.base)|
 |ray_(select #length gcd_~y2.base)|) 0)
 (* (+ |honda_gcd_#in~y1.base| |ray_gcd_#in~y1.base|) 0)
 (* (+ |honda_gcd_#in~y2.base| |ray_gcd_#in~y2.base|) 0)
 (* (+ |honda_gcd_#t~mem4| |ray_gcd_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)|
 |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)|
 |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_~y2.base) 1 0)|
 |ray_(ite (select #valid gcd_~y2.base) 1 0)|) 1)
 (*
 (+ |honda_(ite (select #valid gcd_#in~y2.base) 1 0)|
 |ray_(ite (select #valid gcd_#in~y2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) gcd_#in~y2.base) 1 0)|
 |ray_(ite (select old(#valid) gcd_#in~y2.base) 1 0)|) 0)
 (* (+ |honda_gcd_#t~mem0| |ray_gcd_#t~mem0|) 0)
 (* (+ honda_gcd_~y2.offset ray_gcd_~y2.offset) 0)
 (* (+ honda_gcd_~y2.base ray_gcd_~y2.base) 0)
 (*
 (+ |honda_(select #length gcd_#in~y1.base)|
 |ray_(select #length gcd_#in~y1.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_gcd_#in~y1.offset| |ray_gcd_#in~y1.offset|) 0)
 (* (+ |honda_gcd_#in~y2.offset| |ray_gcd_#in~y2.offset|) 0)
 (*
 (+ |honda_(select #length gcd_~y1.base)|
 |ray_(select #length gcd_~y1.base)|) 0)
 (* (+ |honda_gcd_#t~mem2| |ray_gcd_#t~mem2|) 0)
 (*
 (+ |honda_(ite (select #valid gcd_~y1.base) 1 0)|
 |ray_(ite (select #valid gcd_~y1.base) 1 0)|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_#in~y1.base) 0)|
 |ray_(select (select #memory_int gcd_#in~y1.base) 0)|) 0)
 (*
 (+ |honda_(select old(#length) gcd_#in~y2.base)|
 |ray_(select old(#length) gcd_#in~y2.base)|) 0)
 (* (+ |honda_gcd_#t~mem1| |ray_gcd_#t~mem1|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 (+ |honda_(select (select #memory_int gcd_#in~y2.base) 0)|
 |ray_(select (select #memory_int gcd_#in~y2.base) 0)|) 0)
 (* |honda_gcd_#t~mem5| 0) 
 (* |honda_gcd_#t~mem3| 0) 
 (* |honda_gcd_#t~mem4| 0)
 (* |honda_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |honda_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |honda_gcd_#t~mem0| 0) 
 (* |honda_gcd_#t~mem2| 0) 
 (* |honda_gcd_#t~mem1| 0) 
 (- 1)) 0)
 (= |ray_(select (select old(#memory_int) gcd_#in~y2.base) 0)|
 (* |ray_(select (select old(#memory_int) gcd_#in~y2.base) 0)| lambda))
 (= |ray_(ite (select old(#valid) gcd_#in~y1.base) 1 0)|
 (* |ray_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| lambda))
 (= ray_gcd_~y1.base (* ray_gcd_~y1.base lambda))
 (= |ray_(select old(#length) gcd_#in~y1.base)|
 (* |ray_(select old(#length) gcd_#in~y1.base)| lambda))
 (= ray_gcd_~y1.offset (* ray_gcd_~y1.offset lambda))
 (= |ray_(select #length gcd_#in~y2.base)|
 (* |ray_(select #length gcd_#in~y2.base)| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_(ite (select #valid gcd_#in~y1.base) 1 0)|
 (* |ray_(ite (select #valid gcd_#in~y1.base) 1 0)| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(select (select old(#memory_int) gcd_#in~y1.base) 0)|
 (* |ray_(select (select old(#memory_int) gcd_#in~y1.base) 0)| lambda))
 (= |ray_(select #length gcd_~y2.base)|
 (* |ray_(select #length gcd_~y2.base)| lambda))
 (= |ray_gcd_#in~y1.base| (* |ray_gcd_#in~y1.base| lambda))
 (= |ray_gcd_#in~y2.base| (* |ray_gcd_#in~y2.base| lambda))
 (= |ray_(ite (select #valid gcd_~y2.base) 1 0)|
 (* |ray_(ite (select #valid gcd_~y2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid gcd_#in~y2.base) 1 0)|
 (* |ray_(ite (select #valid gcd_#in~y2.base) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) gcd_#in~y2.base) 1 0)|
 (* |ray_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| lambda))
 (= ray_gcd_~y2.offset (* ray_gcd_~y2.offset lambda))
 (= ray_gcd_~y2.base (* ray_gcd_~y2.base lambda))
 (= |ray_(select #length gcd_#in~y1.base)|
 (* |ray_(select #length gcd_#in~y1.base)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_gcd_#in~y1.offset| (* |ray_gcd_#in~y1.offset| lambda))
 (= |ray_gcd_#in~y2.offset| (* |ray_gcd_#in~y2.offset| lambda))
 (= |ray_(select #length gcd_~y1.base)|
 (* |ray_(select #length gcd_~y1.base)| lambda))
 (= |ray_(ite (select #valid gcd_~y1.base) 1 0)|
 (* |ray_(ite (select #valid gcd_~y1.base) 1 0)| lambda))
 (= |ray_(select (select #memory_int gcd_#in~y1.base) 0)|
 (* |ray_(select (select #memory_int gcd_#in~y1.base) 0)| lambda))
 (= |ray_(select old(#length) gcd_#in~y2.base)|
 (* |ray_(select old(#length) gcd_#in~y2.base)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= |ray_(select (select #memory_int gcd_#in~y2.base) 0)|
 (* |ray_(select (select #memory_int gcd_#in~y2.base) 0)| lambda))
 (>=
 (+
 (* (* |ray_(select (select old(#memory_int) gcd_#in~y2.base) 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| lambda) 0)
 (* (* ray_gcd_~y1.base lambda) 0)
 (* (* |ray_(select old(#length) gcd_#in~y1.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem5| lambda) 0) 
 (* (* ray_gcd_~y1.offset lambda) 1)
 (* (* |ray_(select #length gcd_#in~y2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_#in~y1.base) 1 0)| lambda) 0)
 (* (* |ray_gcd_#t~mem3| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select (select old(#memory_int) gcd_#in~y1.base) 0)| lambda) 0)
 (* (* |ray_(select #length gcd_~y2.base)| lambda) 0)
 (* (* |ray_gcd_#in~y1.base| lambda) 0)
 (* (* |ray_gcd_#in~y2.base| lambda) 0) 
 (* (* |ray_gcd_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| lambda)
 0)
 (*
 (* |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| lambda)
 0) (* (* |ray_(ite (select #valid gcd_~y2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_#in~y2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| lambda) 0)
 (* (* |ray_gcd_#t~mem0| lambda) 0) 
 (* (* ray_gcd_~y2.offset lambda) (- 1)) 
 (* (* ray_gcd_~y2.base lambda) 0)
 (* (* |ray_(select #length gcd_#in~y1.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_gcd_#in~y1.offset| lambda) 0)
 (* (* |ray_gcd_#in~y2.offset| lambda) 0)
 (* (* |ray_(select #length gcd_~y1.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem2| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_~y1.base) 1 0)| lambda) 0)
 (* (* |ray_(select (select #memory_int gcd_#in~y1.base) 0)| lambda) 0)
 (* (* |ray_(select old(#length) gcd_#in~y2.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem1| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select (select #memory_int gcd_#in~y2.base) 0)| lambda) 0)
 (* |ray_gcd_#t~mem5| 0) (* |ray_gcd_#t~mem3| 0) 
 (* |ray_gcd_#t~mem4| 0)
 (* |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |ray_gcd_#t~mem0| 0) (* |ray_gcd_#t~mem2| 0) 
 (* |ray_gcd_#t~mem1| 0)) 0)
 (>=
 (+
 (* (* |ray_(select (select old(#memory_int) gcd_#in~y2.base) 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| lambda) 0)
 (* (* ray_gcd_~y1.base lambda) 0)
 (* (* |ray_(select old(#length) gcd_#in~y1.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem5| lambda) 0) 
 (* (* ray_gcd_~y1.offset lambda) 0)
 (* (* |ray_(select #length gcd_#in~y2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_#in~y1.base) 1 0)| lambda) 0)
 (* (* |ray_gcd_#t~mem3| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select (select old(#memory_int) gcd_#in~y1.base) 0)| lambda) 0)
 (* (* |ray_(select #length gcd_~y2.base)| lambda) 0)
 (* (* |ray_gcd_#in~y1.base| lambda) 0)
 (* (* |ray_gcd_#in~y2.base| lambda) 0) 
 (* (* |ray_gcd_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| lambda)
 0)
 (*
 (* |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| lambda)
 0) (* (* |ray_(ite (select #valid gcd_~y2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_#in~y2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| lambda) 0)
 (* (* |ray_gcd_#t~mem0| lambda) 0) 
 (* (* ray_gcd_~y2.offset lambda) 0) 
 (* (* ray_gcd_~y2.base lambda) 0)
 (* (* |ray_(select #length gcd_#in~y1.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_gcd_#in~y1.offset| lambda) 0)
 (* (* |ray_gcd_#in~y2.offset| lambda) 0)
 (* (* |ray_(select #length gcd_~y1.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem2| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_~y1.base) 1 0)| lambda) 0)
 (* (* |ray_(select (select #memory_int gcd_#in~y1.base) 0)| lambda) 0)
 (* (* |ray_(select old(#length) gcd_#in~y2.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem1| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select (select #memory_int gcd_#in~y2.base) 0)| lambda) 0)
 (* |ray_gcd_#t~mem5| 0) (* |ray_gcd_#t~mem3| 0) 
 (* |ray_gcd_#t~mem4| 0)
 (* |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| (- 1))
 (* |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 1)
 (* |ray_gcd_#t~mem0| 0) (* |ray_gcd_#t~mem2| 0) 
 (* |ray_gcd_#t~mem1| 0)) 0)
 (>=
 (+
 (* (* |ray_(select (select old(#memory_int) gcd_#in~y2.base) 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| lambda) 0)
 (* (* ray_gcd_~y1.base lambda) 0)
 (* (* |ray_(select old(#length) gcd_#in~y1.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem5| lambda) 0) 
 (* (* ray_gcd_~y1.offset lambda) 0)
 (* (* |ray_(select #length gcd_#in~y2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_#in~y1.base) 1 0)| lambda) 0)
 (* (* |ray_gcd_#t~mem3| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select (select old(#memory_int) gcd_#in~y1.base) 0)| lambda) 0)
 (* (* |ray_(select #length gcd_~y2.base)| lambda) 0)
 (* (* |ray_gcd_#in~y1.base| lambda) 0)
 (* (* |ray_gcd_#in~y2.base| lambda) 0) 
 (* (* |ray_gcd_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| lambda)
 1)
 (*
 (* |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| lambda)
 0) (* (* |ray_(ite (select #valid gcd_~y2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_#in~y2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| lambda) 0)
 (* (* |ray_gcd_#t~mem0| lambda) 0) 
 (* (* ray_gcd_~y2.offset lambda) 0) 
 (* (* ray_gcd_~y2.base lambda) 0)
 (* (* |ray_(select #length gcd_#in~y1.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_gcd_#in~y1.offset| lambda) 0)
 (* (* |ray_gcd_#in~y2.offset| lambda) 0)
 (* (* |ray_(select #length gcd_~y1.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem2| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_~y1.base) 1 0)| lambda) 0)
 (* (* |ray_(select (select #memory_int gcd_#in~y1.base) 0)| lambda) 0)
 (* (* |ray_(select old(#length) gcd_#in~y2.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem1| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select (select #memory_int gcd_#in~y2.base) 0)| lambda) 0)
 (* |ray_gcd_#t~mem5| 0) (* |ray_gcd_#t~mem3| 0) 
 (* |ray_gcd_#t~mem4| 0)
 (* |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| (- 1))
 (* |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |ray_gcd_#t~mem0| 0) (* |ray_gcd_#t~mem2| 0) 
 (* |ray_gcd_#t~mem1| 0)) 0)
 (>=
 (+
 (* (* |ray_(select (select old(#memory_int) gcd_#in~y2.base) 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| lambda) 0)
 (* (* ray_gcd_~y1.base lambda) 0)
 (* (* |ray_(select old(#length) gcd_#in~y1.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem5| lambda) 0) 
 (* (* ray_gcd_~y1.offset lambda) 0)
 (* (* |ray_(select #length gcd_#in~y2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_#in~y1.base) 1 0)| lambda) 0)
 (* (* |ray_gcd_#t~mem3| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select (select old(#memory_int) gcd_#in~y1.base) 0)| lambda) 0)
 (* (* |ray_(select #length gcd_~y2.base)| lambda) 0)
 (* (* |ray_gcd_#in~y1.base| lambda) 0)
 (* (* |ray_gcd_#in~y2.base| lambda) 0) 
 (* (* |ray_gcd_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| lambda)
 (- 1))
 (*
 (* |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| lambda)
 0) (* (* |ray_(ite (select #valid gcd_~y2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_#in~y2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| lambda) 0)
 (* (* |ray_gcd_#t~mem0| lambda) 0) 
 (* (* ray_gcd_~y2.offset lambda) 0) 
 (* (* ray_gcd_~y2.base lambda) 0)
 (* (* |ray_(select #length gcd_#in~y1.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_gcd_#in~y1.offset| lambda) 0)
 (* (* |ray_gcd_#in~y2.offset| lambda) 0)
 (* (* |ray_(select #length gcd_~y1.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem2| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_~y1.base) 1 0)| lambda) 0)
 (* (* |ray_(select (select #memory_int gcd_#in~y1.base) 0)| lambda) 0)
 (* (* |ray_(select old(#length) gcd_#in~y2.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem1| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select (select #memory_int gcd_#in~y2.base) 0)| lambda) 0)
 (* |ray_gcd_#t~mem5| 0) (* |ray_gcd_#t~mem3| 0) 
 (* |ray_gcd_#t~mem4| 0)
 (* |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 1)
 (* |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |ray_gcd_#t~mem0| 0) (* |ray_gcd_#t~mem2| 0) 
 (* |ray_gcd_#t~mem1| 0)) 0)
 (>=
 (+
 (* (* |ray_(select (select old(#memory_int) gcd_#in~y2.base) 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| lambda) 0)
 (* (* ray_gcd_~y1.base lambda) 0)
 (* (* |ray_(select old(#length) gcd_#in~y1.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem5| lambda) 0) 
 (* (* ray_gcd_~y1.offset lambda) 0)
 (* (* |ray_(select #length gcd_#in~y2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_#in~y1.base) 1 0)| lambda) 0)
 (* (* |ray_gcd_#t~mem3| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select (select old(#memory_int) gcd_#in~y1.base) 0)| lambda) 0)
 (* (* |ray_(select #length gcd_~y2.base)| lambda) 0)
 (* (* |ray_gcd_#in~y1.base| lambda) 0)
 (* (* |ray_gcd_#in~y2.base| lambda) 0) 
 (* (* |ray_gcd_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| lambda)
 0)
 (*
 (* |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| lambda)
 1) (* (* |ray_(ite (select #valid gcd_~y2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_#in~y2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| lambda) 0)
 (* (* |ray_gcd_#t~mem0| lambda) 0) 
 (* (* ray_gcd_~y2.offset lambda) 0) 
 (* (* ray_gcd_~y2.base lambda) 0)
 (* (* |ray_(select #length gcd_#in~y1.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_gcd_#in~y1.offset| lambda) 0)
 (* (* |ray_gcd_#in~y2.offset| lambda) 0)
 (* (* |ray_(select #length gcd_~y1.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem2| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_~y1.base) 1 0)| lambda) 0)
 (* (* |ray_(select (select #memory_int gcd_#in~y1.base) 0)| lambda) 0)
 (* (* |ray_(select old(#length) gcd_#in~y2.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem1| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select (select #memory_int gcd_#in~y2.base) 0)| lambda) 0)
 (* |ray_gcd_#t~mem5| 0) (* |ray_gcd_#t~mem3| 0) 
 (* |ray_gcd_#t~mem4| 0)
 (* |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 1)
 (* |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| (- 1))
 (* |ray_gcd_#t~mem0| 0) (* |ray_gcd_#t~mem2| 0) 
 (* |ray_gcd_#t~mem1| 0)) 0)
 (>=
 (+
 (* (* |ray_(select (select old(#memory_int) gcd_#in~y2.base) 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| lambda) 0)
 (* (* ray_gcd_~y1.base lambda) 0)
 (* (* |ray_(select old(#length) gcd_#in~y1.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem5| lambda) 0) 
 (* (* ray_gcd_~y1.offset lambda) (- 1))
 (* (* |ray_(select #length gcd_#in~y2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_#in~y1.base) 1 0)| lambda) 0)
 (* (* |ray_gcd_#t~mem3| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select (select old(#memory_int) gcd_#in~y1.base) 0)| lambda) 0)
 (* (* |ray_(select #length gcd_~y2.base)| lambda) 0)
 (* (* |ray_gcd_#in~y1.base| lambda) 0)
 (* (* |ray_gcd_#in~y2.base| lambda) 0) 
 (* (* |ray_gcd_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| lambda)
 0)
 (*
 (* |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| lambda)
 0) (* (* |ray_(ite (select #valid gcd_~y2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_#in~y2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| lambda) 0)
 (* (* |ray_gcd_#t~mem0| lambda) 0) 
 (* (* ray_gcd_~y2.offset lambda) 0) 
 (* (* ray_gcd_~y2.base lambda) 0)
 (* (* |ray_(select #length gcd_#in~y1.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_gcd_#in~y1.offset| lambda) 0)
 (* (* |ray_gcd_#in~y2.offset| lambda) 0)
 (* (* |ray_(select #length gcd_~y1.base)| lambda) 1)
 (* (* |ray_gcd_#t~mem2| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_~y1.base) 1 0)| lambda) 0)
 (* (* |ray_(select (select #memory_int gcd_#in~y1.base) 0)| lambda) 0)
 (* (* |ray_(select old(#length) gcd_#in~y2.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem1| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select (select #memory_int gcd_#in~y2.base) 0)| lambda) 0)
 (* |ray_gcd_#t~mem5| 0) (* |ray_gcd_#t~mem3| 0) 
 (* |ray_gcd_#t~mem4| 0)
 (* |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |ray_gcd_#t~mem0| 0) (* |ray_gcd_#t~mem2| 0) 
 (* |ray_gcd_#t~mem1| 0)) 0)
 (>=
 (+
 (* (* |ray_(select (select old(#memory_int) gcd_#in~y2.base) 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| lambda) 0)
 (* (* ray_gcd_~y1.base lambda) (- 1))
 (* (* |ray_(select old(#length) gcd_#in~y1.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem5| lambda) 0) 
 (* (* ray_gcd_~y1.offset lambda) 0)
 (* (* |ray_(select #length gcd_#in~y2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_#in~y1.base) 1 0)| lambda) 0)
 (* (* |ray_gcd_#t~mem3| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select (select old(#memory_int) gcd_#in~y1.base) 0)| lambda) 0)
 (* (* |ray_(select #length gcd_~y2.base)| lambda) 0)
 (* (* |ray_gcd_#in~y1.base| lambda) 0)
 (* (* |ray_gcd_#in~y2.base| lambda) 0) 
 (* (* |ray_gcd_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| lambda)
 0)
 (*
 (* |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| lambda)
 0) (* (* |ray_(ite (select #valid gcd_~y2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_#in~y2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| lambda) 0)
 (* (* |ray_gcd_#t~mem0| lambda) 0) 
 (* (* ray_gcd_~y2.offset lambda) 0) 
 (* (* ray_gcd_~y2.base lambda) 1)
 (* (* |ray_(select #length gcd_#in~y1.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_gcd_#in~y1.offset| lambda) 0)
 (* (* |ray_gcd_#in~y2.offset| lambda) 0)
 (* (* |ray_(select #length gcd_~y1.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem2| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_~y1.base) 1 0)| lambda) 0)
 (* (* |ray_(select (select #memory_int gcd_#in~y1.base) 0)| lambda) 0)
 (* (* |ray_(select old(#length) gcd_#in~y2.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem1| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select (select #memory_int gcd_#in~y2.base) 0)| lambda) 0)
 (* |ray_gcd_#t~mem5| 0) (* |ray_gcd_#t~mem3| 0) 
 (* |ray_gcd_#t~mem4| 0)
 (* |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |ray_gcd_#t~mem0| 0) (* |ray_gcd_#t~mem2| 0) 
 (* |ray_gcd_#t~mem1| 0)) 0)
 (>=
 (+
 (* (* |ray_(select (select old(#memory_int) gcd_#in~y2.base) 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| lambda) 0)
 (* (* ray_gcd_~y1.base lambda) 0)
 (* (* |ray_(select old(#length) gcd_#in~y1.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem5| lambda) 0) 
 (* (* ray_gcd_~y1.offset lambda) (- 1))
 (* (* |ray_(select #length gcd_#in~y2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_#in~y1.base) 1 0)| lambda) 0)
 (* (* |ray_gcd_#t~mem3| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select (select old(#memory_int) gcd_#in~y1.base) 0)| lambda) 0)
 (* (* |ray_(select #length gcd_~y2.base)| lambda) 0)
 (* (* |ray_gcd_#in~y1.base| lambda) 0)
 (* (* |ray_gcd_#in~y2.base| lambda) 0) 
 (* (* |ray_gcd_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| lambda)
 0)
 (*
 (* |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| lambda)
 0) (* (* |ray_(ite (select #valid gcd_~y2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_#in~y2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| lambda) 0)
 (* (* |ray_gcd_#t~mem0| lambda) 0) 
 (* (* ray_gcd_~y2.offset lambda) 1) 
 (* (* ray_gcd_~y2.base lambda) 0)
 (* (* |ray_(select #length gcd_#in~y1.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_gcd_#in~y1.offset| lambda) 0)
 (* (* |ray_gcd_#in~y2.offset| lambda) 0)
 (* (* |ray_(select #length gcd_~y1.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem2| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_~y1.base) 1 0)| lambda) 0)
 (* (* |ray_(select (select #memory_int gcd_#in~y1.base) 0)| lambda) 0)
 (* (* |ray_(select old(#length) gcd_#in~y2.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem1| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select (select #memory_int gcd_#in~y2.base) 0)| lambda) 0)
 (* |ray_gcd_#t~mem5| 0) (* |ray_gcd_#t~mem3| 0) 
 (* |ray_gcd_#t~mem4| 0)
 (* |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |ray_gcd_#t~mem0| 0) (* |ray_gcd_#t~mem2| 0) 
 (* |ray_gcd_#t~mem1| 0)) 0)
 (>=
 (+
 (* (* |ray_(select (select old(#memory_int) gcd_#in~y2.base) 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| lambda) 0)
 (* (* ray_gcd_~y1.base lambda) 0)
 (* (* |ray_(select old(#length) gcd_#in~y1.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem5| lambda) 0) 
 (* (* ray_gcd_~y1.offset lambda) 0)
 (* (* |ray_(select #length gcd_#in~y2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_#in~y1.base) 1 0)| lambda) 0)
 (* (* |ray_gcd_#t~mem3| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select (select old(#memory_int) gcd_#in~y1.base) 0)| lambda) 0)
 (* (* |ray_(select #length gcd_~y2.base)| lambda) 0)
 (* (* |ray_gcd_#in~y1.base| lambda) 0)
 (* (* |ray_gcd_#in~y2.base| lambda) 0) 
 (* (* |ray_gcd_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| lambda)
 0)
 (*
 (* |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| lambda)
 0) (* (* |ray_(ite (select #valid gcd_~y2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_#in~y2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| lambda) 0)
 (* (* |ray_gcd_#t~mem0| lambda) 0) 
 (* (* ray_gcd_~y2.offset lambda) 0) 
 (* (* ray_gcd_~y2.base lambda) 0)
 (* (* |ray_(select #length gcd_#in~y1.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_gcd_#in~y1.offset| lambda) 0)
 (* (* |ray_gcd_#in~y2.offset| lambda) 0)
 (* (* |ray_(select #length gcd_~y1.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem2| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_~y1.base) 1 0)| lambda) 1)
 (* (* |ray_(select (select #memory_int gcd_#in~y1.base) 0)| lambda) 0)
 (* (* |ray_(select old(#length) gcd_#in~y2.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem1| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select (select #memory_int gcd_#in~y2.base) 0)| lambda) 0)
 (* |ray_gcd_#t~mem5| 0) (* |ray_gcd_#t~mem3| 0) 
 (* |ray_gcd_#t~mem4| 0)
 (* |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |ray_gcd_#t~mem0| 0) (* |ray_gcd_#t~mem2| 0) 
 (* |ray_gcd_#t~mem1| 0)) 0)
 (>=
 (+
 (* (* |ray_(select (select old(#memory_int) gcd_#in~y2.base) 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| lambda) 0)
 (* (* ray_gcd_~y1.base lambda) 0)
 (* (* |ray_(select old(#length) gcd_#in~y1.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem5| lambda) 0) 
 (* (* ray_gcd_~y1.offset lambda) 0)
 (* (* |ray_(select #length gcd_#in~y2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_#in~y1.base) 1 0)| lambda) 0)
 (* (* |ray_gcd_#t~mem3| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select (select old(#memory_int) gcd_#in~y1.base) 0)| lambda) 0)
 (* (* |ray_(select #length gcd_~y2.base)| lambda) 1)
 (* (* |ray_gcd_#in~y1.base| lambda) 0)
 (* (* |ray_gcd_#in~y2.base| lambda) 0) 
 (* (* |ray_gcd_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| lambda)
 0)
 (*
 (* |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| lambda)
 0) (* (* |ray_(ite (select #valid gcd_~y2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_#in~y2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| lambda) 0)
 (* (* |ray_gcd_#t~mem0| lambda) 0) 
 (* (* ray_gcd_~y2.offset lambda) (- 1)) 
 (* (* ray_gcd_~y2.base lambda) 0)
 (* (* |ray_(select #length gcd_#in~y1.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_gcd_#in~y1.offset| lambda) 0)
 (* (* |ray_gcd_#in~y2.offset| lambda) 0)
 (* (* |ray_(select #length gcd_~y1.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem2| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_~y1.base) 1 0)| lambda) 0)
 (* (* |ray_(select (select #memory_int gcd_#in~y1.base) 0)| lambda) 0)
 (* (* |ray_(select old(#length) gcd_#in~y2.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem1| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select (select #memory_int gcd_#in~y2.base) 0)| lambda) 0)
 (* |ray_gcd_#t~mem5| 0) (* |ray_gcd_#t~mem3| 0) 
 (* |ray_gcd_#t~mem4| 0)
 (* |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |ray_gcd_#t~mem0| 0) (* |ray_gcd_#t~mem2| 0) 
 (* |ray_gcd_#t~mem1| 0)) 0)
 (>=
 (+
 (* (* |ray_(select (select old(#memory_int) gcd_#in~y2.base) 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| lambda) 0)
 (* (* ray_gcd_~y1.base lambda) 0)
 (* (* |ray_(select old(#length) gcd_#in~y1.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem5| lambda) 0) 
 (* (* ray_gcd_~y1.offset lambda) 0)
 (* (* |ray_(select #length gcd_#in~y2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_#in~y1.base) 1 0)| lambda) 0)
 (* (* |ray_gcd_#t~mem3| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select (select old(#memory_int) gcd_#in~y1.base) 0)| lambda) 0)
 (* (* |ray_(select #length gcd_~y2.base)| lambda) 0)
 (* (* |ray_gcd_#in~y1.base| lambda) 0)
 (* (* |ray_gcd_#in~y2.base| lambda) 0) 
 (* (* |ray_gcd_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| lambda)
 0)
 (*
 (* |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| lambda)
 (- 1)) (* (* |ray_(ite (select #valid gcd_~y2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_#in~y2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| lambda) 0)
 (* (* |ray_gcd_#t~mem0| lambda) 0) 
 (* (* ray_gcd_~y2.offset lambda) 0) 
 (* (* ray_gcd_~y2.base lambda) 0)
 (* (* |ray_(select #length gcd_#in~y1.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_gcd_#in~y1.offset| lambda) 0)
 (* (* |ray_gcd_#in~y2.offset| lambda) 0)
 (* (* |ray_(select #length gcd_~y1.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem2| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_~y1.base) 1 0)| lambda) 0)
 (* (* |ray_(select (select #memory_int gcd_#in~y1.base) 0)| lambda) 0)
 (* (* |ray_(select old(#length) gcd_#in~y2.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem1| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select (select #memory_int gcd_#in~y2.base) 0)| lambda) 0)
 (* |ray_gcd_#t~mem5| 0) (* |ray_gcd_#t~mem3| 0) 
 (* |ray_gcd_#t~mem4| 0)
 (* |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| (- 1))
 (* |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 1)
 (* |ray_gcd_#t~mem0| 0) (* |ray_gcd_#t~mem2| 0) 
 (* |ray_gcd_#t~mem1| 0)) 0)
 (>=
 (+
 (* (* |ray_(select (select old(#memory_int) gcd_#in~y2.base) 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) gcd_#in~y1.base) 1 0)| lambda) 0)
 (* (* ray_gcd_~y1.base lambda) 0)
 (* (* |ray_(select old(#length) gcd_#in~y1.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem5| lambda) 0) 
 (* (* ray_gcd_~y1.offset lambda) 0)
 (* (* |ray_(select #length gcd_#in~y2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_#in~y1.base) 1 0)| lambda) 0)
 (* (* |ray_gcd_#t~mem3| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select (select old(#memory_int) gcd_#in~y1.base) 0)| lambda) 0)
 (* (* |ray_(select #length gcd_~y2.base)| lambda) 0)
 (* (* |ray_gcd_#in~y1.base| lambda) 0)
 (* (* |ray_gcd_#in~y2.base| lambda) 0) 
 (* (* |ray_gcd_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| lambda)
 0)
 (*
 (* |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| lambda)
 0) (* (* |ray_(ite (select #valid gcd_~y2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid gcd_#in~y2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) gcd_#in~y2.base) 1 0)| lambda) 0)
 (* (* |ray_gcd_#t~mem0| lambda) 0) 
 (* (* ray_gcd_~y2.offset lambda) 0) 
 (* (* ray_gcd_~y2.base lambda) 0)
 (* (* |ray_(select #length gcd_#in~y1.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_gcd_#in~y1.offset| lambda) 0)
 (* (* |ray_gcd_#in~y2.offset| lambda) 0)
 (* (* |ray_(select #length gcd_~y1.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem2| lambda) 0)
 (* (* |ray_(ite (select #valid gcd_~y1.base) 1 0)| lambda) 0)
 (* (* |ray_(select (select #memory_int gcd_#in~y1.base) 0)| lambda) 0)
 (* (* |ray_(select old(#length) gcd_#in~y2.base)| lambda) 0)
 (* (* |ray_gcd_#t~mem1| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* (* |ray_(select (select #memory_int gcd_#in~y2.base) 0)| lambda) 0)
 (* |ray_gcd_#t~mem5| 0) (* |ray_gcd_#t~mem3| 0) 
 (* |ray_gcd_#t~mem4| 0)
 (* |ray_(select (select #memory_int gcd_~y2.base) gcd_~y2.offset)| 0)
 (* |ray_(select (select #memory_int gcd_~y1.base) gcd_~y1.offset)| 0)
 (* |ray_gcd_#t~mem0| 0) (* |ray_gcd_#t~mem2| 0) 
 (* |ray_gcd_#t~mem1| 0)) 0) 
 (= lambda lambda))) (>= lambda 0)))
(check-sat)
(exit)

